/* Zugriffsberechtigungen fr Web-Anwendungen auf BALVI iP anlegen
 * ================================================================
 *
 * Version: 1.84
 * Gltig fr: BALVI iP 1.24.12 oder hher
 * Erforderlich fr: BALVI Schnittsttellenserver 3.5 oder hher
 * Autor: Frank Holler
 *
 * SVN Revisionsinformationen:
 * $Revision: 1121 $
 * $Date: 2019-05-15 13:34:27 +0200 (Mi, 15 Mai 2019) $
 *
 * ================================================================
 *
 * WICHTIGE HINWEISE
 *
 * Dieses Skript muss vom Benutzer SYSTEM ausgefhrt werden,
 * NICHT vom Schema-Besitzer der Anwendung BALVI iP oder von SYS!
 *
 * Grundvoraussetzung:
 * Es wird eine vorhandene Installation von BALVI iP auf einem
 * Oracle-Datenbankserver vorausgesetzt. Zustzlich wird eine
 * Web-Anwendung (WAR) an BALVI iP angebunden, um erweiterte
 * Funktionalitten bereit zu stellen.
 *
 * Da es sich um WebServices handelt, welche kompromittiert
 * werden knnten, wird empfohlen, den Schema-Besitzer der
 * Web-Anwendung abweichend vom Schema-Besitzer der Anwendung
 * BALVI iP anzulegen. Dadurch ist es mglich, diverse
 * Sicherheitsanforderungen zu erfllen, z. B. ber die
 * Option zu verfgen, den Login fr die Web-Anwendung
 * bei Bedarf zu deaktivieren, ohne dass die Anwendung
 * BALVI iP davon betroffen ist.
 *
 * BALVI stellt dieses Skript zur Verfgung, um der Web-
 * Anwendung den Zugriff auf die erforderlichen Datenbank-
 * Objekte (Tabellen, Views, Funktionen) von BALVI iP zu 
 * ermglichen. Mit PL/SQL-Skript werden die notwendigen 
 * Berechtigungen erteilt und entsprechende Synonyme erzeugt, 
 * sodass die Web-Anwendung auf ausgewhlte Objekte des Schemas
 * BALVI iP zugreifen kann, jedoch niemals OWNER-Rechte bestehen.
 * Damit ist es der Web-Anwendung grundstzlich nicht mglich,
 * Objekte von BALVI iP zu ndern (ALTER) oder zu lschen (DROP).
 *
 * Dieses Skript wurde getestet mit
 * - Oracle SQL-Plus
 * - Oracle SQL Developer
 *
 * ================================================================
 *
 *  Anwendungsfall-Beispiel:
 *  ------------------------
 *   Anwendung => ORACLE_USER
 *
 *  - BALVI_IP-Schema Produktion         => BALVI_IP_PROD
 *    - zugehriger Schnittstellenserver => KOMMSERVER_PROD
 *    - zugehriges Probenahme FM        => PROBE_FM_PROD
 *
 *  - Ausfhrung des Grant-Skriptes:
 *
 *    1.) IP zu Schnittstellenserver mit Einstellungen:
 *    :sUserBALVI_IP := 'BALVI_IP_PROD';
 *    :sUserBALVI_WEB := 'KOMMSERVER_PROD';
 *    :WS_BSS := 1;
 *
 *    2.) IP zu Probenahmen FM mit Einstellungen:
 *    :sUserBALVI_IP := 'BALVI_IP_PROD';
 *    :sUserBALVI_WEB := 'PROBE_FM_PROD ';
 *    :WS_BSS := 0;
 *    :WS_PROBE_FM := 1;
 *
 *  - BALVI_IP-Schema Testumgebung       => BALVI_IP_TEST
 *    - zugehriger Schnittstellenserver => KOMMSERVER_TEST
 *   ...
 *
 * ================================================================
 *
 * Letzte nderungen:
 * V 1.84:
     Fehlendes ESCAPE "\" bei VIS_D0113 fr Probenahmen FM (BY) hat die Rechte INSERT/UPDATE nicht durchgefhrt
 * V 1.83:
     Verwirrende Meldung "Der User USER_NAME hat nicht ausreichend Recht zur Ausfhrung des Skripts.
                          Fgen Sie dem User das Recht hinzu: CREATE SYNONYM"
     behoben, wenn der Benutzer nicht existiert.
 * V 1.82:
     Package XGEWERBE ergnzt, das neu zu Release 1.24.15
	 bereitgestellt wurde.
 * V 1.81:
     Fehler von CREATE SYNONYM werden nun im Log ausgegeben
     Ziel-User-Rechte-Prfung auf "CREATE SYNONYM"
 * V 1.80:
     GRANT SELECT, INSERT, UPDATE fr DRT%
 * V 1.79:
     GRANT EXECUTE auf SARCHIV fr Staatsarchiv BY    
 * V 1.78:
     GRANT SELECT fr RN_VERW_EXT
 * V 1.77: 
     GRANT fr BSS-spezifische-Tabellen berarbeitet (gem. Spez. 3.5)
     BSS-eigene Tabellen (volle Rechte im Fall WS_BSS, auch DELETE)
     =>'BSS_ETL_JOBS'
     =>'BSS_ENDPOINTS'
     =>'DEPLOYABLE_RESOURCES'
     =>'JOB_DEF'
     =>'JOB_PARAM'
     =>'JOB_QUEUE_ENTRIES'
     =>'JOB_HISTORY_ENTRIES'
     =>'TEXT_FILE_REPOSITORY'
     =>'XML_EXP_DEF'
     =>'XML_IMP_DEF'
 * V 1.76:
     GRANT SELECT, INSERT, UPDATE fr VIS_S99
 * V 1.75:
     GRANT SELECT fr RN_VERWEISE
 * V 1.74:
     GRANT SELECT fr RN_KOPF und RN_TEXTE
 * V 1.73:
     GRANT SELECT, INSERT, UPDATE, DELETE fr JOB_HISTORY_ENTRIES und JOB_QUEUE_ENTRIES
 * V 1.72:
     GRANT, SELECT, INSERT, UPDATE fr VIS_D0126, VIS_D012601 Auftragsverwaltung FM
 * V 1.71:
     GRANT SELECT, INSERT, UPDATE auf WKD_MOBIL_TOPTEN
 * V 1.70:
     GRANT UPDATE auf Ttigkieten fr Modul LM IP2 fr WS_BSS
 * V 1.69:
     GRANT SELECT auf WKD_MOBIL_T fr IP2 Kataloge-APP 0.3.5 (ANY USER)
 * V 1.68:
     GRANT EXECUTE auf BLV_EIN fr ETL-Job "Betriebe zu IP2 transferieren"
 * V 1.67:
     GRANT SELECT auf S52** fr BSS 3.3 ergnzt
 * V 1.66:
     SELECT auf IP1-IP2-Synchronisatiosn-Views UESICHT,
     und D_UESICHT_BTS (ber OBJECT_NAME LIKE 'D\_%' enthalten)
     Rechte an Funktionen:
       GetProbeMerkmalIDBySID
       GetMd5
 * V 1.65:
     INSERT: alle Untertabellen fr Vorgnge (VIS_D0302%)
 * ...
 * Historie entfernt mit V65
 *
 */

SET SERVEROUTPUT ON SIZE 1000000
spool oraGrantIP_to_Web.log
-- Globale Variablen
VARIABLE fehler          VARCHAR2(2000)
VARIABLE sUserBALVI_IP   VARCHAR2(30)
VARIABLE sUserBALVI_WEB  VARCHAR2(30)
VARIABLE sUserEFI_TRUNC  VARCHAR2(30)
VARIABLE sActUser        VARCHAR2(30)
VARIABLE REVOKE_ONLY     NUMBER
-- Verfahrensbezogene Konfiguration
--VARIABLE WS_BTR          NUMBER
VARIABLE WS_EFI          NUMBER
VARIABLE WS_EFI_DELETE   NUMBER
VARIABLE WS_PROBE_FM     NUMBER
VARIABLE WS_BSS          NUMBER
VARIABLE WS_RIOPP_FM     NUMBER

BEGIN
  /* ====================================================
        DEKLARATIVER TEIL! MUSS vom KUNDEN gendert
        bzw. an die korrekten SCHEMA-Namen angepasst
        werden!
        Die USER-Namen mssen in Grobuchstaben
        geschrieben sein, sonst werden sie nicht
        gefunden!
     ==================================================== */
  :sUserBALVI_IP := 'BALVI_IP1_SCHEMA';
  :sUserBALVI_WEB := 'WEBSERVICE_SCHEMA';

  -- Verfahrensbezogene Konfiguration
  -- Setzen Sie fr das jeweilige Verfahren eine 1

  -- BALVI Schnittstellenserver (BSS)
  :WS_BSS := 1;

  -- WebService BTR (Betriebsstttenregister) (NRW, TH)
  -- entfernt mit Update V57, setzen sie stattdessen bei WS_BSS := 1
  --:WS_BTR := 0;

  -- Probenahme Futtermittel im Browser(BY)
  :WS_PROBE_FM := 0;

  -- Risikoorientierte Probenplanung Futtermittel  RIOPP FM (BY)
  :WS_RIOPP_FM := 0;

  -- Verfahren "Export an EFi" (Status Pilotbetrieb).
  :WS_EFI := 0;
  -- Neu ab Version 35 des Grant-Skriptes ist die Mglichkeit, den Webuser
  -- fr das Lschen der Ausgangskrbe explizit zu berechtigen bzw. sogar einen
  -- explizit abweichenden User festzulegen. Die Konfiguration in der
  -- Job-Oberflche sieht vor, dass man die Oracle-Datenbank-Zugangsdaten fr
  -- das Lschen einstellen muss. Hier muss im Normalfall derselbe Oracle
  -- Datenbankbenutzer eingetragen werden, wie in der Tomcat-Verbindungs-
  -- konfiguration. In diesem Fall sollte, wenn WS_EFI := 1 eingestellt wurde,
  -- ebenfalls WS_EFI_DELETE := 1 eingestellt werden.
  -- Alternativen:
  -- 1.) Datenbank-Benutzer ndern
  --   Wenn bei :sUserEFI_TRUNC anstatt :sUserBALVI_WEB (Standard) ein anderer
  --   Oracle-Benutzername angegeben wird, wird das Lschrecht fr die EFi
  --   Ausgangskrbe Datenbankseitig exklusiv dem angegeben Datenbankbenutzer
  --   zugewiesen.
  -- 2.) Lschrecht verweigern
  --   Setzen Sie die Variablen WS_EFI_DELETE := 0, damit kein Lschrecht
  --   zugewiesen wird.
  :WS_EFI_DELETE := 0;
  -- Beispiel: Anderer Benutzer muss in der Datenbank existieren
  -- Entfernen Sie die fhrenden "--" vor der Variable :sUserEFI_TRUNC und
  -- setzen Sie den entsprechenden Oracle-Benutzer ein.
  --:sUserEFI_TRUNC := 'TEST_EFI_TRUNC';

  -- Falls alle zugewiesenen Rechte entfernt werden sollen,
  -- setzen Sie REVOKE_ONLY auf <> 0 (z.B. 1)
  :REVOKE_ONLY := 0;

  -- Fehlerprotokoll RESET
  :fehler := null;

  DBMS_OUTPUT.PUT_LINE('Dekaration:');
  DBMS_OUTPUT.PUT_LINE('Rechte von User: ' || :sUserBALVI_IP || ' fr User: ' || :sUserBALVI_WEB || ' zuweisen');
END;
/

DECLARE
 -- Rechteprfung:
 TYPE Tname IS RECORD (name VARCHAR2(100), len NUMBER(10));
 TYPE TPrivilege IS TABLE OF Tname INDEX BY BINARY_INTEGER;
 Privs TPrivilege;
 UserPrivs TPrivilege;
 
 i NUMBER(10);
 iCnt NUMBER(10);
 actUser VARCHAR2(30);
BEGIN
   /* ====================================================
           Rechte-Prfung des angemeldeten Benutzers
      ==================================================== */
   DBMS_OUTPUT.PUT_LINE('Rechteprfung');
   Privs(01).name := 'CREATE ANY SYNONYM';
   Privs(02).name := 'DROP ANY SYNONYM';
   Privs(03).name := 'GRANT ANY PRIVILEGE';
   Privs(04).name := 'GRANT ANY OBJECT PRIVILEGE';

   UserPrivs(01).name := 'CREATE SYNONYM';
   --UserPrivs(02).name := 'CREATE VIEW';
   
   -- Erweiterung User-Ausfhrung, Check wer wir sind?
   SELECT USER
   INTO actUser
   FROM DUAL;

   :sActUser := actUser;

   DBMS_OUTPUT.PUT_LINE('Angemeldet als: ' || :sActuser);

   IF :sActUser = 'SYS' THEN
    :fehler := 'Die Ausfhrung als SYS ist nicht mglich, verwenden Sie bitte SYSTEM';

   ELSE
      FOR i IN 1 .. Privs.COUNT LOOP

          SELECT COUNT(*)
          INTO iCnt
          FROM session_privs
          WHERE privilege = Privs(i).name;

          IF iCnt = 0 THEN
              :fehler := 'Der User hat keine ausreichenden Rechte zur Ausfhrung des Skripts.' || CHR(10) ||
                       'Fgen Sie dem User das Recht hinzu: ' || Privs(i).name;
          END IF;

       END LOOP;

     SELECT COUNT(*) INTO iCnt
     FROM ALL_USERS WHERE USERNAME IN (:sUserBALVI_IP , :sUserBALVI_WEB);

     IF iCnt <> 2 THEN
       :fehler := 'Min. ein angegebener Oracle User wurde nicht gefunden, prfen Sie die Angaben ' || 
       chr(10) || '=> :sUserBALVI_IP := ''' || :sUserBALVI_IP || '''' ||
       chr(10) || '=> :sUserBALVI_WEB := ''' || :sUserBALVI_WEB || '''';
     END IF;
     
     -- Benutzer-Berechtigungen fr "sUserBALVI_WEB" prfen
     
     FOR i IN 1 .. UserPrivs.COUNT LOOP
       IF :fehler IS NULL THEN
          SELECT COUNT(*)
          INTO iCnt
          FROM DBA_SYS_PRIVS
          WHERE PRIVILEGE = UserPrivs(i).name
            AND (GRANTEE = :sUserBALVI_WEB
              OR GRANTEE IN (SELECT GRANTED_ROLE FROM DBA_ROLE_PRIVS WHERE GRANTEE = :sUserBALVI_WEB)
              );

          IF iCnt = 0 THEN
              :fehler := :fehler || chr(10) || 'Der User ' || :sUserBALVI_WEB || ' hat nicht ausreichend Recht zur Ausfhrung des Skripts.' || CHR(10) ||
                       'Fgen Sie dem User das Recht hinzu: ' || UserPrivs(i).name;
          END IF;
        END IF;
      END LOOP;
   END IF;

END;
/

BEGIN
 IF :fehler IS NOT NULL THEN
    --:sUserBALVI_IP := NULL;
    RAISE_APPLICATION_ERROR(-20001,'Konfigurationsfehler gefunden:' || CHR(10) || :fehler);
  END IF;
END;
/

DECLARE
   sSQLGrant       VARCHAR2(1000);  -- Skriptvariable zum Generieren des GRANT-Befehls
   sSQLSynon       VARCHAR2(1000);  -- Skriptvariable zum Generieren des SYNONYM-Befehls
   sProt           VARCHAR2(4000);  -- Skriptvariable zum Generieren des Protokolls
BEGIN

   /* ====================================================
        Skript zur Lschung aller vorhandenen Synonyme
      ==================================================== */
  DBMS_OUTPUT.PUT_LINE('Vorhandene Synonyme entfernen:');
  FOR rec IN (SELECT OWNER,SYNONYM_NAME
              FROM   ALL_SYNONYMS
              WHERE  OWNER in (:sUserBALVI_WEB, NVL(:sUserEFI_TRUNC,'#'))
                --AND  TABLE_OWNER = :sUserBALVI_IP
                AND :fehler is null
             )
  LOOP
    sSQLSynon := 'DROP SYNONYM ' || rec.OWNER || '.' || rec.SYNONYM_NAME;
    EXECUTE IMMEDIATE sSQLSynon;
    DBMS_OUTPUT.PUT_LINE( sSQLSynon );
  END LOOP;

END;
/

DECLARE
   sSQLGrant       VARCHAR2(1000);  -- Skriptvariable zum Generieren des GRANT-Befehls
   sSQLSynon       VARCHAR2(1000);  -- Skriptvariable zum Generieren des SYNONYM-Befehls
   sProt           VARCHAR2(4000);  -- Skriptvariable zum Generieren des Protokolls
BEGIN

  /* ====================================================
        Skript zur Lschung aller vorhandenen Grants
      ==================================================== */
  DBMS_OUTPUT.PUT_LINE('vorhandene Grants entfernen');
  FOR rec IN (SELECT OWNER,TABLE_NAME,PRIVILEGE,GRANTEE
              FROM   DBA_TAB_PRIVS
              WHERE  GRANTEE = :sUserBALVI_WEB
                AND  OWNER   = :sUserBALVI_IP
                AND :fehler is null
             )
  LOOP
    sSQLGrant := 'REVOKE ' || rec.PRIVILEGE || ' ON ' || rec.OWNER || '.' || rec.TABLE_NAME || ' FROM ' || rec.GRANTEE;
    EXECUTE IMMEDIATE sSQLGrant;
    DBMS_OUTPUT.PUT_LINE( sSQLGrant );
  END LOOP;
END;
/

DECLARE
   sSQLGrant       VARCHAR2(1000);  -- Skriptvariable zum Generieren des GRANT-Befehls
   sSQLSynon       VARCHAR2(1000);  -- Skriptvariable zum Generieren des SYNONYM-Befehls
   sProt           VARCHAR2(4000);  -- Skriptvariable zum Generieren des Protokolls
   cnt             NUMBER(10);
BEGIN

   /* ====================================================
           Skript zur Generierung der Grant SELECT
      ==================================================== */
  DBMS_OUTPUT.PUT_LINE('Grants generieren - SELECT');
  FOR rec IN ( SELECT OBJECT_NAME, object_type, owner
               FROM ALL_OBJECTS
               WHERE
               (
                 -- Tabellen-Rechte
                 OBJECT_TYPE = 'TABLE' AND
                 (    OBJECT_NAME LIKE 'GLO\_A%'   ESCAPE '\' -- '\'
                   OR OBJECT_NAME LIKE 'VIS\_A%'   ESCAPE '\' -- '\'
                   OR OBJECT_NAME LIKE 'VIS\_D%'   ESCAPE '\' -- '\'
                   OR OBJECT_NAME = 'VIS_S00'
                   OR OBJECT_NAME = 'VIS_S04'
                   OR OBJECT_NAME LIKE 'VIS\_S07%' ESCAPE '\' -- '\'
                   OR OBJECT_NAME LIKE 'VIS\_S50%' ESCAPE '\' -- '\'
                   OR OBJECT_NAME LIKE 'VIS\_S52%' ESCAPE '\' -- '\'
                   OR OBJECT_NAME = 'VIS_S09'
                   OR OBJECT_NAME = 'WKD_SESSION'
                   OR OBJECT_NAME = 'WKD_BETRIEB'
                   OR OBJECT_NAME = 'WKD_D0101_MOBIL'
                   OR OBJECT_NAME = 'WKD_MOBIL_TB'
                   OR OBJECT_NAME LIKE 'WKD\_AVV%' ESCAPE '\' -- '\'
                   OR OBJECT_NAME = 'VIS_S1730'
                   OR OBJECT_NAME = 'VIS_S1731'
                   OR OBJECT_NAME = 'RN_KOPF'
                   OR OBJECT_NAME = 'RN_TEXTE'
                   OR OBJECT_NAME = 'RN_VERWEISE'
                   OR OBJECT_NAME = 'RN_VERW_EXT'
                   OR OBJECT_NAME LIKE 'D\_%' ESCAPE '\' -- '\'
                 )
                 -- View-Rechte
                 OR OBJECT_TYPE = 'VIEW' AND
                 (    OBJECT_NAME LIKE 'GLO\_VA%'   ESCAPE '\' -- '\'
                   OR OBJECT_NAME LIKE 'VIS\_VA%'   ESCAPE '\' -- '\'
                   OR OBJECT_NAME LIKE 'VIS\_VD%'   ESCAPE '\' -- '\'
                   OR OBJECT_NAME LIKE 'VIS\_VS07%' ESCAPE '\' -- '\'
                   OR OBJECT_NAME LIKE 'VIS\_VS50%' ESCAPE '\' -- '\'
                   OR OBJECT_NAME LIKE 'RIOPP%'
                 OR OBJECT_NAME = 'V10642_GEWICHTUNG'
                 --OR OBJECT_NAME LIKE 'VIS\_VD010102$ALLE%'
                 --OR OBJECT_NAME = 'D_MANDANT_ZU_GKZ'
                 OR OBJECT_NAME LIKE 'D\_%' ESCAPE '\' -- '\'
                 OR OBJECT_NAME LIKE 'UESICHT%'
                 )
               )
               -- BALVI_IP-Owner
               AND OWNER = :sUserBALVI_IP
               AND :fehler IS NULL
               AND :REVOKE_ONLY = 0
               ORDER BY 1
             )
  LOOP
    sProt := rec.OBJECT_NAME || ',' || rec.object_type || ' -> ';

    sSQLGrant := 'GRANT SELECT ON ' || rec.owner || '.' || rec.OBJECT_NAME || ' TO ' || :sUserBALVI_WEB;
    sSQLSynon := 'CREATE OR REPLACE SYNONYM ' || :sUserBALVI_WEB || '.' || rec.OBJECT_NAME || ' FOR ' || rec.owner || '.' || rec.OBJECT_NAME;
    sProt := sProt || chr(10) || sSQLGrant || chr(10) || sSQLSynon;

    EXECUTE IMMEDIATE sSQLGrant;
    BEGIN
      EXECUTE IMMEDIATE sSQLSynon;
    EXCEPTION
      WHEN OTHERS THEN sProt := sProt || ' ERROR => ' || SQLCODE || ': ' || SQLERRM;
    END;
    DBMS_OUTPUT.PUT_LINE( sProt );

  END LOOP;

END;
/

DECLARE
   sSQLGrant       VARCHAR2(1000);  -- Skriptvariable zum Generieren des GRANT-Befehls
   sSQLSynon       VARCHAR2(1000);  -- Skriptvariable zum Generieren des SYNONYM-Befehls
   sProt           VARCHAR2(4000);  -- Skriptvariable zum Generieren des Protokolls
   iAnz            NUMBER(10);
BEGIN

  /* ====================================================
           Skript zur Generierung der Grant EDIT
     ==================================================== */
  DBMS_OUTPUT.PUT_LINE('Grants generieren - Bearbeitungsrecht');

  --IF :WS_BTR = 1 THEN
  --  DBMS_OUTPUT.PUT_LINE('- BTR Betriebsstttenregister');
  --END IF;

  IF :WS_PROBE_FM = 1 THEN
    DBMS_OUTPUT.PUT_LINE('- Probenahme FM');
  END IF;

  IF :WS_BSS = 1 THEN
    DBMS_OUTPUT.PUT_LINE('- BALVI Schnittstellenserver');
  END IF;

  IF :WS_EFI = 1 THEN
    DBMS_OUTPUT.PUT_LINE('- eFI');
  END IF;

  IF :WS_RIOPP_FM = 1 THEN
    DBMS_OUTPUT.PUT_LINE('- Risikoorientierte Probenplanung FM');
  END IF;

  FOR rec IN ( SELECT OBJECT_NAME, OBJECT_TYPE, OWNER
               FROM ALL_OBJECTS
               WHERE
               (
                   -- Nur Tabellen-Rechte fr BTR-Schnittstelle
                   OBJECT_TYPE = 'TABLE' AND
                   (   -- FM Probenahme (BY)
                        (    OBJECT_NAME = 'WKD_BETRIEB'
                    OR OBJECT_NAME = 'WKD_PROBENAHME_FM'
                          OR OBJECT_NAME = 'VIS_D010110'
                          OR OBJECT_NAME LIKE 'VIS\_D010102%' ESCAPE '\' -- '\'
                          OR OBJECT_NAME = 'VIS_D010801'
                          OR OBJECT_NAME LIKE 'VIS\_D0113%' ESCAPE '\' -- '\'
                          OR OBJECT_NAME = 'VIS_D01080103'
                          OR OBJECT_NAME = 'VIS_D01080113'
                          OR OBJECT_NAME = 'VIS_D01080110'
                          OR OBJECT_NAME = 'VIS_D0303'
                          OR OBJECT_NAME = 'VIS_D0300'
                          OR OBJECT_NAME = 'VIS_D030301'
                          --OR OBJECT_NAME = 'VIS_D011301'
                          OR OBJECT_NAME LIKE 'VIS\_D0118%' ESCAPE '\' -- '\'
                          OR OBJECT_NAME = 'VIS_D0309'
                    ) AND :WS_PROBE_FM = 1
                    OR -- BALVI Schnittstellenserver allgemein
                        (    OBJECT_NAME = 'VIS_D0101'
                          OR OBJECT_NAME LIKE 'VIS\_D0120%'   ESCAPE '\' -- '\' 
                          OR OBJECT_NAME = 'VIS_D010104'
                          OR OBJECT_NAME = 'VIS_D010110'
                          OR OBJECT_NAME LIKE 'VIS\_D0102%' ESCAPE '\' -- '\'
                          OR OBJECT_NAME = 'VIS_D0103'
                          OR OBJECT_NAME = 'VIS_D0301'
                          OR OBJECT_NAME LIKE 'VIS\_D0302%'   ESCAPE '\' -- '\'
                          OR OBJECT_NAME = 'VIS_D0303'
                          OR OBJECT_NAME = 'WKD_D0303'
                          OR OBJECT_NAME = 'VIS_D0300'
                          OR OBJECT_NAME = 'VIS_D030301'
                          OR OBJECT_NAME LIKE 'VIS\_D010801%' ESCAPE '\' -- '\'
                          OR OBJECT_NAME = 'VIS_D010802'
                          OR OBJECT_NAME LIKE 'VIS\_D010803%' ESCAPE '\' -- '\'
                          OR OBJECT_NAME = 'VIS_D010804'
                          OR OBJECT_NAME LIKE 'VIS\_D010814'  ESCAPE '\' -- '\'
                          OR OBJECT_NAME = 'VIS_D01081901'
                          OR OBJECT_NAME LIKE 'VIS\_D010821%' ESCAPE '\' -- '\'
                          OR OBJECT_NAME LIKE 'VIS\_D0113%' ESCAPE '\' -- '\'
                          OR OBJECT_NAME LIKE 'VIS\_D0114%' ESCAPE '\' -- '\'
                          OR OBJECT_NAME = 'VIS_S31'
                          OR OBJECT_NAME = 'VIS_D91'
                          OR OBJECT_NAME = 'WKD_VIMPORT'
                          OR OBJECT_NAME = 'VIS_D800201'
                          OR OBJECT_NAME LIKE 'VIS\_D8001%'   ESCAPE '\' -- '\'
                          OR OBJECT_NAME LIKE 'VIS\_D8002%'   ESCAPE '\' -- '\'
                          OR OBJECT_NAME LIKE 'VIS\_D8007%'   ESCAPE '\' -- '\'
                          OR OBJECT_NAME LIKE 'VIS\_D0118%'   ESCAPE '\' -- '\'
                          OR OBJECT_NAME LIKE 'VIS\_D0115%'   ESCAPE '\' -- '\'
                          OR OBJECT_NAME LIKE 'VIS\_TD0115%'  ESCAPE '\' -- '\'
                          OR OBJECT_NAME LIKE 'WKD\_D0115%'   ESCAPE '\' -- '\'
                          OR OBJECT_NAME LIKE 'WKD\_MOBIL%'   ESCAPE '\' -- '\'
                          OR OBJECT_NAME LIKE 'WKD\_AVV%'     ESCAPE '\' -- '\'
                          OR OBJECT_NAME LIKE 'WKD\_FM%'      ESCAPE '\' -- '\'
                          OR OBJECT_NAME LIKE 'WKD\_UAMT%'    ESCAPE '\' -- '\'
                          OR OBJECT_NAME LIKE 'WKD\_TSK%'     ESCAPE '\' -- '\'
                          OR OBJECT_NAME LIKE 'AUS%'
                          OR OBJECT_NAME LIKE 'EIN%'
                          OR OBJECT_NAME = 'WKD_MOBIL_TOPTEN'
                          OR OBJECT_NAME = 'VIS_D0126'
                          OR OBJECT_NAME = 'VIS_D012601'
                          OR OBJECT_NAME = 'VIS_S99'
                          OR OBJECT_NAME = 'MOBIL_CLIENT_INFOS'
                          OR OBJECT_NAME = 'IP2_ID_MAPPING'
                          OR OBJECT_NAME LIKE 'DRT%'
                          -- BSS-eigene Tabellen (volle Rechte im Fall WS_BSS, auch DELETE)
                          OR OBJECT_NAME = 'BSS_ETL_JOBS'
                          OR OBJECT_NAME = 'BSS_ENDPOINTS'
                          OR OBJECT_NAME = 'DEPLOYABLE_RESOURCES'
                          OR OBJECT_NAME = 'JOB_DEF'
                          OR OBJECT_NAME = 'JOB_PARAM'
                          OR OBJECT_NAME = 'JOB_QUEUE_ENTRIES'
                          OR OBJECT_NAME = 'JOB_HISTORY_ENTRIES'
                          OR OBJECT_NAME = 'TEXT_FILE_REPOSITORY'
                          OR OBJECT_NAME = 'XML_EXP_DEF'
                          OR OBJECT_NAME = 'XML_IMP_DEF'
                        ) AND :WS_BSS = 1
                    OR -- EFi-Schnittstelle
                        (   OBJECT_NAME LIKE 'EFI\_%' ESCAPE '\' -- '\'
                        ) AND :WS_EFI = 1
                    OR -- RIOPP
                        (   OBJECT_NAME LIKE 'VIS\_D0118%' ESCAPE '\' -- '\'
                         OR OBJECT_NAME = 'VIS_D0113'
                         OR OBJECT_NAME = 'VIS_D0309'
                        ) AND :WS_RIOPP_FM = 1
                    OR -- Allgemeine Schreibrechte, alle WS
                      ( OBJECT_NAME = 'WKD_SESSION'
                     OR OBJECT_NAME = 'VIS_D90'
                     OR OBJECT_NAME = 'VIS_D91'
                     OR OBJECT_NAME = 'VIS_D92'
                     OR OBJECT_NAME = 'VIS_D0308'
                      )
                   )
               )
               -- BALVI_IP-Owner
               AND owner = :sUserBALVI_IP
               AND :fehler is null
               AND :REVOKE_ONLY = 0
               ORDER BY 1
             )
  LOOP
    sProt := rec.OBJECT_NAME || ',' || rec.object_type || ' -> ';

    sSQLGrant := 'GRANT SELECT,INSERT,UPDATE ON ' || rec.owner || '.' || rec.OBJECT_NAME || ' TO ' || :sUserBALVI_WEB;
    sSQLSynon := 'CREATE OR REPLACE SYNONYM ' || :sUserBALVI_WEB || '.' || rec.OBJECT_NAME || ' FOR ' || rec.owner || '.' || rec.OBJECT_NAME;
    sProt := sProt || chr(10) || sSQLGrant || chr(10) || sSQLSynon;

    EXECUTE IMMEDIATE sSQLGrant;
    --IF iAnz = 0 THEN
    BEGIN
      EXECUTE IMMEDIATE sSQLSynon;
    EXCEPTION
      WHEN OTHERS THEN sProt := sProt || ' ERROR => ' || SQLCODE || ': ' || SQLERRM;
    END;
    --END IF;
    DBMS_OUTPUT.PUT_LINE( sProt );

  END LOOP;
END;
/

DECLARE
   sSQLGrant       VARCHAR2(1000);  -- Skriptvariable zum Generieren des GRANT-Befehls
   sSQLSynon       VARCHAR2(1000);  -- Skriptvariable zum Generieren des SYNONYM-Befehls
   sProt           VARCHAR2(4000);  -- Skriptvariable zum Generieren des Protokolls
   iAnz            NUMBER(10);
BEGIN

  /* ====================================================
           Skript zur Generierung der Grant DELETE
     ==================================================== */
  DBMS_OUTPUT.PUT_LINE('Grants generieren - Lschsrecht');

  FOR rec IN ( SELECT OBJECT_NAME, OBJECT_TYPE, OWNER
               FROM ALL_OBJECTS
               WHERE
               (-- Nur Tabellen-Rechte fr eigene Tabellen des Kommunikationsservers,
                -- Arbeits- und Protokolltabellen fr Schnittstellen
                OBJECT_TYPE = 'TABLE' AND (
                     ( -- allgemeine physikalische! Lschrechte (alle Webservices)
                       OBJECT_NAME = 'VIS_D800201'
                     )
                    OR -- EFi-Schnittstelle
                     ( OBJECT_NAME LIKE 'EFI\_%' ESCAPE '\' -- '\'
                     ) AND :WS_EFI = 1
                    OR -- BSS-spezifische Lschrechte auf Tabellenebene
                     ( OBJECT_NAME LIKE 'WKD\_D0115%' ESCAPE '\' -- '\'
                    OR OBJECT_NAME = 'MOBIL_CLIENT_INFOS'
                    OR OBJECT_NAME = 'IP2_ID_MAPPING'
                    -- BSS-eigene Tabellen (volle Rechte im Fall WS_BSS, auch DELETE)
                    OR OBJECT_NAME = 'BSS_ETL_JOBS'
                    OR OBJECT_NAME = 'BSS_ENDPOINTS'
                    OR OBJECT_NAME = 'DEPLOYABLE_RESOURCES'
                    OR OBJECT_NAME = 'JOB_DEF'
                    OR OBJECT_NAME = 'JOB_PARAM'
                    OR OBJECT_NAME = 'JOB_QUEUE_ENTRIES'
                    OR OBJECT_NAME = 'JOB_HISTORY_ENTRIES'
                    OR OBJECT_NAME = 'TEXT_FILE_REPOSITORY'
                    OR OBJECT_NAME = 'XML_EXP_DEF'
                    OR OBJECT_NAME = 'XML_IMP_DEF'
                     ) AND :WS_BSS = 1
                 )
               )
               -- BALVI_IP-Owner
               AND owner = :sUserBALVI_IP
               AND :fehler is null
               AND :REVOKE_ONLY = 0
               ORDER BY 1
             )
  LOOP
    sProt := rec.OBJECT_NAME || ',' || rec.object_type || ' -> ';

    sSQLGrant := 'GRANT DELETE ON ' || rec.owner || '.' || rec.OBJECT_NAME || ' TO ' || :sUserBALVI_WEB;
    sSQLSynon := 'CREATE OR REPLACE SYNONYM ' || :sUserBALVI_WEB || '.' || rec.OBJECT_NAME || ' FOR ' || rec.owner || '.' || rec.OBJECT_NAME;
    sProt := sProt || chr(10) || sSQLGrant || chr(10) || sSQLSynon;

    EXECUTE IMMEDIATE sSQLGrant;

    --IF iAnz = 0 THEN
    BEGIN
      EXECUTE IMMEDIATE sSQLSynon;
    EXCEPTION
      WHEN OTHERS THEN sProt := sProt || ' ERROR => ' || SQLCODE || ': ' || SQLERRM;
    END;
    --END IF;

    DBMS_OUTPUT.PUT_LINE( sProt );

  END LOOP;
END;
/

DECLARE
   sSQLGrant       VARCHAR2(1000);  -- Skriptvariable zum Generieren des GRANT-Befehls
   sSQLSynon       VARCHAR2(1000);  -- Skriptvariable zum Generieren des SYNONYM-Befehls
   sProt           VARCHAR2(4000);  -- Skriptvariable zum Generieren des Protokolls
BEGIN

  /* ====================================================
           Skript zur Generierung der Grant EXECUTE
     ==================================================== */
  DBMS_OUTPUT.PUT_LINE('Grants generieren - EXECUTE');
  FOR rec IN ( SELECT OBJECT_NAME, object_type, owner
               FROM ALL_OBJECTS
               WHERE
               ( -- Types, Funktionen, Procedures oder Packages
                   (   OBJECT_TYPE = 'FUNCTION' OR OBJECT_TYPE = 'PROCEDURE'
                    OR OBJECT_TYPE = 'PACKAGE'  OR OBJECT_TYPE = 'TYPE')
                   AND ( -- Generelle Rechte an Types, Funktionen, Procedures oder Packages
                           (  OBJECT_NAME = 'ISNUMERIC'
                           OR OBJECT_NAME = 'GETNUMERIC'
                           OR OBJECT_NAME = 'BLV_SYS'
                           OR OBJECT_NAME = 'BLVUTILS'
                           OR OBJECT_NAME = 'FNC_S07'
                           OR OBJECT_NAME = 'FNC_S07$D010200'
                           OR OBJECT_NAME = 'BLV_SESSION'
                           OR OBJECT_NAME = 'TB_BEZ'
                           OR OBJECT_NAME = 'T_BEZ'
                           OR OBJECT_NAME = 'CREATEA01081088BEZ'
                           OR OBJECT_NAME = 'CRTNAME'
                           OR OBJECT_NAME = 'GETMD5'
                           OR OBJECT_NAME = 'GETPROBEMERKMALIDBYSID'
                           )
                           OR -- RIOPP
                            ( OBJECT_NAME = 'RIOPP_IP'
                           OR OBJECT_NAME = 'BLV_ITEST'
                           OR OBJECT_NAME = 'FTR_HELPER'
                            ) AND :WS_RIOPP_FM = 1
                           OR -- EFi-Schnittstelle
                            ( OBJECT_NAME = 'MD5HASH'
                            -- OR OBJECT_NAME = 'TRUNC_EFI_TABLES'
                            ) AND :WS_EFI = 1
                           OR -- EFi-Schnittstelle Ausgangskrbe lschen
                           ( OBJECT_NAME = 'TRUNC_EFI_TABLES'
                            ) AND :WS_EFI_DELETE = 1
                           OR -- BALVI Schnitttsellenserver
                           (  OBJECT_NAME LIKE 'TB\_PDA%' ESCAPE '\' -- '\'
                           OR OBJECT_NAME LIKE 'T\_PDA%'   ESCAPE '\' -- '\'
                           OR OBJECT_NAME LIKE 'PDA%'
                           OR OBJECT_NAME LIKE '%\_KATALOG' ESCAPE '\' -- '\'
                           OR OBJECT_NAME LIKE 'TT\_%' ESCAPE '\' -- '\'
                           OR OBJECT_NAME = 'BLV_DMS'
                           OR OBJECT_NAME = 'BLV_EIN'
                           OR OBJECT_NAME = 'BLV_RSK_FM'
                           OR OBJECT_NAME = 'ZBR_AUS'
                           OR OBJECT_NAME = 'ZBR_EIN'
                           OR OBJECT_NAME = 'ZBR_PLAUSI'
                           OR OBJECT_NAME = 'BLV_DUBLETTEN'
						   OR OBJECT_NAME = 'XGEWERBE'
                           OR OBJECT_NAME = 'SARCHIV'
                          ) AND :WS_BSS = 1
                     )
               )
           -- BALVI_IP-Owner
           AND owner = :sUserBALVI_IP
           AND :fehler is null
           AND :REVOKE_ONLY = 0
           ORDER BY 1
       )
  LOOP
    sProt := rec.OBJECT_NAME || ',' || rec.object_type || ' -> ';
    IF (REC.OBJECT_NAME = 'TRUNC_EFI_TABLES' AND :sUserEFI_TRUNC IS NOT NULL) THEN
      sSQLGrant := 'GRANT EXECUTE ON ' || rec.owner || '.' || rec.OBJECT_NAME || ' TO ' || :sUserEFI_TRUNC;
      sSQLSynon := 'CREATE SYNONYM ' || :sUserEFI_TRUNC || '.' || rec.OBJECT_NAME || ' FOR ' || rec.owner || '.' || rec.OBJECT_NAME;
    ELSE
      sSQLGrant := 'GRANT EXECUTE ON ' || rec.owner || '.' || rec.OBJECT_NAME || ' TO ' || :sUserBALVI_WEB;
      sSQLSynon := 'CREATE SYNONYM ' || :sUserBALVI_WEB || '.' || rec.OBJECT_NAME || ' FOR ' || rec.owner || '.' || rec.OBJECT_NAME;
    END IF;

    sProt := sProt || chr(10) || sSQLGrant || chr(10) || sSQLSynon;

    EXECUTE IMMEDIATE sSQLGrant;
    BEGIN
      EXECUTE IMMEDIATE sSQLSynon;
    EXCEPTION
      WHEN OTHERS THEN sProt := sProt || ' ERROR => ' || SQLCODE || ': ' || SQLERRM;
    END;

    DBMS_OUTPUT.PUT_LINE( sProt );

  END LOOP;

END;
/
