/*<TOAD_FILE_CHUNK>*/

ALTER SESSION SET
  PLSQL_CODE_TYPE = NATIVE
  PLSQL_OPTIMIZE_LEVEL = 3
  NLS_LENGTH_SEMANTICS = CHAR;
/

/**

ALTER SESSION SET PLSQL_CODE_TYPE = INTERPRETED;

ALTER SESSION SET PLSQL_OPTIMIZE_LEVEL = 0;

alter session set plsql_warnings = 'Enable:All', 'Disable:(6002, 6006, 6005, 6010)'; 
alter session set plsql_warnings = 'Disable:All';
**/ 
/*******************************************************************************
 Package zum Lesen und Auswerten des Eingangskorbs
 Daten zu einem Protokolleintrag werden komplett zur Verfgung gestellt
*******************************************************************************/

CREATE OR REPLACE PACKAGE xgewerbe AS
/* 
SVN Revisionsinformationen
$Revision: 1146 $
*/

  SUBTYPE tID IS VARCHAR2(32);
  TYPE trID IS RECORD ( ID tID );
  TYPE tbID IS TABLE OF trID;

  TYPE tIdList IS TABLE OF VARCHAR2(32);
  
  TYPE tRefCur IS REF CURSOR;  

  TYPE tKom IS RECORD ( TELEFON VARCHAR2(255), FAX VARCHAR2(255), MOBIL  VARCHAR2(255), EMAIL  VARCHAR2(255), INTERNET VARCHAR2(255));

  TYPE tAdr IS RECORD ( verw EIN_d_verwaltung%ROWTYPE,
                        kat  EIN_d_kataster%ROWTYPE,
                        padr EIN_d_postadresse%ROWTYPE,
                        adr  EIN_d_adresse%ROWTYPE,
                        typ  VARCHAR2(50) );                                               

  TYPE tAbt_Adr IS RECORD ( Abt EIN_d_abteilung%ROWTYPE,
                            Adr tAdr,
                            Adr2 tAdr);
  
  TYPE tbAbt_Adr IS TABLE OF tAbt_Adr;
  
  TYPE tbBTA_ABT IS TABLE OF EIN_r_bta_abt%ROWTYPE;

  TYPE tbBTA IS TABLE OF EIN_d_betriebsart%ROWTYPE;

  TYPE tbFachb IS TABLE OF EIN_d_fachbereiche%ROWTYPE;
  
  TYPE tbReg IS TABLE OF EIN_d_registrierung%ROWTYPE;
  
  TYPE tbUsecase IS TABLE OF EIN_d_usecase%ROWTYPE;                              
  
  TYPE tFkt IS RECORD( Fkt      EIN_d_funktion%ROWTYPE,
                       Pers     EIN_d_person%ROWTYPE,
                       Adr      tAdr,
                       Adr2     tAdr,
                       --Adr_PERS tAdr,
                       Reg      tbReg,
                       Kom      tKom);
  
  TYPE tbFkt IS TABLE OF tFkt;
  
  Type tBtr IS RECORD (
    betreiber tFkt,
    gv tbFkt,   -- gesetzliche Vertreter
    hv tbFkt ); -- Hauptverantwortliche
    
  TYPE tbBtr IS TABLE OF tBtr; 
                                   
  TYPE tBTS IS RECORD( Bts        EIN_d_betriebsstaette%ROWTYPE,
                       Usecases   tbUsecase,
                       Prot       EIN_d_protokoll%ROWTYPE,
                       Fachb      tbFachb,    -- Fachbereiche
                       Reg        tbReg,      -- Registierungen und Nummern
                       Abt_Adr    tbAbt_Adr,  -- Abteilungen mit Adresse
                       Bta        tbBta,      -- Betriebsarten      
                       Bta_Abt    tbBTA_ABT,  -- Betriebsarten-Abteilungen
                       Adr_BTRO   tAdr,   -- Standort der Betriebssttte
                       Adr_BTRO2  tAdr,   -- alte Daten
                       Adr_BTRA   tAdr,   -- Postanschrift der Betriebssttte
                       Adr_BTRA2  tAdr,   -- alte Daten 
                       Kom        tKom,   -- Kommunikationsmittel der Betriebssttte
                       bts_pers   tbFkt,  -- weitere Personen der Betriebssttte
                       Fkt_HV     tFkt,   -- Hauptverantwortlicher der Betriebssttte
                       --Fkt_INH    tFkt,   -- Betreiber 1. Ordnung
                       btr_pers   tbBtr   -- alle weiteren Betreiber n.-Ordnung (1..n) 
                       );                                        
  
  TYPE tA010145 IS RECORD(
    sid vis_a010145.sid%TYPE,
    code vis_a010145.code%TYPE,
    bez vis_a010145.bez%TYPE,
    fb vis_a010145.fb%TYPE,
    skz vis_a010145.skz%TYPE);
  
  TYPE tListData IS RECORD(
    bez VARCHAR2(50),
    wert VARCHAR2(250));
    
  TYPE tbListData IS TABLE OF tListData;
  
  TYPE tbFB IS TABLE OF VARCHAR2(1); -- INDEX BY VARCHAR2(1); 
   
  BTS1 tBts;  -- neue Betriebsstaette
  BTS2 tBts;  -- alte Werte Betriebsstaette
  vMandant_SID vis_d0101.mandant%TYPE := -1; -- Mandant
  vMANDANT_FBs vis_d0101.fb%TYPE;
  vUSER_SID    vis_d0101.upd_user%TYPE := -1;
  vErrMsg       CLOB   := NULL;
  vMessage      CLOB   := NULL;
  vGKZ2        VARCHAR2(2);
  vAus_Prot_ID aus_d_protokoll.id%TYPE;
  CRLF         CONSTANT VARCHAR2(4) := CHR(13);
  TAB          CONSTANT CHAR(1) := CHR(9);
  vCommit      PLS_INTEGER := 1;
  Default_gueltig_bis CONSTANT DATE := DATE '9999-01-01';
  Default_gueltig_von CONSTANT DATE := DATE '1920-12-31';
  vErrCnt      PLS_INTEGER := 0;
  vCnt         PLS_INTEGER := 0;

  --CreatedUseCase PLS_INTEGER := 0; -- nach dem Verarbeiten des Usecase wurde im Ausgangskorb ein neuer Usecase angelegt
  Anl_Min_D0101_ID3 VIS_D0101.D0101_ID3%TYPE := '-1';
  Anl_Min_D0101_ID3_2 VIS_D0101.D0101_ID3%TYPE := '-1'; -- Betreiber 2. Ordnung
  
  NRW CONSTANT VARCHAR2(2) := '05';
  vDateMin CONSTANT DATE := TO_DATE('31.12.1920', 'dd.mm.yyyy');
  vDateMax CONSTANT DATE := TO_DATE('01.01.9999', 'dd.mm.yyyy');

  INH CONSTANT VARCHAR2(3) := 'INH';
  Betreiber CONSTANT VARCHAR2(50) := 'Betreiber';
  --BetreiberN CONSTANT VARCHAR2(50) := 'Betreiber[n]'; -- bergeordnete Betreiber wenn Betreiber ein Komplementr ist
  HV_Betreiber CONSTANT VARCHAR2(50) := 'Hauptansprechpartner';  -- Hauptverantwortlicher des Betreibers
  --HV_BetreiberN CONSTANT VARCHAR2(50) := 'Hauptansprechpartner[n]'; -- Hauptverantwortlicher des Betreibers[n]
  GV_Betreiber CONSTANT VARCHAR2(50) := 'GesetzlicherVertreter'; -- 
  --GV_BetreiberN CONSTANT VARCHAR2(50) := 'GesetzlicherVertreter[n]'; -- 

  VERTRET_PERSON CONSTANT VARCHAR2(40) := 'vertretungsberechtigte Person';

  BI CONSTANT VARCHAR2(2) := 'BI';
  IDV CONSTANT VARCHAR2(10) := 'IDV';
  IDV_INH CONSTANT VARCHAR2(10) := 'IDV-INH';
  GEWERBE CONSTANT VARCHAR2(30) := 'GEWERBEREGISTRIERUNG';
  GEWERBE_CODE CONSTANT VARCHAR2(4) := '0113';
  BTRO CONSTANT VARCHAR2(4) := 'BTRO';
  BTRA CONSTANT VARCHAR2(4) := 'BTRA';

  DUBL_BTS CONSTANT VARCHAR2(15) := 'DUBLETTE_BTS';
  DUBL_BTR CONSTANT VARCHAR2(15) := 'DUBLETTE_BTR';
  
  StandortAdr CONSTANT VARCHAR2(20) := 'Standortadresse';  
  PostAdr CONSTANT VARCHAR2(20) := 'Postadresse';
  OrgStandortAdr CONSTANT VARCHAR2(20) := 'OrgStandortadresse'; -- Originale Standortadresse wenn Normierung statt fand
  OrgPostAdr CONSTANT VARCHAR2(20) := 'OrgPostadresse'; -- Originale Postadresse wenn Normierung statt fand

  HV CONSTANT VARCHAR2(2) := 'HV'; -- Hauptverantwortlicher der Betriebssttte
  BETREIBER_ID CONSTANT VARCHAR2(12) := 'BETREIBER_ID';
  XGEWERBE CONSTANT VARCHAR2(8) := 'XGewerbe';
  
  A010145_BETREIBER_ID CONSTANT NUMBER(10) := 1606001;
  A010145_HIT_NR CONSTANT NUMBER(10) := 514001;
  A010145_IDV_BETREIBER_ID CONSTANT NUMBER(10) := 1474008;
  A010145_GEWERBENR CONSTANT NUMBER(10) := 550001;
  
  A0302_05_RUHT CONSTANT NUMBER(10) := 625001;
  A0302_05_ERTEILT CONSTANT NUMBER(10) := 28001; -- Status erteilt
  A0101_03_SID_EK CONSTANT NUMBER(10) := 434001; -- Rechtsform eingetragener Kaufmann
  A0101_03_CODE_EK CONSTANT VARCHAR2(2) := '29'; -- Rechtsform eingetragener Kaufmann
  A0101_03_SID_GbR CONSTANT NUMBER(10) := 6; -- Rechtsform eingetragener Kaufmann
  A0101_03_CODE_GbR CONSTANT VARCHAR2(2) := '05'; -- Rechtsform eingetragener Kaufmann
    
  vINH VARCHAR2(20) := INH;
  vIDV VARCHAR2(20) := IDV;
  vIDV_INH VARCHAR2(20) := IDV_INH;
  vHV VARCHAR2(20) := HV;
  vBTRO VARCHAR2(20) := BTRO;
  vBTRA VARCHAR2(20) := BTRA;
  
  QUELLE_XGEWERBE CONSTANT VARCHAR2(20) := 'XGEWERBE';
  XGEWERBE_DUBL CONSTANT VARCHAR2(20) := 'XGEWERBE_DUBLETTE'; 
  PARAM_XGEWERBE_DUBL CONSTANT VARCHAR2(20) := 'XGEWERBE_DUBLETTE';
  PARAM_XGEWERBE_DUBL_ANZ CONSTANT VARCHAR2(20) := 'XGEWERBE_DUBL_ANZ';
  PARAM_XGEWERBE_GEWNR CONSTANT VARCHAR2(20) := 'XGEWERBE_GEWERBENR';
  PARAM_XGEWERBE_GEWNR2 CONSTANT VARCHAR2(20) := 'XGEWERBE_GEWERBENR2';
  --PARAM_XGEWERBE_FBFEHLER CONSTANT VARCHAR2(20) := 'XGEWERBE_FBFEHLER';
  PARAM_XGEWERBE_GBI CONSTANT VARCHAR2(20) := 'XGEWERBE_GBI';
  PARAM_XGEWERBE_RECHTSFORM CONSTANT VARCHAR2(20) := 'XGEWERBE_RECHTSFORM';
  XGEWERBE_TAG1 CONSTANT VARCHAR2(15) := '<PRUEFUNG>';
  XGEWERBE_TAG2 CONSTANT VARCHAR2(15) := '</PRUEFUNG>';
  XGEWERBE_MRK_REISE CONSTANT VARCHAR2(15) := 'Reisegewerbe'; 
   
  --PARAM_XGEWERBE_ADR_FEHLER CONSTANT VARCHAR2(20) := 'XGEWERBE_ADR_FEHLER';
     
-- XGewerbe Adressnormierung
CURSOR cAdrNorm (pBTS_IDs IN tb_bez) IS
  WITH adr AS (

    SELECT DISTINCT -- todo 70602090
       d1.*      
     , CASE WHEN IsNumeric(d1.padr_hausnr) = 1 THEN TO_NUMBER(d1.padr_Hausnr)
       ELSE 0
       END hausnr_num 
     , CASE WHEN d1.padr_hausnr IS NULL OR IsNumeric(d1.padr_hausnr) = 0 THEN 'G'
       WHEN MOD( TO_NUMBER(d1.padr_hausnr), 2) = 0 THEN 'G' ELSE 'U'
       END hausnrtyp1
       
     , CASE WHEN d1.padr_hausnr IS NULL OR IsNumeric(d1.padr_hausnr) = 0 THEN 'U'
       WHEN MOD( TO_NUMBER(d1.padr_hausnr), 2) = 0 THEN 'G' ELSE 'U'
       END hausnrtyp2

     , blv_Dubletten.Normierung1(d1.padr_plz) plz_norm
     , blv_Dubletten.Normierung1(d1.padr_ort) ort_norm
     , blv_Dubletten.Normierung1(d1.padr_ortsteil) ortsteil_norm
     , blv_Dubletten.Normierung1(d1.padr_strasse) strasse_norm
     , blv_Dubletten.Normierung1(d1.padr_hausnrzusatz) hausnrzusatz_norm
              
    FROM (  
      -- Adresse Betreiber etc.
      SELECT /*+ INDEX(FKT FK_EIN_D_FKT$D_BTS_ID) ) */  -- todo 70602090
        'FKT' adr_quelle, padr.id d_padr_id, fkt.d_bts_id, r1.typ adr_typ

      , CASE 
        WHEN fkt.typ LIKE Betreiber || '%'
          THEN '- Die Adresse des Betreibers' || 
            CASE WHEN fkt.typ IN ( Betreiber, Betreiber||'1') THEN NULL ELSE '(' || SUBSTR(fkt.typ, LENGTH(Betreiber)+1) || ')' END
            || ' wurde nicht im Adressverzeichnis gefunden.'
        WHEN fkt.typ LIKE HV_Betreiber ||'%' OR fkt.typ LIKE  GV_Betreiber || '%' THEN 
          NULL 
        --WHEN fkt.typ LIKE  GV_Betreiber || '%'
        --  THEN '- Die Adresse des gesetzlichen Vertreters' ||   
         --   CASE WHEN fkt.typ IN ( GV_Betreiber, GV_Betreiber||'1') THEN NULL ELSE '(' || SUBSTR(fkt.typ, LENGTH(GV_Betreiber)+1) || ')' END
        
        ELSE '- Die Adresse vom ' || fkt.typ || ' wurde nicht im Adressverzeichnis gefunden.'
        END  err_msg

       , padr.plz padr_plz, padr.ort padr_ort, padr.ortsteil padr_ortsteil, padr.strasse padr_strasse, padr.hausnr padr_hausnr, padr.hausnrzusatz padr_hausnrzusatz, padr.postfach padr_postfach
       , padr.glo_a24_sid, padr.staat   
       , adr.d_kat_id, adr.id d_adr_id, adr.d_verw_id, fkt.typ fkt_typ          
      FROM ein_d_funktion fkt 
      LEFT JOIN ein_r_fkt_adr r1        
      join ein_d_adresse adr on adr.id = r1.d_adr_id
      join ein_d_postadresse padr on padr.id = adr.d_padr_id
      --JOIN ein_d_protokoll prt on prt.d_bts_id = fkt.d_bts_id
      --AND prt.d0101_id = '-1'
      ON r1.d_fkt_id = fkt.id
      AND r1.typ = PostAdr  -- 'Postadresse'
      WHERE fkt.typ LIKE Betreiber || '%'
      AND fkt.d_bts_id IN ( SELECT dx.bez FROM TABLE ( pBTS_IDs ) dx ) -- todo 70602090
      
      UNION ALL -- todo 70602090

      -- Adresse Betriebssttte
      SELECT 'BTS' adr_quelle, padr.id padr_id, prt.d_bts_id, r1.typ adr_typ
       , '- Die ' || NVL(r1.typ, 'Standortadresse') || ' der Betriebssttte wurde nicht im Adressverzeichnis gefunden.' err_msg   
       , padr.plz, padr.ort, padr.ortsteil, padr.strasse, padr.hausnr, padr.hausnrzusatz, padr.postfach 
       , padr.glo_a24_sid, padr.staat 
       , adr.d_kat_id, adr.id d_adr_id, adr.d_verw_id, 'A' fkt_typ       
      FROM ein_d_protokoll prt
      LEFT JOIN ein_r_bts_adr r1
      join ein_d_adresse adr on adr.id = r1.d_adr_id
      join ein_d_postadresse padr on padr.id = adr.d_padr_id
        AND r1.typ IN( PostAdr, StandortAdr)  -- 'Postadresse', 'Standortadresse'
      --JOIN ein_d_protokoll prt 
      ON prt.d_bts_id = r1.d_bts_id
      --AND prt.d0101_id = '-1'
      WHERE prt.d_bts_id IN ( SELECT dx.bez FROM TABLE ( pBTS_IDs ) dx ) -- todo 70602090 
    ) d1 
     WHERE --d1.d_bts_id IN ( SELECT dx.bez FROM TABLE ( pBTS_IDs ) dx )              
        --AND d1.padr_PLZ IS NOT NULL 
        --AND d1.padr_ort IS NOT NULL
        --AND d1.padr_strasse IS NOT NULL
        --AND 
        d1.padr_postfach IS NULL 
        AND (d1.glo_a24_sid = 120 OR d1.staat = '276')
       
  )  -- END WITH
  
  SELECT adr.adr_quelle, adr.d_bts_id, adr.adr_typ, adr.d_padr_id, adr.d_kat_id, adr.d_adr_id, adr.d_verw_id
    , adr.padr_plz, adr.padr_ort, adr.padr_ortsteil, adr.padr_strasse, adr.padr_hausnr, adr.padr_hausnrzusatz, adr.padr_postfach
    , adr.glo_a24_sid, adr.staat, adr.err_msg, adr.fkt_typ
    , CASE 
      WHEN adr.d_kat_id <> '-1' THEN adr.d_kat_id
      WHEN a2701.rechtswert <> 0 AND a2701.hochwert <> 0 THEN RAWTOHEX( SYS_GUID() ) 
      END d_kat_id_neu 
    , CASE 
      WHEN adr.d_verw_id <> '-1' THEN adr.d_verw_id
      WHEN a27.gkz IS NOT NULL THEN RAWTOHEX( SYS_GUID() ) 
      END d_verw_id_neu

    , a27.id a27_id, a2701.id a2701_id, a27.plz a27_plz, a27.bez a27_strasse, a27.ort a27_ort, a27.ortsteil a27_ortsteil, a27.gkz a27_gkz
    , a2701.rechtswert a2701_rechtswert, a2701.hochwert a2701_hochwert, a2701.x_wert a2701_x_wert, a2701.y_wert a2701_y_wert --, A2701.GKZ14 
    , a2701.hausnr a2701_hausnr, a2701.hausnr_zusatz a2701_hausnr_zusatz
  FROM adr
  LEFT JOIN glo_a27 a27 ON a27.deleted = 0
      AND blv_Dubletten.Normierung1(a27.plz) = adr.PLZ_norm
      AND blv_Dubletten.Normierung1(a27.bez) = adr.Strasse_norm 
      AND blv_Dubletten.Normierung1(a27.ort) = adr.Ort_norm
      AND blv_Dubletten.Normierung1(a27.ortsteil) LIKE CASE WHEN adr.Ortsteil_norm IS NULL OR adr.Ortsteil_norm = CHR(9) THEN '%' ELSE adr.Ortsteil_norm END 
      AND A27.HAUSNR_TYP IN ('N', adr.Hausnrtyp1, adr.Hausnrtyp2) 
      AND adr.Hausnr_num BETWEEN a27.von_hausnr AND A27.BIS_HAUSNR  
  LEFT JOIN glo_a2701 a2701 ON A2701.GLO_A27_ID  = a27.id
    AND adr.Hausnr_num = a2701.hausnr
    AND blv_Dubletten.Normierung1(a2701.hausnr_zusatz) = adr.Hausnrzusatz_norm
    AND a2701.deleted = 0
  ORDER BY adr.fkt_typ
;    

TYPE tbAdrNorm IS TABLE OF cAdrNorm%ROWTYPE; 
 
-- XGewerbe Dublettensuche
CURSOR cDubletten (pBTS_IDs IN TB_BEZ) IS
  WITH btr as (
    SELECT 
     blv_dubletten.normierung1(pers.bezeichnung) bezeichnung
    , pers.bezeichnung prs_bez
    , blv_dubletten.normierung1(pers.nachname) nachname
    , blv_dubletten.normierung1(pers.vorname) vorname
    , blv_dubletten.normierung1(padr.strasse||padr.hausnr) strasse_hsnr
    , blv_dubletten.normierung1(padr.plz) plz
    , blv_dubletten.normierung1(padr.ort) ort
    , pers.typ
    , fkt.d_bts_id
    , bts.zb bts_zb
    --, count(*) over ( partition by null) cnt
    FROM ein_d_person pers
    join ein_d_funktion fkt on fkt.d_pers_id = pers.id
    AND fkt.typ LIKE Betreiber
    join ein_r_fkt_adr r1 on r1.d_fkt_id = fkt.id
    AND r1.typ = PostAdr
    join ein_d_adresse adr on adr.id = r1.d_adr_id
    join ein_d_postadresse padr on padr.id = adr.d_padr_id
    join ein_d_protokoll prt on prt.d_bts_id = fkt.d_bts_id
    and prt.d0101_id = '-1' and prt.parameter NOT LIKE '%'||PARAM_XGEWERBE_GBI||'=1%'
    --and prt.status = 30
    join ein_d_betriebsstaette bts on bts.id = fkt.d_bts_id
    and bts.id IN ( SELECT dx.bez FROM TABLE ( pBTS_IDs ) dx )
  )
    
  select --distinct
   case when d0.d0101_skz = 1 and d0.d0101_id3 = '-1' and d0.d0101_zb = d0.bts_zb then DUBL_BTS ELSE DUBL_BTR end usecase  
  , case when d0.d0101_id = d0.d0101_id3 then 0 else 1 end abw_btr
  , d0.*
  from (
    select /*INDEX(d0101 IDXT_D0101_NORM_ORT) */ 

     d0101.id d0101_id, d0101.code d0101_code, d0101.skz d0101_skz, d0101.d0101_id3, d0101.zb d0101_zb, d0101.daten_herkunft
    , d0101.bez d0101_bez, d0101.plz d0101_plz, d0101.ort d0101_ort, d0101.strasse || d0101.hausnr d0101_str_hsnr,  btr.* 
    from btr
    JOIN vis_d0101 d0101 ON d0101.deleted = 0 and d0101.skz IN (1,99) 
      AND blv_Dubletten.Normierung1(d0101.ort) = btr.ort 
    
    UNION --all
    
    select /*INDEX(d0101 IDXT_D0101_NORM_PLZ) */ 
     d0101.id d0101_id, d0101.code, d0101.skz, d0101.d0101_id3, d0101.zb d0101_zb, d0101.daten_herkunft
    , d0101.bez, d0101.plz, d0101.ort, d0101.strasse|| d0101.hausnr,  btr.* 
    from btr
    JOIN vis_d0101 d0101 ON d0101.deleted = 0 and d0101.skz IN (1,99)
      AND blv_Dubletten.Normierung1(d0101.plz) = btr.PLZ 
  ) d0
  where 

    ( 
      ( d0.typ = 'JP' AND blv_Dubletten.Normierung1(d0.d0101_bez) = d0.Bezeichnung )  
      OR    
      ( d0.typ = 'NP' AND INSTR( blv_Dubletten.Normierung2(d0.d0101_bez), d0.Nachname ) > 0
        AND ( d0.Vorname = CHR(9) OR INSTR( blv_Dubletten.Normierung2(d0.d0101_bez), d0.Vorname) > 0 )
      ) 
      OR
      blv_Dubletten.Normierung1(d0.d0101_str_hsnr) = d0.Strasse_hsnr  
    ) 
        
    and 
    (
      ( d0.d0101_id in ( select dx.d0101_id3 from vis_d0101 dx where dx.deleted = 0 and dx.skz IN (1,99) )

        and 
        
          (
            exists ( -- echter Betreiber mit Betriebssttten
              select 1 from vis_d0101 dx 
              where dx.deleted = 0 and dx.skz IN (1) 
              and dx.d0101_id3 = d0.d0101_id
              and dx.d0101_id3 <> dx.id  ) 
                      
          or
                      
          ( d0.d0101_skz = 99 
            and not exists ( -- ist nicht Betreiber 2. Ordnung
              select 1 from vis_d0101 d1
              where d1.d0101_id3 = d0.d0101_id
              and d1.deleted = 0
              and d1.id <> d1.d0101_id3 and d1.skz = 99 )
          )
                      
         )
         
      ) 
      -- Betriebssttte ohne Betreiber im ZB 
      OR ( d0.d0101_skz = 1 and d0.d0101_id3 = '-1' and d0.d0101_zb = d0.bts_zb )
    ) ;

TYPE tbDubletten IS TABLE OF cDubletten%ROWTYPE;

TYPE tD0102Dubl IS RECORD (
  prs_id tID,
  d010200_id tID,
  prs_bez VARCHAR2(500),
  d010200_bez VARCHAR2(500));

TYPE tbD0102Dubl IS TABLE OF tD0102Dubl;

FUNCTION GetD0102Dubl(pBTS_ID IN VARCHAR2, pD0101_ID IN VARCHAR2) RETURN tbD0102Dubl PIPELINED;
     
--  PROCEDURE StartUseCaseByBTS_ID(pBTS_ID VARCHAR2, pUsecase VARCHAR);
  PROCEDURE StartUseCaseByUseCase_ID(pID IN VARCHAR2, pConfirm IN PLS_INTEGER := 1);
  FUNCTION Fill_Bts1(pBTS_ID EIN_d_betriebsstaette.id%TYPE, pUsecase IN VARCHAR2) RETURN PLS_INTEGER;
  FUNCTION Fill_Bts2(pBTS_ID EIN_d_betriebsstaette.id%TYPE, pUsecase IN VARCHAR2) RETURN PLS_INTEGER;
  FUNCTION Fill_Bts(pBTS OUT NOCOPY tBTS, pBTS_ID IN EIN_d_betriebsstaette.id%TYPE, pBTS_NR IN PLS_INTEGER, pUsecase IN VARCHAR2) RETURN PLS_INTEGER;
  PROCEDURE UseCases;
  PROCEDURE UseCase( pUsecase VARCHAR2);
--  FUNCTION GetD010200_BEZ( pNName VARCHAR2, pVName VARCHAR2) RETURN VARCHAR2; 
  FUNCTION GetD010200_BEZ( pNName IN VARCHAR2, pVName IN VARCHAR2, 
                           pVorsatz IN VARCHAR2, pNachsatz IN VARCHAR2, 
                           pTitel IN VARCHAR2) RETURN VARCHAR2 DETERMINISTIC;  
  FUNCTION GetD010200_Bez(pD0101 IN vis_d0101%ROWTYPE) RETURN VARCHAR2 DETERMINISTIC;

  --FUNCTION Get_Bts1_AdrBtro_Verw RETURN zbr_tbVerw PIPELINED PARALLEL_ENABLE;
  --FUNCTION Get_Bts1 RETURN tbBTS;
  --FUNCTION Get_Bts1_Usecase RETURN tbUseCase PIPELINED PARALLEL_ENABLE;
  PROCEDURE ClearErrMsg;
  FUNCTION GetErrMsg RETURN CLOB; 
  FUNCTION GetErrCnt RETURN NUMBER; 
  PROCEDURE AddErrMsg( pMsg VARCHAR2);
    
  FUNCTION Compare( pS1 IN VARCHAR2, pS2 IN VARCHAR2) RETURN NUMBER;
  FUNCTION Compare( pS1 IN DATE, pS2 IN DATE) RETURN NUMBER;
  FUNCTION Compare( pS1 IN NUMBER, pS2 IN NUMBER) RETURN NUMBER;
  FUNCTION Compare( pS1 IN CLOB, pS2 IN CLOB) RETURN NUMBER;
  
  PROCEDURE UsecaseAlterNeuerWert(pUsecaseID IN VARCHAR2, pLDAP_User IN VARCHAR2, pUser_Name IN VARCHAR2 := NULL);
  PROCEDURE GetA010108(pExtCode IN VARCHAR2, pGewerbsmaessig IN NUMBER, 
            pStandard IN NUMBER, pArt IN VARCHAR2, vA010108_sid OUT PLS_INTEGER, 
            vA010108_sid0 OUT PLS_INTEGER, vBez OUT NOCOPY VARCHAR2, vCode OUT NOCOPY VARCHAR2, 
            vSkz OUT PLS_INTEGER, vFb OUT NOCOPY VARCHAR2,
            vAuswahl OUT PLS_INTEGER);
  FUNCTION GetD0101_ID RETURN VARCHAR2;
  FUNCTION GetCreatedUseCase RETURN NUMBER;
  FUNCTION GetAnl_Min_D0101_ID3 RETURN VARCHAR2;
  FUNCTION GetAnl_Min_D0101_ID3_2 RETURN VARCHAR2;
  FUNCTION GetUser_SID( pMandant_User IN VARCHAR2) RETURN NUMBER;
  FUNCTION Version RETURN VARCHAR2;
  PROCEDURE UsecaseConfirm( pUsecaseID IN VARCHAR2, pErrorCnt OUT NUMBER, pErrMsg OUT NOCOPY VARCHAR2 );
  PROCEDURE UsecaseReject( pUsecaseID IN VARCHAR2, pErrorCnt OUT NUMBER, pErrMsg OUT NOCOPY VARCHAR2 );
  FUNCTION GKZ2 RETURN VARCHAR2;
  PROCEDURE GKZ2 ( pGKZ2 IN VARCHAR2 );
  PROCEDURE Upd_EIN_ADR( pAdr IN OUT NOCOPY tAdr); 
  FUNCTION GET_GIS_SYSTEM RETURN NUMBER;
  FUNCTION GetZBbyGKZ8( pGKZ8 IN VARCHAR2) RETURN VARCHAR2 DETERMINISTIC; 
  FUNCTION CreateD0101P_Name( 
    pNname IN VARCHAR2, pVname IN VARCHAR2,
    pVorsatz IN VARCHAR2, pNachsatz  IN VARCHAR2, 
    pTITEL IN VARCHAR2) RETURN VARCHAR2 DETERMINISTIC;      
  FUNCTION CreateD0101Bez(
    pNName IN VARCHAR2, pVName IN VARCHAR2,
    pVorsatz IN VARCHAR2, pNachsatz  IN VARCHAR2, 
    pTitel IN VARCHAR2) RETURN VARCHAR2 DETERMINISTIC;                                                   
  PROCEDURE SplitNachname(
    pNName IN OUT NOCOPY VARCHAR2, 
    pVorsatz OUT NOCOPY VARCHAR2, pNachsatz OUT NOCOPY VARCHAR2)
    DETERMINISTIC;    
  FUNCTION GetD0101_IDByHitUc(pHitNr IN VARCHAR2, pUc IN VARCHAR2) RETURN tbID PIPELINED;
  FUNCTION GetD0101_IDByHitUc2(pHitNr IN VARCHAR2, pUc IN VARCHAR2) RETURN tID;
  PROCEDURE DeleteByProtID( pProtID IN tID); 
  PROCEDURE DeleteByBtsID( pBTS_ID IN tID, pAusgabe IN NUMBER := 0);
  PROCEDURE DeleteByUscID( pUscID IN tID);  
  PROCEDURE DeleteUscByS97;  
  PROCEDURE UpdateBetreiber_ID(pBTS_ID IN tID);
  PROCEDURE InsertD0300( pD010102_ID IN tID);
  PROCEDURE InsertD0300( pD010102_ID IN tbID);
  FUNCTION OutputDaten(pBTS_ID IN tID) RETURN tbListData PIPELINED;
  --PROCEDURE DublettenBtr_( pBTS_ID IN tID := NULL);
  PROCEDURE DublettenBtr( pBTS_IDs IN tb_bez);
  --FUNCTION XGewerbeCheck( pBTS_ID IN tID) RETURN VARCHAR2;
  PROCEDURE XGewerbeCheck( pBTS_IDs IN tb_bez, pErrMsg IN NUMBER );
  FUNCTION PrepairPrtQuelle( pQuelle IN VARCHAR2) RETURN VARCHAR2 DETERMINISTIC;
  FUNCTION BTA_FB_FEHLER(pBTS_ID IN VARCHAR2, pBTA_ID IN VARCHAR2, pFB IN VARCHAR2) RETURN tbBTA PIPELINED; 
  PROCEDURE SET_MANDANT_FB(pFB IN VARCHAR2);
PROCEDURE CopyAdrToOrg( pMainID IN VARCHAR2, pMainTyp IN VARCHAR2, pAdrID IN VARCHAR2, pAdrTyp IN VARCHAR2);
PROCEDURE Fill_Pers( pFkt IN EIN_d_funktion%ROWTYPE, pUsecaseAend IN NUMBER, pPers IN OUT NOCOPY tFkt, pAdrTyp IN tb_bez );
--FUNCTION IS_ID (pID IN tID) RETURN BOOLEAN;
--PROCEDURE NormierungAdr( pMainID IN tID, pMainTyp IN VARCHAR2, p1 IN OUT NOCOPY tAdr, pAdrBez IN VARCHAR2 );
FUNCTION AddProtParam(pParams IN VARCHAR2, pParam IN VARCHAR2, pValue IN VARCHAR2) RETURN VARCHAR2;
PROCEDURE AbschlussXGewerbe( pBtrBez IN NUMBER := 1, pAdrNorm IN NUMBER := 1, pDubl IN NUMBER := 1, pBAStd NUMBER := 1);
PROCEDURE AbschlussXGewerbeAuswahl(pBTS_IDs IN tb_BEZ, pBtrBez IN NUMBER := 1, pAdrNorm IN NUMBER := 1, pDubl IN NUMBER := 1, pBAStd NUMBER := 1);
FUNCTION AbschlussXGewerbeAnzahl RETURN NUMBER;
FUNCTION GetAdrNorm( pBTS_IDs IN tb_bez) RETURN tbAdrNorm PIPELINED;
FUNCTION GetDubletten( pBTS_IDs IN tb_bez) RETURN tbDubletten PIPELINED;
PROCEDURE CopyAdrToOrg( pBTS_IDs IN tb_bez);
PROCEDURE Fill_Komm( pTyp IN VARCHAR2, pID IN VARCHAR2, pKom OUT NOCOPY tKom);
PROCEDURE Upd_D0101_FB(pD0101_ID IN VARCHAR2);
PROCEDURE Insert_ein_d_fachbereich(pBTS_ID IN tID, pA0150_SID_LM IN NUMBER);
FUNCTION CONST_VERTRET_PERSON RETURN VARCHAR2 DETERMINISTIC;
FUNCTION CONST_Betreiber RETURN VARCHAR2 DETERMINISTIC;
FUNCTION CONST_HV_Betreiber RETURN VARCHAR2 DETERMINISTIC;
FUNCTION CONST_GV_Betreiber RETURN VARCHAR2 DETERMINISTIC;
FUNCTION CONST_Dubl_Btr RETURN VARCHAR2 DETERMINISTIC;
FUNCTION CONST_Dubl_Bts RETURN VARCHAR2 DETERMINISTIC;
FUNCTION VERFAHREN_XGEWERBE RETURN VARCHAR2 DETERMINISTIC;
FUNCTION RemoveTags(pValue IN VARCHAR2) RETURN VARCHAR2;
FUNCTION RemoveTags(pValue IN CLOB) RETURN CLOB;
PROCEDURE UpdByGBI(pBTS_IDs IN tb_bez);
END xgewerbe;
/

/**

kompletten Eingangskorb lschen

DELETE EIN_D_VERWALTUNG;
DELETE EIN_D_POSTADRESSE;
DELETE EIN_D_KATASTER;
DELETE EIN_D_ADRESSE;

TRUNCATE TABLE EIN_D_PROTOKOLL;
DELETE EIN_D_REGISTRIERUNG;
TRUNCATE TABLE EIN_D_TAETIGKEIT;
TRUNCATE TABLE EIN_D_TIERANGABEN;
DELETE EIN_D_USECASE;
TRUNCATE TABLE EIN_D_FACHBEREICHE;
DELETE EIN_D_BEZIEHUNG;
DELETE EIN_D_BEHOERDE;
TRUNCATE TABLE EIN_D_GESPERRT;
DELETE EIN_D_BETRIEBSART;


DELETE EIN_D_ABTEILUNG;

DELETE EIN_D_FUNKTION;
DELETE EIN_D_KOMMUNIKATION;
DELETE EIN_D_PERSON;

DELETE EIN_D_BETRIEBSSTAETTE;

select 'bts' alias, count(*) from ein_d_betriebsstaette union all
select 'prt' alias, count(*) from ein_d_protokoll union all
select 'usc' alias, count(*) from ein_d_usecase union all
select 'bta' alias, count(*) from ein_d_betriebsart union all
select 'fb' alias, count(*) from ein_d_fachbereiche union all
select 'tir' alias, count(*) from ein_d_tierangaben union all
select 'abt' alias, count(*) from ein_d_abteilung union all
select 'reg' alias, count(*) from ein_d_registrierung union all
select 'r_bts_adr' alias, count(*) from ein_r_bts_adr union all
select 'r_fkt_adr' alias, count(*) from ein_r_fkt_adr union all
select 'adr' alias, count(*) from ein_d_adresse union all
select 'verw' alias, count(*) from ein_d_verwaltung union all
select 'padr' alias, count(*) from ein_d_postadresse union all
select 'kat' alias, count(*) from ein_d_kataster union all
select 'pers' alias, count(*) from ein_d_person union all
select 'komm' alias, count(*) from ein_d_kommunikation union all
select 'fkt' alias, count(*) from ein_d_funktion

**/

/*<TOAD_FILE_CHUNK>*/

CREATE OR REPLACE PACKAGE BODY xgewerbe AS
/* 
SVN Revisionsinformationen
$Revision: 1146 $
*/

-- forward declaration
PROCEDURE BetreiberPersonal(pChkPersonalDublette IN BOOLEAN);

PROCEDURE SET_MANDANT_FB(pFB IN VARCHAR2) AS
BEGIN
  vMANDANT_FBs := pFB;
END SET_MANDANT_FB;

--PROCEDURE Fill_Komm( pTyp IN VARCHAR2, pID IN VARCHAR2, pKom OUT NOCOPY tKom);

FUNCTION PrepairPrtQuelle( pQuelle IN VARCHAR2) RETURN VARCHAR2 DETERMINISTIC AS
vRes VARCHAR2(20);
BEGIN

  CASE
  WHEN pQuelle = QUELLE_XGEWERBE THEN
    vRes := QUELLE_XGEWERBE;
  ELSE NULL; 
  END CASE;
  
  RETURN vRes;
  
END PrepairPrtQuelle;

FUNCTION CheckPrtQuelle RETURN BOOLEAN DETERMINISTIC AS
vRes BOOLEAN := FALSE;
BEGIN

  CASE bts1.prot.quelle
  WHEN Quelle_XGewerbe THEN
    vRes := TRUE;
  ELSE  
    AddErrMsg('Das Verfahren (Quelle) kann nicht verarbeitet werden: ' || bts1.prot.quelle);
  END CASE;
  
  RETURN vRes;
END CheckPrtQuelle;

FUNCTION IS_ID (pID IN tID) RETURN BOOLEAN DETERMINISTIC AS
BEGIN

  --RETURN LENGTH(pID) = 32 ;
  RETURN pID NOT IN ('-1', '-2', '-3', '-9999', 'NO_DATA_FOUND') AND pID IS NOT NULL;
  
END IS_ID;

FUNCTION GetAnl_Min_D0101_ID3 RETURN VARCHAR2 AS
BEGIN
  RETURN Anl_Min_D0101_ID3;
END GetAnl_Min_D0101_ID3;  
FUNCTION GetAnl_Min_D0101_ID3_2 RETURN VARCHAR2 AS
BEGIN
  RETURN Anl_Min_D0101_ID3_2;
END GetAnl_Min_D0101_ID3_2;  

FUNCTION GetCreatedUseCase RETURN NUMBER AS
BEGIN
  --RETURN CreatedUseCase;
  RETURN 0;
END;  

FUNCTION GetErrCnt RETURN NUMBER AS
BEGIN
  RETURN vErrCnt;
END;

PROCEDURE AddErrCnt AS
BEGIN
  vErrCnt := vErrCnt + 1;
END;

PROCEDURE AddErrMsg( pMsg IN VARCHAR2) AS
BEGIN
  vErrMsg := vErrMsg || pMsg || CRLF;
  vErrCnt := vErrCnt + 1;
END;

PROCEDURE AddMsg( pMsg IN VARCHAR2) AS
BEGIN
  vMessage := vMessage || pMsg || CRLF;
END;

FUNCTION GetErrMsg RETURN CLOB AS
v1 CLOB;
BEGIN
  If vMessage IS NOT NULL THEN
    v1 := vMessage || CRLF || vErrMsg;
  ELSE
    v1 := vErrMsg;
  END IF;
  RETURN v1;
END;

PROCEDURE ClearErrMsg AS
BEGIN
  vErrMsg := NULL;
  vMessage := NULL;
  vErrCnt := 0;
END;

-- aus einem kompletten Nachnamen mit Vorsatz und Nachsatz diese herausfiltern 
-- und in die entsprechenden Felder schreiben
PROCEDURE SplitNachname(pNName IN OUT NOCOPY VARCHAR2, pVorsatz OUT NOCOPY VARCHAR2, pNachsatz OUT NOCOPY VARCHAR2) DETERMINISTIC AS
vNN VARCHAR2(500) := pNName;
vVor VARCHAR2(500) := NULL;
vNach VARCHAR2(500) := NULL;
BEGIN
 
  IF vNN IS NOT NULL AND INSTR(vNN, ' ') > 0 THEN 
    BEGIN
      SELECT bez INTO vVor 
      FROM (
        SELECT ax.sid, ax.bez
        FROM vis_a0101 ax 
            WHERE ax.deleted > -2 AND ax.skz = 73 
            AND vNN LIKE ax.bez || ' %'
            ORDER BY LENGTH(ax.bez) DESC NULLS LAST
        ) 
      WHERE ROWNUM = 1; 

      EXCEPTION 
      WHEN NO_DATA_FOUND THEN
        vVor := NULL;
    END;    

    BEGIN
      SELECT bez INTO vNach 
      FROM (
        SELECT ax.sid, ax.bez
        FROM vis_a0101 ax 
            WHERE ax.deleted > -2 AND ax.skz = 74 
            AND vNN LIKE '% ' || ax.bez 
            ORDER BY LENGTH(ax.bez) DESC NULLS LAST
        ) 
      WHERE ROWNUM = 1; 
      
      EXCEPTION 
      WHEN NO_DATA_FOUND THEN
        vNach := NULL;
    END;  

    -- Vorsatz entfernen
    IF vVor IS NOT NULL THEN
      vNN := SUBSTR(vNN, LENGTH(vVor) + 1);
    END IF;

    -- Nachsatz entfernen
    IF vNach IS NOT NULL THEN
      vNN := TRIM(SUBSTR(vNN, 1, LENGTH(vNN) - LENGTH(vNach)));
    END IF;
  END IF;  
  
  pNName := TRIM( TRAILING ',' FROM vNN);
  pVorsatz := vVor;
  pNachsatz := vNach;
  
END SplitNachname;

FUNCTION CrtRegBez(p1 IN VARCHAR2) RETURN VARCHAR2 DETERMINISTIC AS
vRes VARCHAR2(100); 
BEGIN
  IF bts1.prot.quelle = QUELLE_XGEWERBE THEN
    vRes := 'Gewerberegistrierung';
  ELSE
    --vRes := vBI_IDV || '-Registriernummer';
    vRes := p1 || '-Registriernummer';
  END IF;
  RETURN vRes;
END;

-- Erzeugt die Bezeichnung fr den Betrieb aus dem Namen einer natrl. Person
FUNCTION CreateD0101Bez(pNName IN VARCHAR2, pVName IN VARCHAR2,
                         pVorsatz IN VARCHAR2, pNachsatz  IN VARCHAR2, 
                         pTitel IN VARCHAR2) RETURN VARCHAR2 DETERMINISTIC AS
v1 VARCHAR2(450);
BEGIN

  v1 := Pnname ||
         CASE WHEN pvname || pVorsatz IS NOT NULL THEN  ', ' || TRIM(pvname || ' ' || pVorsatz) END || 
         CASE WHEN pNachsatz IS NOT NULL THEN  ', ' || pNachsatz END || 
         CASE WHEN pTITEL IS NOT NULL THEN ', ' || pTITEL END;

  -- todo 69675090 Anpassung aus blv_ein bernommen
  IF LENGTH(v1) > 128 THEN
    v1 := SUBSTR(v1, 1, 126) || '..';
  END IF;
  
  RETURN v1;
END CreateD0101Bez;

-- Erzeugt die Bezeichnung einer natrl. Person aus deren Namen
FUNCTION GetD010200_BEZ( pNName IN VARCHAR2, pVName IN VARCHAR2, 
                         pVorsatz IN VARCHAR2, pNachsatz IN VARCHAR2, 
                         pTitel IN VARCHAR2) RETURN VARCHAR2 DETERMINISTIC  AS
  v1 VARCHAR2(450);
  PROCEDURE Add_v1( p1 IN VARCHAR2, p2 IN VARCHAR2) AS
  BEGIN
    IF p1 IS NOT NULL THEN
      IF v1 IS NULL THEN
        v1 := p1;
      ELSE
        v1 := TRIM(v1) || p2 || p1;
      END IF; 
    END IF;
  END;
BEGIN
  v1 := pTitel;
  --Add_V1(TRIM(pTitel), ' ');
  Add_V1(TRIM(pVname), ' ');
  Add_V1(TRIM(pVorsatz), ' ');
  Add_V1(TRIM(pNname), ' ');
  Add_V1(TRIM(pNachsatz), ', ');

  IF LENGTH(v1) > 128 THEN
    v1 := SUBSTR(v1, 1, 126) || '..';
  END IF;

  RETURN v1;   
 
END GetD010200_BEZ;


-- Registrierungszuordnung
PROCEDURE GetA010145( pArt IN VARCHAR2, pCode IN VARCHAR2,
  vA010145_sid OUT PLS_INTEGER, 
  vA010145_bez OUT NOCOPY VARCHAR2, 
  vA010145_fb OUT NOCOPY VARCHAR2,
  vA010145_Code OUT NOCOPY VARCHAR2,
  vA010145_SKZ OUT PLS_INTEGER) DETERMINISTIC AS
  
 vCode vis_a010145.code%TYPE;
 vSKZ vis_a010145.skz%TYPE;
 FUNCTION ExistsReg(pCode IN VARCHAR2) RETURN BOOLEAN AS
 --vRes BOOLEAN := FALSE;
 vCnt PLS_INTEGER;
 BEGIN
 
  SELECT COUNT(*) 
  INTO vCnt
  FROM ein_d_betriebsart ba
  WHERE ba.d_bts_id = bts1.bts.id
  AND ba.art = 'HFMUN'
  AND ba.Code = pCode;
  
  RETURN (vCnt > 0);
 END;
BEGIN
   
  CASE UPPER(pArt) 
  WHEN 'TSK' THEN 
    vA010145_Code := '0104';    
  WHEN 'INVEKO' THEN 
    vA010145_Code := '0118';
  WHEN IDV THEN  
    vA010145_Code := '01901301';
  WHEN IDV_INH THEN  
    vA010145_Code := '01901302';
  WHEN BI THEN  
    vA010145_Code := '0102';
  WHEN 'UI' THEN  
    vA010145_Code := '010201';
  WHEN 'PI' THEN  
    vA010145_Code := '010202';
  WHEN BETREIBER_ID THEN  
    vA010145_Code := '0103';
  WHEN 'FMZULNR' THEN  
    vA010145_Code := '011103%';
  WHEN 'FMZULREG' THEN
    
    CASE
    WHEN ExistsReg('R51') THEN
      vA010145_Code := '02110401';
    WHEN ExistsReg('R52') THEN  
      vA010145_Code := '02110402';
    ELSE
      AddErrMsg('Fr den Registrierungs-Code "' || pArt || '" fehlt einer der Betriebstypen R51 und R52.');
    END CASE;
  /* todo 59528090 21.03.2017 nach Absprache mit CD nicht mehr notwendig
  WHEN GEWERBE THEN
    vA010145_Code := GEWERBE_CODE;    
  WHEN 'HANDELSREGISTER B' THEN
    vA010145_Code := '010902';   */
  ELSE 
    IF bts1.prot.quelle = QUELLE_XGEWERBE THEN
      vA010145_Code := pCode;
    END IF;
  END CASE;

  vSKZ := 
    CASE UPPER( pArt )
    WHEN 'FMZULNR' THEN 60
    WHEN 'FMZULREG' THEN 70
    ELSE 10 END; 
  
  vA010145_SKZ := vSKZ;
  IF vA010145_Code IS NOT NULL THEN
    vCode := RTRIM(vA010145_Code, '%'); -- % abschneiden
    SELECT sid, bez, fb INTO  
      vA010145_sid , vA010145_bez, vA010145_fb
    FROM vis_a010145
    WHERE deleted > -2
     AND code = vCode 
     AND skz = vSKZ;
   END IF;
   EXCEPTION WHEN no_data_found THEN AddErrMsg('Registrierungs-Code "' || pArt || '" ist nicht vorhanden.');
             WHEN too_many_rows THEN AddErrMsg('Registrierungs-Code "' || pArt || '" ist mehrfach vorhanden.'); 

END GetA010145;

PROCEDURE GetA010145(pArt IN VARCHAR2, pCode IN VARCHAR2, pA010145 IN OUT NOCOPY tA010145) AS 
BEGIN
  GetA010145(
    pArt, pCode, 
    pA010145.sid, 
    pA010145.bez, 
    pA010145.fb,
    pA010145.Code,
    pA010145.SKZ); 
END GetA010145;


FUNCTION GetD010200_Bez(pD0101 IN vis_d0101%ROWTYPE) RETURN VARCHAR2 DETERMINISTIC AS
BEGIN
  RETURN GetD010200_Bez(pD0101.nname, pD0101.vname, pD0101.vorsatz_nname, pD0101.nachsatz_nname, pD0101.titel);
END;
 
-- Generieren Bezeichnung: Titel Vorname Vorsatz Nachname, Nachsatz 
FUNCTION CreateD0101P_Name( pNname IN VARCHAR2, pVname IN VARCHAR2,
                            pVorsatz IN VARCHAR2, pNachsatz  IN VARCHAR2, 
                            pTITEL IN VARCHAR2) RETURN VARCHAR2 DETERMINISTIC AS
v1 VARCHAR2(450);
  PROCEDURE Add_v1( p1 IN VARCHAR2, p2 IN VARCHAR2) AS
  BEGIN
    IF p1 IS NOT NULL THEN
      IF v1 IS NULL THEN
        v1 := p1;
      ELSE
        v1 := TRIM(v1) || p2 || p1;
      END IF; 
    END IF; 
  END;
BEGIN

  v1 := pTitel;
  Add_v1(pVName, ' ');
  Add_v1(pVorsatz, ' ');
  Add_v1(pNName, ' ');
  Add_v1(pNachsatz, ', ');

  IF LENGTH(v1) > 128 THEN
    v1 := SUBSTR(v1, 1, 126) || '..';
  END IF;
  
  RETURN v1;
         
END CreateD0101P_Name;

PROCEDURE UpdBTS_HV(pD0101_ID IN VARCHAR2, pPers IN EIN_d_person%ROWTYPE) AS
BEGIN
  UPDATE vis_d0101
  SET d010200_id2 = pPers.ref_id --vD010200_ID
    , nname = pPers.nachname
    , vname = pPers.vorname
    , anrede = pPers.anrede
    , titel = pPers.titel
    , nachsatz_nname = pPers.nachsatz_nachname
    , vorsatz_nname = pPers.vorsatz_nachname
  WHERE id = pD0101_ID
  AND d010200_id2 = '-1'; -- todo 65101090 nur wenn noch kein HV eingetragen ist
END UpdBTS_HV;

PROCEDURE UpdBTS_HV_FROM_BTR(pD0101_ID IN VARCHAR2) AS
vPers ein_d_person%ROWTYPE;
  
CURSOR c1 (pID IN VARCHAR2) IS 
    SELECT d1.d010200_ID2 BTS_D010200_ID2
    , d3.d010200_id2 BTR_D010200_ID2
    , d3.nname 
    , d3.vname 
    , d3.anrede, d3.titel
    , d3.nachsatz_nname
    , d3.vorsatz_nname 
    FROM vis_d0101 d1
    JOIN vis_d0101 d3 ON d3.id = d1.d0101_id3
    WHERE d1.id = pID; 
vC1 c1%ROWTYPE;      
BEGIN
  IF BTS1.btr_pers(1).Betreiber.pers.rechtsform IN (
    '01', --Einzelunternehmer
    '34', --sonstige natrliche Person
    '3402', --Sonstige auslndische Rechtsform - natrliche Person
    '3401', --sonstige auslndische Rechtsform nach EU-Recht - natrliche Person
    '29' --eingetragener Kaufmann/frau
  ) THEN 
    
    OPEN c1 (pD0101_ID);
    FETCH c1 INTO vC1;
      
    IF c1%ROWCOUNT > 0 THEN
      IF vC1.BTS_D010200_ID2 = '-1' AND vC1.BTR_D010200_ID2 <> '-1' THEN

        vPers.ref_id := vC1.BTR_D010200_ID2;
        vPers.vorname := vC1.vname;
        vPers.nachname := vC1.nname;
        vPers.vorsatz_nachname := vC1.vorsatz_nname;
        vPers.nachsatz_nachname := vC1.nachsatz_nname;
        vPers.anrede := vC1.anrede;
        vPers.titel := vC1.titel;
        UpdBTS_HV(bts1.prot.d0101_id, vPers);

      END IF;
    END IF;
    CLOSE C1;          

  END IF;      
END UpdBTS_HV_FROM_BTR;


Function GetAdresse(pAdr_ID IN EIN_D_ADRESSE.ID%TYPE, pTyp IN VARCHAR2) RETURN tAdr AS
  res tAdr := NULL;
BEGIN

  IF pADR_ID IS NOT NULL THEN
  
    res.typ := pTyp;

    SELECT * INTO res.adr
    FROM EIN_d_adresse 
    WHERE ID = pAdr_ID;
   
    IF res.adr.d_verw_id IS NOT NULL THEN      
      SELECT * INTO res.verw
      FROM EIN_D_VERWALTUNG
      WHERE id = res.adr.d_verw_id;               
    END IF; 

    IF res.adr.d_kat_id IS NOT NULL THEN
      SELECT * INTO res.kat
      FROM EIN_D_KATASTER
      WHERE id = res.adr.d_kat_id;               
    END IF;     


    IF res.adr.d_padr_id IS NOT NULL THEN
      SELECT * INTO res.padr
      FROM EIN_D_POSTADRESSE
      WHERE id = res.adr.d_padr_id;
      
      -- todo 53007090
      --IF res.padr.hausnr = '.' THEN -- wird wie ohne Hausnr. interpretiert
      --  res.padr.hausnr := NULL;
      --END IF;      
                     
    END IF;     
 
  END IF;
 
  RETURN res;
END GetAdresse;

-- pMainTyp: BTS / FKT
-- pMain_ID: D_BTS_ID oder D_FKT_ID
-- pAdrTyp: Standortadresse, Postadresse 
PROCEDURE CopyAdrToOrg( pMainID IN VARCHAR2, pMainTyp IN VARCHAR2, pAdrID IN VARCHAR2, pAdrTyp IN VARCHAR2) AS
vAdr tAdr; 

CURSOR cR_BTS (pID IN VARCHAR2, pTyp IN VARCHAR2) IS
  SELECT 1
  FROM ein_r_bts_adr d1
  WHERE d1.typ = pTyp
    AND d1.d_bts_id = pID;
    
CURSOR cR_FKT (pID IN VARCHAR2, pTyp IN VARCHAR2) IS
  SELECT 1
  FROM ein_r_fkt_adr d1
  WHERE d1.typ = pTyp
    AND d1.d_fkt_id = pID;
  
v1 NUMBER(10);
vOrgAdrTyp VARCHAR2(50) := 'Org'||pAdrTyp;  
BEGIN
 
  IF pMainTyp IN('BTS', 'FKT') AND IS_ID(pMainID) THEN
    
    CASE pMainTyp
    WHEN 'BTS' THEN 
    
      OPEN cR_BTS(pMainID, vOrgAdrTyp);
      FETCH cR_BTS INTO v1;      
      CLOSE cR_BTS;
    
    WHEN 'FKT' THEN
    
      OPEN cR_FKT(pMainID, vOrgAdrTyp);
      FETCH cR_FKT INTO v1;      
      CLOSE cR_FKT;
    
    END CASE;
    
    IF v1 IS NULL THEN -- wenn Kopie schon vorhanden dann Abbruch
    
      vAdr := GetAdresse(pAdrID, pAdrTyp); 

      IF vAdr.adr.id <> '-1' THEN
          
        vAdr.Typ := vOrgAdrTyp;
        IF IS_ID(vAdr.verw.id)  THEN
          vAdr.verw.id := SYS_GUID();
          vAdr.adr.d_verw_id := vAdr.verw.id;  
          INSERT INTO ein_d_verwaltung VALUES vAdr.verw;  
        END IF;

        IF IS_ID(vAdr.kat.id)  THEN
          vAdr.kat.id := SYS_GUID();  
          vAdr.adr.d_kat_id := vAdr.kat.id;  
          INSERT INTO ein_d_kataster VALUES vAdr.kat;  
        END IF;

        IF IS_ID(vAdr.padr.id)  THEN
          vAdr.padr.id := SYS_GUID(); 
          vAdr.adr.d_padr_id := vAdr.padr.id;  
          INSERT INTO ein_d_postadresse VALUES vAdr.padr;  
        END IF;

        vAdr.adr.id := SYS_GUID();  
        INSERT INTO ein_d_adresse VALUES vAdr.adr;  

        CASE pMainTyp 
        WHEN 'BTS' THEN 
          INSERT INTO ein_r_bts_adr (d_bts_id, d_adr_id, typ) 
          VALUES ( pMainID, vAdr.adr.id, vAdr.typ);
        WHEN 'FKT' THEN 
          INSERT INTO ein_r_fkt_adr (d_fkt_id, d_adr_id, typ) 
          VALUES ( pMainID, vAdr.adr.id, vAdr.typ);
        ELSE NULL;
        END CASE;   
        

      END IF;      
    END IF;
  END IF;  

END CopyAdrToOrg;


-- Adresse als Org... kopieren 
PROCEDURE CopyAdrToOrg( pBTS_IDs IN tb_bez) AS
BEGIN

  FOR c1 IN (

    SELECT 'BTS' quelle, r1.d_bts_id ref_id, 'Org'||r1.typ ref_typ, r1.d_adr_id
      , adr.d_padr_id, adr.d_verw_id, adr.d_kat_id 
      , RAWTOHEX( SYS_GUID()) d_adr_id_neu
      , CASE WHEN adr.d_padr_id <> '-1' THEN RAWTOHEX( SYS_GUID()) end d_padr_id_neu
      , CASE WHEN adr.d_verw_id <> '-1' THEN RAWTOHEX( SYS_GUID()) end d_verw_id_neu
      , CASE WHEN adr.d_kat_id <> '-1' THEN RAWTOHEX( SYS_GUID()) END d_kat_id_neu

      FROM ein_r_bts_adr r1
      JOIN ein_d_adresse adr ON adr.id = r1.d_adr_id
      JOIN ein_d_protokoll prt on prt.d_bts_id = r1.d_bts_id
      AND prt.d0101_id = '-1'
      WHERE r1.typ IN (PostAdr, StandortAdr)
      AND r1.d_bts_id IN ( SELECT dx.bez FROM TABLE ( pBTS_IDs ) dx )      
        
      UNION ALL
        
      SELECT 'FKT' quelle, r1.d_fkt_id ref_id, 'Org'||r1.typ ref_typ, r1.d_adr_id
      , adr.d_padr_id, adr.d_verw_id, adr.d_kat_id 
      , RAWTOHEX( SYS_GUID()) d_adr_id_neu
      , CASE WHEN adr.d_padr_id <> '-1' THEN RAWTOHEX( SYS_GUID()) END d_padr_id_neu
      , CASE WHEN adr.d_verw_id <> '-1' THEN RAWTOHEX( SYS_GUID()) END d_verw_id_neu
      , CASE WHEN adr.d_kat_id <> '-1' THEN RAWTOHEX( SYS_GUID()) END d_kat_id_neu
      FROM ein_r_fkt_adr r1
      JOIN ein_d_funktion fkt ON fkt.id = r1.d_fkt_id
      AND r1.typ IN (PostAdr, StandortAdr)
      JOIN ein_d_adresse adr on adr.id = r1.d_adr_id         
      JOIN ein_d_protokoll prt on prt.d_bts_id = fkt.d_bts_id
      AND prt.d0101_id = '-1'
      WHERE fkt.d_bts_id IN ( SELECT dx.bez FROM TABLE ( pBTS_IDs ) dx )

  ) LOOP

    INSERT INTO ein_d_postadresse (ID, HAUSNR, HAUSNRZUSATZ, ORT, ORTSTEIL, POSTFACH, STAAT, STRASSE, PLZ, GLO_A24_SID, ADRESSZUSATZ)
    SELECT c1.d_padr_id_neu, HAUSNR, HAUSNRZUSATZ, ORT, ORTSTEIL, POSTFACH, STAAT, STRASSE, PLZ, GLO_A24_SID, ADRESSZUSATZ
    FROM ein_d_postadresse  
    WHERE id = c1.d_padr_id;
    
    INSERT INTO ein_d_kataster ( ID, FLURNUMMER, FLURSTUECK, GEMARKUNG, X_WERT, Y_WERT, RECHTSWERT, HOCHWERT, GIS_QUELLE, S09_SID )
    SELECT c1.d_kat_id_neu, FLURNUMMER, FLURSTUECK, GEMARKUNG, X_WERT, Y_WERT, RECHTSWERT, HOCHWERT, GIS_QUELLE, S09_SID
    FROM ein_d_kataster  
    WHERE id = c1.d_kat_id;

    INSERT INTO ein_d_verwaltung ( ID, BUNDESLAND, BEZIRK, KREIS, GEMEINDE, GKZ, REGIONALSCHLUESSEL, STAAT, TEILORT )
    SELECT c1.d_verw_id_neu, BUNDESLAND, BEZIRK, KREIS, GEMEINDE, GKZ, REGIONALSCHLUESSEL, STAAT, TEILORT
    FROM ein_d_verwaltung
    WHERE id = c1.d_verw_id; 

    INSERT INTO ein_d_adresse ( ID, FREIBEZ, WECHSEL, D_KAT_ID, D_PADR_ID, D_VERW_ID, GUELTIG_VON, GUELTIG_BIS, ADR_ID, ART, ZUSATZ )
    SELECT c1.d_adr_id_neu, FREIBEZ, WECHSEL, c1.D_KAT_ID_NEU, c1.D_PADR_ID_neu, c1.D_VERW_ID_NEU, GUELTIG_VON, GUELTIG_BIS, ADR_ID, ART, ZUSATZ
    FROM ein_d_adresse
    WHERE id = c1.d_adr_id; 

    CASE 
    WHEN c1.quelle = 'BTS' AND c1.d_adr_id_neu <> '-1' AND c1.ref_id <> '-1' THEN
    
      INSERT INTO ein_r_bts_adr (  TYP, D_ADR_ID, D_BTS_ID )
      VALUES( c1.ref_typ, c1.d_adr_id_neu, c1.ref_id );
      
    WHEN c1.quelle = 'FKT' AND c1.d_adr_id_neu <> '-1' AND c1.ref_id <> '-1' THEN
    
      INSERT INTO ein_r_fkt_adr (  TYP, D_ADR_ID, D_FKT_ID )
      VALUES( c1.ref_typ, c1.d_adr_id_neu, c1.ref_id );
    
    ELSE NULL;  
    END CASE;
    

  END LOOP;

END CopyAdrToOrg;


PROCEDURE Clear_BTS( pBTS OUT NOCOPY tBTS) AS
BEGIN

  pBTS :=  NULL;
  pBTS.Fachb := tbFachb();
  pBTS.REG := tbReg();
  --pBTS.fkt_inh.reg := tbReg();
  pBTS.fkt_hv.reg := tbReg();
  pBTS.bta := tbBTA();
  pBTS.Abt_Adr := tbAbt_Adr();  
  pBTS.Bta_Abt := tbBTA_ABT(); 
  pBTS.bts_pers := tbFkt();
  pBTS.btr_pers := tbBtr();   
END;

-- Status zu vis_d010102 anlegen
PROCEDURE InsertD0300( pD010102_ID IN tbID) AS 
--vBem vis_d0300.bem%TYPE;
vGuid tID;
vSysdate CONSTANT DATE := SYSDATE; 
BEGIN
  IF pD010102_ID.COUNT > 0 THEN
    FOR i IN pD010102_ID.FIRST .. pD010102_ID.LAST LOOP
      vGUID := SYS_GUID();
      --vBem := 'Gltig bis: <' || TO_CHAR(pD010102_ID(i).Gueltig_bis, 'dd.mm.yyyy') || '> zu <leer>';
      INSERT INTO vis_d0300 ( ID, A0302_SID, MANDANT, CODE, CODEN, BEZ, /*BEM,*/ INS_USER, INS_DATE, UPD_USER, UPD_DATE, DELETED, DEL_USER, DEL_DATE, FB, ZB, REF_TABLE, REF_OBJ, REF_ID, DATUM, A0302_01_SID, D0101_ID, GUELTIG_VON, GUELTIG_BIS, DATUM2, BEM2, BEM3, DATUM3, BEZ2, BEZ3)
      SELECT vGUID --ID
      , d010102.A0302_05_SID   
      , d010102.mandant MANDANT
      , NULL CODE
      , NULL CODEN
      , (SELECT bez FROM vis_a0302 WHERE sid = d010102.a0302_05_sid ) BEZ  -- 36001
      --, vBem  BEM
      --, 'Gltig bis: <' || TO_CHAR(D010102.Gueltig_bis, 'dd.mm.yyyy') || '> zu <leer>' bem
      , d010102.UPD_USER INS_USER
      , vSYSDATE INS_DATE
      , d010102.UPD_USER
      , vSYSDATE UPD_DATE
      , 0 DELETED
      , -1 DEL_USER
      , NULL DEL_DATE
      , d010102.FB
      , d010102.ZB 
      , 'VIS_D010102' REF_TABLE
      , '1.01.02' REF_OBJ
      , D010102.ID REF_ID
      , vSYSDATE DATUM
      , -1 A0302_01_SID
      , d010102.D0101_ID D0101_ID
      , D010102.GUELTIG_VON_STAT GUELTIG_VON, D010102.GUELTIG_BIS_STAT GUELTIG_BIS, NULL DATUM2, NULL BEM2, NULL BEM3, NULL DATUM3, NULL BEZ2, NULL BEZ3  
      FROM vis_d010102 d010102
      WHERE id = pD010102_ID(i).id;
    END LOOP;
  END IF;
END InsertD0300;

PROCEDURE InsertD0300( pD010102_ID IN tID) AS
v1 trID;
BEGIN
  v1.id := pD010102_ID;
  InsertD0300( tbID( v1 ) );
END InsertD0300;

-- Registrierungen anlegen
-- 06.06.2012 Param. pCheckExists:  bei 1 nur Anlegen wenn noch nicht vorhanden
-- pTyp: 1 Betriebssttte, 2 Betriebssttte alt, 3 Betreiber, 4 Verwendung pBtr2_Reg
-- pArt: Nummernart im Eingangskorb zum bertragen, wenn NULL alle
-- pFkt: zustzliche Funktionen
-- 1: BI fr Betreiber wird in iP als Betreiber_ID 0103 angelegt 
-- pCheckExists : 0 - keine berprfung 
--                1 - berprfung auf Nummer und A010145_sid
--                2 - berprfung auf A010145_sid
--                3 - berprfung auf A010145_sid, wenn Nummer abweichend dann Update
--                4 - berprfung auf Nummer und A010145_sid aber ohne Beachtung der Gltigkeit
FUNCTION Reg_Anl(pD0101_id IN VARCHAR2, 
                 pReg IN OUT NOCOPY tbReg, 
                 pTyp IN PLS_INTEGER, 
                 pArt IN VARCHAR2, 
                 pFkt IN PLS_INTEGER, 
                 pCheckExists IN PLS_INTEGER/*, 
                 pBtr2_Reg IN OUT NOCOPY tbReg*/) RETURN PLS_INTEGER AS
  vID vis_d010102.id%TYPE;
  vA010145 tA010145;
  vInsCnt PLS_INTEGER := 0; 
  vA0302_05_sid CONSTANT vis_a0302.sid%TYPE := A0302_05_ERTEILT;
  --pReg tbReg;
  vFB vis_d0101.fb%TYPE;
  vSYSDATE DATE := SYSDATE;
  
  CURSOR cD010102 (pD0101_ID IN VARCHAR2, pA010145_SID IN NUMBER, pNummer IN VARCHAR2) IS
  SELECT dx.nummer, dx.id
  FROM vis_d010102 dx
  WHERE dx.d0101_id = pD0101_id
    AND dx.deleted = 0
    AND dx.a010145_sid = pA010145_sid
  ORDER BY CASE WHEN dx.nummer = pNummer THEN 0 ELSE 1 END; 
  
  TYPE tD010102 IS TABLE OF cD010102%ROWTYPE;
  vD010102 tD010102;
  
  PROCEDURE InsertD010102(pI IN NUMBER, pNummer IN VARCHAR2) AS
  vIns PLS_INTEGER := 0; 
  vD010102_ID tbID;
  BEGIN
    vID := NULL;
    CASE pCheckExists
    WHEN 1 THEN
      SELECT COUNT(*) INTO vIns
      FROM vis_vd010102
      WHERE d0101_id = pD0101_id
        AND a010145_sid IN ( SELECT ax.sid FROM vis_a010145 ax WHERE ax.skz = vA010145.skz AND ax.code LIKE vA010145.code)
        AND nummer = pNummer;

    WHEN 4 THEN
      SELECT COUNT(*) INTO vIns
      FROM vis_d010102 d010102
      WHERE d010102.d0101_id = pD0101_id
        AND d010102.deleted = 0
        AND d010102.a010145_sid IN ( SELECT ax.sid FROM vis_a010145 ax WHERE ax.skz = vA010145.skz AND ax.code LIKE vA010145.code)
        AND d010102.nummer = pNummer;

    WHEN 2 THEN
      SELECT COUNT(*) INTO vIns
      FROM vis_vd010102
      WHERE d0101_id = pD0101_id
        AND a010145_sid IN ( SELECT ax.sid FROM vis_a010145 ax WHERE ax.skz = vA010145.skz AND ax.code LIKE vA010145.code);

    WHEN 3 THEN

      OPEN cD010102(pD0101_ID, vA010145.sid, pNummer);
      FETCH cD010102 BULK COLLECT INTO vD010102 LIMIT 9999;
      CLOSE cD010102;
        
      IF vD010102.COUNT = 0 THEN
        vIns := 0;
      ELSE
        IF vD010102(1).nummer = pNummer THEN
          vIns := 1; -- alle anderen Lschen

        ELSE
          vIns := 0;          
        END IF;   
        
        FORALL i IN vIns+1 .. vD010102.COUNT
          UPDATE vis_d010102
          SET deleted = -2
            , del_date = vSysdate
            , del_user = vUser_SID
          WHERE id = vD010102(i).id;  
      END IF;  

    ELSE NULL;
    END CASE;

    IF vIns = 0 THEN
    
      vID := SYS_GUID();    

      INSERT INTO vis_d010102 (
        ID, D0101_ID, A010145_SID, FB, BEZ,
        MANDANT, NUMMER, INS_USER, INS_DATE, UPD_USER, UPD_DATE, DELETED, 
        GUELTIG_VON, GUELTIG_BIS, a0302_05_sid, GUELTIG_VON_STAT --, GUELTIG_BIS_STAT
      ) VALUES (
        vID, pD0101_ID, vA010145.sid, vA010145.fb, vA010145.bez,
        vMandant_SID, pNummer /*pReg(pI).nummer*/, vUser_sid, vSYSDATE, vUser_sid, vSYSDATE, 0,
        pReg(pI).gueltig_von, pReg(pI).gueltig_bis, vA0302_05_sid, pReg(pI).gueltig_von
      );
     
      vInsCnt := vInsCnt + SQL%ROWCOUNT;
      IF vA010145.sid = A010145_HIT_NR THEN
        vD010102_id := tbID();
        VD010102_id.extend;
        vD010102_id(1).id := vID; 
        InsertD0300(vD010102_ID);
      END IF;
    END IF;
    
  END;
BEGIN 

  SELECT fb INTO vFB
  FROM vis_d0101
  WHERE id = pD0101_ID;

--  CASE
--  WHEN pTyp = 1 THEN
--    pReg := bts1.Reg;
--  WHEN pTyp = 2 THEN
--    pReg := bts2.Reg;
--  WHEN pTyp = 3 THEN
--    pReg := bts1.fkt_inh.Reg;
--  WHEN pTyp = 4 THEN
--    pReg := pBtr2_Reg;  
--  ELSE
--    NULL;
--  END CASE;

  IF pReg IS NOT NULL AND pReg.COUNT > 0 THEN
    -- erteilt
--    SELECT sid INTO vA0302_05_sid 
--    FROM vis_a0302
--    WHERE deleted = 0
--     AND skz = 5
--     AND code = '04';
     
    FOR i IN pReg.FIRST .. pReg.LAST LOOP

      -- Neuanlage nur wenn gueltig_bis nicht gesetzt bzw. gleich 01.01.9999
      IF pReg(i).art = 'BALVI' OR NVL( pReg(i).gueltig_bis, Default_gueltig_bis) <> Default_gueltig_bis THEN  -- BALVI wird in VIS_D0101.CODE an anderer Stelle bernommen 
        NULL;
      ELSE
      
        IF pArt IS NULL OR pArt = pReg(i).art THEN 
          IF pFkt = 1 AND pReg(i).art = BI THEN        
            GetA010145( BETREIBER_ID, pReg(i).code, vA010145);
          ELSE
            GetA010145( pReg(i).art, pReg(i).code, vA010145);
          END IF;

          IF vA010145.sid > 0 THEN
            InsertD010102(i, pReg(i).nummer); 
            IF vID IS NOT NULL THEN
              pReg(i).ref_id := vID;
              UPDATE ein_d_registrierung SET ref_id = vID
              WHERE id = pReg(i).id;
            END IF;     
          END IF;            
          
        END IF;
      
      END IF;
      
    END LOOP;  

    IF pCheckExists = 0 AND vInsCnt = 0 THEN
        AddErrMsg('Keine Registrierungen angelegt.');
    END IF; 

  --02.02.2016 ELSE AddMsg('Keine Registrierungen vorhanden.');  
  END IF;
  
  RETURN vInsCnt;
  
END Reg_Anl;


--
---- Registrierungen anlegen
---- 06.06.2012 Param. pCheckExists:  bei 1 nur Anlegen wenn noch nicht vorhanden
---- pTyp: 1 Betriebssttte, 2 Betriebssttte alt, 3 Betreiber, 4 Verwendung pBtr2_Reg
---- pArt: Nummernart im Eingangskorb zum bertragen, wenn NULL alle
---- pFkt: zustzliche Funktionen
---- 1: BI fr Betreiber wird in iP als Betreiber_ID 0103 angelegt 
---- pCheckExists : 0 - keine berprfung 
----                1 - berprfung auf Nummer und A010145_sid
----                2 - berprfung auf A010145_sid
----                3 - berprfung auf A010145_sid, wenn Nummer abweichend dann Update
--FUNCTION Reg_Anl_old(pD0101_id IN VARCHAR2, pTyp IN PLS_INTEGER, pArt IN VARCHAR2, pFkt IN PLS_INTEGER, pCheckExists IN PLS_INTEGER, pBtr2_Reg IN OUT NOCOPY tbReg) RETURN PLS_INTEGER AS
--  vID vis_d010102.id%TYPE;
--  vA010145 tA010145;
--  vInsCnt PLS_INTEGER := 0; 
--  vA0302_05_sid vis_a0302.sid%TYPE;
--  pReg tbReg;
--  vFB vis_d0101.fb%TYPE;
--  vSYSDATE DATE := SYSDATE;
--  
--  CURSOR cD010102 (pD0101_ID IN VARCHAR2, pA010145_SID IN NUMBER, pNummer IN VARCHAR2) IS
--  SELECT dx.nummer, dx.id
--  FROM vis_d010102 dx
--  WHERE dx.d0101_id = pD0101_id
--    AND dx.deleted = 0
--    AND dx.a010145_sid = pA010145_sid
--  ORDER BY CASE WHEN dx.nummer = pNummer THEN 0 ELSE 1 END; 
--  
--  TYPE tD010102 IS TABLE OF cD010102%ROWTYPE;
--  vD010102 tD010102;
--  
--  PROCEDURE InsertD010102(pI IN NUMBER, pNummer IN VARCHAR2) AS
--  vIns PLS_INTEGER := 0; 
--  vD010102_ID tbID;
--  BEGIN
--
--    CASE pCheckExists
--    WHEN 1 THEN
--      SELECT COUNT(*) INTO vIns
--      FROM vis_vd010102
--      WHERE d0101_id = pD0101_id
--        AND a010145_sid IN ( SELECT ax.sid FROM vis_a010145 ax WHERE ax.skz = vA010145.skz AND ax.code LIKE vA010145.code)
--        AND nummer = pNummer; --pReg(pI).nummer;
--    WHEN 2 THEN
--      SELECT COUNT(*) INTO vIns
--      FROM vis_vd010102
--      WHERE d0101_id = pD0101_id
--        AND a010145_sid IN ( SELECT ax.sid FROM vis_a010145 ax WHERE ax.skz = vA010145.skz AND ax.code LIKE vA010145.code);
--
--    WHEN 3 THEN
--
--      OPEN cD010102(pD0101_ID, vA010145.sid, pNummer);
--      FETCH cD010102 BULK COLLECT INTO vD010102;
--      CLOSE cD010102;
--        
--      IF vD010102.COUNT = 0 THEN
--        vIns := 0;
--      ELSE
--        IF vD010102(1).nummer = pNummer THEN
--          vIns := 1; -- alle anderen Lschen
--
--        ELSE
--          vIns := 0;          
--        END IF;   
--        
--        FORALL i IN vIns+1 .. vD010102.COUNT
--          UPDATE vis_d010102
--          SET deleted = -2
--            , del_date = vSysdate
--            , del_user = vUser_SID
--          WHERE id = vD010102(i).id;  
--      END IF;  
--
--    ELSE NULL;
--    END CASE;
--    
--    IF vIns = 0 THEN
--    
--      vID := SYS_GUID();    
--
--      INSERT INTO vis_d010102 (
--        ID, D0101_ID, A010145_SID, FB, BEZ,
--        MANDANT, NUMMER, INS_USER, INS_DATE, UPD_USER, UPD_DATE, DELETED, 
--        GUELTIG_VON, GUELTIG_BIS, a0302_05_sid, GUELTIG_VON_STAT --, GUELTIG_BIS_STAT
--      ) VALUES (
--        vID, pD0101_ID, vA010145.sid, vA010145.fb, vA010145.bez,
--        vMandant_SID, pNummer /*pReg(pI).nummer*/, vUser_sid, vSYSDATE, vUser_sid, vSYSDATE, 0,
--        pReg(pI).gueltig_von, pReg(pI).gueltig_bis, vA0302_05_sid, pReg(pI).gueltig_von
--      );
--     
--      vInsCnt := vInsCnt + SQL%ROWCOUNT;
--   
--      IF vA010145.sid = A010145_HIT_NR THEN
--        vD010102_id := tbID();
--        VD010102_id.extend;
--        vD010102_id(1).id := vID; 
--        InsertD0300(vD010102_ID);
--      END IF;
--    END IF;
--    
--  END;
--BEGIN 
--
--  SELECT fb INTO vFB
--  FROM vis_d0101
--  WHERE id = pD0101_ID;
--
--  CASE
--  WHEN pTyp = 1 THEN
--    pReg := bts1.Reg;
--  WHEN pTyp = 2 THEN
--    pReg := bts2.Reg;
--  WHEN pTyp = 3 THEN
--    pReg := bts1.btr_pers(1).betreiber.Reg;
--  WHEN pTyp = 4 THEN
--    pReg := pBtr2_Reg;  
--  ELSE
--    NULL;
--  END CASE;
--
--  IF pReg.COUNT > 0 THEN
--  
--    -- erteilt
--    SELECT sid INTO vA0302_05_sid
--    FROM vis_a0302
--    WHERE deleted = 0
--     AND skz = 5
--     AND code = '04';
--     
--    FOR i IN pReg.FIRST .. pReg.LAST LOOP
--
--      -- Neuanlage nur wenn gueltig_bis nicht gesetzt bzw. gleich 01.01.9999
--      IF pReg(i).art = 'BALVI' OR NVL( pReg(i).gueltig_bis, Default_gueltig_bis) <> Default_gueltig_bis THEN  -- BALVI wird in VIS_D0101.CODE an anderer Stelle bernommen 
--        NULL;
--      ELSE
--      
--        IF pArt IS NULL OR pArt = pReg(i).art THEN 
--          IF pFkt = 1 AND pReg(i).art = BI THEN        
--            GetA010145( BETREIBER_ID, pReg(i).code, vA010145);
--          ELSE
--            GetA010145( pReg(i).art, pReg(i).code, vA010145);
--          END IF;
--        
--          IF vA010145.sid > 0 THEN
--            InsertD010102(i, pReg(i).nummer); 
--      
--            CASE
--            WHEN pTyp = 1 THEN
--              bts1.Reg(i).ref_id := vId;
--              
--              UPDATE ein_d_registrierung SET ref_id = vID
--              WHERE id = bts1.Reg(i).id;
--               
--            WHEN pTyp = 2 THEN
--              bts2.Reg(i).ref_id := vId;
--
--              UPDATE ein_d_registrierung SET ref_id = vID
--              WHERE id = bts2.Reg(i).id;
--
--            WHEN pTyp = 3 THEN
--              bts1.btr_pers(1).betreiber.Reg(i).ref_id := vId;
--
--              UPDATE ein_d_registrierung SET ref_id = vID
--              WHERE id = bts1.btr_pers(1).betreiber.Reg(i).id;
--
--            WHEN pTyp = 4 THEN
--              pReg(i).ref_id := vId;
--
--              UPDATE ein_d_registrierung SET ref_id = vID
--              WHERE id = pReg(i).id;
--
--            
--            ELSE NULL;  
--            END CASE;
--          END IF;            
--          
--        END IF;
--
--        IF bts1.prot.quelle = QUELLE_IDV_NRW /*vGKZ2 = NRW*/ THEN
--          IF pTyp = 1 AND pReg(i).art = IDV AND (vFB LIKE '%D%' OR vFB LIKE '%U%') THEN 
--
--          -- redundant HIT-Registrierung anlegen. 20.10.2014 auch fr FB FM
--
--            SELECT sid, bez, fb, code, skz 
--            INTO vA010145.sid, vA010145.bez, vA010145.fb, vA010145.code, vA010145.skz
--            FROM vis_a010145
--            WHERE sid = A010145_HIT_NR; -- Registriernummer (HIT)
--
--              
--            InsertD010102(i,  SUBSTR(pReg(i).nummer, 4, 12));
--            
--          END IF;
--        END IF;
--      
--      END IF;
--      
--    END LOOP;  
--
--    IF pCheckExists = 0 AND vInsCnt = 0 THEN
--        AddErrMsg('Keine Registrierungen angelegt.');
--    END IF; 
--
--  ELSE
--    AddMsg('Keine Registrierungen vorhanden.');  
--  END IF;
--  
--  RETURN vInsCnt;
--  
--END Reg_Anl_old;

--PROCEDURE Reg_Anl2(pD0101_id IN VARCHAR2, pTyp IN PLS_INTEGER, pArt IN VARCHAR2, pFkt IN PLS_INTEGER) as
--  v PLS_INTEGER;
--  vReg tbReg;
--BEGIN
--
--  CASE pTyp
--  WHEN 1 THEN vReg := bts1.reg;
--  WHEN 2 THEN vReg := bts2.reg;
--  WHEN 3 THEN vReg := bts1.fkt_inh.Reg;
--  ELSE vReg := NULL;
--  END CASE;
--  
--  v := Reg_Anl(pD0101_id, vReg, pTyp, pArt, pFkt, 0);
--END;

PROCEDURE Reg_Anl(pD0101_id IN VARCHAR2,pReg IN OUT NOCOPY tbReg, pTyp IN PLS_INTEGER, pArt IN VARCHAR2, pFkt IN PLS_INTEGER, pCheck IN PLS_INTEGER) as
  v PLS_INTEGER;
BEGIN
  v := Reg_Anl(pD0101_id, pReg, pTyp, pArt, pFkt, pCheck);
END Reg_Anl;

PROCEDURE Reg_Anl(pD0101_id IN VARCHAR2, pTyp IN PLS_INTEGER, pArt IN VARCHAR2, pFkt IN PLS_INTEGER, pCheck IN PLS_INTEGER) as
  v PLS_INTEGER;
BEGIN

  CASE pTyp
  WHEN 1 THEN
    v := Reg_Anl(pD0101_id, bts1.reg, pTyp, pArt, pFkt, pCheck);
  WHEN 2 THEN
    v := Reg_Anl(pD0101_id, bts2.reg, pTyp, pArt, pFkt, pCheck);
  WHEN 3 THEN
    v := Reg_Anl(pD0101_id, bts1.btr_pers(1).betreiber.Reg, pTyp, pArt, pFkt, pCheck);
  ELSE NULL;
  END CASE;  
END Reg_Anl;

FUNCTION Reg_Anl(pD0101_id IN VARCHAR2, pTyp IN PLS_INTEGER, pArt IN VARCHAR2, pFkt IN PLS_INTEGER, pCheck IN PLS_INTEGER) RETURN PLS_INTEGER as
  vReg tbReg;
  v PLS_INTEGER := 0;
BEGIN

  CASE pTyp
  WHEN 1 THEN
    v := Reg_Anl(pD0101_id, bts1.reg, pTyp, pArt, pFkt, pCheck);  
  WHEN 2 THEN
    v := Reg_Anl(pD0101_id, bts2.reg, pTyp, pArt, pFkt, pCheck);  
  WHEN 3 THEN
    v := Reg_Anl(pD0101_id, bts1.btr_pers(1).betreiber.Reg, pTyp, pArt, pFkt, pCheck);  
  ELSE NULL;
  END CASE;
  RETURN v;
END Reg_Anl;


-- alle vorhandene Betreiber_ID's lschen
-- Ausnahmen pID1 und pID2
PROCEDURE DelBetreiber_ID( pNummer IN VARCHAR2, pID1 IN tID := '-1', pID2 IN tID := '-1') AS
TYPE tID IS TABLE OF vis_d010102.id%TYPE;
vD010102_IDs tID;
vSysdate DATE := SYSDATE;
BEGIN
  
  UPDATE vis_d010102
  SET del_date = vSysdate
    , del_user = vUser_SID
    , deleted = -2
  WHERE a010145_sid = A010145_BETREIBER_ID
  AND nummer = pNummer
  AND deleted = 0
  AND d0101_id NOT IN (pID1, pID2)
  RETURNING id BULK COLLECT INTO vD010102_IDs;
      
  -- Status lschen
  IF vD010102_IDs.COUNT > 0 THEN
    FORALL i IN vD010102_IDs.FIRST .. vD010102_IDs.LAST
    UPDATE vis_d0300
    SET deleted = -2
      , del_date = vSysdate
      , del_user = vUser_sid
    WHERE ref_id = vD010102_IDs(i);  
  END IF;  
  
END DelBetreiber_ID;

PROCEDURE Aend_Betreiber_ID( pBTS_ID IN tID, pD0101_ID3 IN tID) AS
vBtr2_Reg tbReg;

CURSOR cBetrieb IS
  SELECT d0101.d0101_id3, d0101_3.code
  FROM ein_r_bts_reg r1
  JOIN ein_d_registrierung reg on reg.id = r1.d_reg_id
  AND reg.art = BI
  JOIN vis_d010102 d010102 ON d010102.nummer = reg.nummer
  AND d010102.deleted = 0
  AND d010102.a010145_sid = A010145_HIT_NR
  JOIN vis_d0101 d0101 ON d0101.id = d010102.d0101_id
  AND d0101.deleted = 0
  JOIN vis_d0101 d0101_3 ON d0101_3.id = d0101.d0101_id3
  WHERE r1.d_bts_id = pBts_ID;   

vBetrieb cBetrieb%ROWTYPE;

BEGIN

  IF IS_ID(pBTS_ID) THEN
    -- alten Betreiber ermitteln
    -- alten Betreiber ber eine Betriebssttte ermitteln  
    OPEN cBetrieb;
    FETCH cBetrieb INTO vBetrieb;
    CLOSE cBetrieb;
    IF vBetrieb.D0101_ID3 <> '-1' THEN 
      IF vBetrieb.D0101_ID3 <> pD0101_ID3 THEN    
        -- alten Betreiber direkt ber die aktuellen EK ermitteln
            
        -- neu Betreiber_ID des alten Betreibers
        SELECT reg.*
        BULK COLLECT INTO vBtr2_Reg
        FROM ein_d_funktion fkt
        JOIN ein_r_fkt_reg r1 ON r1.d_fkt_id = fkt.id
        JOIN ein_d_registrierung reg ON reg.id = r1.d_reg_id
        AND reg.art = BI
        WHERE fkt.d_bts_id = pBTS_ID
        AND FKT.TYP = Betreiber;

        -- BETREIBER_ID beim Betreiber anlegen wenn vorhanden
        IF vBtr2_Reg.COUNT > 0 THEN 
          --IF Reg_Anl(vBetrieb.D0101_ID3, 4, Betreiber_ID, 0, 2, vBtr2_Reg) > 0 THEN
          --  NULL;
          --END IF;

  --        IF Reg_Anl(
  --          pD0101_id => vBetrieb.D0101_ID3, 
  --          pTyp => 4, 
  --          pArt => BI, 
  --          pFkt => 1, -- BI als Betreiber_ID anlegen 
  --          pCheckExists => 2, -- berprfung auf A010145_sid - keine dopplete Betreiber_ID anlegen
  --          pBtr2_Reg => vBtr2_Reg) = 0 THEN 

          IF Reg_Anl(
            pD0101_id => vBetrieb.D0101_ID3,
            pReg => vBtr2_Reg, 
            pTyp => 4, 
            pArt => BI, 
            pFkt => 1, -- BI als Betreiber_ID anlegen 
            pCheckExists => 2 -- berprfung auf A010145_sid - keine dopplete Betreiber_ID anlegen
            ) = 0 THEN 
            
            AddMsg('Der alte Betreiber ' ||vBetrieb.code|| ' hat keine neue Betreiber_ID erhalten.');
          
          END IF;

        ELSE
          AddErrMsg('Der alte Betreiber '||vBetrieb.code||' hat keine neue BI-Nummer im Eingangskorb.');      
        END IF;
      END IF;
    ELSE
      AddErrMsg('Der alte Betreiber konnte nicht ermittelt werden. Deshalb kann ihm keine neue Betreiber-ID vergeben werden.' );         
    END IF;    
  END IF;

END Aend_Betreiber_ID;    

FUNCTION Fill_Bts1(pBTS_ID EIN_d_betriebsstaette.id%TYPE, pUsecase IN VARCHAR2) RETURN PLS_INTEGER AS
BEGIN
  RETURN Fill_Bts(BTS1, pBTS_ID, 1, pUsecase);
END;  

FUNCTION Fill_Bts2(pBTS_ID EIN_d_betriebsstaette.id%TYPE, pUsecase IN VARCHAR2) RETURN PLS_INTEGER AS
BEGIN
  RETURN Fill_Bts(BTS2, pBTS_ID, 2, pUsecase);  
END;


PROCEDURE Fill_Reg( pTyp IN VARCHAR2, pID IN VARCHAR2, pReg OUT NOCOPY tbReg) AS
BEGIN

  CASE pTyp 
  WHEN 'FKT' THEN

    SELECT reg.* BULK COLLECT INTO pReg
    FROM EIN_r_fkt_reg r
    JOIN EIN_d_registrierung reg ON R.D_REG_ID = reg.id
    WHERE r.d_fkt_id = pId;    
  
  WHEN 'BTS' THEN

    SELECT reg.* BULK COLLECT INTO pReg
    FROM EIN_r_bts_reg r
    JOIN EIN_d_registrierung reg ON R.D_REG_ID = reg.id
    WHERE r.d_bts_id = pId;    

  WHEN 'PRS' THEN

    SELECT reg.* BULK COLLECT INTO pReg
    FROM EIN_r_pers_reg r
    JOIN EIN_d_registrierung reg ON R.D_REG_ID = reg.id
    WHERE r.d_pers_id = pId;    

  ELSE 
    RAISE_APPLICATION_ERROR(-20001, 'Package XGEWERBE.FILL_REG Param. Typ=' || pTyp || ' wird nicht untersttzt.');
  END CASE;
  
  IF pReg IS NOT NULL AND pReg.COUNT > 0 THEN
    FOR i IN pReg.FIRST .. pReg.LAST LOOP
      pReg(i).gueltig_von := TRUNC(pReg(i).gueltig_von);
      pReg(i).gueltig_bis := TRUNC(pReg(i).gueltig_bis);
    END LOOP; 
  END IF;          

END Fill_Reg;


PROCEDURE Fill_Pers( pFkt IN EIN_d_funktion%ROWTYPE, pUsecaseAend IN NUMBER, pPers IN OUT NOCOPY tFkt, pAdrTyp IN tb_bez ) AS
vOrder PLS_INTEGER;

--CURSOR cInh (pTyp IN ein_d_funktion.typ%TYPE, pBTS_ID IN ein_d_funktion.d_bts_id%type)  IS
--  SELECT fkt.* --INTO pBTS.fkt_inh.fkt
--  FROM EIN_d_funktion fkt
--  WHERE fkt.typ = pTyp 
--   AND FKT.D_BTS_ID = pBTS_ID
--  ORDER by fkt.gueltig_von DESC, fkt.gueltig_bis DESC NULLS LAST;
vAdrTyp tb_bez;
BEGIN

    --OPEN cInh(pFkt.Typ, pFkt.d_bts_id);
    --FETCH cInh INTO pBtr.fkt;
    --CLOSE cInh;  

    IF pAdrTyp IS NULL THEN
      vAdrTyp := TB_BEZ( T_BEZ('ORG'), T_BEZ('PERS'), T_BEZ(PostAdr));
    ELSE
      vAdrTyp := pAdrTyp;
    END IF;
     
    pPers.fkt := pFkt;
        
    IF pPers.fkt.d_pers_id <> '-1' THEN
      SELECT pers.* INTO pPers.pers
      FROM EIN_d_person pers
      WHERE pers.id = pFkt.d_pers_id;
    ELSE
      RETURN;
    END IF;    

    -- Inhaber - Kommunikation
    Fill_Komm(pTyp => 'FKT', pID => pPers.fkt.id, pKom => pPers.Kom);
    -- Inhaber - Registrierung
    Fill_Reg(pTyp => 'FKT', pID => pPers.fkt.id, pReg => pPers.reg);
              
    -- Inhaber - Adresse
    IF pUsecaseAEND = 0 THEN
      BEGIN
        SELECT r.d_adr_id, r.typ INTO pPers.Adr.adr.id,  pPers.Adr.Typ
        FROM EIN_R_fkt_ADR r         
        WHERE r.d_fkt_id = pFkt.id
        AND r.typ IN ( SELECT * FROM TABLE ( vAdrTyp ) );

        pPers.Adr := GetAdresse(pPers.Adr.adr.id, pPers.Adr.Typ);

        EXCEPTION WHEN no_data_found THEN pPers.Adr.adr.id := '-9999'; 
      END;
    ELSE
      vOrder := 0;
      FOR c1 IN (
        SELECT adr.id adr_id, r.typ
        FROM EIN_R_fkt_ADR r 
        JOIN ein_d_adresse adr ON adr.id = r.d_adr_id
        WHERE r.d_fkt_id = pFkt.id
        --AND r.typ IN( 'ORG', 'PERS', PostAdr)  -- PostAdr 17.10.2014
        AND r.typ IN ( SELECT * FROM TABLE ( vAdrTyp ) )
        ORDER BY adr.gueltig_von DESC NULLS FIRST 
      ) LOOP

        IF vOrder = 0 THEN
          pPers.Adr := GetAdresse(c1.adr_id, c1.typ);      
          vOrder := 1;
        ELSE
          pPers.Adr2 := GetAdresse(c1.adr_id, c1.typ);            
        END IF;
      
      END LOOP;  
    END IF;  

END Fill_Pers;

FUNCTION Fill_Bts(pBTS OUT NOCOPY tBTS, pBTS_ID IN EIN_d_betriebsstaette.id%TYPE, pBTS_NR IN PLS_INTEGER, pUsecase IN VARCHAR2) RETURN PLS_INTEGER AS
  res NUMBER(10) := 1;
  vAdrId EIN_d_adresse.id%TYPE;
  vTyp   EIN_R_BTS_ADR.TYP%TYPE;
  vBTS_ID EIN_d_betriebsstaette.id%TYPE;
  vUsecaseAEND NUMBER(10) := 0;
  vOrder NUMBER(10) := 0;
  vCnt PLS_INTEGER;
  vReg_idv_inh EIN_d_registrierung%ROWTYPE;
  vExt PLS_INTEGER;
BEGIN

  Clear_BTS(pBTS);

--  IF vGKZ2 = NRW THEN
--    vINH  := INH;
--    vIDV  := IDV;
--    vIDV_INH  := IDV_INH;
--    vHV   := HV;
--    vBTRO := BTRO;
--    vBTRA := BTRA;    
--  ELSE
--    vINH  := Betreiber;
--    vIDV  := BI;
--    vIDV_INH := BI;
--    vHV   := NULL; -- nicht vorhanden
--    vBTRO := StandortAdr;
--    vBTRA := PostAdr;      
--  END IF;

  IF pBTS_NR = 1 THEN
    vBTS_ID := pBTS_ID;
   
    IF pUsecase IN('STANDORT_AEND', 'BETR_POST_AEND', 'PERS_AEND',
     'PERS_ADR_AEND', 'BTRB_STANDORT_AEND', 'AEND_BETREI', 'AEND_BT', 
     'AEND_POST_ADR_BETREI', 'AEND_POST_ADR_BT') THEN
      vUsecaseAend := 1;
    ELSE
      vUsecaseAend := 0;
    END IF;  
     
  ELSE
    
    SELECT d_bts_id2 INTO vBTS_ID
    FROM EIN_d_usecase d
    WHERE D.D_BTS_ID = pBTS_ID    
      AND d.usecase = pUsecase;
      
    IF NOT IS_ID(vBTS_ID) THEN
      Res := 0;
    END IF;
  END IF;

  IF Res = 1 THEN
    -- BTS
    SELECT * INTO pBTS.BTS
    FROM EIN_d_betriebsstaette bts
    WHERE bts.id = vBTS_ID;
    pBTS.bts.gueltig_von := TRUNC(pBTS.bts.gueltig_von);
    pBTS.bts.gueltig_bis := TRUNC(pBTS.bts.gueltig_bis);
    
    -- UseCases
    SELECT d.* BULK COLLECT INTO pBTS.Usecases  
    FROM EIN_d_usecase d 
    WHERE D.D_BTS_ID = vBTS_ID
     AND d.usecase = pUsecase;  
    
    IF pBTS_NR = 1 THEN 
      -- Protokoll, nicht bei alte Werte vorhanden
      SELECT * INTO pBTS.Prot
      FROM EIN_d_protokoll prot
      WHERE prot.d_bts_id = vBTS_ID;

      CASE PrepairPrtQuelle( pBTS.Prot.quelle )
      WHEN QUELLE_XGEWERBE THEN
        vINH  := Betreiber;
        vIDV  := GEWERBE;
        vIDV_INH := GEWERBE;
        vHV   := NULL; -- nicht vorhanden
        vBTRO := StandortAdr;
        vBTRA := PostAdr;      
      ELSE NULL; 
      END CASE;

    END IF;
      
    Fill_komm(pTYP => 'BTS', pID => vBTS_ID, pKOM => pBTS.kom);
             
    IF vUsecaseAEND = 0 THEN
    
      -- Adresse BTRO Standort
      BEGIN
        SELECT d_adr_id INTO pBTS.Adr_BTRO.adr.ID
        FROM EIN_R_BTS_ADR r 
        WHERE r.d_bts_id = pBTS.bts.id
          AND r.typ = vBTRO;
      
        pBTS.Adr_BTRO := GetAdresse(pBTS.Adr_BTRO.adr.ID, vBTRO);

        EXCEPTION WHEN no_data_found THEN pBTS.Adr_BTRO.adr.ID := '-9999'; 
      
      END;
    
    ELSE -- AEND - mehrere Adressen vorhanden
      vOrder := 0;
      FOR c1 IN (
        SELECT adr.id adr_id
        FROM EIN_R_BTS_ADR r 
        JOIN ein_d_adresse adr ON adr.id = r.d_adr_id
        WHERE r.d_bts_id = pBTS.bts.id
          AND r.typ = vBTRO
        ORDER BY adr.gueltig_von DESC NULLS FIRST
      ) LOOP
      
        IF vOrder = 0 THEN
          pBTS.Adr_BTRO := GetAdresse(c1.adr_id, vBTRO);      
          vOrder := 1;
        ELSE
          pBTS.Adr_BTRO2 := GetAdresse(c1.adr_id, vBTRO);            
        END IF;
      
      END LOOP;
    
    END IF; 
    
    -- Adresse BTRA Postanschrift
    IF vUsecaseAEND = 0 THEN
      BEGIN
        SELECT d_adr_id INTO vAdrId
        FROM EIN_R_BTS_ADR r 
        WHERE r.d_bts_id = pBTS.bts.id
          AND r.typ = vBTRA;

        pBTS.Adr_BTRA := GetAdresse(vAdrID, vBTRA);
      
        EXCEPTION WHEN no_data_found THEN vAdrID := '-9999'; 
      
      END;
    
    ELSE -- AEND - mehrere Adressen vorhanden   
      vOrder := 0;
      FOR c1 IN (
        SELECT adr.id adr_id
        FROM EIN_R_BTS_ADR r 
        JOIN ein_d_adresse adr ON adr.id = r.d_adr_id
        WHERE r.d_bts_id = pBTS.bts.id
          AND r.typ = vBTRA
        ORDER BY adr.gueltig_von DESC NULLS FIRST
      ) LOOP
      
        IF vOrder = 0 THEN
          pBTS.Adr_BTRA := GetAdresse(c1.adr_id, vBTRA);      
          vOrder := 1;
        ELSE
          pBTS.Adr_BTRA2 := GetAdresse(c1.adr_id, vBTRA);            
        END IF;
      
      END LOOP;
    END IF;
  
    -- Betriebsarten
    SELECT * 
    BULK COLLECT INTO pBTS.bta
    FROM EIN_d_betriebsart
    WHERE d_bts_id = vBTS_ID
    ORDER BY CASE WHEN code IN ( '9999999', '0699', '0399' ) THEN NULL ELSE CODE END 
    NULLS LAST;
            
    -- Registrierung zu Betriebsstaette 
    FILL_Reg(pTyp => 'BTS', pID => vBTS_ID, pReg => pBTS.Reg);
    
    IF bts1.prot.quelle = QUELLE_XGEWERBE THEN
      SELECT fb.* BULK COLLECT INTO pBTS.Fachb
      FROM ein_d_fachbereiche fb
      WHERE fb.d_bts_id = vBTS_ID;
    END IF;
    

    -- wenn keine Gltigkeit in Registrierung vorhanden, dann vom Betrieb bernehmen
    IF pBTS.reg IS NOT NULL AND pBTS.reg.COUNT > 0 THEN
      FOR i IN pBTS.reg.FIRST .. pBTS.reg.LAST LOOP
                
        IF pBTS.reg(i).gueltig_von IS NULL THEN
          pBTS.reg(i).gueltig_von := pBTS.bts.gueltig_von;
        ELSE
          pBTS.reg(i).gueltig_von := TRUNC(pBTS.reg(i).gueltig_von);
        END IF;  
          
        IF pBTS.reg(i).gueltig_bis IS NULL THEN
          pBTS.reg(i).gueltig_bis := pBTS.bts.gueltig_bis;
        ELSE
          pBTS.reg(i).gueltig_bis := TRUNC(pBTS.reg(i).gueltig_bis);
        END IF;    

      END LOOP; 
    END IF; 
   
    -- Begin Betreiber     
    SELECT MAX( CASE WHEN fkt.typ IN( BETREIBER, INH) THEN 1 ELSE GetNumeric( fkt.typ ) END ) INTO vExt
    FROM ein_d_funktion fkt
    WHERE fkt.d_bts_id = vBTS_ID
    AND fkt.typ LIKE BETREIBER||'%'
    OR fkt.typ = INH;
    
    IF vExt > 0 THEN -- Betreiber sind vorhanden   
      --vExt := vExt + 1;
      
      pBTS.Btr_pers := tbBtr();
      pBTS.Btr_pers.EXTEND(vExt);      
      
      FOR cFkt IN (
        SELECT fkt.* FROM ein_d_funktion fkt
        WHERE fkt.d_bts_id = vBTS_ID
        AND fkt.typ <> HV
        ORDER BY fkt.typ
      ) LOOP
      
        vExt := NVL(GetNumeric(cFkt.Typ), 1);
        IF vExt > 0 THEN

          CASE
          WHEN cFkt.Typ IN ( INH, BETREIBER ) THEN  -- Hauptbetreiber
            fill_pers(pFKT => cFkt, pUsecaseAend => vUsecaseAend, pPers => pBTS.Btr_pers(1).betreiber, pAdrTyp => NULL);

          -- Betreiber n.-Ordnung  
          WHEN cFkt.Typ LIKE BETREIBER || '%' AND cFkt.Typ <> BETREIBER THEN -- Betreiber[n]
            IF vExt > 1 THEN
              fill_pers(pFKT => cFkt, pUsecaseAend => vUsecaseAend, pPers => pBTS.Btr_pers(vExt).betreiber, pAdrTyp => NULL );
            END IF;         
            
          -- Gesetzliche Vertreter  
          WHEN cFkt.Typ LIKE GV_Betreiber || '%' THEN
            IF pBTS.Btr_pers(vExt).gv IS NULL OR pBTS.Btr_pers(vExt).gv.COUNT = 0 THEN
              pBTS.Btr_pers(vExt).gv := tbFkt();
            END IF;       
            pBTS.Btr_pers(vExt).gv.EXTEND;
            fill_pers(pFKT => cFkt, pUsecaseAend => vUsecaseAend, pPers => pBTS.Btr_pers(vExt).gv( pBTS.Btr_pers(vExt).gv.LAST), pAdrTyp => NULL );
                      
          -- Hauptverantwortlicher
          WHEN cFkt.Typ LIKE HV_Betreiber || '%' THEN
            IF pBTS.Btr_pers(vExt).hv IS NULL OR pBTS.Btr_pers(vExt).hv.COUNT = 0 THEN
              pBTS.Btr_pers(vExt).hv := tbFkt();
            END IF;       
            pBTS.Btr_pers(vExt).hv.EXTEND;
            fill_pers(pFKT => cFkt, pUsecaseAend => vUsecaseAend, pPers => pBTS.Btr_pers(vExt).hv( pBTS.Btr_pers(vExt).hv.LAST), pAdrTyp => NULL );
          
          ELSE NULL;  
          END CASE;
        END IF; --vExt      
      
      END LOOP; 
    END IF; -- keine Betreiber 

--if false then    
--    -- Inhaber   
--    -- 27.01.2015
--    DECLARE
--    CURSOR cInh (pTyp IN ein_d_funktion.typ%TYPE)  IS
--      SELECT fkt.* --INTO pBTS.fkt_inh.fkt
--      FROM EIN_d_funktion fkt
--      WHERE fkt.typ = pTyp 
--       AND FKT.D_BTS_ID = vBTS_ID
--      ORDER by fkt.gueltig_von DESC, fkt.gueltig_bis DESC NULLS LAST;
--    BEGIN
--      IF bts1.prot.quelle = QUELLE_IDV_NRW THEN
--        OPEN cInh(INH);
--      ELSE
--        OPEN cInh(BETREIBER);
--      END IF;
--      FETCH cInh INTO pBTS.btr_pers(1).betreiber.fkt;
--      CLOSE cInh;   
--
--    END; -- Inhaber
--        
--    IF pBTS.btr_pers(1).betreiber.fkt.d_pers_id <> '-1' THEN
--      SELECT pers.* INTO pBTS.btr_pers(1).betreiber.pers
--      FROM EIN_d_person pers
--      WHERE pers.id = pBTS.btr_pers(1).betreiber.fkt.d_pers_id;
--    END IF;
--    
--    IF /*vGKZ2 = NRW*/ bts1.prot.quelle = QUELLE_IDV_NRW AND pBTS.btr_pers(1).betreiber.pers.id <> '-1' AND pBTS.btr_pers(1).betreiber.pers.Typ = 'NP' THEN
--      SplitNachname(pBTS.btr_pers(1).betreiber.pers.nachname, 
--                    pBTS.btr_pers(1).betreiber.pers.vorsatz_nachname, 
--                    pBTS.btr_pers(1).betreiber.pers.nachsatz_nachname);
--    END IF;
--
--    -- Inhaber - Kommunikation
--    /*
--      SELECT * 
--      FROM (
--        SELECT r1.d_bts_id, kom.komdata, kom.komtyp
--        FROM EIN_d_kommunikation kom
--        JOIN ein_r_bts_kom r1 on r1.d_kom_id = kom.id
--        WHERE r1.d_bts_id = 'A5A9DB1009734CE393BFCC50E06ED56B'  
--      ) PIVOT (
--        MAX(komdata) FOR komtyp IN ('TELEFON' AS "TELEFON", 'EMAIL' AS "EMAIL", 'FAX' AS "FAX", 'MOBIL' AS "MOBIL", 'INTERNET' AS "INTERNET")
--      )  
--    */
--    /*FOR cKom IN (
--      SELECT kom.* 
--      FROM EIN_r_fkt_kom r
--      JOIN EIN_d_kommunikation kom ON KOM.ID = R.D_KOM_ID  
--      WHERE r.d_fkt_id = pBTS.fkt_inh.fkt.id
--    ) LOOP
--    
--      CASE
--      WHEN cKom.komtyp = 'TELEFON' THEN
--        pBTS.fkt_inh.Kom.Telefon := cKom.komdata;
--      WHEN cKom.komtyp = 'MOBIL' THEN
--        pBTS.fkt_inh.Kom.mobil := cKom.komdata;
--      WHEN cKom.komtyp = 'EMAIL' THEN
--        pBTS.fkt_inh.Kom.email := cKom.komdata;
--      WHEN cKom.komtyp = 'FAX' THEN
--        pBTS.fkt_inh.Kom.fax := cKom.komdata;
--      WHEN cKom.komtyp = 'INTERNET' THEN
--        pBTS.fkt_inh.Kom.internet := cKom.komdata;
--      ELSE
--        NULL;
--      END CASE;    
--    
--    END LOOP; */
--
--      SELECT MIN(telefon) tel, MIN(fax) fax, MIN(mobil) mobil, MIN(email) email, MIN(internet) internet
--      INTO pBTS.btr_pers(1).betreiber.Kom.Telefon, pBTS.btr_pers(1).betreiber.Kom.fax, pBTS.btr_pers(1).betreiber.Kom.mobil, pBTS.btr_pers(1).betreiber.Kom.email, pBTS.btr_pers(1).betreiber.Kom.internet
--      FROM EIN_d_kommunikation kom
--      JOIN EIN_r_fkt_kom r ON R.D_KOM_ID = kom.id
--      AND  r.d_fkt_id = pBTS.btr_pers(1).betreiber.fkt.id
--      PIVOT( MIN(komdata)
--        FOR KOMTYP IN ( 
--          'TELEFON' AS telefon,
--          'FAX' AS fax,
--          'MOBIL' AS mobil,
--          'EMAIL' as email,
--          'INTERNET' AS internet ) 
--      );
--        
--    -- Inhaber - Registrierung
--    SELECT reg.* BULK COLLECT INTO pBTS.btr_pers(1).betreiber.reg
--    FROM EIN_r_fkt_reg r
--    JOIN EIN_d_registrierung reg ON R.D_REG_ID = reg.id
--    WHERE r.d_fkt_id = pBTS.btr_pers(1).betreiber.fkt.id;    
--
--    IF pBTS.btr_pers(1).betreiber.reg.COUNT > 0 THEN
--      FOR i IN pBTS.btr_pers(1).betreiber.reg.FIRST .. pBTS.btr_pers(1).betreiber.reg.LAST LOOP
--        pBTS.btr_pers(1).betreiber.reg(i).gueltig_von := TRUNC(pBTS.btr_pers(1).betreiber.reg(i).gueltig_von);
--        pBTS.btr_pers(1).betreiber.reg(i).gueltig_bis := TRUNC(pBTS.btr_pers(1).betreiber.reg(i).gueltig_bis);
--      END LOOP; 
--    END IF;
--    -- wenn keine Gltigkeit in Registrierung vorhanden, dann vom Betrieb bernehmen
--    /* wre falsche bei abweichendem Betreiber
--    IF pBTS.fkt_inh.reg.COUNT > 0 THEN
--      FOR i IN pBTS.fkt_inh.reg.FIRST .. pBTS.fkt_inh.reg.LAST LOOP
--                
--        IF pBTS.fkt_inh.reg(i).gueltig_von IS NULL THEN
--          pBTS.fkt_inh.reg(i).gueltig_von := pBTS.bts.gueltig_von;
--        END IF;    
--        IF pBTS.fkt_inh.reg(i).gueltig_bis IS NULL THEN
--          pBTS.fkt_inh.reg(i).gueltig_bis := pBTS.bts.gueltig_bis;
--        END IF;    
--
--      END LOOP; 
--    END IF; */
--      
--    -- PERS_ID als Registrierung IDV-INH speichern
--    IF pBTS.btr_pers(1).betreiber.pers.pers_id <> '0' AND BTS1.prot.quelle = QUELLE_IDV_NRW THEN  
--      vReg_idv_inh.art := vIDV_INH;
--      vReg_idv_inh.nummer := pBTS.btr_pers(1).betreiber.pers.pers_id;
--      vReg_idv_inh.gueltig_von := pBTS.btr_pers(1).betreiber.fkt.gueltig_von;
--      vReg_idv_inh.gueltig_bis := pBTS.btr_pers(1).betreiber.fkt.gueltig_bis;
--      pBTS.btr_pers(1).betreiber.reg.EXTEND;
--      pBTS.btr_pers(1).betreiber.reg( pBTS.btr_pers(1).betreiber.reg.LAST ) := vReg_idv_inh; 
--    END IF;
--    -- Inhaber - Adresse
--    IF vUsecaseAEND = 0 THEN
--      BEGIN
--        SELECT r.d_adr_id, r.typ INTO vAdrId, vTyp
--        FROM EIN_R_fkt_ADR r 
--        WHERE r.d_fkt_id = pBTS.btr_pers(1).betreiber.fkt.id;
--
--        pBTS.btr_pers(1).betreiber.Adr := GetAdresse(vAdrID, vTyp);
--        EXCEPTION WHEN no_data_found THEN vAdrID := '-9999'; 
--      END;
--    ELSE
--      vOrder := 0;
--      FOR c1 IN (
--        SELECT adr.id adr_id, r.typ
--        FROM EIN_R_fkt_ADR r 
--        JOIN ein_d_adresse adr ON adr.id = r.d_adr_id
--        WHERE r.d_fkt_id = pBTS.btr_pers(1).betreiber.fkt.id
--        AND r.typ IN( 'ORG', 'PERS', PostAdr)  -- PostAdr 17.10.2014
--        ORDER BY adr.gueltig_von DESC NULLS FIRST 
--      ) LOOP
--      
--        IF vOrder = 0 THEN
--          pBTS.btr_pers(1).betreiber.Adr := GetAdresse(c1.adr_id, c1.typ);      
--          vOrder := 1;
--        ELSE
--          pBTS.btr_pers(1).betreiber.Adr2 := GetAdresse(c1.adr_id, c1.typ);            
--        END IF;
--      
--      END LOOP;  
--    END IF;  
-- 
--    --IF pBTS.Prot.quelle = QUELLE_XGEWERBE THEN
--    --
--    --pBTS.btr_pers.
--    --END IF;    
--end if;

  END IF; -- res = 1
    
  RETURN res;
  
END; --Fill_Bts 

-- Index der Registrierung nach CODE ermitteln
FUNCTION RegIndexCode(pCode IN VARCHAR2, pReg IN tbReg) RETURN NUMBER IS
  res NUMBER(10) := -1;
BEGIN

  IF pReg.COUNT > 0 THEN
    FOR i IN pReg.FIRST .. pReg.LAST LOOP
      IF pReg(i).code = pCode THEN
        res := i;
      END IF;    
    END LOOP;    
  END IF;

  RETURN res;
END RegIndexCode;

-- Index der Registrierung nach ART ermitteln
FUNCTION RegIndex(pArt IN VARCHAR2, pReg IN tbReg) RETURN NUMBER IS
  res NUMBER(10) := -1;
BEGIN

  IF pReg IS NOT NULL AND pReg.COUNT > 0 THEN
    FOR i IN pReg.FIRST .. pReg.LAST LOOP
      IF pReg(i).art = pArt THEN
        res := i;
      END IF;    
    END LOOP;    
  END IF;

  RETURN res;
END; 

FUNCTION GetGKZ8byIDV_REGNR( pReg IN tbREG) RETURN VARCHAR2 AS
  res VARCHAR2(8) := '%';
  iReg NUMBER(10);
  vBI_IDV VARCHAR2(20) := vIDV;
BEGIN

  iReg := RegIndex(vBI_IDV, pReg);

  IF iReg > 0 THEN
    CASE bts1.prot.quelle
    WHEN QUELLE_XGEWERBE THEN
      AddErrMsg( 'Fr ' || QUELLE_XGEWERBE || ' kann die GKZ8 nicht ber eine Registrierung ermittelt werden.');  
      --res := '%';
    ELSE NULL;
    END CASE;
  ELSE
    AddErrMsg( CrtRegBez(vBI_IDV) || ' ist nicht vorhanden.');
  END IF;

  RETURN res;
END;

PROCEDURE GetA24_SID_LAND_by_ISO( pISO_Nr IN VARCHAR2, pSID OUT NUMBER, pLand OUT NOCOPY VARCHAR2) AS
BEGIN

    SELECT sid, post INTO pSid, pLand
    FROM glo_a24 
    WHERE deleted = 0
      AND iso_nr = pIso_Nr;
      
    EXCEPTION WHEN NO_DATA_FOUND THEN 
      pSid := 120; -- 24.06.2014 war -1
      pLand := NULL;

END;

PROCEDURE GetA0101_47(pBez IN VARCHAR2, pSID OUT NUMBER, pCode OUT NOCOPY VARCHAR2) AS
BEGIN
       
  SELECT sid, code INTO pSid, pCode
  FROM VIS_VA0101_47
  WHERE bez = pBez;
          
  EXCEPTION WHEN no_data_found THEN 
    pSid := -1;
    pCode := NULL;
          
END;

-- Rechtsform ermitteln
FUNCTION GetA0101_03_SID(pCode VARCHAR2) RETURN NUMBER AS
  vSID VIS_A0101.sid%TYPE := -1;
  vM1 VARCHAR2(100);
  vM2 VARCHAR2(100);
BEGIN

  IF pCode IS NOT NULL THEN
    
    CASE bts1.prot.quelle  
    WHEN QUELLE_XGEWERBE THEN

      vM1 := 'Die Rechtsform "' || pCode || '" ist nicht im Katalog enthalten.';
      vM2 := 'Die Rechtsform "' || pCode || '" ist mehrfach im Katalog enthalten.';

      SELECT a0101.sid INTO vSID
      FROM vis_a0101 a0101
      WHERE a0101.skz = 3
       AND a0101.deleted = 0
       AND a0101.code = pCode;    
       
    ELSE NULL;
    
    END CASE; 
   
  END IF;  
  
  RETURN vSID;
  
  EXCEPTION 
  WHEN no_data_found THEN
    AddMsg(vM1);
    RETURN -1; 
  WHEN too_many_rows THEN
    AddMsg(vM2);
    RETURN -1; 
END;

-- Vergleiche
FUNCTION Compare( pS1 IN VARCHAR2, pS2 IN VARCHAR2) RETURN NUMBER AS
  vRes PLS_INTEGER;
BEGIN
  IF (pS1 IS NULL AND pS2 IS NULL) OR pS1 = pS2 THEN
    vRes := 1;
  ELSE 
    vRes := 0;
  END IF;  
  RETURN vRes;
END;

FUNCTION Compare( pS1 IN DATE, pS2 IN DATE) RETURN NUMBER AS
  vRes PLS_INTEGER;
BEGIN
  IF (pS1 IS NULL AND pS2 IS NULL) OR pS1 = pS2 THEN
    vRes := 1;
  ELSE 
    vRes := 0;
  END IF;  
  RETURN vRes;
END;

FUNCTION Compare( pS1 IN NUMBER, pS2 IN NUMBER) RETURN NUMBER AS
  vRes PLS_INTEGER;
BEGIN
  IF (pS1 IS NULL AND pS2 IS NULL) OR pS1 = pS2 THEN
    vRes := 1;
  ELSE 
    vRes := 0;
  END IF;  
  RETURN vRes;
END;

FUNCTION Compare( pS1 IN CLOB, pS2 IN CLOB) RETURN NUMBER AS
  vRes PLS_INTEGER;
BEGIN
  IF (pS1 IS NULL AND pS2 IS NULL) OR pS1 = pS2 THEN
    vRes := 1;
  ELSE 
    vRes := 0;
  END IF;  
  RETURN vRes;
END;

-- Vergleich Adressen, bei Gleichheit Rckgabe 1
FUNCTION CompareAdr( Adr1 tAdr, Adr2 tAdr) RETURN PLS_INTEGER AS
  res PLS_INTEGER := 1;
BEGIN
  
  -- padr Vergleich
  IF Compare(adr1.padr.plz || adr1.padr.ort || adr1.padr.ortsteil || 
            adr1.padr.postfach || adr1.padr.strasse || adr1.padr.hausnr || 
            adr1.padr.hausnrzusatz ,
            adr2.padr.plz || adr2.padr.ort || adr2.padr.ortsteil || 
            adr2.padr.postfach || adr2.padr.strasse || adr2.padr.hausnr || 
            adr2.padr.hausnrzusatz
           ) = 0 THEN
    res := 0;
        
  END IF;   
  
--  -- kat Vergleich
--  IF res = 1 THEN  
--    IF Compare(adr1.kat.flurnummer || adr1.kat.flurstueck || adr1.kat.gemarkung, 
--              adr2.kat.flurnummer || adr2.kat.flurstueck || adr2.kat.gemarkung
--             ) = 0 THEN
--      res := 0;
--    END IF;  
--  END IF;
--    
--  IF res = 1 THEN
--    IF Compare(adr1.kat.x_wert, adr2.kat.x_wert ) = 0 THEN
--      res := 0;
--    END IF;   
--  END IF;
--    
--  IF res = 1 THEN  
--    IF Compare(adr1.kat.y_wert, adr2.kat.y_wert ) = 0 THEN
--      res := 0;
--    END IF;    
--  END IF;
--    
--  IF res = 1 THEN  
--    IF Compare(adr1.kat.rechtswert, adr2.kat.rechtswert ) = 0 THEN
--      res := 0;
--    END IF;    
--  END IF;
--    
--  IF res = 1 THEN
--    IF Compare(adr1.kat.hochwert, adr2.kat.hochwert ) = 0 THEN
--      res := 0;
--    END IF;  
--  END IF;
--  
--  -- verw Vergleich  
--  IF res = 1 THEN  
--    IF Compare(adr1.verw.gkz, adr2.verw.gkz) = 0 THEN
--      res := 0;
--    END IF;  
--  END IF;  
  
  RETURN res;

END;


-- Betriebsartenzuordnung
PROCEDURE GetA010108(pExtCode IN VARCHAR2, pGewerbsmaessig IN NUMBER, pStandard IN NUMBER, 
pArt IN VARCHAR2, vA010108_sid OUT PLS_INTEGER, vA010108_sid0 OUT PLS_INTEGER, 
vBez OUT NOCOPY VARCHAR2, vCode OUT NOCOPY VARCHAR2, vSkz OUT PLS_INTEGER, 
vFb OUT NOCOPY VARCHAR2, vAuswahl OUT PLS_INTEGER) AS
BEGIN
 
   
  SELECT sid, a010108_sid0, bez, Code,Skz, Fb, Auswahl INTO
  vA010108_sid, vA010108_sid0, vBez, vCode, vSkz, vFb, vAuswahl
  FROM VIS_A010108 a010108
  WHERE a010108.deleted = 0
    AND a010108.skz in (1,2,3,5)
    --AND (a010108.fb LIKE '%D%' OR a010108.fb LIKE '%P%' OR a010108.fb LIKE '%T%' OR a010108.fb LIKE '%H%')
    AND a010108.code = pExtCode;

  EXCEPTION WHEN no_data_found THEN AddMsg('Der unspezifische Betriebsart-Typ "' || pExtCode || '" wird nicht angelegt.');
            WHEN too_many_rows THEN AddMsg('Der unspezifische Betriebsart-Typ "' || pExtCode || '" wird nicht angelegt.');

END;

/**
  Liefert zur HIT-Nr. die passende D0101_ID
  In Abhngigkeit vom Usecase werden alle HIT-Nr. oder nur die angemeldeten verendet
  Bsp.:
  SELECT dx.id
  FROM TABLE( zbr_ein.GetD0101_IDbyHitUc('123','AEND_POST_ADR_BETREI')
**/
FUNCTION GetD0101_IDByHitUc(pHitNr IN VARCHAR2, pUc IN VARCHAR2) RETURN tbID PIPELINED AS
vID trID; 
BEGIN
  vID.ID := GetD0101_IDByHitUc2(pHitNr, pUc);
  PIPE ROW( vID );

  RETURN;
END GetD0101_IDByHitUc;

FUNCTION GetD0101_IDByHitUc2(pHitNr IN VARCHAR2, pUc IN VARCHAR2) RETURN tID AS
vID tID; 

CURSOR c1 (p1 IN VARCHAR2, p2 IN VARCHAR2 := BI) IS
SELECT prt.d0101_id
FROM ein_d_protokoll prt
JOIN ein_r_bts_reg r1 ON r1.d_bts_id = prt.d_bts_id
JOIN ein_d_registrierung reg ON reg.id = r1.d_reg_id
AND reg.art = p2
AND reg.nummer = p1
WHERE prt.deleted = 0
  AND prt.status = 0; -- externe Neuanlage / nderung
    
v1 c1%ROWTYPE;    

BEGIN
  BEGIN
    IF pHitNr IS NULL THEN
      vID := 'NO_DATA_FOUND';
    ELSE
      -- 13.11.2015 todo 59518090: HIT-Nr. ist eindeutig deshalb alle betrachten
        SELECT d010102.d0101_ID INTO vID
        FROM vis_d010102 d010102
        WHERE d010102.nummer = pHitNr
        AND d010102.deleted = 0
        AND d010102.a010145_sid = A010145_HIT_NR;
      
--      CASE 
--      WHEN pUC IN ('WIEDER_ANMELD_BTR', 'STORNO_BTR', 'ABMELD_BTR') THEN
--        SELECT d010102.d0101_ID INTO vID
--        FROM vis_vd010102$alle d010102
--        WHERE d010102.nummer = pHitNr
--        AND d010102.a010145_sid = A010145_HIT_NR;
--      ELSE
--        SELECT d010102.d0101_ID INTO vID
--        FROM vis_vd010102 d010102
--        WHERE d010102.nummer = pHitNr
--        AND d010102.a010145_sid = A010145_HIT_NR;
--      
--      END CASE;  
    
    END IF;
    
    EXCEPTION 
    WHEN NO_DATA_FOUND THEN
      vID := 'NO_DATA_FOUND'; 
    WHEN TOO_MANY_ROWS THEN
      vID := 'TOO_MANY_ROWS';
    WHEN OTHERS THEN
      RAISE_APPLICATION_ERROR(-20001, SQLERRM);
  END;

  IF pHitNr IS NOT NULL AND vID = 'NO_DATA_FOUND' THEN
  
    -- Im EK nach nicht besttigter ANMELD_BTR mit dieser HIT-Nr. suchen
    OPEN c1 (pHitNr);
    FETCH c1 INTO v1;
    IF c1%FOUND THEN 
      vID := v1.D0101_ID;
    END IF;
    CLOSE c1;
  END IF;  
  
  RETURN vID;
END GetD0101_IDByHitUc2;

FUNCTION GetD0101byPers_ID( pPers IN EIN_d_person%ROWTYPE) RETURN VARCHAR2 AS
  vID VIS_D010102.d0101_id%TYPE;
  vA010145_SID vis_d010102.a010145_sid%TYPE;
BEGIN
  

--  IF pPers.typ = 'JP' THEN -- juristische Person - ber Registrierung  
    vA010145_SID := CASE bts1.prot.quelle 
                    WHEN QUELLE_XGEWERBE THEN A010145_GEWERBENR
                    END;

    SELECT d0101_id INTO vID 
    FROM VIS_VD010102 d010102 
    WHERE d010102.nummer = pPers.Pers_ID 
      AND a010145_sid = vA010145_SID;
      
--  ELSE -- natrliche Person - ber D0102.pers_id
--     
--    SELECT d010200.d0101_id INTO vID
--    FROM vis_d0102 d0102
--    JOIN vis_d010200 d010200 ON d010200.d0102_id = d0102.id
--      AND d010200.deleted = 0 
--      AND d010200.HAUPTANSPRECHPARTNER = 1
--      AND d0102.deleted = 0
--      AND d0102.pers_id = pPers.pers_id; 
  
--  END IF;
    
  RETURN vID;
  
  EXCEPTION 
  WHEN no_data_found THEN 
    RETURN NULL;
  WHEN too_many_rows THEN 
    AddErrMsg('INH TYP "' || pPers.typ || '" PERS_ID "' || pPers.pers_ID || '" ist mehrfach in iP vorhanden.');
    RETURN NULL;   
  
END; --GetD0101ByPers_ID

FUNCTION GetD0101byCodeNr( pCode VARCHAR2, pNummer VARCHAR2) RETURN VARCHAR2 DETERMINISTIC AS
  vID VIS_D010102.d0101_id%TYPE;
--  vSID vis_a010145.sid%TYPE;
--  vBez vis_a010145.bez%TYPE;
--  vFB  vis_a010145.fb%TYPE;
--  vSKZ vis_a010145.skz%TYPE;
--  vCode vis_a010145.code%TYPE
  vA010145 tA010145;
BEGIN
  
  GetA010145(pCode, NULL, vA010145);
  
  IF vA010145.SID > 0 THEN
 
    SELECT d0101_id INTO vID 
    FROM VIS_vD010102 d010102 
    WHERE d010102.nummer = pNummer
      AND d010102.a010145_sid = vA010145.SID; 

  END IF;      
    
  RETURN vID;
  
  EXCEPTION 
  WHEN no_data_found THEN 
    RETURN '-1';
  WHEN too_many_rows THEN 
    --AddErrMsg('CODE "' || pCode || '", Nummer "' || pNummer || '" ist mehrfach in iP vorhanden.');
    RETURN '-2';   
  
END GetD0101byCodeNr;

-- VIS_D0102 aus bts1.fkt_hv.pers ablegen zum Betrieb Anlegen
FUNCTION InsertD0102( /*pD0101_ID IN VARCHAR2,*/ pPers IN EIN_D_PERSON%ROWTYPE) RETURN VARCHAR2 AS
vD0102_ID VIS_D0102.ID%TYPE;
vSysdate DATE := SYSDATE; 
vBez vis_d0102.bez%TYPE; 
BEGIN
    
  BEGIN
    SELECT id INTO vD0102_ID
    FROM vis_d0102
    WHERE deleted = 0
    AND pers_id = pPers.pers_id;

    EXCEPTION WHEN no_data_found THEN vD0102_ID := '-1';
              WHEN too_many_rows THEN vD0102_ID := '-2';

  END;
  
  CASE
  WHEN vD0102_ID = '-1' THEN
    vD0102_ID := SYS_GUID();
    vBez := GetD010200_Bez( pPers.nachname, pPers.vorname, pPers.vorsatz_nachname, pPers.nachsatz_nachname, pPers.Titel);
    INSERT INTO vis_d0102 (id, deleted, mandant, ins_date, upd_date, ins_user, upd_user, 
      bez, nname, vname, vorsatz_nname, nachsatz_nname, anrede, titel, pers_id, geb_ort, geb_datum)
    VALUES( vD0102_id, 0, vMandant_SID, vSYSDATE, vSYSDATE, vUser_SID, vUser_SID,
            vBez,
            pPers.nachname,
            pPers.vorname,
            pPers.vorsatz_nachname,
            pPers.nachsatz_nachname,
            pPers.anrede,
            pPers.titel,
            pPers.pers_id,
            pPers.geburtsort, pPers.geburtsdatum);         
    
  WHEN vD0102_ID = '-2' THEN
    AddErrMsg('Person mit PERS_ID "' ||  pPers.pers_id || '" ist mehrfach vorhanden.');    
  ELSE
    AddMsg('Person mit PERS_ID "' ||  pPers.pers_id || '" ist bereits vorhanden und wird verwendet.');
  END CASE;
    
  RETURN vD0102_ID;
      
END InsertD0102;

-- Personalfunhktionen anlegen
-- sind keine im Zuordnungskatalog dann einen leeren Datensatz anlegen
PROCEDURE InsertD010202(pA0101_03_SID IN NUMBER, pD0101_ID IN VARCHAR2, pD010200_ID IN VARCHAR2) AS
vD010202 vis_d010202%ROWTYPE;
vExists PLS_INTEGER := 0;

CURSOR cD010202 (pD010200_ID IN tID, pA0101_70_SID NUMBER) IS
  SELECT d010202.d010200_ID
  FROM vis_d010202 d010202
  WHERE d010202.deleted = 0
  AND d010202.d010200_id = pD010200_ID
  AND d010202.a0101_70_sid = pA0101_70_sid;
  
vCD010202 cD010202%ROWTYPE;
  
BEGIN

  -- Initialisierung
  SELECT * INTO vD010202
  FROM vis_d010202 WHERE id = '-1';
            
  vD010202.d010200_id := pD010200_id;
  vD010202.d0101_id   := pD0101_id;
  vD010202.MANDANT    := vMandant_SID; 
  vD010202.INS_USER   := vUser_SID;
  vD010202.INS_DATE   := SYSDATE;
  vD010202.UPD_USER   := vUser_SID;
  vD010202.UPD_DATE   := SYSDATE;
  vD010202.DELETED    := 0;
  vD010202.DEL_USER   := '-1';
  vD010202.DEL_DATE   := NULL;
  vD010202.d0103_id   := '-1';
  vD010202.zb         := '%';
  vD010202.fb         := '%';
  vD010202.az_prozent := 0;
  vD010202.vertreter  := NULL;
  vD010202.code       := NULL;
  vD010202.coden      := NULL;
  vD010202.bez        := NULL;

  FOR c1 IN ( 
    SELECT a0088.a0101_70_sid
    FROM vis_va0088$a0101_03$a0101_70 a0088
    WHERE a0088.a0101_03_sid = pA0101_03_sid
  ) LOOP

    OPEN cD010202 (pD010200_id, c1.A0101_70_sid);
    FETCH cD010202 INTO vCD010202;
    IF cD010202%NOTFOUND THEN 

      vD010202.id := SYS_GUID();
      vD010202.a0101_70_sid := NVL(c1.A0101_70_sid, -1);
      INSERT INTO vis_d010202 VALUES vD010202;

    END IF;
    CLOSE cD010202;
    
    vExists := 1;
    
  END LOOP;
   
  IF vExists = 0 THEN
    vD010202.id := SYS_GUID();
    vD010202.a0101_70_sid := -1;
    INSERT INTO vis_d010202 VALUES vD010202;  
  END IF;
   
END InsertD010202;

-- Personalfunktionen ber Funktionsbezeichnung anlegen
PROCEDURE InsD010202byBez70(pA0101_70_bez IN VARCHAR2, pD0101_ID IN VARCHAR2, pD010200_ID IN VARCHAR2, bForce BOOLEAN := True) AS
vD010202 vis_d010202%ROWTYPE;
vExists PLS_INTEGER := 0;

CURSOR c1 (pBez IN VARCHAR2) IS
SELECT a.sid 
FROM vis_a0101 a
WHERE a.deleted > -2
AND a.skz = 70 
AND a.bez = pBez;

CURSOR cD010202 (pD010200_ID IN tID, pA0101_70_SID NUMBER) IS
  SELECT d010202.d010200_ID
  FROM vis_d010202 d010202
  WHERE d010202.deleted = 0
  AND d010202.d010200_id = pD010200_ID
  AND d010202.a0101_70_sid = pA0101_70_sid;
  
vCD010202 cD010202%ROWTYPE;

BEGIN

  -- Initialisierung
  SELECT * INTO vD010202
  FROM vis_d010202 WHERE id = '-1';
            
  vD010202.id := SYS_GUID();
  vD010202.d010200_id := pD010200_id;
  vD010202.d0101_id   := pD0101_id;
  vD010202.MANDANT    := vMandant_SID; 
  vD010202.INS_USER   := vUser_SID;
  vD010202.INS_DATE   := SYSDATE;
  vD010202.UPD_USER   := vUser_SID;
  vD010202.UPD_DATE   := SYSDATE;
  vD010202.DELETED    := 0;
  vD010202.DEL_USER   := '-1';
  vD010202.DEL_DATE   := NULL;
  vD010202.d0103_id   := '-1';
  vD010202.zb         := '%';
  vD010202.fb         := '%';
  vD010202.az_prozent := 0;
  vD010202.vertreter  := NULL;
  vD010202.code       := NULL;
  vD010202.coden      := NULL;
  vD010202.bez        := NULL;
  vD010202.a0101_70_sid := -1;

  OPEN c1(pA0101_70_Bez);
  FETCH c1 INTO vD010202.a0101_70_sid;
  IF NOT c1%FOUND THEN
    vD010202.a0101_70_sid := -1;
  END IF;

  IF vD010202.a0101_70_sid > -1 THEN
    OPEN cD010202 (vD010202.d010200_id, vD010202.a0101_70_sid);
    FETCH cD010202 INTO vCD010202;
    IF cD010202%FOUND THEN
      vExists := 1;
    END IF;
    CLOSE cD010202;  
  END IF;

  IF vExists = 0 AND ( vD010202.a0101_70_sid > -1 OR bForce) THEN
    INSERT INTO vis_d010202 VALUES vD010202;
  END IF;
  CLOSE c1;
     
END InsD010202byBez70;



FUNCTION InsertD0102Adr( /*pD0101_ID IN VARCHAR2,*/ pPers IN tFKT) RETURN VARCHAR2 AS
vD0102 VIS_D0102%ROWTYPE;
--vGlo_a24_sid glo_a24.sid%TYPE;
vSysdate DATE := SYSDATE; 
--vBez vis_d0102.bez%TYPE; 
BEGIN

  SELECT * INTO vD0102
  FROM vis_d0102 WHERE id = '-1';
  
  vD0102.ID := SYS_GUID();
  vD0102.bez := GetD010200_Bez( pPers.pers.nachname, pPers.pers.vorname, pPers.pers.vorsatz_nachname, pPers.pers.nachsatz_nachname, pPers.pers.Titel);     
  vD0102.deleted := 0;
  vD0102.mandant := vMandant_SID;
  vD0102.ins_date := vSYSDATE;
  vD0102.upd_date := vSYSDATE;
  vD0102.ins_user := vUser_SID;
  vD0102.upd_user := vUser_SID;
  vD0102.nname := pPers.pers.nachname;
  vD0102.vname := pPers.pers.vorname;
  vD0102.vorsatz_nname := pPers.pers.vorsatz_nachname;
  vD0102.nachsatz_nname := pPers.pers.nachsatz_nachname;
  vD0102.anrede := pPers.pers.anrede;
  vD0102.titel := pPers.pers.titel;
  vD0102.pers_id := pPers.pers.pers_id;
  -- Kommunikation in d010200
  --vD0102.kom_tel := pPers.kom.telefon;
  --vD0102.kom_fax := pPers.kom.fax;
  --vD0102.kom_email := pPers.kom.email;
  --vD0102.kom_internet := pPers.kom.internet;
  --vD0102.kom_mobil := pPers.kom.mobil;
  -- Adresse
  GetA24_SID_Land_By_ISO( pPers.adr.padr.staat, vD0102.Glo_a24_sid, vD0102.land);
  vD0102.plz := pPers.adr.padr.plz;
  vD0102.ort := pPers.adr.padr.ort;
  vD0102.ortsteil := pPers.adr.padr.ortsteil;
  vD0102.adresszusatz := pPers.adr.padr.adresszusatz;
  vD0102.strasse := pPers.adr.padr.strasse;
  vD0102.hausnr := pPers.adr.padr.hausnr;
  vD0102.hausnrzusatz := pPers.adr.padr.hausnrzusatz;
  vD0102.gkz := SUBSTR(pPers.adr.verw.gkz,1,8);
  vD0102.geb_ort := pPers.pers.geburtsort;
  vD0102.geb_datum := pPers.pers.geburtsdatum;
  
  INSERT INTO vis_d0102 VALUES vD0102;

  RETURN vD0102.ID;
      
END InsertD0102Adr;

-- Person anlegen
PROCEDURE pers_anl( pPers IN OUT NOCOPY tFkt, 
                    pBetreiber IN tFkt, 
                    pInhaber IN NUMBER, 
                    pIsHV IN PLS_INTEGER, 
                    pInsFkt IN PLS_INTEGER/*,
                    pChkDublette IN BOOLEAN*/) AS
/*
  pInsFkt:
  0 - keine personalfunktion anlegen
  1 - Personalfunktion ber die Rechtsform anlegen
  2 - Personalfunktion "vertretungsberechtigte Person" wenn vorhanden anlegen 
**/ 

  vD0102_ID VIS_D0102.ID%TYPE;
  vA0101_03_SID vis_a0101.sid%TYPE := -1;
  vBez vis_d0101.bez%TYPE;
  vD010200_ID2 vis_d0101.d010200_id2%TYPE;
  vSYSDATE DATE := SYSDATE;
  vSKZ vis_d0101.skz%TYPE;
  
--  CURSOR cD010200 (pD0101_ID VARCHAR2, pVName VARCHAR2, pNName VARCHAR2, pGebDat DATE) IS
--  SELECT d010200.id
--  FROM vis_d010200 d010200
--  JOIN vis_d0102 d0102 ON d0102.id = D010200.d0102_id
--  AND d010200.deleted = 0
--  AND d0102.deleted = 0
--  AND d010200.d0101_id = pD0101_ID
--  AND d0102.vname ||TAB = pVName||TAB
--  AND d0102.nname = pNName
--  AND NVL(D0102.GEB_DATUM, vDateMax) = NVL(pGebDat, vDateMax) ; 
--
--  vCD010200 cD010200%ROWTYPE;
--  vFound BOOLEAN := FALSE;
BEGIN

--DBMS_OUTPUT.PUT_LINE(' pers_anl pPers.pers.id:'||pPers.pers.id);
  -- pPers.pers.ref_id ist bei Dubletten gesetzt
  IF NOT IS_ID( pPers.pers.id ) OR IS_ID(pPers.pers.ref_id) THEN
    RETURN;
  END IF;
 
--  IF pChkDublette THEN
--    OPEN cD010200(  pD0101_ID => pBetreiber.pers.ref_id, 
--                    pNName => pPers.pers.nachname, 
--                    pVName => pPers.pers.vorname,
--                    pGebDat => pPers.pers.geburtsdatum);
--    FETCH cD010200 INTO vCD010200;
--    vFound := cD010200%FOUND;
--    CLOSE cD010200;
--  END IF;
--    
--  IF vFound THEN
--    RETURN;
--  END IF;  

  vBez := GetD010200_BEZ(pPers.pers.nachname, pPers.pers.vorname,
                         pPers.pers.vorsatz_nachname, 
                         pPers.pers.nachsatz_nachname,
                         pPers.pers.titel );
--DBMS_OUTPUT.PUT_LINE('vBez:'||vBez);
  --IF vD010200_id2 = '-1' OR pInhaber = 0 THEN -- Anlegen

    vD0102_ID := insertD0102Adr(pPers);
--DBMS_OUTPUT.PUT_LINE ( 'vD0102_ID = ' || vD0102_ID );    
--DBMS_OUTPUT.PUT_LINE ( 'pBetreiber.pers.ref_id = ' || pBetreiber.pers.ref_id );
    pPers.pers.ref_id := SYS_GUID();
    --pPers.pers.ref_id := vD010200_ID
    INSERT INTO vis_d010200
    ( ID, D0102_ID, D0101_ID, MANDANT, INS_USER, INS_DATE, UPD_USER, UPD_DATE, 
      DELETED, /*HAUPTANSPRECHPARTNER,*/ INHABER, BETRIEBSPERSONAL, BEZ,
      kom_tel, kom_fax, kom_email, kom_internet, kom_mobil)
    VALUES (pPers.pers.ref_id, vD0102_ID, pBetreiber.pers.ref_id, vMandant_SID, vUSER_SID, vSYSDATE, vUser_SID, vSYSDATE, 
      0, /*1,*/ pInhaber, 1, vBez,
      pPers.kom.telefon, pPers.kom.fax, pPers.kom.email, pPers.kom.internet, pPers.kom.mobil
      );
    
    UPDATE ein_d_person
    SET ref_id = pPers.pers.ref_id
    WHERE id = pPers.pers.id;
--DBMS_OUTPUT.PUT_LINE ( 'pPers.pers.ref_id = ' || pPers.pers.ref_id ); 
--DBMS_OUTPUT.PUT_LINE ( 'pPers.pers.id = ' || pPers.pers.id );   
    IF pIsHv = 1 THEN   
      UpdBTS_HV(pBetreiber.pers.ref_id, pPers.pers);                  
--      UPDATE vis_d0101
--      SET d010200_id2 = pPers.pers.ref_id --vD010200_ID
--        , nname = pPers.pers.nachname
--        , vname = pPers.pers.vorname
--        , anrede = pPers.pers.anrede
--        , titel = pPers.pers.titel
--        , nachsatz_nname = pPers.pers.nachsatz_nachname
--        , vorsatz_nname = pPers.pers.vorsatz_nachname
--      WHERE id = pBetreiber.pers.ref_id;                         
    END IF;
    
--DBMS_OUTPUT.PUT_LINE ( 'pInsFkt = ' || pInsFkt );  
  CASE pInsFkt 
  WHEN 1 THEN
    IF pBetreiber.Pers.a0101_03_sid > -1 THEN
      vA0101_03_sid := pBetreiber.Pers.a0101_03_sid;
    ELSE
      vA0101_03_sid :=  GetA0101_03_sid( pBetreiber.Pers.rechtsform); 
    END IF;
    InsertD010202(vA0101_03_SID, pBetreiber.pers.ref_id, pPers.pers.ref_id);
  WHEN 2 THEN
    InsD010202byBez70(VERTRET_PERSON, pBetreiber.pers.ref_id, pPers.pers.ref_id, True);
  ELSE NULL;
  END CASE;
      
END pers_anl;


-- Betriebsstaette - Hauptverantwortlichen anlegen
PROCEDURE pers_anl_hv(pD0101_id VARCHAR2, pPers IN ein_d_person%ROWTYPE, pInhaber IN NUMBER, pUpdBTS IN PLS_INTEGER) AS
  vD010200_ID vis_d010200.id%TYPE;
  vD0102_ID VIS_D0102.ID%TYPE;
  vA0101_03_SID vis_a0101.sid%TYPE := -1;
  vBez vis_d0101.bez%TYPE;
  vD010200_ID2 vis_d0101.d010200_id2%TYPE;
  vInsertD010202 BOOLEAN := False;
  vSYSDATE DATE := SYSDATE;
  vSKZ vis_d0101.skz%TYPE;
BEGIN

  IF pPers.id IS NULL THEN
    RETURN;
  END IF;

  vBez := CreateD0101Bez(
            pPers.nachname, pPers.vorname, 
            pPers.vorsatz_nachname, 
            pPers.nachsatz_nachname,
            pPers.titel);

  UPDATE VIS_D0101
  SET nname = pPers.nachname,
      vname = pPers.vorname,
      vorsatz_nname = pPers.vorsatz_nachname,
      nachsatz_nname = pPers.nachsatz_nachname,
      anrede = pPers.anrede,
      titel = pPers.titel,
      bez = NVL(bez, vBez ),
      upd_date = vSYSDATE,
      upd_user = vUser_SID      
  WHERE id = pD0101_ID
  RETURNING d010200_id2, skz INTO vD010200_id2, vSkz ;  
  
  -- berprfung HAUPTANSPRECHPARTNER
  -- wenn nicht vorhanden -> anlegen, sonst aktualisieren - ist dann aber ein Datenfehler
-- 12.06.2014
--  SELECT COUNT(*) INTO vCnt
--  FROM vis_d010200
--  WHERE deleted = 0
--   AND HAUPTANSPRECHPARTNER = 1
--   AND d0101_id = pD0101_ID;
   
  vBez := GetD010200_BEZ(pPers.nachname, pPers.vorname,
                         pPers.vorsatz_nachname, 
                         pPers.nachsatz_nachname,
                         pPers.titel );

  IF vD010200_id2 = '-1' OR pInhaber = 0 THEN -- Anlegen

    vD0102_ID := InsertD0102(/*pD0101_ID,*/ pPers);
    
    vD010200_ID := SYS_GUID();
    INSERT INTO vis_d010200
    (ID, D0102_ID, D0101_ID, MANDANT, INS_USER, INS_DATE, UPD_USER, UPD_DATE, DELETED, /*HAUPTANSPRECHPARTNER,*/ INHABER, BETRIEBSPERSONAL, BEZ)
    VALUES (vD010200_ID, vD0102_ID, pD0101_ID, vMandant_SID, vUSER_SID, vSYSDATE, vUser_SID, vSYSDATE, 0, /*1,*/ pInhaber, 1,  
            vBez );
                           
    UPDATE vis_d0101
    SET d010200_id2 = vD010200_ID
--      , upd_date = vSYSDATE
--      , upd_user = vUser_SID
--      , nname = pPers.nachname
--      , vname = pPers.vorname
--      , anrede = pPers.anrede
--      , titel = pPers.titel
--      , vorsatz_nname = pPers.vorsatz_nachname
--      , nachsatz_nname = pPers.vorsatz_nachname
    WHERE id = pD0101_ID;                         
    
    vInsertD010202 := True;

  ELSE -- eigentlich Fehler
    AddMsg('Hauptansprechpartner ist bereits vorhanden und wurde aktualisiert.');
      
    SELECT id, d0102_id INTO vD010200_ID, vD0102_id
      FROM vis_d010200
      WHERE id = vD010200_ID2;
            
    IF vD0102_ID = '-1' THEN -- D0102 anlegen
      vD0102_ID := InsertD0102(/*pD0101_ID,*/ pPers);   
      vInsertD010202 := True;   
    ELSE   
       
      UPDATE vis_d0102
      SET nname         = pPers.nachname,
          vname         = pPers.vorname,
          vorsatz_nname = pPers.vorsatz_nachname,
          nachsatz_nname = pPers.nachsatz_nachname,          
          anrede    = pPers.anrede,
          titel     = pPers.titel,
          pers_id   = pPers.pers_id,
          geb_datum = pPers.geburtsdatum,
          geb_ort   = pPers.geburtsort,
          bez       = vBez,
          upd_date  = vSYSDATE,
          upd_user  = vUser_SID          
      WHERE id = vD0102_ID;
    
    END IF;
    
    UPDATE VIS_D010200
    SET d0102_id = vD0102_id,
        bez = vBez,
        inhaber = pInhaber,                     
        upd_date = vSYSDATE,
        upd_user = vUser_SID
    WHERE id = vD010200_id;
    
  END IF;
  
  IF vInsertD010202 THEN
    IF bts1.btr_pers(1).betreiber.Pers.a0101_03_sid > -1 THEN
      vA0101_03_sid := bts1.btr_pers(1).betreiber.Pers.a0101_03_sid;
    ELSE
      vA0101_03_sid :=  GetA0101_03_sid(bts1.btr_pers(1).betreiber.Pers.rechtsform); 
    END IF;
    InsertD010202(vA0101_03_SID, pD0101_ID, vD010200_ID);
  END IF;
  
  -- Betriebssttte HV anpassen
  IF vSkz = 99 AND pUpdBTS = 1 THEN
    UPDATE vis_d0101 SET
      d010200_id2 = vD010200_id,
      nname = pPers.nachname,
      vname = pPers.vorname,
      vorsatz_nname = pPers.vorsatz_nachname,
      nachsatz_nname = pPers.nachsatz_nachname,
      anrede = pPers.anrede,
      titel = pPers.titel
    WHERE d0101_id3 = pD0101_ID
    AND d0101_id3 <> ID
    AND deleted = 0;
  
  END IF;  
    
END pers_anl_hv;

-- Registrierungen abmelden 14.10.2014
-- pTyp: 1 Betriebssttte, 2 Betriebssttte alt, 3 Betreiber
FUNCTION Reg_Dea(pD0101_id IN VARCHAR2, pTyp IN PLS_INTEGER) RETURN PLS_INTEGER AS
  TYPE tID IS TABLE OF vis_d010102.id%TYPE;
  vID tID;
  vA010145 tA010145;
  vUpdCnt PLS_INTEGER := 0; 
  vA0302_05_sid vis_a0302.sid%TYPE;
  vReg tbReg;
  vSYSDATE DATE := SYSDATE;
  
  PROCEDURE AbmeldungD010102(pI IN NUMBER) AS
  BEGIN   
    
    IF vReg(pI).nummer IS NULL THEN
      UPDATE vis_d010102 
      SET gueltig_bis = vReg(pI).gueltig_bis
        , upd_date = vSYSDATE
        , upd_user = vUser_SID
      WHERE d0101_id = pD0101_ID
        AND deleted = 0
        AND a010145_sid IN ( SELECT ax.sid FROM vis_a010145 ax WHERE ax.skz = vA010145.skz AND ax.code LIKE vA010145.code)
      RETURNING id BULK COLLECT INTO vID;
    ELSE
      UPDATE vis_d010102 
      SET gueltig_bis = vReg(pI).gueltig_bis
        , upd_date = vSYSDATE
        , upd_user = vUser_SID
      WHERE d0101_id = pD0101_ID
        AND deleted = 0
        AND a010145_sid = vA010145.sid
        AND nummer = vReg(pI).nummer            
        AND a010145_sid IN ( SELECT ax.sid FROM vis_a010145 ax WHERE ax.skz = vA010145.skz AND ax.code LIKE vA010145.code)
      RETURNING id BULK COLLECT INTO vID;
    END IF;
    
    vUpdCnt := vUpdCnt + SQL%ROWCOUNT;
    
  END AbmeldungD010102;
BEGIN 

  CASE
  WHEN pTyp = 1 THEN
    vReg := bts1.Reg;
  WHEN pTyp = 2 THEN
    vReg := bts2.Reg;
  WHEN pTyp = 3 THEN
    vReg := bts1.btr_pers(1).betreiber.Reg; 
  ELSE
    NULL;
  END CASE;

  IF vReg.COUNT > 0 THEN
  
    SELECT sid INTO vA0302_05_sid
    FROM vis_a0302
    WHERE deleted = 0
     AND skz = 5
     AND code = '08';  -- entzogen
     
    FOR i IN vReg.FIRST .. vReg.LAST LOOP

      IF vReg(i).art NOT IN( 'BALVI', vIDV, vIDV_INH) AND vReg(i).gueltig_bis < Default_gueltig_bis THEN 
      
        --IF pArt IS NULL OR pArt = pReg(i).art THEN 
          GetA010145( vReg(i).art, vReg(i).code, vA010145);
        
          IF vA010145.sid > 0 THEN
            AbmeldungD010102(i); 
            IF vID.COUNT > 0 THEN
              CASE
              WHEN pTyp = 1 THEN
                bts1.Reg(i).ref_id := vId(1);
                
                UPDATE ein_d_registrierung SET ref_id = vID(1)
                WHERE id = bts1.Reg(i).id;
                 
              WHEN pTyp = 2 THEN
                bts2.Reg(i).ref_id := vId(1);

                UPDATE ein_d_registrierung SET ref_id = vID(1)
                WHERE id = bts2.Reg(i).id;

              WHEN pTyp = 3 THEN
                bts1.btr_pers(1).betreiber.Reg(i).ref_id := vId(1);

                UPDATE ein_d_registrierung SET ref_id = vID(1)
                WHERE id = bts1.btr_pers(1).betreiber.Reg(i).id;
              
              ELSE NULL;  
              END CASE;
            END IF;
          END IF;            
          
        --END IF;
      
      END IF;
      
    END LOOP;  

    IF vUpdCnt = 0 THEN
      AddErrMsg('Keine Registrierung abgemeldet.');
    END IF; 

  ELSE
    AddMsg('Keine Registrierungen vorhanden.');  
  END IF;
  
  RETURN vUpdCnt;
  
END REG_DEA;

-- Registrierungen korrigieren 14.10.2014
-- pTyp: 1 Betriebssttte, 3 Betreiber
FUNCTION Reg_kor(pD0101_id IN VARCHAR2, pTyp IN PLS_INTEGER) RETURN PLS_INTEGER AS
  TYPE tID IS TABLE OF vis_d010102.id%TYPE;  
  vID tID;
  vA010145 tA010145;
  vUpdCnt PLS_INTEGER := -1; 
  --vA0302_05_sid vis_a0302.sid%TYPE;
  pReg tbReg;
  vReg2 tbReg;
  vSYSDATE DATE := SYSDATE;
  vIdxAlt PLS_INTEGER;
  
  PROCEDURE UpdateD010102(pIdx IN PLS_INTEGER) AS
  BEGIN
    GetA010145( pReg(pIdx).art, pReg(pIdx).code, vA010145);
                  
    IF vA010145.sid > 0 THEN               
          
      UPDATE vis_d010102 
      SET gueltig_bis = pReg(pIdx).gueltig_bis
        , gueltig_von = pReg(pIdx).gueltig_von
        , nummer = pReg(pIdx).nummer
        --, a010145_sid = vA010145_sid
        , bez = vA010145.bez
        , fb = vA010145.fb
        , upd_date = vSYSDATE
        , upd_user = vUser_SID
        , a0302_05_sid = 29001 -- 05 nderung
      WHERE d0101_id = pD0101_ID
        AND deleted = 0
        AND a010145_sid IN ( SELECT ax.sid FROM vis_a010145 ax WHERE ax.skz = vA010145.skz AND ax.code LIKE vA010145.code)
        AND nummer || TAB = bts2.reg(vIdxAlt).Nummer || TAB
      RETURNING id BULK COLLECT INTO vID;
        
      vUpdCnt := SQL%ROWCOUNT;
            
    ELSE
      AddErrMsg('Die korrigierte Registrierungs-/Zulassungsart ' || pReg(pIdx).art || 
                ' ist unbekannt und wird nicht verarbeitet.');
    END IF;  
  END;
  
BEGIN 

  CASE
  WHEN pTyp = 1 THEN
    pReg := bts1.Reg;
    vReg2 := bts2.reg;
  WHEN pTyp = 3 THEN
    pReg := bts1.btr_pers(1).betreiber.Reg;
    vReg2 := bts2.btr_pers(1).betreiber.reg; 
  ELSE
    NULL;
  END CASE;

  IF pReg.COUNT > 0 THEN
     
    FOR i IN pReg.FIRST .. pReg.LAST LOOP

      IF pReg(i).art NOT IN( 'BALVI', vIDV, vIDV_INH) 
      AND NVL(pReg(i).gueltig_bis, Default_gueltig_bis) = Default_gueltig_bis THEN  
        vIdxAlt := RegIndex(pReg(i).art, vReg2);
        IF vIdxAlt > 0 THEN 
          
          UpdateD010102(i); 
          
          IF vUpdCnt > 0 THEN -- 1. ID in ref_id speichern
            CASE
            WHEN pTyp = 1 THEN
              bts1.Reg(i).ref_id := vId(1);
                  
              UPDATE ein_d_registrierung SET ref_id = vID(1)
              WHERE id = bts1.Reg(i).id;
                   
            WHEN pTyp = 2 THEN
              bts2.Reg(i).ref_id := vId(1);

              UPDATE ein_d_registrierung SET ref_id = vID(1)
              WHERE id = bts2.Reg(i).id;

            WHEN pTyp = 3 THEN
              bts1.btr_pers(1).betreiber.Reg(i).ref_id := vId(1);

              UPDATE ein_d_registrierung SET ref_id = vID(1)
              WHERE id = bts1.btr_pers(1).betreiber.Reg(i).id;
                
            ELSE NULL;  
            END CASE;
          END IF;
                              
        ELSE
          AddErrMsg('Der alte Werte fr die korrigierten Registrierung/Zulassung ' 
          || pReg(i).art || TRIM(TRAILING FROM ' ' || pReg(i).nummer) ||  
          ' ist nicht im Eingangskorb vorhanden.');  
        END IF; -- vIdxAlt > 0
      
      END IF;
      
    END LOOP;  

    IF vUpdCnt = 0 THEN
      AddErrMsg('Keine Registrierung/Zulassung korrigiert.');
    END IF; 

  ELSE
    AddMsg('Keine Registrierungen vorhanden.');  
  END IF;
  
  RETURN vUpdCnt;
  
END REG_KOR;

--------------------------------------------------------------------------------


FUNCTION AnlageFKT_INH(pFkt_inh IN OUT NOCOPY tFkt, pZB IN VARCHAR2, pBtrOrdnung IN NUMBER) RETURN VARCHAR2 AS
  vI  PLS_INTEGER;
  vD0101 vis_d0101%ROWTYPE;
  vHausnrTyp1 VARCHAR2(1);
  vHausnrTyp2 VARCHAR2(1);
  vHausNr glo_a27.von_hausnr%TYPE := NULL;
BEGIN
  
  SELECT * INTO vD0101 FROM vis_d0101 WHERE id = '-1';

  IF pFKT_INH.Pers.a0101_03_sid > -1 THEN
    vD0101.A0101_03_sid := pFKT_INH.Pers.a0101_03_sid;
  ELSE    
    vD0101.A0101_03_SID := GetA0101_03_SID( pFKT_INH.Pers.RECHTSFORM);
  END IF;
  -- bei Natrlicher Person wurde keine Rechtform eingetragen -> EinzelU
  IF pFKT_INH.pers.typ = 'NP' AND vD0101.A0101_03_SID = -1 THEN
    vD0101.a0101_03_sid := 2; -- EinzelU    
  END IF;
     
  pFkt_Inh.pers.a0101_03_sid := vD0101.A0101_03_SID; 
  bts1.btr_pers(1).betreiber.pers.a0101_03_sid := vD0101.A0101_03_SID; -- todo 69761090 bugfix
  
  --GetA24_SID_Land_By_ISO( pFKT_INH.adr.verw.staat, vD0101.glo_A24_sid, vD0101.land);
  GetA24_SID_Land_By_ISO( pFKT_INH.adr.padr.staat, vD0101.glo_A24_sid, vD0101.land);
  
  vD0101.code := NULL;
--  vI := RegIndex('BALVI', bts1.reg);
--  IF vI > 0 THEN
--    vD0101.code := bts1.reg(vI).nummer;
--  END IF;
    
  vD0101.id := SYS_GUID();
  pFkt_inh.pers.ref_id := vD0101.id;
  
  UPDATE ein_d_person
  SET ref_id = pFkt_inh.pers.ref_id
  WHERE id = pFkt_inh.pers.id;
   
  vD0101.mandant      := vMandant_SID;
  vD0101.D0101_ID2    := vD0101.id;    
  vD0101.D0101_ID3    := vD0101.id; 
  vD0101.D0101_ID4    := '-1';    
  vD0101.D0101_ID10   := '-1';    
  vD0101.D010200_ID   := '-1';
  vD0101.d010200_id2  := '-1';    
  vD0101.A030501_01_SID := -1;
  vD0101.A030501_02_SID := -1;
  vD0101.A030502_SID    := -1;
  vD0101.A0113_100_SID  := -1;
  vD0101.A010108_SID    := -1;
  vD0101.A030501_05_SID := -1;
  --24.06.2014 vD0101.GLO_A24_SID  := 120;
  vD0101.GLO_A24_SID2 := vD0101.GLO_A24_SID;
  vD0101.s09_SID      := -1;
  vD0101.SKZ          := 99;  
  vD0101.BEZ          := CASE WHEN pFKT_INH.pers.typ = 'JP' THEN pFKT_INH.pers.bezeichnung 
                         ELSE CreateD0101Bez( pFKT_INH.pers.nachname,
                                              pFKT_INH.pers.vorname,
                                              pFKT_INH.pers.vorsatz_nachname,
                                              pFKT_INH.pers.nachsatz_nachname,
                                              pFKT_INH.pers.titel)
                         END; 
  vD0101.NAME1        := pFKT_INH.pers.bezeichnung2;
  vD0101.INS_USER     := vUSer_sid;
  vD0101.INS_DATE     := SYSDATE;
  vD0101.UPD_USER     := vUser_sid;
  vD0101.UPD_DATE     := SYSDATE;
  vD0101.DEL_USER     := -1;
  vD0101.DELETED      := 0;
  vD0101.TITEL        := pFKT_INH.pers.titel;
  vD0101.ANREDE       := pFKT_INH.pers.anrede; 
  vD0101.NNAME        := pFKT_INH.pers.nachname;
  vD0101.VNAME        := pFKT_INH.pers.vorname;
  vD0101.VORSATZ_NNAME  := pFKT_INH.pers.vorsatz_nachname;
  vD0101.NACHSATZ_NNAME := pFKT_INH.pers.nachsatz_nachname;
  vD0101.ANMELDUNG    := TRUNC(pFKT_INH.fkt.gueltig_von);
  vD0101.ABMELDUNG    := CASE WHEN TRUNC(pFKT_INH.fkt.gueltig_bis) = Default_gueltig_bis THEN NULL ELSE TRUNC(pFKT_INH.fkt.gueltig_bis) END; 
  --vD0101.LAND         := vD0101.land;
  vD0101.PLZ          := pFKT_INH.adr.padr.plz;
  vD0101.ORT          := pFKT_INH.adr.padr.ort;
  vD0101.adresszusatz := pFkt_inh.adr.padr.adresszusatz;
  vD0101.ORTSTEIL     := pFKT_INH.adr.padr.ortsteil;
  vD0101.STRASSE      := pFKT_INH.adr.padr.strasse; 
  vD0101.HAUSNR       := pFKT_INH.adr.padr.hausnr;
  vD0101.HAUSNRZUSATZ := pFKT_INH.adr.padr.hausnrzusatz; 
    /*GEMEINDE,*/
  IF pFKT_INH.adr.verw.gkz IS NULL THEN 
    
    IF pFKT_INH.adr.padr.hausnr IS NULL THEN
      vHausnrtyp1 := 'G';
      vHausnrtyp2 := 'U';
    ELSE
      -- todo 56877090: Fehler wenn Hausnr. alphanumerisch
      IF IsNumeric(pFKT_INH.adr.padr.hausnr) = 1 THEN 
        vHausnr := TO_NUMBER( pFKT_INH.adr.padr.hausnr );
        IF MOD( vHausnr, 2) = 0 THEN 
          vHausnrtyp1 := 'G';  -- gerade Hausnr.
        ELSE
          vHausnrtyp1 := 'U';  -- ungerade Hausnr.
        END IF;
        vHausnrtyp2 := vHausnrtyp1;      
      END IF;
    END IF;
            
    SELECT MAX(a27.gkz), COUNT(DISTINCT a27.GKZ) INTO vD0101.GKZ, vI  
    FROM glo_a27 a27
    WHERE a27.deleted = 0
      AND a27.plz = pFKT_INH.adr.padr.plz
      -- wenn Strae NULL dann alle Straen verwenden
      AND a27.bez LIKE CASE WHEN pFKT_INH.adr.padr.strasse IS NULL THEN '%' ELSE pFKT_INH.adr.padr.strasse END 
      AND a27.ort = pFKT_INH.adr.padr.ort
      AND A27.HAUSNR_TYP IN ('N', vHausnrtyp1, vHausnrtyp2) 
      -- wenn Hausnr. NULL dann alle hausnr. verwenden
      AND ( vHausnr BETWEEN a27.von_hausnr AND A27.BIS_HAUSNR OR vHausnr IS NULL);
      
    IF bts1.prot.quelle = QUELLE_XGEWERBE THEN   
      NULL; -- keine Meldung bei XGewerbe
    ELSE
      CASE
      WHEN vI = 0 THEN
        AddMsg('GKZ fr den Betreiber'||
              CASE WHEN pBtrOrdnung > 1 THEN '('||pBtrOrdnung||')' END   
              ||' konnte nicht ermittelt werden.');
      WHEN vI > 1 THEN
        AddMsg('GKZ fr den Betreiber' ||
              CASE WHEN pBtrOrdnung > 1 THEN '('||pBtrOrdnung||')' END   
                || ' konnte nicht eindeutig ermittelt werden, bitte prfen!');
      ELSE NULL;
      END CASE;            
    END IF;
    
  ELSE
    vD0101.GKZ := pFKT_INH.adr.verw.gkz;
  END IF;
    
  vD0101.ABW_POST     := 0;
  
  vD0101.IS_POSTFACH  :=  pFKT_INH.adr.padr.postfach_jn;
  
  vD0101.P_PLZ        := pFKT_INH.adr.padr.plz;
  vD0101.P_ORT        := pFKT_INH.adr.padr.ort;
  --vD0101.adresszusatz := pFkt_inh.adr.padr.adresszusatz;
  vD0101.P_ORTSTEIL   := pFKT_INH.adr.padr.ortsteil; 
  
  vD0101.P_STRASSE    := CASE
                         WHEN pFKT_INH.adr.padr.postfach_jn = 1 THEN pFKT_INH.adr.padr.postfach
                         ELSE pFKT_INH.adr.padr.strasse
                         END;
                         
  vD0101.P_LAND       := vD0101.land; 
  vD0101.P_HAUSNR     := CASE WHEN pFKT_INH.adr.padr.postfach_jn = 0 THEN pFKT_INH.adr.padr.hausnr
                         END;
  vD0101.P_HAUSNRZUSATZ := CASE WHEN pFKT_INH.adr.padr.postfach_jn = 0 THEN pFKT_INH.adr.padr.hausnrzusatz
                           END;     
                           
  vD0101.P_ANREDE     := pFKT_INH.PERS.anrede;
  vD0101.KOM_TEL      := pFKT_INH.kom.telefon; 
  vD0101.KOM_FAX      := pFKT_INH.kom.fax;
  vD0101.KOM_MOBIL    := pFKT_INH.kom.mobil;
  vD0101.KOM_EMAIL    := pFKT_INH.kom.email;
  vD0101.KOM_INTERNET  := vD0101.KOM_INTERNET;
  vD0101.FLURSTUECK   := pFKT_inh.adr.kat.flurstueck;
  vD0101.GEMARKUNG    := pFKT_inh.adr.kat.gemarkung;
  vD0101.ZB           := pZB;   --'%'; 
  vD0101.FB           := '-'; 
  vD0101.FB0          := '-';   
  --vD0101.FACHB, 
  --vD0101.FACHB0, 
  vD0101.BEZ_ART      := CASE WHEN pFKT_INH.pers.typ = 'JP' THEN 'F' ELSE 'N' END;
  vD0101.BEM          := NULL; -- todo 58247090 lschen wegen Daten in -1 Datensatz
  vD0101.HIT_BEZ_1    := SUBSTR(pFkt_inh.pers.kurzbez1, 1, 30); 
  vD0101.HIT_BEZ_2    := SUBSTR(pFkt_inh.pers.kurzbez2, 1, 30);
  vD0101.HIT_P_BEZ_1  := SUBSTR(pFkt_inh.pers.kurzbez1, 1, 30);
  vD0101.HIT_P_BEZ_2  := SUBSTR(pFkt_inh.pers.kurzbez2, 1, 30);

  vD0101.P_ANREDE     := pFKT_INH.pers.anrede; 
  vD0101.P_NAME       := CASE WHEN pFKT_INH.pers.typ = 'JP' 
                         THEN pFKT_INH.pers.bezeichnung  
                         ELSE CreateD0101P_Name(pFKT_INH.pers.nachname, 
                                                pFKT_INH.pers.vorname, 
                                                pFKT_INH.pers.vorsatz_nachname, 
                                                pFKT_INH.pers.nachsatz_nachname, 
                                                pFKT_INH.pers.titel)
                         
                         END ;
  vD0101.P_NAME1      := CASE WHEN pFKT_INH.pers.typ = 'JP' THEN pFKT_INH.pers.bezeichnung2 ELSE NULL END;    
  --vD0101.P_NAME2      := pFKT_INH.pers.vorname;    
    
  vD0101.P_BEZ_ART  := CASE WHEN pFKT_INH.pers.typ = 'JP' THEN 'F' ELSE 'N' END;
  vD0101.HOCHWERT   := pFkt_inh.adr.kat.hochwert;
  vD0101.RECHTSWERT := pFKT_inh.adr.kat.rechtswert; 
  vD0101.X_WERT     := pFKT_inh.adr.kat.x_wert; 
  vD0101.Y_WERT     := pFKT_inh.adr.kat.y_wert;
  vD0101.GLO_A24_SID2 := vD0101.glo_A24_sid;
  vD0101.Ambulant_jn := 0;
  --vD0101.GIS_QUELLE
  vD0101.daten_herkunft := NVL( BTS1.Usecases(1).datenherkunft, bts1.prot.quelle);  --'BEA';
  vD0101.quelle := bts1.prot.quelle;  
  INSERT INTO vis_d0101 VALUES vD0101;

  Reg_Anl(vD0101.id, pFkt_Inh.Reg, 3, NULL, 1, 0);
 
  IF pFKT_INH.pers.typ = 'NP' THEN
    -- Anlage Hauptansprechpartner
    pers_anl_hv(vD0101.id, pFKT_INH.Pers, 1, 1);
  END IF;     

  IF pBtrOrdnung = 1 THEN
    Anl_Min_D0101_ID3 := vD0101.id;
  END IF;
  
  RETURN vD0101.id;

END AnlageFKT_INH;

-- S07 Param. GIS_SYSTEM, Verfahren GIS
FUNCTION GET_GIS_SYSTEM RETURN NUMBER AS
  vSID PLS_INTEGER := NULL;
  
  CURSOR c1 IS 
  SELECT wert
  FROM vis_vs07
  WHERE s07_code = 'GIS'
  AND s0701_code = 'GIS_SYSTEM';
    
--  SELECT s0702.wert 
--  FROM vis_s07 s07
--  JOIN vis_s0701 s0701 ON s0701.s07_id = s07.id
--   AND s0701.deleted = 0
--   AND s0701.code = 'GIS_SYSTEM'
--  JOIN vis_s0702 s0702 ON s0702.s0701_id = s0701.id
--  JOIN vis_s09 s09 ON s09.sid = s0702.wert
--  WHERE s07.code = 'GIS' 
--  AND s07.deleted = 0;
  
BEGIN

  OPEN c1;
  FETCH c1 INTO vSID;
  CLOSE c1; 
  
  RETURN vSID;
  
END; 

PROCEDURE Upd_Koordinaten( pAdr IN OUT NOCOPY tAdr) AS
BEGIN
  --IF NVL(pAdr.padr.hausnr, TAB) <> '.' AND NVL(pAdr.padr.strasse, TAB) NOT LIKE 'Standort:' THEN
    IF blvUtils.GET_HK(pAdr.padr.strasse, pAdr.padr.hausnr, pAdr.padr.hausnrzusatz, pAdr.padr.plz, pAdr.padr.ort, pAdr.padr.ortsteil) = 1 THEN
      pAdr.kat.rechtswert := BLVUTILS.GET_HK_RECHTSWERT;
      pAdr.kat.hochwert := BLVUTILS.GET_HK_HOCHWERT;
      pAdr.kat.x_wert := BLVUTILS.GET_HK_X_WERT;
      pAdr.kat.y_wert := BLVUTILS.GET_HK_Y_WERT;
      pAdr.kat.gis_quelle := 'HK';
      pAdr.kat.s09_sid := GET_GIS_SYSTEM();
    END IF;        
  --END IF;

END;

PROCEDURE Upd_EIN_ADR( pAdr IN OUT NOCOPY tAdr) AS 
  vGKZ glo_a26.gkz%TYPE := NULL;
  

  CURSOR c1 IS
  SELECT a2701.GKZ14
  FROM glo_a27 a27
  JOIN glo_a2701 a2701 ON a2701.glo_a27_id = a27.id 
   AND a2701.deleted = 0
   AND NVL( TO_CHAR(A2701.HAUSNR), TAB) =  NVL( pAdr.padr.hausnr, TAB) -- 15.03.2013 Stringvergleich erzwingen um Fehler zu umgehen
   AND NVL( UPPER(A2701.HAUSNR_ZUSATZ), TAB) = NVL( UPPER(pAdr.padr.hausnrzusatz), TAB)
  
   AND a27.deleted = 0
   AND a27.plz = pAdr.padr.plz
   AND UPPER(a27.ort) = UPPER(pAdr.padr.ort)
   AND NVL( UPPER(a27.ortsteil), TAB) = NVL( UPPER(pAdr.padr.ortsteil), NVL( UPPER(a27.ortsteil), TAB)) 
   AND UPPER(A27.bez) =  UPPER(pAdr.padr.strasse)
   AND a27.gkz LIKE pAdr.verw.gkz || '%';


  CURSOR c2 IS
  SELECT a27.GKZ
  FROM glo_a27 a27
  WHERE a27.deleted = 0
   AND a27.plz = pAdr.padr.plz
    AND UPPER(a27.ort) = UPPER(pAdr.padr.ort)
    AND NVL( UPPER(a27.ortsteil), TAB) = NVL( UPPER(pAdr.padr.ortsteil), NVL( UPPER(a27.ortsteil), TAB)) 
    AND UPPER(A27.bez) =  UPPER(pAdr.padr.strasse)
    AND a27.gkz LIKE pAdr.verw.gkz || '%'
    ORDER BY a27.GKZ NULLS LAST;

  CURSOR c3 IS
  SELECT a26.GKZ
  FROM glo_a26 a26
  WHERE a26.deleted = 0
   AND a26.plz = pAdr.padr.plz
    AND UPPER(a26.bez) = UPPER(pAdr.padr.ort)
    AND NVL( UPPER(a26.ortsteil), TAB) = NVL( UPPER(pAdr.padr.ortsteil), NVL( UPPER(a26.ortsteil), TAB) ) 
    AND a26.gkz LIKE pAdr.verw.gkz || '%'
    ORDER BY a26.GKZ NULLS LAST;
 
BEGIN

  IF pAdr.padr.ort IS NOT NULL AND pAdr.padr.PLZ IS NOT NULL THEN
    OPEN c1;
    FETCH c1 INTO vGKZ;
    IF NOT c1%FOUND THEN
  --DBMS_OUTPUT.PUT_LINE('NOT c1%FOUND');  
      OPEN c2;
      FETCH c2 INTO vGKZ;
      IF NOT c2%FOUND THEN
  --DBMS_OUTPUT.PUT_LINE('NOT c2%FOUND');  
        OPEN c3;
        FETCH c3 INTO vGKZ;
        CLOSE c3;
      END IF;
      CLOSE c2;    
    END IF;  
    CLOSE c1; 
  --DBMS_OUTPUT.PUT_LINE ( 'vGKZ = ' || vGKZ );
    IF vGKZ IS NOT NULL THEN -- was gefunden
      pAdr.verw.gkz := vGKZ;                
    END IF;    
  END IF;
END;

-- ndern Standortadresse
PROCEDURE Standort_Kor(pD0101_ID VARCHAR2, pAdr_Btro IN OUT NOCOPY tAdr) AS
  vA24_SID vis_d0101.glo_a24_sid%TYPE := -1;
  vLand vis_d0101.land%TYPE := NULL;
  vSysdate DATE := SYSDATE;
  vD0101 vis_d0101%ROWTYPE;
  --vGKZ VARCHAR2(14);
BEGIN
--DBMS_OUTPUT.PUT_LINE ( 'pAdr_Btro.adr.id = ' || pAdr_Btro.adr.id );
  IF pAdr_Btro.adr.id IS NOT NULL THEN

    GetA24_SID_LAND_by_ISO(pAdr_Btro.padr.staat, vA24_SID, vLand);
--DBMS_OUTPUT.PUT_LINE ( 'pAdr_Btro.verw.gkz = ' || pAdr_Btro.verw.gkz );
    -- GKZ11 ermitteln
    IF NVL(LENGTH(pAdr_Btro.verw.gkz), 0) <= 8 THEN
      IF NOT IS_ID( pAdr_Btro.padr.ID ) THEN
        IF bts1.prot.quelle = QUELLE_XGEWERBE THEN
          pAdr_Btro.verw.gkz := bts1.prot.gkz;
        END IF;
      ELSE
        Upd_EIN_ADR(pAdr_Btro);
      END IF;      
    END IF;

    SELECT * INTO vD0101 FROM vis_d0101 WHERE id = pD0101_ID;
    
    -- standortadresse
    vD0101.plz         := pAdr_Btro.padr.plz;
    vD0101.ort         := pAdr_Btro.padr.ort;
    vD0101.adresszusatz:= pAdr_Btro.padr.adresszusatz;      
    vD0101.ortsteil    := pAdr_Btro.padr.ortsteil;
    vD0101.strasse     := pAdr_Btro.padr.strasse;
    vD0101.hausnr      := pAdr_Btro.padr.hausnr;
    vD0101.hausnrzusatz := pAdr_Btro.padr.hausnrzusatz;   
    vD0101.glo_a24_sid := vA24_sid;          -- a24.iso_nr land
    vD0101.land        := vLand;
    -- verwaltung 
    vD0101.gkz         := pAdr_Btro.verw.gkz;
    -- Kataster
    vD0101.flurstueck  := pAdr_Btro.kat.flurstueck;
    vD0101.flurnummer  := pAdr_Btro.kat.flurnummer;
    vD0101.gemarkung   := pAdr_Btro.kat.gemarkung;           
    vD0101.upd_date    := vSYSDATE;
    vD0101.upd_user    := vUser_SID;
--DBMS_OUTPUT.PUT_LINE ( 'vD0101.abw_post = ' || vD0101.abw_post );
    IF vD0101.abw_post = 0 /* todo 57287090 AND vGKZ2 = NRW*/ THEN
      --vD0101.abw_post    := 1;  -- 11.02.2014; bei ANL_MIN wird anschl. das Feld abgepasst

      vD0101.p_plz          := pAdr_Btro.padr.plz;
      vD0101.p_ort          := pAdr_Btro.padr.ort;    
      --vD0101.adresszusatz   := pAdr_Btro.padr.adresszusatz;  
      vD0101.p_ortsteil     := pAdr_Btro.padr.ortsteil;
      vD0101.p_strasse      := pAdr_Btro.padr.strasse; 
      vD0101.p_hausnr       := pAdr_Btro.padr.hausnr;
      vD0101.p_hausnrzusatz := pAdr_Btro.padr.hausnrzusatz;   
      vD0101.glo_a24_sid2   := vA24_sid;          -- a24.iso_nr land
      vD0101.p_land         := vLand;
    
    END IF; 
    
    IF NVL(pAdr_Btro.padr.hausnr, TAB) <> '.' AND NVL(pAdr_Btro.padr.strasse, TAB) NOT LIKE 'Standort:' THEN
  
      Upd_Koordinaten(pAdr_Btro);           
      -- Kataster   
      vD0101.rechtswert  := pAdr_Btro.kat.rechtswert;
      vD0101.hochwert    := pAdr_Btro.kat.hochwert;
      vD0101.x_wert      := pAdr_Btro.kat.x_wert;
      vD0101.y_wert      := pAdr_Btro.kat.y_wert;
      vD0101.gis_quelle  := pAdr_Btro.kat.gis_quelle;
      vD0101.s09_sid     := NVL(pAdr_Btro.kat.s09_sid, vD0101.s09_sid);
    END IF;
  
    UPDATE vis_d0101 SET ROW = vD0101 WHERE id = vD0101.ID;
    
  END IF;

    
END;

PROCEDURE BETR_POST_KOR(pD0101_ID IN VARCHAR2, pAdr_Btra IN tAdr, pPers IN EIN_d_person%ROWTYPE ) AS
  vA24_SID vis_d0101.glo_a24_sid%TYPE := -1;
  vLand vis_d0101.land%TYPE := NULL;
  vSysdate DATE := SYSDATE;
BEGIN

  IF pAdr_Btra.adr.id IS NOT NULL THEN
    GetA24_SID_LAND_by_ISO(pAdr_Btra.padr.staat, vA24_SID, vLand);  

    UPDATE vis_d0101
    SET -- postadresse
        p_plz       = pAdr_Btra.padr.plz,
        p_ort       = pAdr_Btra.padr.ort,
        --adresszusatz= pAdr_btra.padr.adresszusatz,      
        p_ortsteil  = pAdr_Btra.padr.ortsteil,
        
        is_postfach = pAdr_Btra.padr.postfach_jn,
                                          
                        
        p_strasse   = pAdr_Btra.padr.strasse,
                      
        p_hausnr    = CASE WHEN pAdr_Btra.padr.postfach_jn = 0 THEN pAdr_Btra.padr.hausnr
                      END,
                           
        p_hausnrzusatz = CASE WHEN pAdr_Btra.padr.postfach_jn = 0 THEN pAdr_Btra.padr.hausnrzusatz 
                         END,
        p_land      = vLand,      
        glo_a24_sid2 = vA24_sid,          -- a24.iso_nr land
        abw_post    = 1,
        upd_date    = vSYSDATE,
        upd_user    = vUser_SID
    WHERE id = pD0101_ID;  
  END IF;  
 
  IF pPers.ID IS NOT NULL THEN
    DECLARE 
    vK1 VARCHAR2(30) := SUBSTR(pPers.kurzbez1, 1, 30);
    vK2 VARCHAR2(30) := SUBSTR(pPers.kurzbez2, 1, 30);
    BEGIN
      UPDATE vis_d0101
      SET -- postadresse  
            BEZ_ART = CASE WHEN pPers.typ = 'JP' THEN 'F' ELSE 'N' END,
            HIT_BEZ_1    = vK1, 
            HIT_BEZ_2    = vK2,
            HIT_P_BEZ_1  = vK1,
            HIT_P_BEZ_2  = vK2,
            P_ANREDE     = pPers.anrede, 
            P_NAME       = CASE WHEN pPers.typ = 'JP' 
                           THEN pPers.bezeichnung  
                           ELSE CreateD0101P_Name(pPers.nachname, 
                                                  pPers.vorname, 
                                                  pPers.vorsatz_nachname, 
                                                  pPers.nachsatz_nachname, 
                                                  pPers.titel)                         
                           
                           
                           END,
            -- 15.10.2012 P_NAME1      = CASE WHEN pPers.typ = 'JP' THEN pPers.bezeichnung2 ELSE NULL END,
            P_NAME1      = pPers.bezeichnung2,
            --vD0101.P_NAME2      := pFKT_INH.pers.vorname;              
            P_BEZ_ART  = CASE WHEN pPers.typ = 'JP' THEN 'F' ELSE 'N' END             
        WHERE id = pD0101_ID;
      END;
    END IF;
END;

PROCEDURE BETR_POST_DEA(pD0101_ID VARCHAR2) AS
vSysdate DATE := SYSDATE;
BEGIN
  
  UPDATE vis_d0101
  SET
      p_plz       = plz,
      p_ort       = ort,            
      p_ortsteil  = ortsteil,
      is_postfach = 0,
      p_strasse   = strasse, 
      p_hausnr    = hausnr,
      p_hausnrzusatz = hausnrzusatz,
      p_land      = Land,      
      glo_a24_sid2 = glo_A24_sid,
--      abw_post     = 0,
--      -- 15.10.2012
--      p_bez_art   = bez_art,
--      p_anrede    = CASE WHEN bez_art = 'F' THEN f_anrede ELSE anrede END,
--      p_name      = CASE WHEN bez_art = 'F' THEN bez 
--                    ELSE CreateD0101P_Name( nname, 
--                                            vname, 
--                                            vorsatz_nname, 
--                                            nachsatz_nname, 
--                                            titel) 
--                    END,
--      p_name1     = name1,
      upd_date    = vSYSDATE,
      upd_user    = vUser_SID      
  WHERE id = pD0101_ID;
    
END;

-- Betriebsstaette - Kommunikation
-- pDel = 1 dann lschen sonst aktualisieren
-- pBetreiber = 1 - dann ber den Betreiber der Betriebssttte verwenden
PROCEDURE bts_kom(pD0101_id IN VARCHAR2, pDel IN NUMBER, pBetreiber IN NUMBER) AS
  vID vis_d0101.id%TYPE;
  vSysdate DATE := SYSDATE;  
BEGIN

  IF pBetreiber = 1 THEN
    SELECT d0101_id3 INTO vID
    FROM vis_d0101
    WHERE id = pD0101_ID;
  ELSE
    vID := pD0101_ID;
  END IF;

  IF pDel = 1 THEN 
    UPDATE VIS_D0101
    SET kom_tel   = NULL,
        kom_fax   = NULL, 
        kom_mobil = NULL ,
        kom_email = NULL ,
        kom_internet = kom_internet,
        upd_date  = vSYSDATE,
        upd_user  = vUser_SID      
    WHERE id = vID;

  ELSE
  
    IF pBetreiber = 0 THEN  
      -- Betrieb
      UPDATE VIS_D0101
      SET kom_tel   = bts1.kom.telefon,
          kom_fax   = bts1.kom.fax,
          kom_mobil = bts1.kom.mobil,
          kom_email = bts1.kom.email,
          kom_internet = kom_internet,
          upd_date  = vSYSDATE,
          upd_user  = vUser_SID      
      WHERE id = vID;  

    ELSE
      -- Betreiber
      UPDATE VIS_D0101
      SET kom_tel   = bts1.btr_pers(1).betreiber.kom.telefon,
          kom_fax   = bts1.btr_pers(1).betreiber.kom.fax,
          kom_mobil = bts1.btr_pers(1).betreiber.kom.mobil,
          kom_email = bts1.btr_pers(1).betreiber.kom.email,
          kom_internet = kom_internet,
          upd_date  = vSYSDATE,
          upd_user  = vUser_SID      
      WHERE id = vID;  
    
    END IF;
  END IF;
    
  IF SQL%ROWCOUNT = 0 THEN
    AddMsg('Kommunikationsmittel wurden in iP nicht aktualisiert.');
  END IF;
END;



-- Betriebsstaette - Hauptverantwortlichen deaktivieren
PROCEDURE pers_dea(pD0101_id VARCHAR2) AS
  vUpdCnt NUMBER(10) := 0;
  vD010200_ID vis_d010200.id%TYPE;
  vD0102_ID vis_d0102.id%TYPE;
  vSYSDATE DATE := SYSDATE;
BEGIN
  
  UPDATE 
  ( SELECT d010200.id, d010200.d0102_id, D010200.deleted, d010200.del_date, d010200.del_user
    FROM vis_d010200 d010200
    JOIN vis_d0101 d0101 ON d0101.id = pD0101_id
    AND d0101.id = pD0101_id
    AND d0101.d010200_id2 = d010200.id
    AND d010200.deleted = 0 ) dx
  SET deleted = -2,
      del_date = vSYSDATE,
      del_user = vUser_SID
  RETURNING id, d0102_id INTO vD010200_ID, vD0102_id; 
  
  IF SQL%ROWCOUNT = 1 AND vD010200_ID <> '-1' THEN
    -- Personalfunktionen lschen
    UPDATE vis_d010202
    SET deleted = -2,
        del_date = vSYSDATE,
        del_user = vUser_SID
    WHERE d010200_id = vD010200_id
    AND deleted = 0;    
    
    -- Person lschen
    IF vD0102_id <> '-1' THEN
      UPDATE vis_d0102
      SET deleted = -2,
          del_date = vSYSDATE,
          del_user = vUser_SID
      WHERE id = vD0102_id
      AND deleted = 0
      AND id NOT IN ( SELECT dx.d0102_id FROM vis_d010200 dx WHERE dx.deleted = 0);    
    END IF;
  
  END IF;
  
  UPDATE VIS_D0101
  SET nname = NULL,
      vname = NULL,
      vorsatz_nname = NULL,
      nachsatz_nname = NULL,
      anrede = NULL,
      titel = NULL,
      d010200_id2 = '-1',
      upd_date    = vSYSDATE,
      upd_user    = vUser_SID      
  WHERE id = pD0101_ID;

  vUpdCnt := SQL%ROWCOUNT;

--  UPDATE vis_d010200
--  SET deleted = -2,
--      del_date = SYSDATE,
--      del_user = vUser_SID
--  WHERE deleted = 0
--    AND HAUPTANSPRECHPARTNER = 1
--    AND d0101_id = pD0101_ID;
--
--  vUpdCnt := vUpdCnt + SQL%ROWCOUNT;
  
  IF vUpdCnt = 0 THEN
    AddMsg('Keinen Hauptverantwortlichen abgemeldet.');  
  END IF;


END;

-- D_PERSON korrigieren / ndern
-- Prfung D_FUNKTION.TYP = HV / INH notwendig
PROCEDURE pers_kor(pD0101_id VARCHAR2) AS
BEGIN
  
  NULL;

END;

/*******************************************************************************
  Korrektur D0101.CODE
*******************************************************************************/
PROCEDURE balvi_kor(pD0101_id IN VARCHAR2) AS
  i1 NUMBER(10);


  vSysdate DATE := SYSDATE;

BEGIN
  i1 := RegIndex('BALVI', bts1.reg);
  IF i1 > 0 THEN
    
    UPDATE VIS_D0101
    SET code    = bts1.reg(i1).nummer,
      upd_date  = vSYSDATE,
      upd_user  = vUser_SID    
    WHERE id = pD0101_ID;

  END IF;

END;

-- Abteilung anlegen
PROCEDURE BTRB_ANL(pD0101_id VARCHAR2) AS
  vCnt PLS_INTEGER;
  vId VIS_D0103.id%TYPE;
  vA0101_47_sid vis_a0101.sid%TYPE;
  vA0101_47_code vis_a0101.code%TYPE;
  
  vA24_SID NUMBER(10) := -1;
  vLand VARCHAR2(35) := NULL;
  vSysdate DATE := SYSDATE; 
  
  CURSOR cD0103 (pNr IN VARCHAR2) IS
  SELECT 1
  FROM VIS_D0103
  WHERE d0101_id = pD0101_id
  AND deleted = 0 
  AND abt_nummer = pNr;
   
BEGIN 

  IF bts1.abt_adr.COUNT > 0 THEN

    FOR i IN bts1.abt_adr.FIRST .. bts1.abt_adr.LAST LOOP
      
      -- berprfung Nummer 
      OPEN cD0103 (bts1.abt_adr(i).abt.nummer);
      FETCH cD0103 INTO vCnt;
            
      IF cD0103%NOTFOUND THEN
      
        GetA0101_47( bts1.abt_adr(i).abt.abteilungsart, vA0101_47_sid, vA0101_47_code);
      
        GetA24_SID_LAND_by_ISO(bts1.abt_adr(i).adr.padr.staat, vA24_SID, vLand);       
      
        vID := SYS_GUID();
        bts1.abt_adr(i).abt.ref_id := vID; -- fr spter beim Zuordnen der BA zur Abteilung notwendig
        
        INSERT INTO vis_d0103 (ID, A0101_47_SID, D0101_ID, MANDANT, BEZ, 
               INS_USER, INS_DATE, UPD_USER, UPD_DATE, DELETED, 
               FLURSTUECK, GEMARKUNG, GEMEINDE, 
               GKZ, LAND, GLO_A24_SID,
               ORT, ORTSTEIL, 
               PLZ, STRASSE, HAUSNR, HAUSNRZUSATZ, 
               GUELTIG_VON, GUELTIG_BIS, 
               HOCHWERT, RECHTSWERT, 
               X_WERT, Y_WERT,  
               ABT_NUMMER)
        VALUES (vId, vA0101_47_sid, pD0101_ID, vMandant_SID, bts1.abt_adr(i).abt.bez, 
               vUser_SID, vSYSDATE, vUSER_SID, vSYSDATE, 0,  
               bts1.abt_adr(i).adr.KAT.FLURSTUECK,  bts1.abt_adr(i).adr.KAT.GEMARKUNG, bts1.abt_adr(i).adr.VERW.GEMEINDE,  
               bts1.abt_adr(i).adr.VERW.GKZ, vLand, vA24_sid, 
               bts1.abt_adr(i).adr.PADR.ORT, bts1.abt_adr(i).adr.PADR.ORTSTEIL, 
               bts1.abt_adr(i).adr.PADR.PLZ, bts1.abt_adr(i).adr.PADR.STRASSE, 
               bts1.abt_adr(i).adr.PADR.HAUSNR, bts1.abt_adr(i).adr.PADR.HAUSNRZUSATZ, 
               bts1.abt_adr(i).abt.gueltig_von, bts1.abt_adr(i).abt.gueltig_bis, 
               bts1.abt_adr(i).adr.kat.hochwert, bts1.abt_adr(i).adr.KAT.RECHTSWERT, 
               bts1.abt_adr(i).adr.kat.x_wert, bts1.abt_adr(i).adr.kat.y_wert,
               bts1.abt_adr(i).abt.nummer
               );
      
      ELSE         
        AddMsg('Abteilung mit der Nummer "' || bts1.abt_adr(i).abt.nummer || '" ist bereits vorhanden.');
      END IF;
      
      CLOSE cD0103;
      
    END LOOP;
  ELSE
    AddMsg('Keine Abteilungen vorhanden.');
  END IF;
 
END;

-- Abteilung abmelden
PROCEDURE BTRB_DEA(pD0101_id VARCHAR2) AS
  vUpdCnt NUMBER(10) := 0;
  vSysdate DATE := SYSDATE;  
BEGIN 

  IF bts1.abt_adr.COUNT > 0 THEN

    FOR i IN bts1.abt_adr.FIRST .. bts1.abt_adr.LAST LOOP
      
      UPDATE vis_d0103
      SET gueltig_bis = CASE WHEN bts1.abt_adr(i).abt.gueltig_bis IS NULL 
                             THEN vSYSDATE 
                             ELSE bts1.abt_adr(i).abt.gueltig_bis END,
          upd_date    = vSYSDATE,
          upd_user    = vUser_SID                             
      WHERE d0101_id = pD0101_id
        AND deleted = 0 
        AND abt_nummer = bts1.abt_adr(i).abt.nummer
        AND NVL(gueltig_bis, Default_gueltig_bis) = Default_gueltig_bis;

      vUpdCnt := vUpdCnt + SQL%ROWCOUNT;
                     
    END LOOP;
          
    IF vUpdCnt = 0 THEN
        AddMsg('Keine Abteilungen abgemeldet.');
    END IF; 

  ELSE
    AddMsg('Keine Abteilungen vorhanden.');  
  END IF;

   
END;

-- Abteilung korrigieren
PROCEDURE BTRB_Kor(pD0101_id VARCHAR2) AS
  vA0101_47_sid vis_a0101.sid%TYPE;
  vA0101_47_code vis_a0101.code%TYPE;
  vUpdCnt NUMBER(10) := 0;   
  vSYSDATE DATE := SYSDATE;
BEGIN 

  IF bts1.abt_adr.COUNT > 0 THEN
  
    FOR i IN bts1.abt_adr.FIRST .. bts1.abt_adr.LAST LOOP

      GetA0101_47( bts1.abt_adr(i).abt.abteilungsart, vA0101_47_sid, vA0101_47_code);
    
      UPDATE vis_d0103
      SET gueltig_bis   = bts1.abt_adr(i).abt.gueltig_bis,
          gueltig_von   = bts1.abt_adr(i).abt.gueltig_von,
          a0101_47_sid  = vA0101_47_sid,
          code          = vA0101_47_code,
          bez           = bts1.abt_adr(i).abt.bez,
          upd_date      = vSYSDATE,
          upd_user      = vUser_SID          
      WHERE d0101_id = pD0101_id
        AND deleted = 0 
        AND abt_nummer = bts1.abt_adr(i).abt.nummer;

      vUpdCnt := vUpdCnt + SQL%ROWCOUNT;
                     
    END LOOP;  

    IF vUpdCnt = 0 THEN
        AddMsg('Keine Daten aktualisiert.');
    END IF; 

  ELSE
    AddMsg('Keine Abteilungen vorhanden.');  
  END IF;
  
END;

-- Abteilung - Standortadresse korrigieren
PROCEDURE BTRB_Standort_Kor(pD0101_ID VARCHAR2) AS
  vA24_SID NUMBER(10) := -1;
  vLand VARCHAR2(35) := NULL;
  vUpdCnt NUMBER(10 ) := 0;
  vSysdate DATE := SYSDATE;  
BEGIN

  IF bts1.abt_adr.COUNT > 0 THEN

    FOR i IN bts1.abt_adr.FIRST .. bts1.abt_adr.LAST LOOP
    
      GetA24_SID_LAND_by_ISO(bts1.abt_adr(i).adr.padr.staat, vA24_SID, vLand);
    
      UPDATE vis_d0103
      SET
       --A0101_47_SID = vA0101_47_sid, 
       MANDANT      = vMandant_SID,  
       --BEZ          = bts1.abt_adr(i).abt.bez, 
       UPD_USER     = vUser_SID, 
       UPD_DATE     = vSYSDATE, 
       DELETED      = 0, 
       FLURSTUECK   = bts1.abt_adr(i).adr.KAT.FLURSTUECK, 
       GEMARKUNG    = bts1.abt_adr(i).adr.KAT.GEMARKUNG, 
       GEMEINDE     = bts1.abt_adr(i).adr.VERW.GEMEINDE, 
       GKZ          = bts1.abt_adr(i).adr.VERW.GKZ, 
       LAND         = vLand, 
       GLO_A24_SID  = vA24_sid,
       ORT          = bts1.abt_adr(i).adr.PADR.ORT, 
       ORTSTEIL     = bts1.abt_adr(i).adr.PADR.ORTSTEIL, 
       PLZ          = bts1.abt_adr(i).adr.PADR.PLZ, 
       STRASSE      = bts1.abt_adr(i).adr.PADR.STRASSE, 
       HAUSNR       = bts1.abt_adr(i).adr.PADR.HAUSNR,
       HAUSNRZUSATZ = bts1.abt_adr(i).adr.PADR.HAUSNRZUSATZ, 
       --GUELTIG_BIS  = bts1.abt_adr(i).abt.gueltig_bis, 
       --GUELTIG_VON  = bts1.abt_adr(i).abt.gueltig_von, 
       HOCHWERT     = bts1.abt_adr(i).adr.kat.hochwert, 
       RECHTSWERT   = bts1.abt_adr(i).adr.KAT.RECHTSWERT, 
       X_WERT       = bts1.abt_adr(i).adr.kat.x_wert, 
       Y_WERT       = bts1.abt_adr(i).adr.kat.y_wert
       --ABT_NUMMER   = bts1.abt_adr(i).abt.nummer
      WHERE d0101_id = pD0101_ID
        AND deleted = 0
        AND abt_nummer =  bts1.abt_adr(i).abt.nummer;
    
      vUpdCnt := vUpdCnt + SQL%ROWCOUNT;
    END LOOP;
 
    IF vUpdCnt = 0 THEN
        AddMsg('Keine Abteilungsadressen aktualisiert.');
    END IF;

 ELSE
    AddMsg('Keine Abteilungsadressen vorhanden.');
  END IF;          

END;


FUNCTION GetFbMandant(pMandantSid IN NUMBER) RETURN VARCHAR2 DETERMINISTIC AS
 v1 vis_d0101.fb%TYPE;
BEGIN

  SELECT LISTAGG(a0101_06.fb, '') WITHIN GROUP (ORDER BY a0101_06.fb) INTO v1
  FROM vis_s5004 s5004
  JOIN vis_a0101 a0101_06 ON a0101_06.sid = s5004.a0101_06_sid
  WHERE s5004.deleted = 0
  AND s5004.al >= 3  -- 1 - kein Zugrif, 2 - Lesen, 3 - Bearbeiten, 4 - Bearbeiten Fremddaten
  AND s5004.s50_sid = pMandantSid;

  IF v1 IS NULL THEN -- alle Fachbereiche
    SELECT LISTAGG(a0101_06.fb, '') WITHIN GROUP (ORDER BY a0101_06.fb) INTO v1
    FROM vis_a0101 a0101_06 
    WHERE a0101_06.deleted = 0
    AND a0101_06.skz = 6;    
  END IF;
  
  RETURN v1;
  
END GetFbMandant;


PROCEDURE FB_Anlegen( pD0101_ID IN VARCHAR2, pFB IN VARCHAR2, pGueltig_von IN DATE, pGueltig_bis IN DATE
, pA0150_SID IN NUMBER, pA0101_01_SID IN NUMBER, pA0115_SID IN NUMBER) AS
  vCnt PLS_INTEGER;
  vD010104_ID vis_d010104.ID%TYPE;
  vGueltig_bis vis_d010104.gueltig_bis%TYPE;
  vFBBez vis_a0101.bez%TYPE;
  vFBSid vis_a0101.sid%TYPE;
  vD010104_gueltig_bis vis_d010104.gueltig_bis%TYPE;
  vD010104_gueltig_von vis_d010104.gueltig_von%TYPE;
  vGUID VARCHAR2(32);
  vSYSDATE DATE := SYSDATE;
  --vD0301 vis_d0301%ROWTYPE;
BEGIN
    
  SELECT sid, bez INTO vFBSid, vFBBez 
  FROM vis_va0101_06 WHERE fb = pFB;

  vD010104_gueltig_bis := NVL(TRUNC(pGueltig_bis), Default_gueltig_bis);
  vD010104_gueltig_von := TRUNC(pGueltig_von);
    
  BEGIN
    SELECT ID,gueltig_bis INTO vD010104_ID, vGueltig_bis 
    FROM vis_d010104
    WHERE d0101_id = pD0101_id
      AND deleted = 0
      AND fb = pFB;
    vCnt := 1;
    EXCEPTION 
    WHEN TOO_MANY_ROWS THEN vCnt := 2;
    WHEN NO_DATA_FOUND THEN vCnt := 0; 
  END;

  CASE vCnt  
  WHEN 0 THEN -- nicht vorhanden
    vGUID := SYS_GUID();
    INSERT INTO vis_d010104 (
      ID, D0101_ID, A0101_06_SID, 
      MANDANT, CODE, INS_USER, INS_DATE, UPD_USER, UPD_DATE, DELETED, FB, 
      GUELTIG_BIS, GUELTIG_VON, AKTIV, 
      A0150_SID, A0101_01_SID, A0115_SID
    ) VALUES (
      vGUID, pD0101_ID, vFBSid,
      vMandant_SID, pFB, vUser_SID, vSYSDATE, vUser_SID, vSYSDATE, 0, pFB, 
      vD010104_gueltig_bis, vD010104_gueltig_von, 1, 
      NVL(pA0150_SID, -1), NVL(pA0101_01_SID, -1), NVL(pA0115_SID, -1)
    );  

  WHEN 1 THEN -- ein FB vorhanden, -> gueltig_bis berprfen
    IF vGueltig_bis < Default_gueltig_bis THEN  -- kleiner 01.01.9999 -> Abmeldung lschen
      UPDATE vis_d010104
      SET gueltig_bis = Default_gueltig_bis
        , upd_date = vSYSDATE
        , upd_user = vUser_SID
      WHERE id = vD010104_ID;
      AddMsg('Im Fachbereich ' || vFBBez || ' wurde die Abmeldung gelscht.');
    END IF;
      
  WHEN 2 THEN -- mehrere FB vorhanden
      AddMsg('Der Fachbereich ' || vFBBez || ' ist mehrfach vorhanden. Lschen Sie die nicht bentigten Fachbereiche.');      
  ELSE NULL;
    
  END CASE;
  
END FB_Anlegen;

PROCEDURE FB_Anlegen( pD0101_ID IN VARCHAR2, pFB IN VARCHAR2, pGueltig_von IN DATE, pGueltig_bis IN DATE) AS
BEGIN
  FB_Anlegen( pD0101_ID, pFB, pGueltig_von, pGueltig_bis, -1, -1, -1);
END;

-- Betriebsart anlegen
FUNCTION BTYP_Anl(pD0101_id IN VARCHAR2, pUpdD0101_BEM IN BOOLEAN) RETURN PLS_INTEGER AS
  vID vis_d010101.id%TYPE;
  --vA0101_47_sid vis_a0101.sid%TYPE;
  --vA0101_47_code vis_a0101.code%TYPE;
  vUpdCnt PLS_INTEGER := 0; 
  --vD010101 VIS_D010101%ROWTYPE;
  vSid NUMBER(10);
  vSid0 NUMBER(10);
  vBez VARCHAR2(128);
  vCode VARCHAR2(128);
  vSkz NUMBER(10);
  vFB VARCHAR2(32);  
  vFB1 VARCHAR2(1);  
  vFBx VARCHAR2(32) := NULL;
  vFB0x VARCHAR2(32) := NULL;
  vFachb vis_d0101.fachb%TYPE;
  vFachb0 vis_d0101.fachb0%TYPE;
  vFbOk BOOLEAN;
  vAuswahl PLS_INTEGER;
  vGUID VARCHAR2(32);
  vSysdate DATE := SYSDATE;
  vFM PLS_INTEGER := 0;
  vLM PLS_INTEGER := 0;
	vHauptn NUMBER(10) := 0;
	vBem vis_d010101.bem%TYPE;
  vD0101_bem vis_d0101.bem%type := NULL;
  vFBMandant vis_d0101.fb%TYPE;
  vCoden vis_d010101.Coden%TYPE;
  vCoden1 vis_d010101.Coden%TYPE;
  vCoden2 vis_d010101.Coden%TYPE;
  vCoden3 vis_d010101.Coden%TYPE;
  --vCoden4 vis_d010101.Coden%TYPE;
  vCoden5 vis_d010101.Coden%TYPE;
  vTs_Stat_rel_jn VIS_D010101.TS_STAT_REL_JN%TYPE;
  vStandort vis_d010101.bez%TYPE;
  
	CURSOR cD010101 ( pD0101_ID IN VARCHAR2, pFB IN VARCHAR2, pSKZ IN NUMBER, pGueltig_von IN DATE) IS
		SELECT 1
		FROM vis_d010101 d010101  -- 05.11.2015 vis_vd010101 durch vis_d010101 ersetzt
		JOIN vis_a010108 a010108 ON a010108.sid = d010101.a010108_sid
    AND (
      a010108.skz = 2 OR 
      ( a010108.skz = 3 AND a010108.fb LIKE '%U%' AND ( a010108.code like '0608%' OR a010108.code LIKE '0609%' ) ) 
    )    
		AND d010101.aktiv = 1
		AND d010101.deleted = 0
		AND d010101.gueltig_bis > pGueltig_von
		AND a010108.skz = pSKZ
		AND a010108.fb LIKE '%' || pFB ||'%'
		AND d010101.d0101_id = pD0101_ID;
  
  PROCEDURE ChkFB( pArt IN VARCHAR2, pFB IN OUT NOCOPY VARCHAR2, pFbAnlegen IN PLS_INTEGER, pGueltig_von IN DATE,  pGueltig_bis IN DATE) AS
  vFB_HDPT VARCHAR2(32);  -- neue wegen todo 67404090
  BEGIN

      CASE
      WHEN pArt = 'ADV' AND NVL(pFB, '-') NOT LIKE '%H%' THEN
        pFB := pFB || 'H';
        vFB_HDPT := 'H';
        IF pFbAnlegen = 1 THEN 
          FB_Anlegen(pD0101_ID, vFB_HDPT, pGueltig_von, pGueltig_bis);
        END IF;

      --ELSIF pArt = 'HIT' AND NVL(pFB, '-') NOT LIKE '%U%' THEN 
      --  pFB := pFB || 'U';
      --  vFB_HDPT := 'U';
      
      WHEN pArt IN('HIT', 'BALVI') THEN -- HIT nur in NRW, BALVI in TH
        IF NVL(pFB, '-') NOT LIKE '%D%' THEN
          pFB := pFB || 'D';
          vFB_HDPT := 'D';          
          IF pFbAnlegen = 1 THEN 
            FB_Anlegen(pD0101_ID, vFB_HDPT, pGueltig_von, pGueltig_bis);
          END IF;                    
        END IF;
        
        IF NVL(pFB, '-') NOT LIKE '%P%' THEN
          pFB := pFB || 'P';
          vFB_HDPT := 'P';
          IF pFbAnlegen = 1 THEN 
            FB_Anlegen(pD0101_ID, vFB_HDPT, pGueltig_von, pGueltig_bis);
          END IF;
        END IF;
        
        IF NVL(pFB, '-') NOT LIKE '%T%' THEN
          pFB := pFB || 'T';
          vFB_HDPT := 'T';
          IF pFbAnlegen = 1 THEN 
            FB_Anlegen(pD0101_ID, vFB_HDPT, pGueltig_von, pGueltig_bis);
          END IF;
        END IF; 
                    
      ELSE NULL;
      END CASE;
            
  END;
  
BEGIN 
  IF bts1.bta.COUNT > 0 THEN

    SELECT NVL(MAX( CASE WHEN a010108.skz = 1 THEN d010101.coden END), 0) 
    , NVL(MAX( CASE WHEN a010108.skz = 2 THEN d010101.coden END), 0)
    , NVL(MAX( CASE WHEN a010108.skz = 3 THEN d010101.coden END), 0)
    --, NVL(MAX( CASE WHEN a010108.skz = 4 THEN d010101.coden END), 0)
    , NVL(MAX( CASE WHEN a010108.skz = 5 THEN d010101.coden END), 0)
    INTO vCoden1, vCoden2, vCoden3, /*vCoden4,*/ vCoden5
    FROM vis_d010101 d010101
    JOIN vis_a010108 a010108 on a010108.sid = d010101.a010108_sid
    WHERE d010101.deleted = 0
    AND d010101.aktiv = 1
    AND d010101.d0101_id = pD0101_id;  
  
    SELECT 
        TRIM( BOTH FROM  
          CASE WHEN d0101.land <> 'D' THEN d0101.land || ' ' END ||
          CASE WHEN D0101.PLZ IS NOT NULL THEN d0101.plz || ' ' END ||
          CASE WHEN D0101.ort IS NOT NULL THEN d0101.ort || ' ' END ||
          CASE WHEN D0101.ortsteil IS NOT NULL THEN '/' || d0101.ortsteil || ' ' END ) || ', ' ||
        CASE WHEN D0101.strasse IS NOT NULL THEN d0101.strasse || ' ' END ||
        CASE WHEN D0101.hausnr IS NOT NULL THEN d0101.hausnr || ' ' END ||
        CASE WHEN D0101.hausnrzusatz IS NOT NULL THEN d0101.hausnrzusatz END 
    INTO vStandort  
    FROM vis_d0101 d0101
    WHERE d0101.id = pD0101_ID;
  
    IF bts1.Fachb IS NULL OR bts1.fachb.COUNT = 0 THEN  -- keine Fachbereiche vorgegeben
      IF vMANDANT_FBs IS NULL THEN
        vFBMandant := GetFbMandant(vMandant_SID); -- alle Fachbereiche des Mandante verwenden
      ELSE
        vFBMandant := vMANDANT_FBs; -- von auen bei Aufruf aus iP zugewiesen Fachbereiche
      END IF;
    ELSE     
    
      FOR i IN bts1.fachb.first .. bts1.fachb.LAST LOOP  -- vorgegebene Fachbereiche
        vFbMandant := vFbMandant || bts1.fachb(i).code; 
      END LOOP;
    END IF;
  
    SELECT fb, fb0 INTO vFBx, vFB0x
    FROM vis_d0101
    WHERE id = pD0101_id;
  
    IF vFBx IN( '-', '%') THEN
      vFBx := NULL;
    END IF;

    IF vFB0x IN( '-', '%') THEN
      vFB0x := NULL;
    END IF;    
    
    -- berprfung Anzahl LM- und FM-Betriebsarten
    FOR i IN bts1.bta.FIRST .. bts1.bta.LAST LOOP
      CASE
			WHEN bts1.prot.quelle = QUELLE_XGEWERBE AND bts1.bta(i).art = 'BALVI' 
      AND bts1.bta(i).code NOT IN ('0399','0699', '9999999') THEN
        FOR c1 IN (
        SELECT dx.skz a010108_skz, dx.fb a010108_fb
        FROM vis_a010108 dx
        WHERE dx.code = bts1.bta(i).code
          AND dx.deleted = 0
          AND dx.skz IN (1,2,3,5)
        ) LOOP
          CASE
          WHEN c1.a010108_skz = 3 AND c1.a010108_fb LIKE '%U%' THEN
            vFM := vFM + 1;
            EXIT;
          WHEN c1.a010108_skz = 2 AND c1.a010108_fb LIKE '%H%' THEN
            vLM := vLM + 1;
            EXIT;
          ELSE NULL;
          END CASE;
          
        END LOOP;     
           
      ELSE NULL;
      
      END CASE;	
		END LOOP;
				
    FOR i IN bts1.bta.FIRST .. bts1.bta.LAST LOOP
      IF (NVL( bts1.bta(i).gueltig_bis, Default_gueltig_bis) = Default_gueltig_bis) 
      AND ( bts1.bta(i).ART = 'BALVI')  THEN -- 20.10.2014
        
        GetA010108( bts1.bta(i).code, bts1.bta(i).gewerbsmaessig, 1, bts1.bta(i).art ,vSid, vSid0, vBez, vCode, vSkz, vFb, vAuswahl);
        
        IF vSID > 0 THEN
          vFbOk := FALSE; 
          -- Fachbereiche berprfen und anlegen
          CASE
          WHEN vFB <> '%' AND bts1.prot.quelle IN( QUELLE_XGEWERBE) /*vGKZ2 = NRW*/ THEN
            FOR iFB IN 1 .. LENGTH(vFB) LOOP
               
              vFB1 := SUBSTR(vFB,iFB,1);
              -- nur diese Fachbereiche verarbeiten TS, TSCH, TAM, LM, FM
              IF -- HKL  A, TS  D, FlHY  F, LM  H, TNP  N, TSCH  P, TAM  T, FM  U, WEIN  W              
              (vFB1 IN( 'A', 'D', 'F', 'H', 'N', 'P', 'T', 'U', 'W' ) )
              AND INSTR( vFbMandant, vFB1) > 0 THEN
                
                vFbOk := TRUE; -- BA kann wegen Berechtigung auf mind. einen Fachb. angelegt werden
                            
                IF NVL(INSTR(vFBx, vFB1), 0) = 0 THEN -- FB noch nicht vorhanden

                  -- Fachbereich merken und anlegen
                  vFBx := vFBx || vFB1;
                  FB_Anlegen(pD0101_ID, vFB1, bts1.bta(i).gueltig_von, bts1.bta(i).gueltig_bis); 
                END IF;
                
                IF NVL(INSTR( vFB0x, vFB1),0) = 0 THEN -- FB noch nicht vorhanden
                  -- Fachbereich merken und nicht anlegen
                  vFB0x := vFB0x || vFB1; 
                END IF;
              END IF;
                
            END LOOP;                 
          
          ELSE NULL;
          END CASE;  
        
          IF vFbOk THEN                             
            CASE 
            WHEN vSKZ = 2 AND vFB LIKE '%H%' AND vLM >= 1 THEN -- LM-BA 
              -- angemeldete LM-BA vorhanden -> dann keine Haupt-BA
              OPEN cD010101(pD0101_id, 'H', vSKZ, NVL(bts1.bta(i).gueltig_von, Default_gueltig_von) );
              
            WHEN vSKZ = 3 AND vFB LIKE '%U%' AND vFM >= 1 
            AND (vCode LIKE '0608%' OR vCode LIKE '0609%' ) THEN -- FM-BA
              -- angemeldete FM-BA vorhanden -> dann keine Haupt-BA
              OPEN cD010101(pD0101_id, 'U', vSKZ, NVL(bts1.bta(i).gueltig_von, Default_gueltig_von) );        
              
            ELSE vHauptn := 0;
            END CASE;
            
  						 
            IF cD010101%ISOPEN THEN
              FETCH cD010101 INTO vHauptn;
              IF cD010101%FOUND THEN --BA vorhanden
                vHauptn := 0;	-- keine Haupt-BA
              ELSE
                vHauptn := 1; -- keine BA vorh. und nur eine zum Importieren 
              END IF;					
              CLOSE cD010101;
            END IF;
            vID := SYS_GUID();
            
            vBem := NULL;
            IF bts1.prot.quelle IN(QUELLE_XGEWERBE) THEN

              vBem := SUBSTR( NVL( bts1.bta(i).lbez, bts1.bta(i).bez) || 
                              CASE WHEN bts1.bta(i).scope IS NOT NULL THEN ' ('||bts1.bta(i).scope||')' END, 
                              1, 2000) ;

              vD0101_bem := vD0101_Bem || CRLF ||
                            NVL( bts1.bta(i).lbez, bts1.bta(i).bez) || 
                            CASE WHEN bts1.bta(i).scope IS NOT NULL THEN ' ('||bts1.bta(i).scope||')' END ||';';

            END IF;
            
            -- todo 69762090: LFDNR, TS_STAT_REL_JN und BEZ aktualisieren 
            vTs_Stat_rel_jn := 0; 
            vCoden := NULL;          
            CASE vSkz
            WHEN 1 THEN
              vTs_Stat_rel_jn := 1;
              vCoden1 := vCoden1 + 1;
              vCoden := vCoden1;
            WHEN 2 THEN
              vCoden2 := vCoden2 + 1;
              vCoden := vCoden2;               
            WHEN 3 THEN
              vCoden3 := vCoden3 + 1;
              vCoden := vCoden3;
              vTs_Stat_rel_jn := 1;
            --WHEN 4 THEN
            --  vCoden4 := vCoden4 + 1;
            --  vCoden := vCoden4;
            WHEN 5 THEN
              vCoden5 := vCoden5 + 1;
              vCoden := vCoden5;
              vTs_Stat_rel_jn := 1;
            ELSE NULL;
            END CASE;            
            
            IF vSKZ IN (1,3,5) THEN
              vBez := SUBSTR(vBez || ' (' || vCoden || '); ' || vStandort,1, 128);
            END IF;

            INSERT INTO vis_d010101 (
              ID, ID0, MANDANT, D0101_ID, INS_USER, INS_DATE, UPD_USER, UPD_DATE, DELETED,
              A010108_SID0, A010108_SID, bez, CODE, A010108_SKZ, FB, HAUPTN,  
              ANGEMELDET, ABGEMELDET, 
              AKTIV, 
              GUELTIG_VON, GUELTIG_BIS, gewerbsmaessig, bem
              --, HAUPT_TNP_JN, ZB, FRISTRELEVANT,  
              , CODEN, TS_STAT_REL_JN             
            ) VALUES (
              vID, vID, vMandant_SID, pD0101_id, vUser_SID, vSYSDATE, vUser_SID, vSYSDATE, 0,
              vSid0, vSid, vBez, vCode, vSkz, vFb, vHauptn,
               bts1.bta(i).gueltig_von, CASE WHEN bts1.bta(i).gueltig_bis = Default_gueltig_bis THEN NULL ELSE bts1.bta(i).gueltig_bis END, 
               1, 
               NVL(bts1.bta(i).gueltig_von, Default_gueltig_von), NVL(bts1.bta(i).gueltig_bis, Default_gueltig_bis), bts1.bta(i).gewerbsmaessig, vBem,
               CASE WHEN vSKZ = 1 THEN vCoden ELSE 0 END, vTs_Stat_rel_jn
            );

            vUpdCnt := vUpdCnt + SQL%ROWCOUNT;
            bts1.bta(i).ref_id := vId;
          ELSE 
            AddMsg('Die Betriebsart '|| vCode || ' ' || vBez || ' wurde wegen fehlender Fachbereichsberechtigung nicht angelegt.');
          END IF; -- BA anlegen
        END IF;
      END IF;                           
    END LOOP;  
   
    IF vUpdCnt = 0 THEN
        AddMsg('Es wurden keine Betriebsarten angelegt.');
    ELSE
      
      Upd_D0101_FB(pD0101_ID);       
    
      -- EIN_D_BETRIEBSART.REF_ID setzen 
      FORALL i IN bts1.bta.FIRST .. bts1.bta.LAST 
      UPDATE ein_d_betriebsart
      SET ref_id = bts1.bta(i).ref_id
      WHERE id = bts1.bta(i).id;
        
    END IF; 

  ELSE
    AddMsg('Keine Betriebsarten vorhanden.');  
  END IF;
  
  IF pUpdD0101_Bem THEN
    UPDATE vis_d0101
    SET bem = CASE WHEN bem IS NOT NULL THEN bem || CRLF END ||
              'Angelegt aus XGewerbeanzeige am '|| TO_CHAR(bts1.Usecases(1).ins_date, 'dd.mm.yyyy') || 
              CASE WHEN vD0101_BEM IS NOT NULL THEN ':' || vD0101_Bem END
    WHERE id = pD0101_ID;
  END IF;  
  
  RETURN vUpdCnt;
END BTYP_Anl;

-- alle aktiven IDV-Betreiber ID Code '01901302' zum Betrieb deaktivieren
PROCEDURE IDV_BETREIBER_ID_Deaktivieren(pD0101_id IN VARCHAR2) AS
  vA0302_05_SID CONSTANT NUMBER(10) := 36001; -- CODE=80 "Gltigkeit gendert"
  vSYSDATE DATE := SYSDATE;
  vGueltig_bis DATE := TRUNC(vSYSDATE);
BEGIN

  UPDATE VIS_D010102
  SET gueltig_bis = vGueltig_bis
    , upd_date = vSYSDATE
    , A0302_05_SID = vA0302_05_SID 
  WHERE d0101_id = pD0101_id
    AND deleted = 0
    AND  A0302_05_SID <> vA0302_05_SID
    AND a010145_sid = A010145_IDV_BETREIBER_ID --IDV-Betreiber ID Code '01901302'
    -- Prfung auf Gltigkeit ber VIS_VD010102
    AND EXISTS( SELECT 1 FROM vis_vd010102 dx 
                WHERE dx.id = VIS_D010102.id
              );
END;

/*******************************************************************************
 Betreiberwechsel
1.  D0101.ID des Betriebes ist bekannt, sonst Fehler und Abbruch.
2.  Betreiber (D0101.ID) ber IDV-Betreiber ID Code '01901302' (VIS_D010102) ermitteln
    => wenn vorhanden Vergleich der ermittelte D0101.ID des neuen Betreibers mit der D0101.ID des Betriebes
    a) wenn gleich (Betrieb=Betreiber):
    - fertig
    b) wenn ungleich (Betrieb mit abweichendem Betreiber)
    - dann diese D0101.ID als D0101_ID3 im Betrieb (Punkt 1) setzen, damit sind die Punkte 3a, 3b und 3c verarbeitet
    - IDV-Betreiber ID im Betrieb deaktivieren (wenn vorhanden): D010102.gueltig_bis, d010102.A0302_05_SID (Status)
      (Hinweise: DB-Historie funktioniert hier nicht)
    => wenn nicht vorhanden weiter mit Punkt 3
3.  Betreiber wechsel Varianten ermitteln ber Vergleich der kompletten Adresse:
a) abweichender Betreiber wechselt zu Betrieb = Betreiber
   => wenn Adresse gleich dann D0101.D0101_ID3 = D0101.ID und IDV-Betreiber ID zum Betrieb speichern
b) abweichender Betreiber wechselt zu abweichendem Betreiber
   - abweichenden Betreiber als SKZ=99 anlegen wie bei ANL_MIN
c) Betrieb = Betreiber wechselt zu abweichendem Betreiber
   - wie b)
   - IDV-Betreiber ID im Betrieb aktualisieren: D010102.gueltig_bis, d010102.A0302_05_SID (Status)
d) Betrieb = Betreiber wechselt zu Betrieb = Betreiber
*******************************************************************************/
PROCEDURE pers_aend(pD0101_id IN VARCHAR2) AS
  vD0101_ID3 vis_d0101.d0101_id3%TYPE;
  vD0101_ID3_old vis_d0101.d0101_id3%TYPE;
  vZB vis_d0101.zb%TYPE;
  --vCompareAdr PLS_INTEGER := 0;
  vSysdate DATE := SYSDATE;  
BEGIN

  IF bts1.btr_pers(1).betreiber.pers.id IS NULL THEN
    RETURN;
  END IF;
  
  -- alte Betreiber-ID
  SELECT d0101_id3, zb INTO vD0101_ID3_old, vZB
  FROM vis_d0101
  WHERE id = pD0101_id;
   
  -- Betrieb mit IDV-Betreiber ID ermitteln
  vD0101_ID3 := GetD0101byPers_ID(bts1.btr_pers(1).betreiber.pers );

  IF vD0101_ID3 IS NULL THEN
    vD0101_id3 := AnlageFKT_INH(bts1.btr_pers(1).betreiber, vZB, 1); -- Betreiber anlegen
  END IF;  

  IF vD0101_ID3_old <> vD0101_ID3 THEN 
    UPDATE vis_d0101    
    SET d0101_id3 = vD0101_ID3
      , betreiber_abw = CASE WHEN pD0101_ID <> vD0101_ID3 THEN 1 ELSE 0 END    
      , upd_date = vSYSDATE
      -- Hauptansprechpartner prfen und wenn nicht zum Betrieb gehrend dann zurcksetzen
      , d010200_id2 = 
          CASE WHEN 
            EXISTS ( SELECT 1 FROM vis_d010200 dx 
                     WHERE dx.id = vis_d0101.d010200_id2 
                     AND dx.d0101_id = vis_d0101.id ) THEN d010200_id2  
          ELSE '-1' END
      , ( bez, p_name, hit_bez_1, hit_bez_2 ) =
        ( SELECT dx.bez, dx.p_name, dx.hit_bez_1, dx.hit_bez_2 FROM vis_d0101 dx WHERE dx.id = vD0101_ID3)     
    WHERE id = pD0101_ID; 
  END IF;

/* 23.06.2014 
  IF vD0101_ID3 IS NULL THEN  -- nicht vorhanden
    --Adressenvergleich
    IF ( CompareAdr(bts1.fkt_inh.adr, bts1.adr_btro) = 1 AND bts1.adr_btra.adr.adr_id IS NULL) OR
      CompareAdr(bts1.fkt_inh.adr, bts1.adr_btra) = 1 THEN --kein abweichender Betreiber  
      vCompareAdr := 1;
    END IF;
 
    -- 3a)
    CASE
    WHEN vD0101_ID3_old <> pD0101_ID AND vCompareAdr = 1 THEN
      -- IDV-Betreiber-ID zum Betrieb speichern
     Reg_Anl(pD0101_ID, 3, vIDV_INH, 0, 1);
      
      UPDATE vis_d0101    
      SET d0101_id3 = pD0101_ID
        , betreiber_abw = 0
        , upd_date = SYSDATE
      WHERE id = pD0101_ID;
    
    -- 3b)
    WHEN vD0101_ID3_old <> pD0101_ID AND vCompareAdr = 0 THEN
      -- abweichenden Betreiber als SKZ=99 anlegen wie bei ANL_MIN
      vD0101_id3 := AnlageFKT_INH(bts1.fkt_inh, vZB, pD0101_ID); -- Betreiber anlegen
      UPDATE vis_d0101    
      SET d0101_id3 = vD0101_ID3
        , betreiber_abw = 1      
        , upd_date = SYSDATE
      WHERE id = pD0101_ID;
      
    -- 3c)
    WHEN vD0101_ID3_old = pD0101_ID AND vCompareAdr = 0 THEN
      -- abweichenden Betreiber als SKZ=99 anlegen wie bei ANL_MIN
      vD0101_id3 := AnlageFKT_INH(bts1.fkt_inh, vZB, pD0101_ID); -- Betreiber anlegen
      UPDATE vis_d0101    
      SET d0101_id3 = vD0101_ID3
        , betreiber_abw = 1        
        , upd_date = SYSDATE
      WHERE id = pD0101_ID;            

      -- IDV-Betreiber ID im Betrieb deaktivieren: D010102.gueltig_bis, d010102.A0302_05_SID (Status)
      --IDV_BETREIBER_ID_Deaktivieren(pD0101_ID);

    -- 3d)
    WHEN vD0101_ID3_old = pD0101_ID AND vCompareAdr = 1 THEN
      AddMsg('Der Betrieb ist schon der eigene Betreiber.'); 
      RETURN;
      
    ELSE NULL;
    END CASE;   
  
  ELSE
    
    -- Betrieb=Betreiber auf abweichenden Betreiber 
    IF vD0101_ID3_old = pD0101_id AND vD0101_id3 <> vD0101_ID3_old THEN
      -- IDV-Betreiber ID vom Betrieb deakivieren
      --IDV_BETREIBER_ID_Deaktivieren(pD0101_ID);
      NULL; 
    END IF;  
  
    -- vorhandenen Betreiber eintragen
    UPDATE vis_d0101    
    SET d0101_id3 = vD0101_ID3
        , betreiber_abw = CASE WHEN pD0101_ID <> vD0101_ID3 THEN 1 ELSE 0 END    
      , upd_date = SYSDATE
    WHERE id = pD0101_ID;  
  
  END IF;
*/
END;

-- Postanschrift des Betreibers korrigieren
-- TYPE: KOR oder AEND
PROCEDURE pers_adr_kor(pD0101_id IN VARCHAR2, Typ VARCHAR2) AS
  vD0101_ID3 vis_d0101.d0101_id3%TYPE;
  vLand vis_d0101.p_land%TYPE;
  vA24_SID2 VIS_D0101.glo_a24_sid2%TYPE;
  vSysdate DATE := SYSDATE;
  vD0101 vis_d0101%ROWTYPE;
BEGIN
   
  GetA24_SID_Land_By_ISO( bts1.btr_pers(1).betreiber.adr.padr.staat, vA24_sid2, vLand); 

  SELECT d3.* INTO vD0101
  FROM vis_d0101 d1
  JOIN vis_d0101 d3 ON d3.id = d1.d0101_id3
  WHERE d1.id = pD0101_ID;  
  
  vD0101.P_PLZ        := bts1.btr_pers(1).betreiber.adr.padr.plz;
  vD0101.P_ORT        := bts1.btr_pers(1).betreiber.adr.padr.ort;
  --vD0101.adresszusatz := bts1.btr_pers(1).betreiber.adr.padr.adresszusatz;
  vD0101.P_ORTSTEIL   := bts1.btr_pers(1).betreiber.adr.padr.ortsteil;
  
  vD0101.P_STRASSE    := 
                      CASE WHEN bts1.btr_pers(1).betreiber.adr.padr.postfach_jn = 1 THEN bts1.btr_pers(1).betreiber.adr.padr.postfach
                      ELSE bts1.btr_pers(1).betreiber.adr.padr.strasse
                      END;                      
                      -- bts1.btr_pers(1).betreiber.adr.padr.strasse || bts1.btr_pers(1).betreiber.adr.padr.postfach; 
  vD0101.P_LAND       := vLand;
  vD0101.P_HAUSNR     :=  CASE WHEN bts1.btr_pers(1).betreiber.adr.padr.postfach_jn = 0 THEN bts1.btr_pers(1).betreiber.adr.padr.hausnr
                          END;
                          --bts1.btr_pers(1).betreiber.adr.padr.hausnr;
                          
  vD0101.P_HAUSNRZUSATZ := CASE WHEN bts1.btr_pers(1).betreiber.adr.padr.postfach_jn = 0 THEN bts1.btr_pers(1).betreiber.adr.padr.hausnrzusatz
                           END; 
                        --bts1.btr_pers(1).betreiber.adr.padr.hausnrzusatz; 
  vD0101.IS_POSTFACH := bts1.btr_pers(1).betreiber.adr.padr.postfach_jn; 
                           
  vD0101.glo_a24_sid2 := vA24_sid2;
    

  IF vD0101.IS_POSTFACH = 1 THEN
      vD0101.ABW_POST := 1;
  END IF;
 
  IF vD0101.abw_post = 0 THEN
    vD0101.PLZ        := bts1.btr_pers(1).betreiber.adr.padr.plz;
    vD0101.ORT        := bts1.btr_pers(1).betreiber.adr.padr.ort;
    vD0101.adresszusatz := bts1.btr_pers(1).betreiber.adr.padr.adresszusatz;
    vD0101.ORTSTEIL   := bts1.btr_pers(1).betreiber.adr.padr.ortsteil;
    vD0101.STRASSE    := bts1.btr_pers(1).betreiber.adr.padr.strasse; 
    vD0101.LAND       := vLand;
    vD0101.HAUSNR     := bts1.btr_pers(1).betreiber.adr.padr.hausnr;
    vD0101.HAUSNRZUSATZ := bts1.btr_pers(1).betreiber.adr.padr.hausnrzusatz; 
    vD0101.glo_a24_sid := vA24_sid2;  
  
  END IF;   

  vD0101.upd_date := vSysdate;
  vD0101.upd_user := vUser_sid; 
    
  UPDATE vis_d0101 
  SET ROW = vD0101
  WHERE id = vD0101.ID;

END;  -- pers_adr_kor

-- allen Meldungen im Eingangskorb zu dieser BI-Nummer die D0101_ID zuordnen
-- damit eine Besttigung erfolgen kann  
PROCEDURE UpdateD0101ByRegNr(pArt IN VARCHAR2, pNummer IN VARCHAR2, pD0101_id IN VARCHAR2) AS

  CURSOR c1 (pNummer IN VARCHAR2, pArt IN VARCHAR2) IS
    SELECT prot.rowid prot_rowid, prot.status prot_status, uc.rowid uc_rowid, uc.deleted uc_deleted
    FROM ein_d_registrierung reg
    JOIN ein_r_bts_reg r_reg ON r_reg.d_reg_id = reg.id
    JOIN ein_d_protokoll prot ON prot.d_bts_id = r_reg.d_bts_id
    -- AND prot.status IN( 0, 20) -- 07.01.2016 auch bei den Dubletten

    JOIN ein_d_usecase uc ON uc.d_bts_id = r_reg.d_bts_id
     --AND (uc.deleted = 0 OR -- noch nicht besttigt
     --     (uc.deleted = -1 AND  prot.status = 20)) -- oder Dublette
    WHERE reg.nummer = pNummer
      AND reg.art = pArt  
      AND ( prot.d0101_id IN( '-9999', '-1') OR 
            uc.d0101_id IN( '-9999', '-1') ); -- 07.01.2016 auch -1 

  TYPE tC1 IS TABLE OF c1%ROWTYPE;
  vC1 tC1;
  
  vCnt PLS_INTEGER := 0;

BEGIN

  OPEN c1 (pNummer, pArt);
  FETCH c1 BULK COLLECT INTO vC1;
  CLOSE c1;
  
  IF vC1.COUNT > 0 THEN
    FORALL i IN vC1.FIRST .. vC1.LAST
    UPDATE ein_d_protokoll
    SET d0101_id = pD0101_ID
    WHERE rowid = vC1(i).prot_rowid; 

    FORALL i IN vC1.FIRST .. vC1.LAST
    UPDATE ein_d_usecase -- 07.01.2016
    SET d0101_id = pD0101_ID
    WHERE rowid = vC1(i).uc_rowid;
    
    FOR i IN vC1.FIRST .. vC1.LAST LOOP
      IF vC1(i).prot_status = 0 AND vC1(i).uc_deleted = 0 THEN
        vCnt := vCnt + 1;
      END IF;
    END LOOP;
        
  END IF;

  -- 19.07.2013 von JB
  IF vCnt > 0 THEN
    AddMsg('Weitere Usecases liegen fr diesen Betrieb vor.');
  END IF;
--  IF vCnt = 1 THEN
--    AddMsg('Die Betreibszuordnung (D0101_ID) wurde bei einem Usecase vorgenommen.');
--  ELSIF vCnt > 1 THEN
--    AddMsg('Die Betreibszuordnung (D0101_ID) wurde bei ' || vCnt || ' Usecases vorgenommen.');
--  END IF;  
END UpdateD0101ByRegNr;


-- bei allen GEWERBE_BETRIEB_ID D0101_ID setzen
PROCEDURE UpdD0101_id_by_GBI(pD0101_ID IN tID, pBTS_ID IN tID, pGBI_ID IN VARCHAR2) AS

  CURSOR c1 (pID IN VARCHAR2, pBTS_ID IN tID) IS
    SELECT prt.ID prt_id, uc.id uc_id, prt.d_bts_id
    FROM ein_d_protokoll prt
    JOIN ein_d_usecase uc ON uc.d_bts_id = prt.d_bts_id
    AND uc.deleted = 0 
    AND uc.usecase NOT IN (DUBL_BTR, DUBL_BTS)    
    WHERE prt.gewerbe_betrieb_id = pID
      AND prt.d_bts_id <> pBTS_ID 
      AND prt.status = 0
      AND prt.deleted = 0;
      
  TYPE tC1 IS TABLE OF c1%ROWTYPE;
  vC1 tC1;
  
BEGIN
  IF pGBI_ID IS NOT NULL THEN
    OPEN c1(pGBI_ID, pBTS_ID);
    FETCH c1 BULK COLLECT INTO vC1;
    CLOSE c1;
    IF vC1.COUNT > 0 THEN
      FORALL i IN vC1.FIRST .. vC1.LAST
      UPDATE ein_d_protokoll
      SET d0101_id = pD0101_ID
        , parameter = AddProtParam(parameter, PARAM_XGEWERBE_GBI, '1')
      WHERE id = vC1(i).prt_id;    
    
      FORALL i IN vC1.FIRST .. vC1.LAST
      UPDATE ein_d_usecase
      SET d0101_id = pD0101_ID
      WHERE id = vC1(i).uc_id;    

      FORALL i IN vC1.FIRST .. vC1.LAST
      UPDATE ein_d_betriebsstaette
      SET ref_id = pD0101_ID
      WHERE id = vC1(i).d_bts_id;    
    
    END IF;
    
  END IF; 

END UpdD0101_id_by_GBI;
    
    
-- Vergleich alle Namensfelder fr natrl. Personen
FUNCTION IsEqualHV( pPers1 IN ein_d_person%ROWTYPE, pPers2 IN ein_d_person%ROWTYPE) RETURN BOOLEAN AS
vRes BOOLEAN := FALSE;
BEGIN
  IF Compare(pPers1.nachname, pPers2.nachname) = 1 AND
  Compare(pPers1.vorname, pPers2.vorname) = 1 AND
  Compare(pPers1.anrede, pPers2.anrede) = 1 AND
  Compare(pPers1.titel, pPers2.titel) = 1 AND
  Compare(pPers1.vorsatz_nachname, pPers2.vorsatz_nachname) = 1 AND
  Compare(pPers1.nachsatz_nachname, pPers2.nachsatz_nachname) = 1 THEN
    vRes := True;
  END IF;
  
  RETURN vRes;
END IsEqualHV; 

PROCEDURE Insert_ein_d_fachbereich(pBTS_ID IN tID, pA0150_SID_LM IN NUMBER) AS

BEGIN

  DELETE ein_d_fachbereiche WHERE d_bts_id = pBTS_ID;

  INSERT INTO ein_d_fachbereiche 
  ( ID, D_BTS_ID, CODE, A0101_06_SID, GUELTIG_VON, GUELTIG_BIS, A0150_SID )
  SELECT RAWTOHEX( SYS_GUID() ) , pBTS_ID, dx.code, dx.sid, dx.gueltig_von, dx.gueltig_bis,
  CASE WHEN dx.code = 'H' AND pA0150_SID_LM > 0 THEN pA0150_SID_LM ELSE NULL END
  FROM (
  select distinct a0101_06.sid, a0101_06.code, bts.gueltig_von, bts.gueltig_bis
  from ein_d_betriebsstaette bts 
  join ein_d_betriebsart bta on bta.d_bts_id = bts.id
  join vis_a0101 a0101_06 on bta.fachbereich like '%' || a0101_06.code || '%'
  and a0101_06.deleted = 0 and a0101_06.skz = 6
  where bts.id = pBTS_ID ) dx;

END Insert_ein_d_fachbereich;

PROCEDURE Upd_D0101_FB(pD0101_ID IN VARCHAR2) AS

CURSOR cFB IS
  SELECT
    NVL( LISTAGG( d010104.FB ) WITHIN GROUP( ORDER BY d010104.FB), '-') fb0
  , NVL( LISTAGG( CASE WHEN d010104.gueltig_bis = Default_gueltig_bis THEN d010104.FB END ) WITHIN GROUP( ORDER BY d010104.FB), '-') fb   
  FROM vis_d010104 d010104
  WHERE d010104.deleted = 0
  AND d010104.d0101_id = pD0101_ID;

vFB cFB%ROWTYPE;
vFachb vis_d0101.fachb%TYPE;
vFachb0 vis_d0101.fachb0%TYPE;
vD0101_ID3 vis_d0101.d0101_id3%TYPE;
vSysdate CONSTANT DATE := SYSDATE;
BEGIN

  OPEN cFB;
  FETCH cFB INTO vFB;
  IF cFB%FOUND THEN
      
    vFachb := blvUtils.Get_FB2KurzbV(vFB.fb);
    vFachb0 := blvUtils.Get_FB2KurzbV(vFB.fb0);

    UPDATE vis_d0101
    SET fb = vFB.FB,
        fb0 = vFB.FB0,
        fachb = vFachb,
        fachb0 = vFachb0, 
        -- Abmeldung eventuell lschen
        abmeldung = CASE WHEN vFB.FB IS NULL THEN abmeldung ELSE NULL END,
        upd_date = vSysdate
    WHERE id = pD0101_id
    RETURNING d0101_id3 INTO vD0101_ID3;
  
    IF vFB.FB IS NOT NULL AND IS_ID(vD0101_ID3) AND vD0101_ID3 <> pD0101_ID THEN
      UPDATE vis_d0101
      SET abmeldung = NULL
        , upd_date = vSysdate
      WHERE id = vD0101_ID3;
    END IF;
  END IF;  
  CLOSE cFB;

END Upd_D0101_FB; 

-- Fachbereiche anlegen
FUNCTION ANL_FB( pD0101_ID IN VARCHAR2) RETURN PLS_INTEGER AS
vSysdate CONSTANT DATE := SYSDATE;
vD0301 vis_d0301%ROWTYPE;

TYPE tD0101 IS RECORD(
  strasse vis_D0101.STRASSE%TYPE, 
  hausnr vis_D0101.HAUSNR%TYPE,
  hausnrzusatz vis_D0101.hausnrzusatz%TYPE, 
  plz vis_D0101.PLZ%TYPE,
  ort vis_D0101.ORT%TYPE,
  ortsteil vis_D0101.Ortsteil%TYPE );  
  
vD0101 tD0101;

  PROCEDURE InitD0301 AS
  BEGIN   
    -- Initialisierung nur wenn auch Termine angelgt werden mssen
    FOR i IN bts1.fachb.FIRST .. bts1.fachb.last LOOP
      
      IF bts1.fachb(i).erstkontrolle_tage IS NOT NULL THEN
      
        SELECT d0101.STRASSE, d0101.HAUSNR, d0101.hausnrzusatz, d0101.PLZ, d0101.ORT, d0101.Ortsteil
        INTO vD0101
        FROM vis_d0101 d0101
        WHERE d0101.id = pD0101_ID;   
      
        SELECT * INTO vD0301  -- Initialisierung mit Standardwerten
        FROM vis_d0301 WHERE id = '-1';
        
        vD0301.bez := 'Plankontrolltermin';
        vD0301.d0101_id := pD0101_ID;
        vD0301.d0101_id1 := BLV_SYS.GET_MD_D0101_ID;  -- Eigenbehrde
        
        BEGIN
          SELECT d010200.id INTO vD0301.d010200_id1 -- angelegt durch
          FROM vis_s50 s50
          JOIN vis_d010200 d010200 ON d010200.d0102_id = s50.d0102_id
          AND d010200.deleted = 0
          AND d010200.d0101_id = vD0301.d0101_id1
          WHERE s50.sid = vUSER_SID;
          EXCEPTION WHEN no_data_found THEN vD0301.d010200_id1 := '-1';
          WHEN too_many_rows THEN vD0301.d010200_id1 := '-1';
        END;
        
        vD0301.d010200_id := '-1';
        vD0301.A010801_01_SID := -1;  -- keine Ttigkeitsart
        vD0301.a0301_01_SID := 27001; -- Plankontrolltermin
        vD0301.a0301_02_SID := 4001; -- Status eingetragen (Standard)
        vD0301.STATUS := 1;
        vD0301.ort := DBO.GETADRESSE(vD0101.STRASSE, vD0101.HAUSNR, vD0101.hausnrzusatz, vD0101.PLZ, vD0101.ORT || ' ' || vD0101.Ortsteil);
        vD0301.prioritaet := 3; -- hoch
        vD0301.datumerledigt := TRUNC(vSYSDATE);
        vD0301.PKS := '%';
        vD0301.REF_OBJ := '1.01';
        vD0301.REF_ID := pD0101_id;
        vD0301.tabellenname := 'VIS_D0101';
        vD0301.mandant := vMandant_SID;    
        vD0301.INS_USER := vUSER_SID;
        vD0301.INS_DATE := vSYSDATE;
        vD0301.UPD_USER := vUSER_SID;
        vD0301.UPD_DATE := vSYSDATE; 
        vD0301.DELETED  := 0; 
        vD0301.DEL_USER := -1;
        vD0301.DEL_DATE := NULL;
        
        EXIT;
      END IF;        
    END LOOP;
  
  END InitD0301;

BEGIN
  
  IF bts1.fachb IS NOT NULL AND bts1.fachb.COUNT > 0 THEN
    
    InitD0301;
    
    FOR i IN bts1.fachb.FIRST .. bts1.fachb.LAST LOOP
        FB_Anlegen(pD0101_ID => pD0101_ID, 
                   pFB => bts1.fachb(i).code, 
                   pGueltig_von => NVL( bts1.fachb(i).gueltig_von, Default_gueltig_von), 
                   pGueltig_bis => NVL( bts1.fachb(i).gueltig_bis, Default_gueltig_bis),
                   pA0150_SID => bts1.fachb(i).a0150_sid,
                   pA0101_01_SID => bts1.fachb(i).A0101_01_sid,
                   pA0115_SID => bts1.fachb(i).A0115_SID );
                   
      IF bts1.fachb(i).erstkontrolle_tage IS NOT NULL THEN

        vD0301.ID := SYS_GUID();
        vD0301.FB := bts1.fachb(i).code;
        vD0301.DATUMSTART := TRUNC(vSYSDATE) +  bts1.fachb(i).erstkontrolle_tage;
        vD0301.DATUMENDE := vD0301.DATUMSTART;
        vD0301.TERMINBEZ := TO_CHAR(vD0301.DATUMSTART, 'DD.MM.YYYY');
        
        IF bts1.fachb(i).A0150_SID > 0 THEN
          SELECT a0150.d010200_id INTO vD0301.D010200_id
          FROM vis_a0150 a0150 
          WHERE a0150.sid = bts1.fachb(i).A0150_SID; 
        ELSE
          vD0301.d010200_id := '-1';
        END IF;
            
        INSERT INTO vis_d0301 VALUES vD0301;          
                 
      END IF;              
                                      
    END LOOP;
    
    Upd_D0101_FB(pD0101_ID);
    
  END IF;

  RETURN bts1.fachb.COUNT;
  
END ANL_FB;

PROCEDURE BetreiberPersonal(pChkPersonalDublette IN BOOLEAN) AS
BEGIN

    --GesetzlicherVertreter XGewerbe
    IF bts1.btr_pers(1).gv IS NOT NULL AND bts1.btr_pers(1).gv.COUNT > 0 THEN
      --DBMS_OUTPUT.PUT_LINE('Anz. GV:'||bts1.btr_pers(1).gv.COUNT);    
      for i in bts1.btr_pers(1).gv.first .. bts1.btr_pers(1).gv.last loop
        --DBMS_OUTPUT.PUT_LINE(i||'.GV');
        pers_anl( pPers => bts1.btr_pers(1).gv(i), 
                  pBetreiber => bts1.btr_pers(1).betreiber, 
                  pInhaber => 0, pIsHV => i, pInsFkt => 1/*,
                  pChkDublette => pChkPersonalDublette*/ );
      end loop;
    END IF; -- GesetzlicherVertreter
    
    -- Hauptverantwortlicher
    IF bts1.btr_pers(1).hv IS NOT NULL AND bts1.btr_pers(1).hv.COUNT > 0 THEN
      --DBMS_OUTPUT.PUT_LINE('Anz. HV:'||bts1.btr_pers(1).hv.COUNT);    
      FOR i IN bts1.btr_pers(1).hv.FIRST .. bts1.btr_pers(1).hv.LAST LOOP
        --DBMS_OUTPUT.PUT_LINE(i||'.HV');
          -- ist die gleiche person schon als GV vorhanden 
        IF bts1.btr_pers(1).gv IS NOT NULL AND bts1.btr_pers(1).gv.COUNT > 0 THEN

          FOR iGV IN bts1.btr_pers(1).gv.FIRST .. bts1.btr_pers(1).gv.LAST LOOP  
              
            -- Vor und Nachname gleich
            IF bts1.btr_pers(1).gv(iGV).pers.nachname = bts1.btr_pers(1).hv(i).pers.nachname AND 
            Compare(bts1.btr_pers(1).gv(iGV).pers.vorname, bts1.btr_pers(1).hv(i).pers.vorname) = 1 THEN
              
              bts1.btr_pers(1).hv(i).pers.ref_id := bts1.btr_pers(1).gv(iGV).pers.ref_id; 
              --vPrs := bts1.btr_pers(1).gv(iGV).pers;
              
            END IF;
              
          END LOOP;
            
          IF NOT IS_ID(bts1.btr_pers(1).hv(i).pers.ref_id) THEN -- nicht identisch mit GV
            --DBMS_OUTPUT.PUT_LINE('nicht identisch mit GV');
            pers_anl( pPers => bts1.btr_pers(1).hv(i), 
                      pBetreiber => bts1.btr_pers(1).betreiber, 
                      pInhaber => 0, pIsHV => 0, pInsFkt => 2/*,
                      pChkDublette => pChkPersonalDublette*/ );  -- Funktion "vertretungsberechtigte Person" hinzufgen
          ELSE
            --DBMS_OUTPUT.PUT_LINE('identisch mit GV');
            InsD010202byBez70( pA0101_70_bez => VERTRET_PERSON, 
                               pD0101_ID => bts1.btr_pers(1).betreiber.pers.ref_id, 
                               pD010200_ID => bts1.btr_pers(1).hv(i).pers.ref_id,
                               bForce => FALSE );                                    
            --vPrs := bts1.btr_pers(1).hv(i).pers;
          END IF;
            
          -- todo 62927090: HV setzen entfllt
          /*IF i = 1 AND IS_ID(vPrs.ID) THEN
            -- HV in BTS setzen
            UpdBTS_HV(bts1.prot.d0101_id, vPrs);               
          END IF; */ 
        ELSE -- kein GV vorhanden
          --DBMS_OUTPUT.PUT_LINE('kein GV vorhanden');
          pers_anl( pPers => bts1.btr_pers(1).hv(i), 
                    pBetreiber => bts1.btr_pers(1).betreiber, 
                    pInhaber => 0, pIsHV => 0, pInsFkt => 2/*,
                    pChkDublette => pChkPersonalDublette*/ );  -- Funktion "vertretungsberechtigte Person" hinzufgen
            
        END IF;
          
      END LOOP;
    END IF; -- Hauptverantwortlicher

END BetreiberPersonal;

-- Betreiber 1. Ordnung anlegen
PROCEDURE AnlageBetreiber(vD0101_ID3 IN OUT NOCOPY VARCHAR2, vZb IN VARCHAR2) AS
vD010200_ID2 vis_d010200.id%TYPE;
--vPrs ein_d_person%ROWTYPE;
BEGIN

    IF NOT IS_ID(vD0101_ID3) THEN -- nicht vorhanden  
      vD0101_id3 := AnlageFKT_INH(bts1.btr_pers(1).betreiber, vZB, 1); -- Betreiber anlegen
      -- nach AnlageFKT_INH verschoben Anl_Min_D0101_ID3 := vD0101_ID3;               
    END IF;
    
    -- berprfung und Anlage HV bei natrl. Person
    IF bts1.btr_pers(1).betreiber.pers.typ = 'NP' THEN  -- nur NRW
      CASE 
      -- gleiche PERS_ID -> HV vom BTR der BTS zuordnen
      WHEN bts1.fkt_hv.pers.pers_id = bts1.btr_pers(1).betreiber.pers.pers_id THEN
        SELECT dx.d010200_id2 INTO vD010200_ID2 
        FROM vis_d0101 dx WHERE dx.id = vD0101_ID3;

  --    WHEN IsEqualHV(bts1.fkt_hv.pers, bts1.fkt_inh.pers) THEN
  --      SELECT dx.d010200_id2 INTO vD010200_ID2 
  --      FROM vis_d0101 dx WHERE dx.id = vD0101_ID3;

      ELSE
        pers_anl_hv(bts1.prot.d0101_id, bts1.fkt_hv.pers, 0, 0);  -- HV ist optional, kann fehlen  
        vD010200_ID2 := '-1';
      END CASE;
    ELSE
      vD010200_ID2 := '-1';
    END IF;
    
    IF vD0101_ID3 <> bts1.prot.d0101_id THEN -- abweichenden Betreiber eintragen
 
      UPDATE VIS_D0101
      SET d0101_id3     = vD0101_id3,
          d0101_id2     = vD0101_id3,
          d010200_id2   = CASE WHEN vD010200_id2 <> '-1' THEN vD010200_id2 ELSE d010200_id2 END, 
          betreiber_abw = 1,
          -- 06.06.2014        
          --        bez           = CASE WHEN bez IS NULL 
          --                          THEN ( SELECT bez FROM vis_d0101 WHERE id = vD0101_ID3) -- Bezeichnung vom Betreiber 
          --                        ELSE bez
          --                        END,
          --        name1         = CASE WHEN name1 IS NULL
          --                          THEN ( SELECT name1 FROM vis_d0101 WHERE id = vD0101_ID3) -- Bezeichnung vom Betreiber 
          --                        ELSE name1
          --                        END,
          bez_art       = 'F',  -- 05.06.2014 'P'   -- 24.01.2013 bei abweichendem Betreiber ist Betriebssttte immer Person
          (bez, p_anrede, p_name, hit_bez_1, hit_bez_2) = 
            ( SELECT dx.bez, dx.p_anrede,  dx.p_name, dx.hit_bez_1, dx.hit_bez_2 
              FROM vis_d0101 dx WHERE dx.id = vD0101_ID3),
          nname = CASE WHEN vD010200_ID2 = '-1' THEN nname ELSE bts1.btr_pers(1).betreiber.pers.nachname END,
          vname = CASE WHEN vD010200_ID2 = '-1' THEN vname ELSE bts1.btr_pers(1).betreiber.pers.vorname END,
          vorsatz_nname = CASE WHEN vD010200_ID2 = '-1' THEN vorsatz_nname ELSE bts1.btr_pers(1).betreiber.pers.vorsatz_nachname END,  
          nachsatz_nname = CASE WHEN vD010200_ID2 = '-1' THEN nachsatz_nname ELSE bts1.btr_pers(1).betreiber.pers.nachsatz_nachname END,
          titel = CASE WHEN vD010200_ID2 = '-1' THEN titel ELSE bts1.btr_pers(1).betreiber.pers.titel END,
          anrede = CASE WHEN vD010200_ID2 = '-1' THEN anrede ELSE bts1.btr_pers(1).betreiber.pers.anrede END                         
      WHERE id = bts1.prot.d0101_id;

    ELSE  -- darf es nicht mehr geben
        
      UPDATE VIS_D0101
      SET bez = CASE WHEN bez IS NULL THEN
                  CASE WHEN bts1.btr_pers(1).betreiber.pers.typ = 'JP' THEN bts1.btr_pers(1).betreiber.pers.bezeichnung 
                       ELSE -- 23.06.2014 bts1.FKT_INH.pers.nachname || ', ' || bts1.FKT_INH.pers.vorname 
                        CreateD0101Bez( bts1.btr_pers(1).betreiber.pers.nachname, bts1.btr_pers(1).betreiber.pers.vorname,
                                        bts1.btr_pers(1).betreiber.pers.vorsatz_nachname, bts1.btr_pers(1).betreiber.pers.nachsatz_nachname,
                                        bts1.btr_pers(1).betreiber.pers.titel)                       
                  END
                ELSE bez
                END,
          name1 = CASE WHEN name1 IS NULL
                  THEN bts1.btr_pers(1).betreiber.pers.bezeichnung2
                  ELSE name1
                  END,     
          titel = bts1.btr_pers(1).betreiber.pers.titel,
          anrede= bts1.btr_pers(1).betreiber.pers.anrede,
          vname = bts1.btr_pers(1).betreiber.pers.vorname,
          nname = bts1.btr_pers(1).betreiber.pers.nachname,
          vorsatz_nname = bts1.btr_pers(1).betreiber.pers.vorsatz_nachname,
          nachsatz_nname = bts1.btr_pers(1).betreiber.pers.nachsatz_nachname                           
      WHERE id = bts1.prot.d0101_id;  

      IF CompareAdr(bts1.btr_pers(1).betreiber.adr, bts1.adr_btro) = 1 THEN --keine abweichende Postanschrift
        BETR_POST_DEA(bts1.prot.d0101_id);
      ELSE
        -- abweichende Postanschrift
        BETR_POST_KOR(bts1.prot.d0101_id, bts1.btr_pers(1).betreiber.adr, bts1.btr_pers(1).betreiber.pers);
      END IF;
            
      
    
    END IF;
    
    Betreiberpersonal(FALSE);
    

END AnlageBetreiber;

PROCEDURE AnlageBtr2Ordnung(vZB IN VARCHAR2) AS
BEGIN

  -- Betreiber 2. Ordnung
--DBMS_OUTPUT.PUT_LINE ( 'bts1.btr_pers.COUNT = ' || bts1.btr_pers.COUNT );  
  IF bts1.btr_pers IS NOT NULL AND bts1.btr_pers.COUNT > 1 THEN
--DBMS_OUTPUT.PUT_LINE('Betreiber 2. Ordnung vorhanden');    
    FOR iBtr IN 2 .. 2 LOOP

      IF NOT IS_ID(bts1.btr_pers(iBtr).betreiber.pers.ref_id) -- nicht vorhanden
      AND  IS_ID( AnlageFKT_INH(bts1.btr_pers(iBtr).betreiber, vZB, iBtr) ) THEN -- Betreiber angelegt        
      
        Anl_Min_D0101_ID3_2 := bts1.btr_pers(iBtr).betreiber.pers.ref_id;  
      
        UPDATE vis_d0101
        SET d0101_id3 = bts1.btr_pers(iBtr).betreiber.pers.ref_id
           , betreiber_abw = 1
        WHERE id = bts1.btr_pers(iBtr-1).betreiber.pers.ref_id;        
        
        --GesetzlicherVertreter XGewerbe
        IF bts1.btr_pers(iBtr).gv IS NOT NULL AND bts1.btr_pers(iBtr).gv.COUNT > 0 THEN
--    DBMS_OUTPUT.PUT_LINE('Anz. GV:'||bts1.btr_pers(iBtr).gv.COUNT);    
          for i in bts1.btr_pers(iBtr).gv.first .. bts1.btr_pers(iBtr).gv.last loop
--    DBMS_OUTPUT.PUT_LINE(iBtr||'.GV');
            pers_anl( pPers => bts1.btr_pers(iBtr).gv(i), 
                      pBetreiber => bts1.btr_pers(iBtr).betreiber, 
                      pInhaber => 0, pIsHV => i, pInsFkt => 1/*,
                      pChkDublette => FALSE*/ );
          end loop;
        END IF; -- GesetzlicherVertreter
        
        -- Hauptverantwortlicher
        IF bts1.btr_pers(iBtr).hv IS NOT NULL AND bts1.btr_pers(iBtr).hv.COUNT > 0 THEN
--    DBMS_OUTPUT.PUT_LINE('Anz. HV:'||bts1.btr_pers(iBtr).hv.COUNT);    
          FOR i IN bts1.btr_pers(iBtr).hv.FIRST .. bts1.btr_pers(iBtr).hv.LAST LOOP
--    DBMS_OUTPUT.PUT_LINE(i||'.HV');
            pers_anl( pPers => bts1.btr_pers(iBtr).hv(i), 
                      pBetreiber => bts1.btr_pers(iBtr).betreiber, 
                      pInhaber => 0, pIsHV => 0, pInsFkt => 0/*,
                      pChkDublette => FALSE*/ );    
          END LOOP;
        END IF; -- HV
            
      END IF;

    
    END LOOP;
  END IF; -- Betreiber n.Ordnung 


END AnlageBtr2Ordnung;
/*******************************************************************************
 Anlage einer Betriebssttte komplett
 - Betriebssttte mit
   - Standortadresse
   - Postadresse
   - Kommunikation
   - Hauptverantwortlichen
     - Kommunikation und Person
   - Registrierung
   - Betriebsart   
   - Abteilung
   - Tierangaben
 - abweichenden Betreiber
   - Postanschrift
   - Registrierungen
   - Kommunikation    
/******************************************************************************/
PROCEDURE Anl_Min(pUsecase_ID IN VARCHAR2) AS
  vD0101_ID3 vis_d0101.d0101_id3%TYPE;
  vD010200_ID2 vis_d0101.d010200_id2%TYPE;
  --vD0101_bez vis_d0101.bez%TYPE;
  --vD0101_bem vis_d0101.bem%TYPE;
  vZB vis_d0101.zb%TYPE := NULL;
  vI    PLS_INTEGER;
  vI2   PLS_INTEGER;
  iReg  PLS_INTEGER;
  --iRegBtr PLS_INTEGER; 
  vID   VARCHAR2(32);
  vCnt  PLS_INTEGER;
  vGKZ8 VARCHAR2(8);
  vBI_IDV   VARCHAR2(20) := vIDV;
  vSYSDATE DATE := SYSDATE;
  vIdList tIdList := tIdList();
  vAmbulant_jn NUMBER(1) := 0;
    
  TYPE tD0101_P IS RECORD (
    bez vis_d0101.bez%TYPE,
    p_anrede vis_d0101.p_anrede%TYPE,
    p_name vis_d0101.p_name%TYPE,
    hit_bez_1 vis_d0101.hit_bez_1%TYPE,
    hit_bez_2 vis_d0101.hit_bez_2%TYPE,
    bem vis_d0101.bem%TYPE);
  vD0101_p tD0101_P;

  CURSOR cMrkReise (pBTS_ID IN tID) IS
  SELECT 1 f1
  FROM ein_d_merkmal mrk
  --WHERE mrk.d_bts_id = bts1.bts.id
  WHERE mrk.d_bts_id = pBTS_ID
  AND mrk.bezeichnung = XGEWERBE_MRK_REISE;

BEGIN
--DBMS_OUTPUT.PUT_LINE('hier ist anl_min');
  Anl_Min_D0101_ID3 := '-1';
  
  CASE bts1.prot.quelle
  WHEN Quelle_XGewerbe THEN
    vBI_IDV := GEWERBE;
  ELSE NULL;
  END CASE;
    
  -- wenn ein_d_protokoll.d0101_id nicht richtig vergeben dann neu erzeugen
  IF NOT IS_ID(bts1.prot.d0101_id) THEN
    bts1.prot.d0101_id := SYS_GUID();
    bts1.bts.ref_id := bts1.prot.d0101_id;
     
    UPDATE ein_d_protokoll
    SET d0101_id = bts1.prot.d0101_id
    WHERE id = bts1.prot.id;    

    UPDATE ein_d_usecase
    SET d0101_id = bts1.prot.d0101_id
    WHERE id = pUsecase_ID;

    UPDATE ein_d_betriebsstaette
    SET ref_id = bts1.bts.ref_id
    WHERE id = bts1.bts.id;

  END IF; 
  vD0101_id3 := bts1.prot.d0101_id; 

   
  IF LENGTH(bts1.bts.zb) = 5 THEN
    vZB := bts1.bts.zb;
  ELSE  
    IF bts1.prot.quelle = QUELLE_XGEWERBE THEN
      vGKZ8 := SUBSTR( NVL(bts1.adr_btro.verw.gkz, bts1.prot.gkz), 1, 8);
    ELSE
      vGKZ8 := GetGKZ8ByIDV_RegNr(bts1.reg);
    END IF;
    vZB := GetZBbyGKZ8(vGKZ8); -- 13.09.2013
  END IF;

  IF bts1.adr_btro.verw.gkz IS NULL THEN
    bts1.adr_btro.verw.gkz := bts1.prot.gkz;
  END IF;

  --GetA24_SID_LAND_by_ISO(bts1.   pFKT_INH.adr.verw.staat
  -- Minimalanlage VIS_D0101 ohne abweichenden Betreiber
  --vD0101_bez := NULL;
  vD0101_p := null;
  --vD0101_bem := NULL;

  --IF bts1.prot.quelle = QUELLE_XGEWERBE AND bts1.bta.COUNT = 0 THEN
  --  vD0101_p.bem := 'Angelegt aus XGewerbeanzeige am ' || TO_CHAR(bts1.Usecases(1).ins_date, 'dd.mm.yyyy'); 
  --END IF;

  IF bts1.prot.quelle = QUELLE_XGEWERBE AND IS_ID( bts1.btr_pers(1).betreiber.pers.ref_id ) THEN
--DBMS_OUTPUT.PUT_LINE('bts1.btr_pers(1).betreiber.pers.ref_id:'||bts1.btr_pers(1).betreiber.pers.ref_id);
    vD0101_ID3 := bts1.btr_pers(1).betreiber.pers.ref_id;
      
    SELECT d1.bez, d1.p_anrede, d1.p_name, d1.hit_bez_1, d1.hit_bez_2 
    INTO vD0101_p.bez, vD0101_p.p_anrede, vD0101_p.p_name, vD0101_p.hit_bez_1, vD0101_p.hit_bez_2 
    FROM vis_d0101 d1
    WHERE d1.id = vD0101_ID3;
    IF vD0101_p.bez || '_' <> bts1.btr_pers(1).betreiber.pers.bezeichnung || '_' THEN
      vD0101_p.bem := CASE WHEN vD0101_p.bem IS NOT NULL THEN vD0101_p.BEM || CRLF END 
                   || 'Bezeichnung laut Gewerbeanmeldung:' || bts1.btr_pers(1).betreiber.pers.bezeichnung;
    END IF;
  ELSE 
    vD0101_ID3 := bts1.prot.d0101_id;
  END IF;

  -- Prfung Reisegewerbe -> als ambulant_jn = 1 anlegen
  OPEN cMrkReise (bts1.bts.id);
  FETCH cMrkReise INTO vAmbulant_jn;
  IF cMrkReise%FOUND THEN 
    vAmbulant_jn := 1;
  END IF;
  CLOSE cMrkReise;  
  
  INSERT INTO vis_d0101 
  ( 
    ID, MANDANT, D0101_ID2, D0101_ID3, SKZ, NAME1, BEZ_ART,
    INS_USER, INS_DATE, UPD_USER, UPD_DATE, DELETED, ANMELDUNG, ABMELDUNG, 
    GKZ, zb, daten_herkunft, quelle, abw_post,
    bez, p_anrede, p_name, hit_bez_1, hit_bez_2, bem, ambulant_jn
    -- 09.08.2019
    , kom_tel, kom_fax, kom_mobil, kom_email, kom_internet 
  ) VALUES (
    -- 23.01.2013
    bts1.prot.d0101_id, vMandant_SID, vD0101_ID3, vD0101_ID3, 1, bts1.bts.zusatzbez, --'P',
    CASE WHEN bts1.btr_pers(1).betreiber.pers.typ = 'JP' THEN 'F' ELSE 'N' END, 
    bts1.prot.User_SID, vSYSDATE, bts1.prot.User_SID, vSYSDATE, 0, bts1.bts.gueltig_von, bts1.bts.gueltig_bis,
    bts1.adr_btro.verw.gkz, vZB, NVL(bts1.usecases(1).datenherkunft, bts1.prot.quelle)/*'BEA'*/, bts1.prot.quelle, 0,
    vD0101_p.bez, vD0101_p.p_anrede, vD0101_p.p_name, vD0101_p.hit_bez_1, vD0101_p.hit_bez_2, vD0101_p.bem, vAmbulant_jn
    -- 09.08.2019
    , bts1.kom.telefon, bts1.kom.fax, bts1.kom.mobil, bts1.kom.email, bts1.kom.internet     
  );
  
  -- Betrieb D0101.CODE setzen
  -- gibt es nicht bei XGewerbe 
  --BALVI_Kor(bts1.prot.d0101_id);
  -- Kommunikationsmittel Betrieb
  -- 09.08.2019 oben eingefgt BTS_KOM(bts1.prot.d0101_id, 0, 0);

  -- Standortanschrift
  Standort_kor(bts1.prot.d0101_id, bts1.adr_btro);
  --Postanschrift
  CASE
  WHEN bts1.adr_btra.typ IS NULL THEN -- keine Postanschrift vorhanden
  -- 09.08.2019 nicht notwendig weil Postanschrift wie Standortanschrift in STANDORT_KOR gesetzt wird
  --  BETR_POST_DEA(bts1.prot.d0101_id);    
    NULL;
  WHEN CompareAdr(bts1.adr_btro, bts1.adr_btra) = 1 THEN
    -- Postanschrift wie Standort setzen
  -- 09.08.2019 nicht notwendig weil Postanschrift wie Standortanschrift in STANDORT_KOR gesetzt wird
  --  BETR_POST_DEA(bts1.prot.d0101_id);
    NULL;  
  ELSE
    -- abweichende Postanschrift
    BETR_POST_KOR(bts1.prot.d0101_id, bts1.adr_btra, NULL);
  END CASE;
  
  -- Hauptverantwortliche
  -- nach unten verschoben pers_anl(bts1.prot.d0101_id, bts1.fkt_hv.pers, 0);  -- HV ist optional, kann fehlen
  
  --btrb_anl(bts1.prot.d0101_id); -- Abteilung 

  -- Fachbereiche werden auch ber die Betriebsarten angelegt
  IF bts1.prot.quelle IN (QUELLE_XGEWERBE) THEN
    IF ANL_FB(bts1.prot.d0101_id) = 0 THEN 
      NULL; 
    --  AddMsg('Der Betrieb wird ohne Fachbereiche angelegt.');    
    END IF;
  END IF;

  -- Betriebsarten
  IF btyp_anl(pD0101_ID => bts1.prot.d0101_id, 
              pUpdD0101_Bem => bts1.prot.quelle = QUELLE_XGEWERBE ) = 0 THEN --todo 64908090
    AddMsg('Der Betrieb wird ohne Betriebsarten angelegt.');
  END IF;    


  --18.01.2016 reg_anl2(bts1.prot.d0101_id, 1, NULL, 0); -- Registrierungen
  reg_anl(bts1.prot.d0101_id, bts1.reg, 1, NULL, 0, 0); -- Registrierungen
  
 /* 
  Betreiber :
  PERS_ID von FKT_INH in iP suchen 
     bei D_PERS.TYP = NP -> D0102.PERS_ID vergleichen
     bei D_PERS.TYP = JP -> Registrierung     
  => wenn vorhanden dann als abweichender Betreiber nehmen
  => wenn nicht vorh. dann Vergleich ADR_ID von Betriebssttte BTRA wenn vorh. sond BTRO mit
     Adresse Betreiber FKT_INH => wenn gleich dann kein abweichender Betreiber 
 */ 
  vD0101_ID3 := '-1';
  CASE bts1.prot.quelle
  WHEN QUELLE_XGEWERBE THEN
    vD0101_ID3 := bts1.btr_pers(1).betreiber.pers.ref_id;
  ELSE NULL;  
  END CASE;

  IF NOT IS_ID(vD0101_ID3) THEN 
      
    AnlageBetreiber(vD0101_ID3, vZB);

    AnlageBtr2Ordnung(vZB);
  
  END IF;

  
  IF vAmbulant_jn = 1 THEN -- Reisegewerbe
    UPDATE vis_d0101
    SET abw_post = 1
      , gkz = NVL(gkz, zb)
      , ( p_ort, p_ortsteil, p_plz, p_strasse, p_hausnr, p_hausnrzusatz, p_land, is_postfach ) =
        ( select
         d1.p_ort, d1.p_ortsteil, d1.p_plz, d1.p_strasse, d1.p_hausnr, d1.p_hausnrzusatz, d1.p_land, d1.is_postfach
         from vis_d0101 d1
         where d1.id = vis_d0101.d0101_id3 )
    WHERE id = bts1.prot.d0101_id
      AND ambulant_jn = 1; 
  END IF;    
  
END Anl_Min;

PROCEDURE UseCases AS
BEGIN

  FOR i IN bts1.usecases.FIRST .. bts1.usecases.LAST LOOP
    UseCase( bts1.usecases(i).usecase );
  END LOOP;

END;



-- pConfirm: 1 - Besttigung, 0 - Ablehnung 
PROCEDURE StartUseCaseByUseCase_ID(pID IN VARCHAR2, pConfirm IN PLS_INTEGER := 1) AS
  v PLS_INTEGER;
  
  CURSOR cUsecase (pID IN VARCHAR2) IS
  SELECT uc.d_bts_id, uc.usecase, uc.user_sid, uc.mandant, uc.aus_d_usecase_id, uc.d0101_id 
  , (SELECT d0101.deleted FROM vis_d0101 d0101 WHERE d0101.id = uc.d0101_id) d0101_deleted
  FROM ein_d_usecase uc
  WHERE uc.id = pID;
  
  vUsecase cUsecase%ROWTYPE;
BEGIN
  ClearErrMsg;
  --CreatedUseCase := 0;
  Anl_Min_D0101_ID3 := '-1';
  Anl_Min_D0101_ID3_2 := '-1';
    
  OPEN cUsecase(pId);
  FETCH cUsecase INTO vUsecase;
  CLOSE cUsecase;
  
  vMandant_SID := vUsecase.mandant;
    
  
  IF NOT IS_ID(vUsecase.D_BTS_ID) THEN
    IF pConfirm = 1 THEN
      AddErrMsg('Der Usecase ' || vUsecase.Usecase || ' kann nicht besttigt werden (BTS_ID = ' || vUsecase.D_BTS_ID || ').');
    ELSE
      AddErrMsg('Der Usecase ' || vUsecase.Usecase || ' kann nicht abgelehnt werden (BTS_ID = ' || vUsecase.D_BTS_ID || ').');
    END IF;  
    RETURN;
  END IF;
  
  IF pConfirm = 1 AND IS_ID(vUsecase.D0101_ID) AND vUsecase.d0101_deleted = -2 THEN
    AddErrMsg( 'Die Meldung kann nicht importiert werden, die entsprechende Betriebssttte wurde gelscht.');
    RETURN;
  END IF;
  
  v:= Fill_BTS1(vUsecase.D_BTS_ID, vUsecase.Usecase);
  IF pConfirm = 1 THEN
    v:= FILL_BTS2(vUsecase.D_BTS_ID, vUsecase.Usecase);
  END IF;
  
  IF CheckPrtQuelle() THEN
  
    IF pConfirm = 1 THEN  
      UseCase(vUsecase.UseCase);    
      IF vCommit = 1 THEN 
        IF vErrCnt = 0 THEN 

          UPDATE ein_d_usecase
          SET bearbeitung_jn = 0
          WHERE id = pID
          AND bearbeitung_jn = 1;
        
          COMMIT;          
        ELSE
          ROLLBACK;
        END IF;
          
      END IF;

    ELSE -- Ablehnung
      NULL;   
    END IF;
  END IF;
END StartUseCaseByUseCase_ID;

-- Betreiberwechsel
PROCEDURE AEND_BETREI(pD0101_ID tID, pBTS_ID2 IN tID) AS
  --iReg_bts PLS_INTEGER;
  iReg_fkt PLS_INTEGER;
  vD0101_ID3 vis_d0101.d0101_id3%TYPE := NULL;
  vD0101_ID3_alt vis_d0101.d0101_id3%TYPE := NULL;
  vDaten_herkunft vis_d0101.daten_herkunft%TYPE;
  vBez vis_d0101.bez%TYPE;
  vP_name    vis_d0101.P_name%TYPE;
  vHit_bez_1 vis_d0101.Hit_bez_1%TYPE; 
  vHit_bez_2 vis_d0101.Hit_bez_2%TYPE;  
  vSysdate DATE := SYSDATE;
  vZB vis_d0101.zb%TYPE; 
  vHitNr vis_d010102.nummer%TYPE; 
  
  PROCEDURE AnlageBtr AS
  BEGIN
    -- abweichender Betreiber anlegen
    CASE
    WHEN vD0101_ID3 = '-1' THEN
      --22.04.2015AddErrMsg('Betreiber mit der BI-Nummer wurde nicht gefunden:' || bts1.fkt_inh.reg(iReg_fkt).nummer);
      vD0101_ID3 := AnlageFkt_INH( bts1.btr_pers(1).betreiber, '%', 1);
      IF vD0101_ID3 IS NULL THEN
        AddErrMsg('Betreiber mit der Betreiber-ID wurde nicht gefunden und konnte nicht angelegt werden: ' || bts1.btr_pers(1).betreiber.reg(iReg_fkt).nummer);
      END IF;  
    WHEN vD0101_ID3 = '-2' THEN
      AddErrMsg('Es sind mehrere Betreiber mit der Betreiber-ID vorhanden: ' || bts1.btr_pers(1).betreiber.reg(iReg_fkt).nummer);
    WHEN vD0101_ID3 IS NULL THEN
      AddErrMsg('Die Nummernart ist nicht vorhanden: ' || BETREIBER_ID);
    ELSE NULL;
    END CASE;
        
    IF vD0101_ID3 NOT IN ('-1', '-2') THEN

      SELECT daten_herkunft, bez, p_name, hit_bez_1, hit_bez_2
      INTO vDaten_herkunft, vBez, vP_name, vHit_bez_1, vHit_bez_2
      FROM vis_d0101
      WHERE id = vD0101_ID3;

      UPDATE vis_d0101 d0101
      SET d0101_id3 = vD0101_ID3
        , betreiber_abw = CASE WHEN pD0101_ID = vD0101_ID3 THEN 0 ELSE 1 END -- 22.04.2015
        , upd_date = vSYSDATE
        -- Bez vom Betreiber bernehmen wenn Betreiber und Betriebssttte von BEA
        , bez       = CASE WHEN blvUtils.bea_konform(daten_herkunft) = 1 AND blvUtils.bea_konform(vDaten_herkunft) = 1 THEN vBEZ ELSE bez END
        , p_name    = CASE WHEN blvUtils.bea_konform(daten_herkunft) = 1 AND blvUtils.bea_konform(vDaten_herkunft) = 1 THEN vP_Name ELSE p_name END
        , hit_bez_1 = CASE WHEN blvUtils.bea_konform(daten_herkunft) = 1 AND blvUtils.bea_konform(vDaten_herkunft) = 1 THEN vHit_bez_1 ELSE hit_bez_1 END
        , hit_bez_2 = CASE WHEN blvUtils.bea_konform(daten_herkunft) = 1 AND blvUtils.bea_konform(vDaten_herkunft) = 1 THEN vHit_bez_2 ELSE hit_bez_2 END
        , d010200_id2 = CASE WHEN EXISTS( 
                          SELECT 1 FROM vis_d010200 dx 
                          WHERE dx.deleted = 0 AND dx.id = d0101.d010200_id2 
                          AND dx.d0101_id = d0101.id)
                        THEN d010200_id2 ELSE '-1' END
      WHERE id = pD0101_ID;
    ELSE
       AddErrMsg('Der Betreiberwechsel konnte nicht durchgefhrt werden.');              
    END IF;  
  
  END AnlageBtr;               
BEGIN

  --iReg_bts := RegIndex('BI', bts1.reg);                           
  iReg_fkt := RegIndex(BI, bts1.btr_pers(1).betreiber.reg);
        
  IF /*iReg_bts > 0 AND*/ iReg_fkt > 0 THEN
    -- 13.11.2015 todo 59518090: HIT-Nr. sind eindeutig deshalb keine Gltigkeitsprfung notwendig
    SELECT d010102.nummer, d0101.d0101_id3 INTO vHitNr, vD0101_ID3_alt
    FROM vis_d0101 d0101  
    join vis_d010102 d010102 ON d010102.d0101_id = d0101.id
    AND d010102.a010145_sid = A010145_HIT_NR
    AND d010102.deleted = 0
    AND d010102.d0101_id = pD0101_ID;
    
    -- Betreiber_ID = Hit-Nr. berall lschen
    DelBetreiber_ID(vHitNr);
  
    -- Nr. des Betreibers vergleichen
    -- Betrieb und Betreiber sind nicht identisch                          
    IF /*bts1.reg(iReg_bts).nummer <>*/ vHitNr <> bts1.btr_pers(1).betreiber.reg(iReg_fkt).nummer THEN

      --22.04.2015 vD0101_ID3 := GetD0101byCodeNr('BI', bts1.fkt_inh.reg(iReg_fkt).nummer);           
      vD0101_ID3 := GetD0101byCodeNr(BETREIBER_ID, bts1.btr_pers(1).betreiber.reg(iReg_fkt).nummer);     
      AnlageBtr();                                      

    ELSE -- Betreiber_id = Hit-Nr.
      vD0101_ID3 := '-1';
      AnlageBtr();
    
    END IF; 
      
    -- alten Betreiber neue Betreiber_ID zuordnen
    IF vD0101_ID3_alt <> vD0101_Id3 THEN
      Aend_Betreiber_ID( pBTS_ID2, vD0101_Id3 ); -- alten Betreiber neue Betreiber_ID zuordnen
    END IF;   
    
    
  ELSE -- Fehler
    --IF iReg_bts <= 0 THEN -- 22.04.2015 < hinzugefgt
    --  AddErrMsg('BI-Nummer der Betriebssttte ist nicht vorhanden.');
    --END IF;
    IF iReg_fkt <= 0 THEN -- 22.04.2015 < hinzugefgt
      AddErrMsg('BI-Nummer des Betreibers ist nicht vorhanden.');        
    END IF;
        
  END IF;  

END; -- AEND_BETREI

-- ndern Name des Betreibers
PROCEDURE AEND_NAME_BETREI(pD0101_ID VARCHAR2) AS 
  --iReg PLS_INTEGER;
  vD0101_ID3 vis_d0101.d0101_id3%TYPE;
  vP_NAME vis_d0101.p_name%TYPE;
  vBez vis_d0101.bez%TYPE;
  vD010200_Bez vis_d010200.bez%TYPE;
  vD0102_ID vis_d010200.d0102_id%TYPE;
  vD010200_ID vis_d010200.id%TYPE;
  vDaten_herkunft VIS_D0101.DATEN_HERKUNFT%TYPE;
  vK1 VARCHAR2(30) := SUBSTR(bts1.btr_pers(1).betreiber.pers.kurzbez1, 1, 30);
  vK2 VARCHAR2(30) := SUBSTR(bts1.btr_pers(1).betreiber.pers.kurzbez2, 1, 30);
  vSYSDATE DATE := SYSDATE;
BEGIN

  SELECT d0101_id3, daten_herkunft INTO vD0101_ID3, vDaten_herkunft
  FROM vis_d0101
  WHERE id = pD0101_ID;  
  
  IF vD0101_ID3 <> '-1' THEN
    
  --iReg := RegIndex('BI', bts1.fkt_inh.reg);
  --IF iReg > 0 THEN
  --  vD0101_ID3 := GetD0101byCodeNr('BI', bts1.fkt_inh.reg(iReg).nummer);
  --  IF vD0101_ID3 IS NULL THEN
  --    AddErrMsg('Betreiber mit der BI-Nummer wurde nicht gefunden:' || bts1.fkt_inh.reg(iReg).nummer);
  --  ELSE
  
      IF bts1.btr_pers(1).betreiber.pers.typ = 'JP' THEN -- juristische person  
        vBez := bts1.btr_pers(1).betreiber.pers.bezeichnung;
        vP_Name := vBez;
        UPDATE vis_d0101
        SET --05.03.2014 bez = CASE WHEN abw_post = 0 THEN vBez ELSE bez END
            bez = vBez
          -- 04.03.2014 todo 53017090
          -- 05.06.2014 todo 53983090 , p_name   = CASE WHEN abw_post = 1 AND NVL(daten_herkunft, 'X') <> 'BEA' THEN p_name ELSE vBez END
          , p_name       = vP_Name
          , HIT_BEZ_1    = vK1 
          , HIT_BEZ_2    = vK2
          , HIT_P_BEZ_1  = vK1
          , HIT_P_BEZ_2  = vK2
          
          , upd_date = vSYSDATE
        WHERE id = vD0101_ID3;
     
      ELSE  -- 12.07.2013 natrliche Person
        
        vBez := CreateD0101Bez(
                  bts1.btr_pers(1).betreiber.pers.nachname, 
                  bts1.btr_pers(1).betreiber.pers.vorname, 
                  bts1.btr_pers(1).betreiber.pers.vorsatz_nachname, 
                  bts1.btr_pers(1).betreiber.pers.nachsatz_nachname, 
                  bts1.btr_pers(1).betreiber.pers.titel);  
                                
        vP_Name := CreateD0101P_Name(
                      bts1.btr_pers(1).betreiber.pers.nachname, 
                      bts1.btr_pers(1).betreiber.pers.vorname, 
                      bts1.btr_pers(1).betreiber.pers.vorsatz_nachname, 
                      bts1.btr_pers(1).betreiber.pers.nachsatz_nachname, 
                      bts1.btr_pers(1).betreiber.pers.titel);       

        vD010200_Bez := GetD010200_Bez(
                  bts1.btr_pers(1).betreiber.pers.nachname, 
                  bts1.btr_pers(1).betreiber.pers.vorname, 
                  bts1.btr_pers(1).betreiber.pers.vorsatz_nachname, 
                  bts1.btr_pers(1).betreiber.pers.nachsatz_nachname, 
                  bts1.btr_pers(1).betreiber.pers.titel); 

        UPDATE vis_d0101
        SET --05.03.2014 bez     = CASE WHEN abw_post = 0 THEN vBez ELSE bez END
            bez     = vBez
          -- 04.03.2014 todo 53017090
          -- 05.06.2014 todo 53983090 , p_name   = CASE WHEN abw_post = 1 AND NVL(daten_herkunft, 'X') <> 'BEA' THEN p_name ELSE vBez END
          , p_name = vP_Name
          , vname    = bts1.btr_pers(1).betreiber.pers.vorname
          , nname    = bts1.btr_pers(1).betreiber.pers.nachname
          , titel    = bts1.btr_pers(1).betreiber.pers.titel
          , anrede   = bts1.btr_pers(1).betreiber.pers.anrede
          , vorsatz_nname  = bts1.btr_pers(1).betreiber.pers.vorsatz_nachname
          , nachsatz_nname = bts1.btr_pers(1).betreiber.pers.nachsatz_nachname
          , p_anrede = bts1.btr_pers(1).betreiber.pers.anrede  
          
          , HIT_BEZ_1    = vK1 
          , HIT_BEZ_2    = vK2
          , HIT_P_BEZ_1  = vK1
          , HIT_P_BEZ_2  = vK2          
               
          , upd_date = vSYSDATE
          , upd_user = vUser_SID
        WHERE id = vD0101_ID3;
      
        UPDATE vis_d010200 
        SET bez = vD010200_bez
          , upd_date = vSYSDATE
          , upd_user = vUser_SID
        WHERE d0101_id = vD0101_ID3
        AND deleted = 0
        AND inhaber = 1
        RETURNING d0102_id, id INTO vD0102_ID, vD010200_ID;
        
        IF SQL%ROWCOUNt > 0 THEN
          UPDATE vis_d0102
          SET bez = vD010200_bez
            , upd_date = vSYSDATE
            , upd_user = vUser_SID          
            , vname    = bts1.btr_pers(1).betreiber.pers.vorname
            , nname    = bts1.btr_pers(1).betreiber.pers.nachname
            , titel    = bts1.btr_pers(1).betreiber.pers.titel
            , anrede   = bts1.btr_pers(1).betreiber.pers.anrede
            , vorsatz_nname  = bts1.btr_pers(1).betreiber.pers.vorsatz_nachname
            , nachsatz_nname = bts1.btr_pers(1).betreiber.pers.nachsatz_nachname
            , geb_datum = bts1.btr_pers(1).betreiber.pers.geburtsdatum
            , geb_ort   = bts1.btr_pers(1).betreiber.pers.geburtsort
          WHERE id = vD0102_ID;            
         
          -- Hauptansprechpartner in Betrieb aktualisieren
          UPDATE vis_d0101
          SET upd_date = vSYSDATE
            , upd_user = vUser_SID          
            , vname    = bts1.btr_pers(1).betreiber.pers.vorname
            , nname    = bts1.btr_pers(1).betreiber.pers.nachname
            , titel    = bts1.btr_pers(1).betreiber.pers.titel
            , anrede   = bts1.btr_pers(1).betreiber.pers.anrede
            , vorsatz_nname  = bts1.btr_pers(1).betreiber.pers.vorsatz_nachname
            , nachsatz_nname = bts1.btr_pers(1).betreiber.pers.nachsatz_nachname
          WHERE d010200_id2 = vD010200_ID
          AND id <> vD0101_ID3
          AND deleted = 0;            
         
        END IF;
        
      END IF;
        
      -- bei allen BEA-Betriebssttten des Betreibers BEZ aktualisieren
      -- wenn Betreiber von BEA      
      IF blvUtils.bea_konform(vDaten_herkunft) = 1 THEN         
        UPDATE vis_d0101
        SET bez = vBez
          , p_name = vP_Name
          -- 05.06.2014 todo 53983090
          , hit_bez_1 = vK1
          , hit_bez_2 = vK2
          , upd_date = vSYSDATE
        WHERE d0101_id3 = vD0101_ID3
        AND blvUtils.bea_konform(daten_herkunft) = 1;        
      END IF;
  ELSE
    AddErrMsg('Betriebssttte hat keinen Betreiber.');  
  END IF;
END AEND_NAME_BETREI;

FUNCTION ExistAnmeld_BTR( pReg IN OUT NOCOPY tbReg) RETURN VARCHAR2 AS
 vIReg PLS_INTEGER;
 vDeleted PLS_INTEGER;
 vBTS_ID ein_d_protokoll.d_bts_id%TYPE := NULL;
 vD0101_id ein_d_protokoll.d0101_id%TYPE := NULL; 

BEGIN
  vIReg := RegIndex(vIDV, pReg);
  IF vIReg > 0 THEN
  
    SELECT MIN(uc.deleted), MAX(uc.d_bts_id) INTO vDeleted, vBTS_ID
    FROM ein_d_registrierung d_reg
    JOIN ein_r_bts_reg r_reg ON r_reg.d_reg_id = d_reg.id
    JOIN ein_d_usecase uc ON uc.d_bts_id = r_reg.d_bts_id
    AND uc.usecase IN('ANL_MIN', 'ANMELD_BTR', 'ANMELD_BS') 
    WHERE d_reg.art = vIDV
      AND d_reg.nummer = pReg(vIReg).nummer
      AND d_reg.id <> pReg(vIReg).id;      
    END IF;
  
  CASE 
  WHEN vDeleted IS NULL THEN
    AddErrMsg('Der Betrieb mit der Registrier-Nr. (' || vIDV || ') ' ||
                pReg(vIReg).nummer || ' ist noch nicht importiert (ist nicht im Eingangskorb vorhanden).');
  WHEN vDeleted = 0 THEN
    AddErrMsg('Die Anmeldung des Betriebs mit der Registrier-Nr. (' || vIDV || ') ' || 
                pReg(vIReg).nummer || ' muss noch besttigt werden.');
  WHEN vDeleted = -1 THEN
    -- BTS_ID verwenden
    IF vBTS_ID <> '-9999' THEN
      
      SELECT MAX(prot.d0101_id) INTO vD0101_ID
      FROM ein_d_protokoll prot
      WHERE prot.d_bts_id = vBTS_ID;
      
      IF vD0101_ID IS NULL OR vD0101_ID IN( '-9999', '-1') THEN
        AddErrMsg('Der Betrieb mit der Registrier-Nr. (' || vIDV || ') ' || 
                    pReg(vIReg).nummer || ' wurde bereits besttigt aber die Betriebszuordnung (D0101_ID) wurde nicht gesetzt (technisches Problem).') ;
      
      END IF;
      
    ELSE
      AddErrMsg('Der Betrieb mit der Registrier-Nr. (' || vIDV || ') ' || 
                  pReg(vIReg).nummer || ' wurde bereits besttigt (technisches Problem).') ;
    END IF;
  ELSE
    NULL;    
  END CASE;
  RETURN vD0101_ID;
END ExistAnmeld_BTR;


------------------------------------------------------------------------------
PROCEDURE UseCase( pUsecase VARCHAR2) AS
  vD0101_id EIN_d_protokoll.d0101_id%TYPE;
  vD0101_ID3 vis_d0101.d0101_id3%TYPE;
  vZB vis_d0101.zb%TYPE;
  vBI_IDV   VARCHAR2(20) := vIDV;
  iReg_bts PLS_INTEGER;
  iReg_fkt PLS_INTEGER;
  vAUS_REG_ID VARCHAR2(32) := SYS_GUID();
  vUsecase_ID ein_d_usecase.id%TYPE;
  vGUID VARCHAR2(32);
  vSYSDATE DATE := SYSDATE;
  vUC_BTS_ID2 ein_d_usecase.d_bts_id2%TYPE;
  vDate DATE;
  
  PROCEDURE Storno_Btr(pD0101 IN BOOLEAN, pD010104 IN BOOLEAN, pD010101 IN BOOLEAN, 
                       pD010102 IN BOOLEAN, pIsStorno IN NUMBER, pCanAusgangskorb IN BOOLEAN) AS
    vA010145 tA010145;
    vD010102_ID tbID;
    --bOK BOOLEAN := FALSE;
    
    vA010108_sid vis_a010108.sid%TYPE; 
    vA010108_sid0 vis_a010108.A010108_sid0%TYPE;
    vBez vis_a010108.bez%TYPE; 
    vCode vis_a010108.code%TYPE;
    vSkz vis_a010108.skz%TYPE;
    vFb vis_a010108.fb%TYPE;    
    vAuswahl vis_a010108.auswahl%TYPE;    
    vD010101_ID vis_d010101.id%TYPE;
    bIsUpdated BOOLEAN := FALSE;
  BEGIN
  
    -- Abmeldung Betrieb lschen
    IF pD0101 THEN
      UPDATE vis_d0101
      SET abmeldung = NULL
        , upd_date = vSYSDATE
        , upd_user = vUser_SID
      WHERE id = vD0101_ID
        AND abmeldung > vDateMin;  

      IF SQL%ROWCOUNT > 0 THEN
        AddMsg('Die Abmeldung im Betrieb wurde gelscht.'); 
        bIsUpdated := TRUE;
      END IF;           
        
    END IF;
    
    -- Abmeldung Fachbereich TS lschen
    IF pD010104 THEN
      UPDATE vis_d010104
      SET gueltig_bis = vDateMax
        , upd_date = vSYSDATE
        , upd_user = vUser_SID  
      WHERE D0101_ID = vD0101_ID
        AND deleted = 0
        AND a0101_06_sid = 76 -- Fachbereich TS 
        AND gueltig_bis < vDateMax; 
        
        IF SQL%ROWCOUNT = 0 THEN
          NULL; --AddMsg('Die Abmeldung im Fachbereichs TS wurde nicht gelscht.');
        ELSE
          AddMsg('Die Abmeldung im Fachbereich TS wurde gelscht.'); 
          bIsUpdated := TRUE;
          
          -- Fachbereich TS hinzufgen          
          UPDATE vis_d0101
          SET fb = LTRIM(FB, '-') || 'D'
            , fachb = BLVUTILS.GET_FB2KURZBV( LTRIM(FB, '-') || 'D')
            , upd_date = vSYSDATE
            , upd_user = vUser_SID
          WHERE id = vD0101_ID
          AND fb NOT LIKE '%D%';
          
        END IF;     
    END IF;
    
    -- Abmeldung D010101
    IF pD010101 AND  bts1.bta.COUNT > 0 THEN
      FOR iBA IN bts1.bta.FIRST .. bts1.bta.LAST LOOP
        
        vA010108_SID := NULL;
        
        GetA010108(bts1.bta(iBA).code, bts1.bta(iBA).gewerbsmaessig, 1, bts1.bta(iBA).art, 
        vA010108_sid, vA010108_sid0, vBez, vCode, vSkz, vFb, vAuswahl);               
        
        IF vA010108_SID > 0 THEN  -- richtige Betriebsart
          
          UPDATE vis_d010101
          SET gueltig_bis = vDateMax
            , abgemeldet = NULL
            , upd_date = vSYSDATE
            , upd_user = vUser_SID           
          WHERE d0101_id = vD0101_ID
            AND deleted = 0
            AND aktiv = 1
            AND a010108_sid = vA010108_SID
            AND gewerbsmaessig = bts1.bta(iBA).gewerbsmaessig
            AND abgemeldet > vDateMin
          RETURNING id INTO vD010101_ID;          
          
          IF SQL%ROWCOUNT = 0 THEN -- BA nicht aktualisiert
            NULL; -- AddMsg('Die Abmeldung der Betriebsart ' || bts1.bta(iBA).code || ' ' || vBez || ' wurde nicht gelscht.'); 
          ELSE
            AddMsg('Die Abmeldung der Betriebsart ' || vBez || ' wurde gelscht.'); 
            bts1.bta(iBA).ref_id := vD010101_ID;
            bIsUpdated := TRUE;
            
            UPDATE ein_d_betriebsart
            SET ref_id = vD010101_ID
            WHERE id = bts1.bta(iBA).id;
                        
          END IF;        
        END IF;      
      END LOOP;   
    END IF;
    
    -- Abmeldung N/Z/R lschen
    IF pD010102 THEN 
      IF bts1.reg.COUNT > 0 THEN 
        FOR iReg IN bts1.reg.FIRST .. bts1.reg.Last LOOP
          IF bts1.reg(iReg).art <> 'BALVI' THEN        
              
            GetA010145( bts1.reg(iReg).art, bts1.reg(iReg).code, vA010145);      
            IF vA010145.SID > 0 THEN    
							
							SELECT id --, a0302_05_sid, gueltig_von, gueltig_bis 
							BULK COLLECT INTO vD010102_ID 
              FROM vis_d010102 
              WHERE d0101_id = vD0101_ID
                AND deleted = 0
                AND nummer = bts1.reg(iReg).Nummer
                AND a010145_sid IN (SELECT ax.sid FROM vis_a010145 ax WHERE ax.skz = vA010145.skz AND ax.code LIKE vA010145.code)
                AND (gueltig_bis > vDateMin OR a0302_05_sid <> A0302_05_ERTEILT);
						
							IF vD010102_ID.COUNT = 0 THEN 
                NULL; --AddMsg('Die Abmeldung der ' || vA010145.bez || ' ' || bts1.reg(iReg).Nummer || ' wurde nicht gelscht.');
							ELSE
                vDate := TRUNC(bts1.prot.ins_date);
                --FORALL i IN vD010102_ID.FIRST .. vD010102_ID.LAST
                UPDATE vis_d010102
                SET gueltig_bis = NULL
                  , upd_date = vSYSDATE
                  , upd_user = vUser_SID
                  , gueltig_von_stat = vDate -- todo 58338090 CASE WHEN pIsStorno = 1 THEN gueltig_von_stat ELSE bts1.bts.gueltig_von END
                  , gueltig_bis_stat = NULL
                WHERE id = vD010102_id(1).id
                  AND gueltig_bis IS NOT NULL;   

                IF SQL%ROWCOUNT > 0 THEN
                  AddMsg('Die Abmeldung der ' || vA010145.bez || ' ' || bts1.reg(iReg).Nummer || ' wurde gelscht.');              
                  bIsUpdated := TRUE;
                ELSE
                  NULL; --AddMsg('Die Abmeldung der ' || vA010145.bez || ' ' || bts1.reg(iReg).Nummer || ' wurde nicht gelscht.');  
                END IF;
                                  
                -- evtuell den Status noch aktualisieren
                --FORALL i IN vD010102_ID.FIRST .. vD010102_ID.LAST
                vDate := TRUNC(bts1.prot.ins_date);
                UPDATE vis_d010102
                SET upd_date = vSYSDATE
                  , upd_user = vUser_SID
                  , gueltig_von_stat = vDate -- todo 58338090 CASE WHEN pIsStorno = 1 THEN gueltig_von_stat ELSE bts1.bts.gueltig_von END
                  , gueltig_bis_stat = NULL
                  , a0302_05_sid = A0302_05_ERTEILT -- Status erteilt
                WHERE id = vD010102_id(1).id
                  AND a0302_05_sid <> A0302_05_ERTEILT;   

                IF SQL%ROWCOUNT > 0 THEN
                  InsertD0300(vD010102_ID(1).id);
                END IF;
                                
                                                    
                bts1.reg(iReg).ref_id := vD010102_ID(1).id;
                    
                UPDATE ein_d_registrierung -- d010102.id im Eingangskorb hinterlegen
                SET ref_id = vD010102_ID(1).id
                WHERE id = bts1.reg(iReg).id;
                  
              END IF;
            END IF;
          END IF;
        END LOOP;
      ELSE
        AddErrMsg('Fr die Betriebssttte fehlt die Registriernummer im Eingangskorb.');        
      END IF;
    END IF;
    
    --UpdBetreiber_ID(); 
    UpdateBetreiber_ID(pBTS_ID => BTS1.bts.id); -- todo 64175090 22.03.2017
            
  END; -- Storno_Btr
  
  -- 16.07.2014
  -- Besttigung Betreiberwechsel  
  PROCEDURE Bestaet_Aend_Betrei AS

  vBtrA010145 tA010145;
  vBtsA010145 tA010145;
  
  vBtr_IDIdx PLS_INTEGER;
  vBts_IDIdx PLS_INTEGER;
  vSysdate CONSTANT DATE := SYSDATE;
  
  CURSOR cVerglHIT (pBTS_ID IN VARCHAR2, pRegNr IN VARCHAR2) IS
  SELECT 1 f1
  FROM ein_r_bts_reg r1
  JOIN ein_d_registrierung reg ON reg.id = r1.d_reg_id
  AND reg.art = BI 
  AND reg.nummer = pRegNr 
  AND r1.d_bts_id = pBTS_ID;
  
  vVerglHit cVerglHit%ROWTYPE;  

  BEGIN
    -- aktuellen Betreiber der Betriebssttte ermitteln
    SELECT d0101_id3 INTO vD0101_ID3
    FROM vis_d0101
    WHERE id = vD0101_ID;
    
    -- Betreiber_ID ermitteln
    GetA010145(Betreiber_ID, NULL, vBtrA010145);    
    -- HIT-Nr. ermitteln
    GetA010145(BI, NULL, vBtsA010145);    
    vBts_IdIdx := RegIndex(BI, bts1.reg);
    IF vBts_IDIdx > 0 THEN 
      -- alle vorhandene Betreiber_ID's lschen
      DelBetreiber_ID( bts1.reg(vBts_IdIdx).nummer, vD0101_ID3, vD0101_ID);

    ELSE
      AddErrMsg('Die ' ||vBtsA010145.BEZ|| ' fehlt bei der Betriebssttte im Eingangskorb.');
    END IF;
    
    -- Wenn Betreiber_ID noch nicht beim Betreiber vorhanden ist dann hinzufgen
    vBtr_IdIdx := RegIndex(BI, bts1.btr_pers(1).betreiber.reg);
    IF vBtr_IdIdx > 0 THEN
      
      -- BETREIBER_ID beim Betreiber anlegen, wenn noch keine Betreiber_id vorhanden 
      --IF Reg_Anl(vD0101_ID3, 3, BI, 1, 2) > 0 THEN
      if reg_anl(pD0101_ID => vD0101_ID3, pTyp => 3, pArt => BI, pFkt => 1, pCheck => 3) > 0 THEN 
        NULL;
      END IF;
      
      -- berprfung HV 
      -- falls HV nicht zum Betreiber/Betreibssttte gehrt, dann Verweis lschen
      -- Ursache: HV gehrt zum alten Betreiber
      -- HV muss manuell geplegt werden
      UPDATE vis_d0101
      SET d010200_id2 = '-1'
        , upd_date = vSysdate
        , upd_user = vUser_sid
      WHERE id = vD0101_ID 
      AND d010200_id2 NOT IN (
        SELECT id FROM vis_d010200 d010200 WHERE d010200.d0101_id IN (vD0101_ID, vD0101_ID3) 
        UNION ALL SELECT '-1' FROM dual
      );
    ELSE
      AddErrMsg('Die BI-Nummer fehlt beim Betreiber im Eingangskorb.');
    END IF;
    
    -- alten Betreiber eventuell eine neue BETREIBER_ID zuordnen
    -- todo 59518090 12.11.2015
    -- wenn alte Betreiber keine Betriebe mehr hat, liegt dieser trotzdem im EK
    -- Workaround dafr: sind beide BI gleich wird keine neue BetreiberID vergeben  
    IF vBts_IdIdx > 0 AND IS_ID( vUC_BTS_ID2 ) THEN
      
      OPEN cVerglHit( vUC_BTS_ID2, bts1.reg(vBts_IdIdx).nummer);
      FETCH cVerglHit INTO vVerglHit;
      CLOSE cVerglHit; 
      IF vVerglHit.f1 IS NULL THEN  -- BI-Nr. sind nicht gleich
        Aend_Betreiber_id( vUC_BTS_ID2, vD0101_ID3 );
      END IF;
      
    END IF;
       
  END Bestaet_Aend_Betrei;


  -- 27.01.2015
  -- Wechsel Hauptverantwortlicher
  PROCEDURE pers_aend_hv(pD0101_id IN VARCHAR2) AS
    vD010200_ID vis_d010200.id%TYPE;
    vD0102_ID VIS_D0102.ID%TYPE;
    vA0101_03_SID vis_a0101.sid%TYPE := -1;
    vBez vis_d0101.bez%TYPE;
    vD010200_ID2 vis_d0101.d010200_id2%TYPE;
    vInsertD010202 BOOLEAN := False;
    vSYSDATE DATE := SYSDATE;
    vSKZ vis_d0101.skz%TYPE;
    vPers EIN_d_person%ROWTYPE;
    
    CURSOR cD0102 IS
    SELECT d010200.id, d0101.d010200_id2
    FROM vis_d0101 d0101
    JOIN vis_d010200 d010200 ON d010200.d0101_id IN ( d0101.id, d0101.d0101_id3)
    AND d010200.deleted = 0
    JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id
    AND d0102.pers_id = vPers.pers_id
    AND d0101.id = pD0101_ID;
    
  BEGIN
    vPers := bts1.fkt_hv.pers;
       
    IF vPers.id IS NULL OR NVL( vPers.pers_id, '0') = '0'THEN
      RETURN;
    END IF;

    OPEN cD0102;
    FETCH cD0102 INTO vD010200_id, vD010200_ID2;
    CLOSE cD0102;

    IF vD010200_id = vD010200_ID2 THEN -- kein HV- Wechsel notwendig
      RETURN;
    END IF;

    vBez := GetD010200_BEZ(vPers.nachname, vPers.vorname,
                           vPers.vorsatz_nachname, 
                           vPers.nachsatz_nachname,
                           vPers.titel );

    IF vD010200_ID IS NULL THEN -- HV nicht vorhanden -> anlegen  

      vD0102_ID := InsertD0102(/*pD0101_ID,*/ vPers);
      
      vD010200_ID := SYS_GUID();
      INSERT INTO vis_d010200
      (ID, D0102_ID, D0101_ID, MANDANT, INS_USER, INS_DATE, UPD_USER, UPD_DATE, DELETED, /*HAUPTANSPRECHPARTNER,*/ INHABER, BETRIEBSPERSONAL, BEZ)
      VALUES (vD010200_ID, vD0102_ID, pD0101_ID, vMandant_SID, vUSER_SID, vSYSDATE, vUser_SID, vSYSDATE, 0, /*1,*/ 0, 1,  
              vBez );
                              
      InsertD010202(-9999, pD0101_ID, vD010200_ID);    

    END IF;
    
    UPDATE VIS_D0101
    SET nname = vPers.nachname,
        vname = vPers.vorname,
        vorsatz_nname = vPers.vorsatz_nachname,
        nachsatz_nname = vPers.nachsatz_nachname,
        anrede = vPers.anrede,
        titel = vPers.titel,
        bez = NVL(bez, vBez ),
        upd_date = vSYSDATE,
        upd_user = vUser_SID,
        d010200_id2 = vD010200_id      
    WHERE id = pD0101_ID;
      
      
  END pers_aend_hv;
  
  -- nur Platzhalter
  PROCEDURE A_Start AS BEGIN NULL; END;

BEGIN
  
--  IF vGKZ2 = NRW THEN
--    vBI_IDV := IDV;
--  END IF;

  -- USER_SID aus EIN_D_USECASE bestimmen
  vUser_SID := -1;
  vMandant_SID := -1;
  FOR i IN bts1.usecases.FIRST .. bts1.usecases.LAST LOOP  
    IF bts1.usecases(i).usecase = pUsecase THEN
      vUser_SID := bts1.usecases(i).user_sid;
      vMandant_SID := bts1.usecases(i).mandant;
      vUsecase_ID := bts1.usecases(i).id;
      vUC_BTS_ID2 := bts1.usecases(i).d_bts_id2;
    END IF;
  END LOOP;

--DBMS_OUTPUT.PUT_LINE ( 'bts1.prot.quelle = ' || bts1.prot.quelle );   
  IF bts1.prot.quelle = QUELLE_XGEWERBE THEN
    vUser_Sid := BLV_SYS.GET_USER_SID;
    vMandant_SID := BLV_SYS.GET_MANDANT;	 
    bts1.prot.user_sid := vUser_SID;
    bts1.prot.mandant := vMandant_SID;
    
    UPDATE ein_d_protokoll
    SET user_sid = vUser_SID
      , mandant = vMandant_SID
    WHERE id = bts1.prot.id;
    
  END IF;
--DBMS_OUTPUT.PUT_LINE ( 'vUser_Sid = ' || vUser_Sid );
--DBMS_OUTPUT.PUT_LINE ( 'vMandant_SID = ' || vMandant_SID );

  vD0101_id := bts1.prot.d0101_id;
--DBMS_OUTPUT.PUT_LINE ( 'bts1.prot.d0101_id = ' || bts1.prot.d0101_id );
--DBMS_OUTPUT.PUT_LINE ( 'bts1.prot.status = ' || bts1.prot.status );

  CASE
  WHEN bts1.prot.status = 1 THEN -- Besttigung der nderung von iP nicht bei XGewerbe
    NULL;  
  WHEN bts1.prot.status = 0 THEN -- kommt nicht aus iP

    vD0101_id := bts1.prot.d0101_id;
    IF NOT IS_ID(vD0101_ID) 
    AND pUsecase NOT IN( 'ANL_MIN', 'ANMELD_BTR', 'ANMELD_BS') AND bts1.prot.quelle IN( QUELLE_XGEWERBE) /*vGKZ2 <> NRW*/ THEN
      
      -- Prfung auf nicht besttige Neuanlage 
      vD0101_ID := ExistAnmeld_BTR(bts1.reg);
      
      IF IS_ID(vD0101_id) THEN
      
        bts1.prot.d0101_id := vD0101_id;
        
        UPDATE ein_d_protokoll
        SET d0101_id = vD0101_ID
        WHERE id = bts1.prot.id;

        UPDATE ein_d_usecase  -- 11.01.2016
        SET d0101_id = vD0101_ID
        WHERE d_bts_id = bts1.prot.d_bts_id;

         
      ELSE
        RETURN;
      END IF;         
    END IF;  

    CASE
    WHEN pUsecase IN( 'ANL_MIN', 'ANMELD_BTR', 'ANMELD_BS') THEN
      IF bts1.prot.quelle = QUELLE_XGEWERBE THEN
        IF IS_ID(bts1.bts.ref_id) THEN -- Betrieb ist vorhanden
          -- Betriebsarten anlegen
          IF btyp_anl(pD0101_ID => bts1.bts.ref_id,
                      pUpdD0101_Bem => FALSE) = 0 THEN --; -- Betriebsarten
            NULL;
          --  AddMsg('Der Betrieb wird ohne Betriebsarten angelegt.');
          END IF;    
          -- Registrierungen anlegen
          reg_anl( pD0101_id => bts1.bts.ref_id
                  , pReg => bts1.reg
                  , pTyp => 1
                  , pArt => NULL 
                  , pFkt => 0
                  , pCheck => 4); -- Gltigkeit wird nichtn beachtet
        
          -- Fachbereiche anlegen
          IF ANL_FB(bts1.prot.d0101_id) = 0 THEN 
            NULL; 
          END IF;          
          

          -- Betreiber nicht vorhanden -> anlegen
          SELECT d0101_id3, ZB INTO vD0101_ID3, vZB
          FROM vis_d0101 
          WHERE id = bts1.bts.ref_id;
          
          IF NOT IS_ID(vD0101_ID3) THEN
            AnlageBetreiber(vD0101_ID3, vZb);
            AnlageBtr2Ordnung(vZb);
          ELSE
            -- Betreiber-Personal anlegen
            BetreiberPersonal( pChkPersonalDublette => TRUE);
            null;
          END IF;
          
        ELSE
          Anl_Min(vUsecase_id);
          UpdBTS_HV_FROM_BTR(bts1.prot.d0101_id);
        END IF;
        
        -- bei allen GEWERBE_BETRIEB_ID D0101_ID setzen
        IF bts1.prot.gewerbe_betrieb_id IS NOT NULL AND IS_ID(bts1.prot.d0101_id) THEN
          UpdD0101_id_by_GBI( 
            pD0101_ID => bts1.prot.d0101_id,
            pBTS_ID => bts1.prot.d_bts_id,
            pGBI_ID => bts1.prot.gewerbe_betrieb_id);
        END IF;                
        
        IF bts1.prot.korrektur_jn = 1 THEN -- Korrekturmeldung
          -- bei allen dazugehrigen Meldungen D0101_ID setzen
          DECLARE
          vKorr_Bts_ID tbID; 
          BEGIN
            UPDATE ein_d_protokoll
            SET d0101_id = bts1.prot.d0101_id
            WHERE d0101_id = '-1'
            AND source_id = bts1.prot.source_id
            RETURNING d_bts_id BULK COLLECT INTO vKorr_BTS_ID;
            
            IF vKorr_Bts_ID.COUNT > 0 THEN
            
              FORALL i IN vKorr_bts_id.FIRST .. vKorr_Bts_ID.LAST   
              UPDATE ein_d_usecase  
              SET d0101_id = bts1.prot.d0101_id
              WHERE d0101_id = '-1'
              AND d_bts_id = vKorr_bts_id(i).ID;
              
              FORALL i IN vKorr_bts_id.FIRST .. vKorr_Bts_ID.LAST   
              UPDATE ein_d_betriebsstaette  
              SET ref_id = bts1.prot.d0101_id
              WHERE ref_id IS NULL
              AND id = vKorr_bts_id(i).ID;
                          
            END IF;
          END;
        END IF;
      
      ELSE -- bts1.prot.quelle = QUELLE_XGEWERBE
        Anl_Min(vUsecase_id);
      END IF;
      
    --ELSIF pUsecase IN('STANDORT_AEND') THEN
    -- nderung wird nur ber eine EIN_D_BESTRIEBSSTAETTE geliefert
    
    -- ndern Name des betreibers
    WHEN pUsecase IN ('AEND_NAME_BETREI', 'AEND_NAME_BT') THEN
      Aend_Name_Betrei(vD0101_ID);

    -- Betreiberwechsel
    WHEN pUsecase IN ('AEND_BETREI', 'AEND_BT') THEN
      Aend_Betrei(vD0101_ID, vUC_BTS_ID2);
      
    WHEN pUsecase IN('STANDORT_KOR', 'AEND_STANDORT_BTR', 'AEND_STANDORT_BS') THEN
      Standort_kor(vD0101_id, bts1.adr_btro);
   
    WHEN pUsecase IN('BETR_POST_KOR', 'BETR_POST_ANL', 'BETR_POST_AEND') THEN
      BETR_POST_KOR(vD0101_ID, bts1.adr_btra, NULL);
    
    --WHEN pUsecase IN('BETR_POST_AEND') THEN
    -- nderung wird nur ber eine EIN_D_BESTRIEBSSTAETTE geliefert
        
    --WHEN pUsecase IN('BETR_POST_DEA') THEN
    --  BETR_POST_DEA(vD0101_ID);
          
    WHEN pUsecase IN('KOM_ANL', 'KOM_KOR', 'ANLEG_KOM_BTR', 'AEND_KOM_BTR', 'AEND_KOM_BS') THEN  -- Kommunikationsmittel der Betriebssttte        
      bts_kom(vD0101_id, 0, 0);
      
    WHEN pUsecase IN('KOM_DEA') THEN  -- Kommunikationsmittel der Betriebssttte
      bts_kom(vD0101_id, 1, 0);

    WHEN pUsecase IN('PERS_ANL') THEN -- Neuanlage des Hauptverantwortlicher Betriebssttte
      pers_anl_hv(vD0101_id, bts1.fkt_hv.pers, 0, 0);
        
    WHEN pUsecase IN('PERS_DEA') THEN -- Abmelden des Hauptverantwortlicher Betriebssttte
      pers_dea(vD0101_id);
      
    --WHEN pUsecase IN('PERS_KOR' ) THEN
    --  NULL;

    WHEN pUsecase IN('PERS_AEND') THEN -- neuer Betreiber zuordnen bzw. neuen Betreiber anlegen

     -- nderung wird nur ber eine EIN_D_BESTRIEBSSTAETTE geliefert
      -- 27.01.2015
      IF bts1.btr_pers(1).betreiber.pers.id <> '-1' THEN -- Betreiberwechsel
        pers_aend(vD0101_id);
      END IF;

      IF bts1.fkt_hv.pers.id <> '-1' AND bts1.fkt_hv.pers.pers_id <> '0' THEN -- Hauptverantwortlicherwechsel
        pers_aend_hv( vD0101_id);
      END IF;  
    
    WHEN pUsecase IN('PERS_ADR_KOR', 'AEND_POST_ADR_BETREI', 'AEND_POST_ADR_BT') THEN  -- Postanschrift des Betreibers ndern
      pers_adr_kor(vD0101_id, 'KOR');

    WHEN pUsecase IN('PERS_ADR_AEND') THEN
    -- nderung wird nur ber eine EIN_D_BESTRIEBSSTAETTE geliefert
      pers_adr_kor(vD0101_id, 'AEND');
    
    -- Kommunikationsmittel des Inhabers
    WHEN pUsecase IN('PERS_KOM_ANL', 'ANLEG_KOM_BETREI') THEN -- Kommunikationsmittel des Inhabers Anlegen
      bts_kom(vD0101_id, 0, 1);
          
    WHEN pUsecase IN('PERS_KOM_KOR', 'AEND_KOM_BETREI', 'AEND_KOM_BT') THEN -- Kommunikationsmittel des Inhabers ndern
      bts_kom(vD0101_id, 0, 1);

    WHEN pUsecase IN('PERS_KOM_DEA') THEN -- Kommunikationsmittel des Inhabers Lschen
      bts_kom(vD0101_id, 1, 1);    
    
    WHEN pUsecase IN('BTYP_ANL', 'ANMELD_BA') THEN -- Betriebsart anlegen
      IF BTYP_ANL(vD0101_id, FALSE) = 0 THEN NULL; END IF;
      
    --ELSIF pUsecase IN('BTYP_DEA', 'ABMELD_BA') THEN -- Betriebsart abmelden, wird in blvbtr.dll verarbeitet
    --  NULL;
    
    WHEN pUsecase IN('BALVI_KOR') THEN --Kennzeichen Nr.
      BALVI_KOR(vD0101_id);
    
    WHEN pUsecase IN('BTRB_ANL') THEN -- Anlage Abteilung
      BTRB_ANL(vD0101_id);
        
    WHEN pUsecase IN('BTRB_DEA') THEN -- Abteilung abmelden
      BTRB_DEA(vD0101_id);

    WHEN pUsecase IN('BTRB_KOR') THEN -- Abteilung korrigieren
      BTRB_Kor(vD0101_ID);
    
    WHEN pUsecase IN('BTRB_STANDORT_KOR') THEN -- Abteilung Standortadresse
      BTRB_Standort_Kor(vD0101_ID);

    --WHEN pUsecase IN('BTRB_STANDORT_AEND') THEN -- Abteilung Standortadresse
    -- nderung wird nur ber eine EIN_D_BESTRIEBSSTAETTE geliefert
    
    --WHEN pUsecase IN('BTRB_BTYP_ANL', 'BTRB_BTYP_DEA') THEN -- Zuordnung BA-Abteilung
    --  NULL;

    WHEN pUsecase IN('REG_ANL', 'ZREG_ANL') THEN -- Registrierungen anlegen
      reg_anl(vD0101_id, 1, NULL, 0, 1);

    WHEN pUsecase IN('ZREG_DEA') THEN -- Registrierungen abmelden
      IF reg_dea(vD0101_id, 1) > 0 THEN NULL; END IF;
    
    WHEN pUsecase IN('ZREG_KOR') THEN -- Registrierungen korrigieren
      IF reg_kor(vD0101_id, 1) > 0 THEN NULL; END IF;

    --WHEN pUsecase IN('ABMELD_BTR') THEN -- 27.04.2012 Tierhaltung abmelden in blvBTR.dll umgesetzt
    --  AbmeldungD0101(vD0101_ID, bts1.bts.gueltig_bis);
 
    -- 23.01.2013
    WHEN pUsecase IN('STORNO_BTR', 'STORNO_ABMELD_BS') THEN -- Stornierung der Abmeldung
             -- pD0101, pD010104, pD010101, pD010102, pIsStorno, pCanAusgangskorb      
     Storno_Btr(True,   True,     True,     True,     1,         FALSE );

    WHEN pUsecase IN('WIEDER_ANMELD_BTR', 'WIEDER_ANMELD_BS') THEN -- Wieder Anmeldung
             -- pD0101, pD010104, pD010101, pD010102, pIsStorno, pCanAusgangskorb      
     Storno_Btr(True,   True,     False,    True,     0,         FALSE );
    
    WHEN pUsecase IN( 'AEND_BEZ_BTR', 'AEND_BEZ_BS') THEN -- Zusatzbez. der Betriebssttte gendert
      UPDATE vis_d0101
      SET name1 = bts1.bts.zusatzbez
        -- bei nicht abweichender Postanschrift diese auch aktualisieren
        , p_name1 = CASE WHEN abw_post = 0 THEN bts1.bts.zusatzbez ELSE p_name1 END
        , upd_date = vSYSDATE
        , upd_user = vUser_SID 
      WHERE id = vD0101_ID;

    ELSE
    
      AddErrMsg('Usecase "' || pUsecase || '" wird nicht untersttzt.');

    END CASE;

  
  WHEN bts1.prot.status = 20 and pUsecase = 'DUBLETTE' THEN -- Dublette anlegen
    Anl_Min(vUsecase_ID);
    -- offene ANL_MIN / ANMELD_BTR und itere Usecase erledigen weil Betriebs bereits ber Dublette angelegt wurde
    --06.06.2016 Absprache DD, kommt nicht mehr zur Anwendung  ConfirmANMELD_BTR_AND_OLD;

  ELSE
  
    AddErrMsg('EIN_D_PROTOKOLL.STATUS = ' || bts1.prot.status ||  ' Usecase ' || pUsecase || ' wird nicht untersttzt.');
  
  END CASE;
  
END;

PROCEDURE MandantZbByGKZ8(pGKZ8 IN VARCHAR2, vSID OUT NUMBER, vZB OUT NOCOPY VARCHAR2) DETERMINISTIC AS
BEGIN 
  vZB := NULL;
  
  vZB := GetZBbyGKZ8( SUBSTR(pGKZ8, 1, 8) ); -- 13.09.2013
  
  IF vZB IS NOT NULL THEN
  
    -- 07.05.2012: Fehlerbehandlung wenn kein Mandant gefunden wird
    BEGIN
    
      SELECT s50_sid INTO vSID
      FROM 
      (
          SELECT SID  AS S50_SID,
            CODE  AS S50_CODE,
            ZB, -- AS GKZ,
            ANZAHL, 
            --DENSE_RANK() OVER (PARTITION BY ZB ORDER BY ANZAHL, CODE) RANK
            ROW_NUMBER() OVER (PARTITION BY ZB ORDER BY ANZAHL, CODE) RANK
          FROM
          (
            SELECT 
              S50.SID,
              S50.CODE, 
              A25.ZB,
              A25.CODE a25_code,
              COUNT(A25.ZB) OVER(PARTITION BY S50.CODE) ANZAHL
            FROM VIS_S50 S50
              JOIN VIS_S5002 S5002 ON S5002.S50_SID = S50.SID
              JOIN GLO_A25 A25_Z ON A25_Z.SID = S5002.GLO_A25_SID
                AND a25_z.deleted = 0  
              JOIN GLO_A25 A25 ON A25.ZB LIKE a25_z.zb || '%'
                AND a25.deleted = 0 AND a25.kat <= 5
            WHERE
                  S5002.AL > 2
              -- Hat der Mandant entsprechende Fachbereiche
              --AND EXISTS ( 
              AND s50.sid IN ( 
                 SELECT S5004.S50_SID              
                 FROM VIS_S5004 S5004 
                 JOIN VIS_A0101 A0101_06 ON A0101_06.SID = S5004.A0101_06_SID AND A0101_06.SKZ = 6 
                  --   WHERE A0101_06.CODE IN ( 'D', 'H' ) -- todo DD TSCH, TAM, FM, FLHY, TS, LM
                    --   2628001 M  DM
                    --   81      F  FlHY
                    --   79      U  FM
                    --   1866001 G  GK
                    --   264001  A  HKL
                    --   69001   K  KF
                    --   236001  L  LegReg
                    --   80      H  LM
                    --   605001  Q  QM
                    --   166001  R  RE
                    --   78      T  TAM
                    --   1207001 N  TNP
                    --   76      D  TS
                    --   77      P  TSCH
                    --   24001   W  WEIN

                  WHERE --s5004.a0101_06_sid IN( 76, 77, 78, 79, 80, 81 )  
                    a0101_06.code IN ( 'D', 'P', 'T', 'U', 'H', 'F')
                    AND S5004.AL > 2
                    AND S5004.DELETED > -2
                    AND A0101_06.DELETED > -2
                    --AND S5004.S50_SID = S50.SID
              )
              AND S50.SKZ = 1
              AND S50.Deleted = 0
              AND S5002.Deleted = 0
            ORDER BY A25.ZB, ANZAHL               
          )
          WHERE zb = vZb 
          ORDER BY ZB, RANK
        ) WHERE ROWNUM = 1;

      EXCEPTION 
      WHEN no_data_found THEN
        AddErrMsg('Es ist kein Mandant mit Berechtigungen auf den ZB ' || vZB || ' vorhanden.');
        vSID := -2;

    END;
    
  END IF;
  
  --RETURN vSID;

END MandantZbByGKZ8; --  GetMandantByZB

FUNCTION GetMandantByGKZ8(pGKZ8 IN VARCHAR2) RETURN NUMBER DETERMINISTIC AS
vMandantSID NUMBER(10);
vZB VARCHAR2(5);
BEGIN
  MandantZbByGKZ8(pGKZ8, vMandantSID, vZB);
  RETURN vMandantSID;
END GetMandantByGKZ8;

PROCEDURE AbmeldenHitNr AS
  vHitNr ein_d_registrierung.nummer%TYPE := NULL;
  vSysdate CONSTANT DATE := SYSDATE;
  vD010102_ID tbID;
  vBis DATE;
BEGIN
    
  IF BTS1.reg.COUNT > 0 THEN 
    FOR i IN BTS1.reg.FIRST .. BTS1.reg.LAST LOOP
      IF BTS1.reg(i).art = BI THEN 
        vHitNr := BTS1.reg(i).nummer;
        vBis := BTS1.reg(i).gueltig_bis;
        EXIT;
      END IF; 
    END LOOP;

    -- Hit-Nr. aus EK mit Status ruht und Historie anlegen
    UPDATE vis_d010102 d010102
    SET a0302_05_sid = A0302_05_RUHT
      , upd_date = vSysdate
      , upd_user = vUser_sid
      , gueltig_bis = vBis
      , gueltig_von_stat = vBis
    WHERE d0101_id = bts1.prot.d0101_id
    AND a010145_sid = A010145_HIT_NR
    AND deleted = 0
    AND nummer = vHitNr
    RETURNING ID BULK COLLECT INTO vD010102_ID;
    
    IF SQL%ROWCOUNT > 0 THEN
      InsertD0300(vD010102_ID);
    END IF;
  END IF;
  
  IF vHitNr IS NULL THEN
    AddErrMsg('Im Eingangskorb fehlt die BI-Nummer.'); 
  END IF;
  
END AbmeldenHitNr;

FUNCTION AddProtParam(pParams IN VARCHAR2, pParam IN VARCHAR2, pValue IN VARCHAR2) RETURN VARCHAR2 AS
vRes VARCHAR2(4000);
BEGIN

  CASE
  WHEN pParams NOT LIKE '%' || pParam || '=%' THEN
    vRes := pParams || pParam || '=' || pValue || ';';   
  WHEN pParams LIKE '%' || pParam || '=;%' THEN 
    vRes := REPLACE(pParam || '=;', pParam || '=' || pValue || ';');     
  WHEN pParams LIKE '%'|| pParam || '%;' THEN
    vRes := REGEXP_REPLACE(pParams, '(' || pParam || '=)[[:alnum:]]{1,};', '\1' || pValue || ';' ); 
  ELSE
    vRes := pParams || pParam || '=' || pValue || ';';
  END CASE;
  
  RETURN vRes;
  
END AddProtParam;

-- wahrscheinlich nicht verwendet
--PROCEDURE DublettenBtr_( pBTS_ID IN tID := NULL) AS
--vDubletten blv_dubletten.tbDubletten;
--vDubBTR PLS_INTEGER := 0; 
--vDubBTS PLS_INTEGER := 0; 
--v1 VARCHAR2(1);
--BEGIN
--
--  DELETE ein_d_usecase 
--  WHERE d_bts_id = pBTS_ID
--  AND usecase IN( DUBL_BTR, DUBL_BTS )
--  AND deleted = -1;
--
--  IF IS_ID(pBTS_ID) AND Compare(pBTS_ID, bts1.bts.id) = 0 THEN
--    FOR c1 IN (
--      SELECT uc.usecase, uc.d_bts_id, uc.d0101_id
--      FROM ein_d_usecase uc
--      WHERE uc.deleted = 0
--      --AND uc.datenherkunft = QUELLE_XGEWERBE
--      AND uc.usecase NOT IN( DUBL_BTR, DUBL_BTS ) -- NOT LIKE 'DUBLETTE%'
--      AND uc.d_bts_id = pBTS_ID
--      --AND ROWNUM = 1
--    ) LOOP    
--      IF c1.d0101_ID = '-1' THEN
--        v1 := '1';
--        IF FILL_BTS1(c1.d_bts_id, c1.usecase) IS NULL THEN NULL; END IF;
--      ELSE
--        v1 := '0';        
--      END IF;
--      EXIT;      
--    END LOOP;
--        
--  END IF; 
--
--  IF NOT IS_ID( bts1.bts.id ) OR v1 = '0' THEN
--    RETURN;
--  END IF;  
--
--
----DBMS_OUTPUT.PUT_LINE('delete DUBLETTE_BTR/BTS in ein_d_usecase:'||sql%rowcount);
--      
--  IF bts1.btr_pers IS NOT NULL AND bts1.btr_pers.COUNT > 0 THEN
--
--    SELECT dx.*
--    BULK COLLECT INTO vDubletten
--    FROM TABLE (
--      BLV_DUBLETTEN.GET( pBezeichnung => bts1.btr_pers(1).betreiber.pers.bezeichnung, 
--                         pNACHNAME => bts1.btr_pers(1).betreiber.pers.nachname,
--                         pVORNAME => bts1.btr_pers(1).betreiber.pers.vorname,
--                         pSTRASSE => bts1.btr_pers(1).betreiber.adr.padr.strasse, 
--                         pHAUSNR => bts1.btr_pers(1).betreiber.adr.padr.hausnr,
--                         pPLZ => bts1.btr_pers(1).betreiber.adr.padr.plz, 
--                         pORT => bts1.btr_pers(1).betreiber.adr.padr.ort, 
--                         pISFIRMA => CASE WHEN bts1.btr_pers(1).betreiber.pers.typ = 'JP' THEN 1 ELSE 0 END, 
--                         pZBFILTERBYMANDANT => 0) ) dx  -- 0 nur Betreiber
--    WHERE ( 
--      EXISTS ( -- echter Betreiber mit Betriebssttten 
--      SELECT 1 FROM vis_d0101 d1 
--      WHERE d1.d0101_id3 = dx.d0101_id
--        AND d1.d0101_id3 <> d1.id  -- nicht Betriebssttten ohne abweichenden Betreiber verwenden 
--        AND d1.deleted = 0 
--        AND d1.skz = 1 ) OR
--      NOT EXISTS ( -- ist nicht Betreiber 2. Ordnung
--        SELECT 1 FROM vis_d0101 d1 
--        WHERE d1.d0101_id3 = dx.d0101_id 
--        AND d1.deleted = 0 
--        AND d1.id <> d1.d0101_id3 AND d1.skz = 99 ) )
--     --AND ROWNUM < 100  
--     ;
--                       
----DBMS_OUTPUT.PUT_LINE('Anzahl Betreiber-Dubletten:'||vDubletten.COUNT);
--    vDubBTR := vDubletten.count;
--    IF vDubletten.COUNT > 0 THEN
--      
--      FORALL i IN vDubletten.FIRST .. vDubletten.Last 
--        INSERT INTO ein_d_usecase ( id, d0101_id, d_bts_id, 
--          usecase, datenherkunft, deleted, mandant,
--          aend_art, aend_grund, lastmodified )
--        VALUES ( RAWTOHEX(SYS_GUID()), vDubletten(i).d0101_id, bts1.bts.id, 
--          DUBL_BTR, XGEWERBE_DUBL, -1, -1,  
--          '0', '0', SYSDATE);    
--      
----DBMS_OUTPUT.PUT_LINE('insert DUBLETTE_BTR in ein_d_usecase:'||sql%rowcount);
--    END IF;
--    
--    -- Betriebssttten ohne Betreiber als Dubletten
--    SELECT dx.*
--    BULK COLLECT INTO vDubletten 
--    FROM TABLE (
--      BLV_DUBLETTEN.GET( pBezeichnung => bts1.btr_pers(1).betreiber.pers.bezeichnung, 
--                         pNACHNAME => bts1.btr_pers(1).betreiber.pers.nachname,
--                         pVORNAME => bts1.btr_pers(1).betreiber.pers.vorname,
--                         pSTRASSE => bts1.btr_pers(1).betreiber.adr.padr.strasse, 
--                         pHAUSNR => bts1.btr_pers(1).betreiber.adr.padr.hausnr,
--                         pPLZ => bts1.btr_pers(1).betreiber.adr.padr.plz, 
--                         pORT => bts1.btr_pers(1).betreiber.adr.padr.ort, 
--                         pISFIRMA => CASE WHEN bts1.btr_pers(1).betreiber.pers.typ = 'JP' THEN 1 ELSE 0 END, 
--                         pZBFILTERBYMANDANT => 2) ) dx  -- 2 kein ZB-Filter 
--    WHERE 
--      EXISTS ( -- Betriebssttten ohne Betreiber 
--      SELECT 1 FROM vis_d0101 d1 
--      WHERE d1.id = dx.d0101_id 
--        AND d1.deleted = 0 
--        AND d1.skz = 1
--        AND d1.d0101_id3 = '-1'
--        AND d1.zb = bts1.bts.zb ) 
--      --AND ROWNUM < 100
--      ;
--                       
----DBMS_OUTPUT.PUT_LINE('Anzahl Betriebssttten-Dubletten:'||vDubletten.COUNT);
--    vDubBts := vDubletten.COUNT;
--    IF vDubletten.COUNT > 0 THEN
--      
--      FORALL i IN vDubletten.FIRST .. vDubletten.Last 
--        INSERT INTO ein_d_usecase ( id, d0101_id, d_bts_id, 
--          usecase, datenherkunft, deleted, mandant,
--          aend_art, aend_grund, lastmodified )
--        VALUES ( RAWTOHEX(SYS_GUID()), vDubletten(i).d0101_id, bts1.bts.id, 
--          DUBL_BTS, XGEWERBE_DUBL, -1, -1,  
--          '0', '0', SYSDATE);    
--
----DBMS_OUTPUT.PUT_LINE('insert DUBLETTE_BTS in ein_d_usecase:'||sql%rowcount);
--      
--    END IF;
--
--    IF vDubBTR > 0 OR vDubBts > 0 THEN 
--      v1 := '1';
--    ELSE
--      v1 := '0'; 
--    END IF;
--    UPDATE ein_d_protokoll
--    SET parameter = AddProtParam(parameter, PARAM_XGEWERBE_DUBL, v1) 
--    WHERE d_bts_id = bts1.bts.id;    
--       
--  END IF;        
--END DublettenBtr_;


PROCEDURE DublettenBtr( pBTS_IDs IN tb_bez) AS
vSysdate CONSTANT DATE := SYSDATE;
BEGIN

  -- alle vorhandenen Dubletten lschen
  DELETE ein_d_usecase 
  WHERE d_bts_id IN ( SELECT dx.bez FROM TABLE( pBTS_IDs ) dx )
  AND usecase IN( DUBL_BTR, DUBL_BTS)
  AND deleted = -1;

  -- alle Parameter fr Dubletten zurcksetzen
  UPDATE ein_d_protokoll
  SET parameter = AddProtParam(
                  AddProtParam( parameter, 
                    PARAM_XGEWERBE_DUBL, '0'),
                    PARAM_XGEWERBE_DUBL_ANZ,'0') 
  WHERE d_bts_id IN ( SELECT dx.bez FROM TABLE( pBTS_IDs ) dx );

  FOR c1 IN cDubletten(pBTS_IDs) LOOP -- nur fr prt.d0101_id = '-1'

    INSERT INTO ein_d_usecase ( id, d0101_id, d_bts_id, 
      usecase, datenherkunft, deleted, mandant,
      aend_art, aend_grund, lastmodified )
    VALUES ( RAWTOHEX(SYS_GUID()), c1.d0101_id, c1.d_bts_id, 
      c1.usecase, XGEWERBE_DUBL, -1, -1,  
      '0', '0', vSYSDATE);    

    --UPDATE ein_d_protokoll
    --SET parameter = AddProtParam(parameter, PARAM_XGEWERBE_DUBL, '1') 
    --WHERE d_bts_id = c1.d_bts_id;
        
  END LOOP;
  
  FOR c1 IN (
    SELECT prt.rowid prt_rowid
    , ( 
      SELECT COUNT(*) 
      FROM ein_d_usecase uc 
      WHERE uc.d_bts_id = prt.d_bts_id
      AND uc.deleted = -1
      AND uc.usecase IN ( DUBL_BTR, DUBL_BTS)
      ) dubl_anz       
    FROM ein_d_protokoll prt
    WHERE prt.d_bts_id IN ( SELECT dx.bez FROM TABLE( pBTS_IDs ) dx )
  ) LOOP
  
  
    UPDATE ein_d_protokoll prt
    SET parameter = AddProtParam(
                    AddProtParam(parameter, 
                      PARAM_XGEWERBE_DUBL, CASE WHEN c1.dubl_anz > 1 THEN '1' ELSE '0' END),
                      PARAM_XGEWERBE_DUBL_ANZ, TO_CHAR(c1.dubl_anz) ) 
    WHERE prt.rowid = c1.prt_rowid;
  END LOOP;  
          
END DublettenBtr;

FUNCTION GetDubletten( pBTS_IDs IN tb_bez) RETURN tbDubletten PIPELINED IS
BEGIN
  
  FOR c1 IN cDubletten(pBTS_IDs) LOOP
    PIPE ROW (c1);
  END LOOP;
  RETURN;
  
END GetDubletten;

PROCEDURE NormierungAdressen(pBTS_IDs IN tb_bez) AS
BEGIN

  CopyAdrToOrg(pBTS_IDs);

  -- Ortsteil aus Ort elemenieren und in Feld ORTSTEIL speichern
  -- Zusatz aus Hausnr elementieren und in Feld HAUSNRZUSATZ speichern  
  FOR c1 IN (
    
    SELECT d2.* FROM (

      SELECT d1.* 

      , CASE WHEN d1.pos_ot > 0 
        THEN TRIM(BOTH FROM SUBSTR( d1.ort, d1.Pos_ot + 4))
        ELSE ortsteil END ortsteil_neu
        
      , CASE WHEN d1.pos_ot > 0 
        THEN TRIM(BOTH FROM SUBSTR( d1.ort, 1, d1.Pos_ot - 1 ))
        ELSE ort END ort_neu

      , CASE WHEN hausnr <> d1.hausnr2 
        THEN d1.hausnr2
        ELSE hausnr END hausnr_neu
        
--      , CASE WHEN hausnr <> d1.hausnr2
--        THEN NVL( TRIM(SUBSTR(hausnr, LENGTH(d1.hausnr2) + 1)), hausnrzusatz ) 
--        ELSE hausnrzusatz END hausnrzusatz_neu
      -- todo 70677090: Erweiterung beim Trennen Hausnr. und Zusatz          

--      , CASE WHEN hausnr <> d1.hausnr2
--        THEN SUBSTR(hausnr, LENGTH(d1.hausnr2) + 1) || 
--            CASE WHEN hausnrzusatz IS NOT NULL AND hausnr NOT LIKE '%-%' AND hausnrzusatz NOT LIKE '-%' THEN '-' END || hausnrzusatz 
--        WHEN hausnrzusatz NOT LIKE '%-%' THEN  '-' ||hausnrzusatz
--        ELSE hausnrzusatz 
--        END hausnrzusatz_neu
      -- todo 70677090 10.04.2019
      , TRIM( BOTH FROM CASE 
        WHEN hausnr <> d1.hausnr2
            THEN SUBSTR(hausnr, LENGTH(d1.hausnr2) + 1) || 
                CASE 
                WHEN d1.hausnr like '%und' or d1.hausnr like '%u.' then ' '||trim(hausnrzusatz) 
                when d1.zusatz_is_alnum = 0 then ' '||hausnrzusatz
                when d1.zusatz_is_alnum = 1 then '-'||hausnrzusatz 
                else hausnrzusatz
                end
                
        WHEN isnumeric_hausnr = 1 and regexp_like(d1.hausnrzusatz, '[a-zA-Z]')  and zusatz_is_digit = 0 THEN hausnrzusatz
        WHEN zusatz_is_alnum = 1 THEN  '-' || hausnrzusatz
        ELSE hausnrzusatz 
        END ) hausnrzusatz_neu
        
      FROM (
        -- Adressen ber FUNKTION
        SELECT padr.hausnr, padr.hausnrzusatz 
        --, REGEXP_SUBSTR(padr.hausnr,'^[[:digit:]]*') hausnr2
        -- todo 70677090 10.04.2019
        , nvl( regexp_substr(padr.hausnr,'^[[:digit:]]*'), padr.hausnr) hausnr2
        , case when padr.hausnrzusatz is null or regexp_like(padr.hausnrzusatz, '[^([:alnum:][:space:])]') then 0 else 1 end zusatz_is_alnum 
        , case when regexp_like(padr.hausnrzusatz, '[[:digit:]]') then 1 else 0 end zusatz_is_digit
        , isnumeric(padr.hausnr) isnumeric_hausnr
        
        ,padr.ort, padr.ortsteil, padr.id padr_id
        --, fkt.d_bts_id
        , INSTR( UPPER(padr.ort), ' OT ') pos_ot
        FROM ein_d_funktion fkt 
        join ein_r_fkt_adr r1 on r1.d_fkt_id = fkt.id
        AND r1.typ = PostAdr -- 'Postadresse'
        join ein_d_adresse adr on adr.id = r1.d_adr_id
        join ein_d_postadresse padr on padr.id = adr.d_padr_id
        AND (padr.hausnr IS NOT NULL OR padr.ort IS NOT NULL)
        JOIN ein_d_protokoll prt on prt.d_bts_id = fkt.d_bts_id
        --AND prt.d0101_id = '-1'
        
        WHERE fkt.d_bts_id IN ( SELECT dx.bez FROM TABLE ( pBTS_IDs ) dx )
        
        UNION
        -- Adresse Betriebssttte
        SELECT padr.hausnr, padr.hausnrzusatz 
        --, regexp_substr(padr.hausnr,'^[[:digit:]]*') hausnr2
        -- todo 70677090 10.04.2019
        , nvl( regexp_substr(padr.hausnr,'^[[:digit:]]*'), padr.hausnr) hausnr2
        , case when padr.hausnrzusatz is null or regexp_like(padr.hausnrzusatz, '[^([:alnum:][:space:])]') then 0 else 1 end zusatz_is_alnum 
        , case when regexp_like(padr.hausnrzusatz, '[[:digit:]]') then 1 else 0 end zusatz_is_digit
        , isnumeric(padr.hausnr) isnumeric_hausnr

        , padr.ort, padr.ortsteil, padr.id padr_id
        , INSTR( UPPER(padr.ort), ' OT ') pos_ot
        --, r1.d_bts_id,
        FROM ein_r_bts_adr r1
        join ein_d_adresse adr on adr.id = r1.d_adr_id
        join ein_d_postadresse padr on padr.id = adr.d_padr_id
          AND r1.typ IN( PostAdr, StandortAdr)  -- ('Postadresse','Standortadresse')
        AND (padr.hausnr IS NOT NULL OR padr.ort IS NOT NULL)
        JOIN ein_d_protokoll prt on prt.d_bts_id = r1.d_bts_id
        --AND prt.d0101_id = '-1'
        WHERE r1.d_bts_id IN ( SELECT dx.bez FROM TABLE ( pBTS_IDs ) dx )
      ) d1   
    ) d2 WHERE d2.pos_ot > 0 OR d2.hausnr <> d2.hausnr_neu OR d2.hausnrzusatz <> d2.hausnrzusatz_neu
  ) LOOP   

    UPDATE ein_d_postadresse
    SET ortsteil = c1.ortsteil_neu
      , ort = c1.ort_neu 
      --, hausnr = CASE WHEN hausnrzusatz IS NOT NULL THEN hausnr ELSE c1.hausnr_neu END
      --, hausnrzusatz = CASE WHEN hausnrzusatz IS NOT NULL THEN hausnrzusatz ELSE c1.hausnrzusatz_neu END         
      , hausnr = c1.hausnr_neu
      , hausnrzusatz = c1.hausnrzusatz_neu         
    WHERE id = c1.padr_id;      
    
  END LOOP;

  FOR c1 IN cAdrNorm ( pBTS_IDs ) LOOP   

    UPDATE ein_d_kataster
    SET rechtswert = c1.A2701_rechtswert
      , hochwert = c1.A2701_hochwert
      , x_wert = c1.A2701_x_wert
      , y_wert = c1.A2701_y_wert
      , gis_quelle = 'HK'
    WHERE id = c1.d_kat_id
    AND c1.a2701_rechtswert <> 0 AND c1.a2701_hochwert <> 0; 
   
    INSERT INTO ein_d_kataster ( id, rechtswert, hochwert, x_wert, y_wert, gis_quelle )
    SELECT 
     c1.d_kat_id_neu, c1.A2701_rechtswert, c1.A2701_hochwert, c1.A2701_x_wert, c1.A2701_y_wert, 'HK'
    FROM dual
    WHERE c1.d_kat_id IS NULL AND c1.d_kat_id_neu IS NOT NULL
    AND c1.a2701_rechtswert <> 0 AND c1.a2701_hochwert <> 0;   
  
    UPDATE ein_d_verwaltung
    SET gkz = c1.a27_gkz
    WHERE id = c1.d_verw_id 
    AND gkz IS NULL 
    AND c1.a27_gkz IS NOT NULL;

    INSERT INTO ein_d_verwaltung ( id, gkz )
    SELECT 
     c1.d_verw_id_neu, c1.a27_gkz
    FROM dual
    WHERE c1.d_verw_id IS NULL AND c1.d_verw_id_neu IS NOT NULL
    AND c1.a27_gkz IS NOT NULL;     

    UPDATE ein_d_postadresse
    SET plz = c1.A27_plz
      , ort = c1.A27_ort
      , ortsteil = c1.A27_ortsteil
      , strasse = c1.A27_strasse
      , hausnrZusatz = CASE WHEN hausnrZusatz IS NOT NULL THEN hausnrZusatz ELSE NVL(c1.A2701_hausnr_zusatz, hausnrZusatz) END
    WHERE id = c1.d_padr_id
      AND c1.a27_id <> '-1' 
      AND (
        plz <> c1.A27_plz OR
        ort <> c1.A27_ort OR
        ortsteil || TAB <> c1.A27_ortsteil || TAB OR
        strasse <> c1.A27_strasse OR
        hausnrZusatz||TAB <> c1.A2701_hausnr_zusatz||TAB );

    UPDATE ein_d_adresse
    SET d_kat_id = NVL(d_kat_id, c1.d_kat_id_neu)
      , d_verw_id = NVL(d_verw_id, c1.d_verw_id_neu)
    WHERE id = c1.d_adr_id;
   
    UPDATE ein_d_usecase
    SET error_message = CASE WHEN error_message IS NOT NULL AND c1.err_msg IS NOT NULL THEN error_message || CRLF END || c1.err_msg
    WHERE d_bts_id = c1.d_bts_id
    AND usecase NOT IN (DUBL_BTR, DUBL_BTS)
    AND deleted = 0
    AND c1.a27_id IS NULL;
    
  END LOOP;

END NormierungAdressen;

FUNCTION GetAdrNorm( pBTS_IDs IN tb_bez) RETURN tbAdrNorm PIPELINED IS
BEGIN
  FOR c1 IN cAdrNorm( pBTS_IDs ) LOOP
    PIPE ROW (c1);
  END LOOP;
  RETURN;
END;

PROCEDURE BA_Standardwerte_XGewerbe(pBTS_IDs IN tb_bez) AS
vFBs VARCHAR2(100);
BEGIN

  UPDATE (
  SELECT ba.art, ba.fachbereich, code
  , CASE 
    WHEN REGEXP_LIKE(BA.fachbereich, '[HF%]', 'i') THEN '9999999'
    WHEN REGEXP_LIKE(BA.fachbereich, '[AUN]', 'i') THEN '0699'
    WHEN REGEXP_LIKE(BA.fachbereich, '[PDT]', 'i') THEN '0399'
    ELSE NULL
    END code_neu  
  FROM ein_d_betriebsart ba
  WHERE BA.D_BTS_ID IN ( SELECT dx.bez FROM TABLE( pBTS_IDs) dx )
  AND ba.art =  'WZG012008' 
  )
  SET art = 'BALVI'
    --, scope = NVL(scope, code)
    , code = code_neu
    , fachbereich = 
      CASE WHEN fachbereich = '%' THEN 
      ( SELECT MAX(a010108.fb) FROM vis_a010108 a010108 WHERE a010108.skz IN (1,2,3,5) AND a010108.deleted = 0 AND a010108.code = code_neu ) 
      ELSE fachbereich END
  WHERE code_neu IS NOT NULL;
  
  -- todo 62823090
  UPDATE (
    SELECT ba.*
    FROM ein_d_betriebsart ba
    WHERE BA.D_BTS_ID IN ( SELECT dx.bez FROM TABLE( pBTS_IDs) dx )
    AND ba.gueltig_von IS NOT NULL
    AND ba.bez NOT LIKE '% (NEU)' 
    AND EXISTS( 
      SELECT 1
      FROM ein_d_usecase uc
      WHERE uc.d_bts_id = ba.d_bts_id
      AND uc.usecase NOT LIKE 'DUBLETTE%'
      AND uc.aend_grund LIKE '02%' -- Ummeldung
    )
  ) SET bez = SUBSTR(bez,1, 1994) || ' (NEU)'
      , lbez = lbez || ' (NEU)';

  -- wenn gueltig_von nicht gesetzt dann von Betriebssttte vorbelegen
  UPDATE(
    SELECT bts.gueltig_von bts_gueltig_von, ba.*
    FROM ein_d_betriebsart ba
    JOIN ein_d_betriebsstaette bts on bts.id = ba.d_bts_id
    WHERE BA.D_BTS_ID IN ( SELECT dx.bez FROM TABLE( pBTS_IDs) dx )
    AND ba.gueltig_von IS NULL
  ) SET gueltig_von = bts_gueltig_von;    
  
END BA_Standardwerte_XGewerbe;


--PROCEDURE Betreiberbezeichnung( p1 IN OUT NOCOPY tFKT) AS
--vBez ein_d_person.bezeichnung%TYPE;
--BEGIN
--  IF p1.pers.typ = 'NP' THEN
--    vBez := CreateD0101Bez( 
--                pNName => p1.pers.nachname, 
--                pVName => p1.pers.vorname,
--                pVorsatz => p1.pers.vorsatz_nachname, 
--                pNachsatz => p1.pers.nachsatz_nachname, 
--                pTitel => p1.pers.titel);
--    
--    IF vBez IS NOT NULL AND ( p1.pers.bezeichnung IS NULL OR p1.pers.bezeichnung <> vBez) THEN
--      p1.pers.bezeichnung := vBez;
--      UPDATE ein_d_person
--      SET bezeichnung = vBez
--      WHERE id = p1.pers.id;     
--    END IF;
--    
--  END IF;
--END Betreiberbezeichnung;

--PROCEDURE Betreiberbezeichnungen AS
--BEGIN
--  IF bts1.btr_pers IS NOT NULL THEN
--    FOR i IN bts1.btr_pers.FIRST .. bts1.btr_pers.LAST LOOP 
--      IF bts1.btr_pers(i).betreiber.pers.typ = 'NP' AND  bts1.btr_pers(i).betreiber.fkt.typ LIKE 'Betreiber%' THEN
--        Betreiberbezeichnung( bts1.btr_pers(i).betreiber);
--      END IF;
--    END LOOP;  
--  END IF;
--END Betreiberbezeichnungen;


PROCEDURE Betreiberbezeichnungen(pBTS_IDs IN tb_bez) AS

CURSOR c1 IS 
  SELECT 'BTR' ziel, prs.rowid prs_rowid --, prs.bezeichnung , prs.nachname, prs.vorname, prs.vorsatz_nachname, prs.nachsatz_nachname, prs.titel
  , CreateD0101Bez( 
            pNName => prs.nachname, 
            pVName => prs.vorname,
            pVorsatz => prs.vorsatz_nachname, 
            pNachsatz => prs.nachsatz_nachname, 
            pTitel => prs.titel) bez_neu
  FROM ein_d_person prs
  JOIN ein_d_funktion fkt ON fkt.d_pers_id = prs.id
  AND prs.typ = 'NP' AND fkt.typ LIKE Betreiber||'%' 
  AND fkt.d_bts_id IN ( SELECT dx.bez FROM TABLE ( pBTS_IDs ) dx ) 
  UNION ALL
  SELECT 'EK' ziel, prs.rowid prs_rowid --, prs.bezeichnung , prs.nachname, prs.vorname, prs.vorsatz_nachname, prs.nachsatz_nachname, prs.titel
  , (
      SELECT MAX(
          CreateD0101Bez( 
              pNName => prs1.nachname, 
              pVName => prs1.vorname,
              pVorsatz => prs1.vorsatz_nachname, 
              pNachsatz => prs1.nachsatz_nachname, 
              pTitel => prs1.titel) )   
      FROM ein_d_funktion fkt1
      JOIN ein_d_person prs1 ON prs1.id = fkt1.d_pers_id
      WHERE fkt1.typ = GV_Betreiber || REPLACE(fkt.typ, Betreiber, '')
      AND fkt1.d_bts_id = fkt.d_bts_id
   ) bez_neu
  FROM ein_d_person prs
  JOIN ein_d_funktion fkt ON fkt.d_pers_id = prs.id
  AND (prs.a0101_03_sid = A0101_03_SID_EK OR prs.rechtsform = A0101_03_CODE_EK) 
  AND fkt.typ LIKE Betreiber||'%' 
  AND fkt.d_bts_id IN ( SELECT dx.bez FROM TABLE ( pBTS_IDs ) dx ) ;

TYPE tData IS TABLE OF c1%ROWTYPE; 
vData tData;

BEGIN 

  IF pBTS_IDs IS NOT NULL AND pBTS_IDs.COUNT > 0 THEN  
    OPEN c1;
    LOOP
      FETCH c1 BULK COLLECT INTO vData LIMIT 500;

      EXIT WHEN vData.COUNT = 0;
    
      FORALL i IN vDATA.FIRST .. vData.LAST
      UPDATE ein_d_person prs
      SET bezeichnung = CASE 
                        WHEN vData(i).ziel = 'EK' AND bezeichnung IS NOT NULL THEN bezeichnung 
                        ELSE vData(i).bez_neu END
      WHERE prs.rowid = vData(i).prs_rowid
      AND vData(i).bez_neu IS NOT NULL; --AND vData(i).bez_neu <> prs.bezeichnung;    
  
    END LOOP; 
    CLOSE c1;
  END IF;
END Betreiberbezeichnungen;


PROCEDURE UsecaseAlterNeuerWert(pUsecaseID IN VARCHAR2, pLDAP_User IN VARCHAR2, pUser_Name IN VARCHAR2 := NULL) AS

  vBTS_id ein_d_usecase.d_bts_id%TYPE;
  vBTS_id2 ein_d_usecase.d_bts_id2%TYPE;
  vUsecase EIN_D_USECASE.USECASE%TYPE;
  res NUMBER(10); 
  vNeuer_Wert ein_d_usecase.neuer_wert%type := NULL;
  vAlter_Wert EIN_D_USECASE.ALTER_WERT%type := NULL;
  iReg PLS_INTEGER;
  vGKZ8 VARCHAR2(8);
  vGKZ5 VARCHAR2(5);
  vMandantSID vis_s50.sid%TYPE := -1;
  vUserSID vis_s50.sid%TYPE := -1;
  vUser_Name vis_s50.bez%TYPE;
  vAutoConfirm NUMBER(1) := 0;
  cRefCur SYS_REFCURSOR;
  vTmp NUMBER;
  vDeleted vis_d0101.deleted%TYPE;
  vUcInsdate ein_d_usecase.ins_date%TYPE;
  vQuelle ein_d_protokoll.quelle%TYPE;  
  vD0101_id ein_d_protokoll.d0101_id%TYPE;
  
  PROCEDURE AddNeuer_Wert(p IN VARCHAR2) AS
  BEGIN
    IF p IS NOT NULL THEN
      vNeuer_Wert := vNeuer_Wert || p || CRLF;
    END IF;      
  END;
  
  PROCEDURE AddAlter_Wert(p IN VARCHAR2) AS
  BEGIN
    IF p IS NOT NULL THEN
      vAlter_Wert := vAlter_Wert || p || CRLF;
    END IF; 
  END;
   
  PROCEDURE SetAutoConfirm AS
  BEGIN
    --CASE
    --WHEN vUsecase = 'ABMELD_BTR' THEN
      vAutoConfirm := 1;
    --WHEN vExistsAlteUsecase = 0 THEN
    --  vAutoConfirm := 1;
    --ELSE NULL;
    --END CASE;
  END;
  
  PROCEDURE UpdMandant(pMandant IN NUMBER, pZB IN VARCHAR2) AS
  BEGIN
  
    bts1.prot.mandant := pMandant;
    
    UPDATE ein_d_usecase
    SET mandant = bts1.prot.mandant
      , zb = pZB
    WHERE id = pUsecaseID;
    
    UPDATE ein_d_protokoll
    SET mandant = bts1.prot.mandant 
    WHERE id = bts1.prot.id;

  END;
  
  -- nur Platzhalter
  PROCEDURE A_Start AS BEGIN NULL; END;
  
BEGIN

  ClearErrMsg();
  
  IF pLDAP_User IS NOT NULL THEN
    BEGIN
      SELECT sid, bez INTO vUserSID, vUser_Name
      FROM vis_s50 
      WHERE deleted = 0
      AND ad_user_guid = pLDAP_User;
       
      EXCEPTION 
      WHEN no_data_found THEN 
        AddErrMsg('LDAP-User "' || pLDAP_User || '" ist nicht vorhanden.');
        vUser_Name := pUser_Name;
        vUserSID := -1; 
      WHEN too_many_rows THEN 
        AddErrMsg('LDAP-User "' || pLDAP_User || '" ist mehrfach vorhanden.');
        vUser_Name := pUser_Name;
        vUserSID := -1; 
    END;
  ELSE
    vUser_Name := pUser_Name;
  END IF;
  
  CASE
  WHEN vUserSid > 0 THEN
  
    UPDATE ein_d_usecase
    SET User_SID = vUserSID,
        user_name = vUser_name
    WHERE id = pUsecaseID;
    
  WHEN vUser_Name IS NOT NULL THEN
  
    vUserSID := -1;     

  ELSE NULL; 
  END CASE;

  UPDATE ein_d_usecase
  SET user_name = vUser_name,
      user_sid = vUserSID
  WHERE id = pUsecaseID; 

  SELECT uc.d_bts_id, uc.d_bts_id2, uc.Usecase, uc.Mandant, uc.ins_date, prt.quelle, prt.d0101_id
  INTO vBTS_ID, vBTS_ID2, vUsecase, vMandantSID, vUcInsDate, vQuelle, vD0101_id
  FROM ein_d_usecase uc
  JOIN ein_d_protokoll prt on prt.d_bts_id = uc.d_bts_id
  WHERE uc.id = pUsecaseID;
    
  
  res := Fill_BTS1(vBTS_ID, vUsecase);
  Clear_BTS(BTS2);

  
  IF NOT CheckPrtQuelle() THEN
    RETURN;
  END IF;

  IF  vUsecase NOT IN( 'ANL_MIN', 'ANMELD_BTR', 'ANMELD_BS') THEN 
    SELECT dx.deleted INTO vDeleted
    FROM vis_d0101 dx 
    WHERE dx.id = vD0101_id;

    IF vDeleted = -2 THEN
      AddErrMsg( 'Die Meldung kann nicht importiert werden, die entsprechende Betriebssttte wurde gelscht.');
    END IF;

  END IF;    
    
END UsecaseAlterNeuerWert;  


FUNCTION GetD0101_ID RETURN VARCHAR2 AS
BEGIN
  RETURN bts1.prot.d0101_id;
END;

/*******************************************************************************
  Liefert VIS_S50.SID des User
  Param. : 
  - pMandant_User: in der Form Mandant/User oder User@Mandant
  Rckgabe bei Fehler:
  - (-2) : Mandant/User nicht gefunden
  - (-3) : Mandant/User mehrfach vorhanden
  Beispiel:
    SELECT xgewerbe.GetUser_SID('BALVI/FG') FROM dual
    oder
    SELECT xgewerbe.GetUser_SID('FG@BALVI') FROM dual    
*******************************************************************************/
FUNCTION GetUser_SID( pMandant_User IN VARCHAR2) RETURN NUMBER AS
  vSID PLS_INTEGER := -1;
BEGIN

  BEGIN
  
    IF pMandant_User LIKE '%@%' THEN

      SELECT s50_3.sid INTO vSID 
      FROM VIS_S50 s50_1
      JOIN vis_s50 s50_3 ON s50_1.sid = s50_3.s50_sid00
      AND s50_1.skz = 1
      AND s50_1.deleted = 0
      AND S50_3.CODE || '/' || s50_1.CODE = pMandant_User;

    ELSE

      SELECT s50_3.sid INTO vSID 
      FROM VIS_S50 s50_1
      JOIN vis_s50 s50_3 ON s50_1.sid = s50_3.s50_sid00
      AND s50_1.skz = 1
      AND s50_1.deleted = 0
      AND S50_1.CODE || '/' || s50_3.CODE = pMandant_User;

    END IF;

    EXCEPTION WHEN NO_DATA_FOUND THEN vSID := -2;
              WHEN TOO_MANY_ROWS THEN vSID := -3;
              
  END;
  
  RETURN vSID;
              
END; -- GetUser_SID

-- Besttigung eines Usecase
-- pErrorCnt: Rckgabe Anzahl Fehler
-- pErrMsg: im Fehlerfall Fehlertext
PROCEDURE UsecaseConfirm( pUsecaseID IN VARCHAR2, pErrorCnt OUT NUMBER, pErrMsg OUT NOCOPY VARCHAR2 ) AS
vSysDate DATE := SYSDATE;
BEGIN
  StartUseCaseByUseCase_ID( pUsecaseID, 1 );
  pErrorCnt := GetErrCnt();
  pErrMsg := GetErrMsg();
  IF GetErrCnt() = 0 THEN
    UPDATE ein_d_usecase
    SET deleted = -1
      , del_date = vSYSDATE
      , bearbeitung_jn = 0
    WHERE id = pUsecaseID;
  END IF;

END;


-- Usecase ablehnen
PROCEDURE UsecaseReject( pUsecaseID IN VARCHAR2, pErrorCnt OUT NUMBER, pErrMsg OUT NOCOPY VARCHAR2 ) AS
vSYSDATE DATE := SYSDATE;
BEGIN
  StartUseCaseByUseCase_ID( pUsecaseID, 0 );
  pErrorCnt := GetErrCnt();
  pErrMsg := GetErrMsg();
  IF GetErrCnt() = 0 THEN
    UPDATE ein_d_usecase
    SET deleted = -1
      , del_date = vSYSDATE
    WHERE id = pUsecaseID;
  END IF;
END;


FUNCTION GKZ2 RETURN VARCHAR2 AS
BEGIN
  RETURN vGKZ2;
END;

PROCEDURE GKZ2 ( pGKZ2 IN VARCHAR2 ) AS
BEGIN
  vGKZ2 := pGKZ2;
END;

-- 13.09.2013
FUNCTION GetZBbyGKZ8( pGKZ8 IN VARCHAR2) RETURN VARCHAR2 DETERMINISTIC AS
  vZB glo_a25.zb%TYPE;
  vA25_SID1 PLS_INTEGER;
  vSID PLS_INTEGER;

  CURSOR c1 IS
    SELECT sid, glo_a25_sid1, zb
    FROM glo_a25
    WHERE deleted > -2
    AND code = pGKZ8; 
  
  FUNCTION NextA25(pSID IN NUMBER) RETURN VARCHAR2 AS
    CURSOR c2 IS
      SELECT sid, glo_a25_sid1, zb
      FROM glo_a25
      WHERE deleted > -2
        AND sid = pSID;
    
    vZB_2 VARCHAR2(32);
    vA25_SID1_2 PLS_INTEGER;
    vSID_2 PLS_INTEGER;
    res VARCHAR2(5);
  BEGIN
    OPEN c2;
        
    FETCH c2 INTO vSID_2, vA25_SID1_2, vZB_2;    
    IF c2%FOUND THEN
      IF vA25_sid1_2 = -1 or vA25_sid1_2 = vSid_2 THEN
        res := vZB_2;
      ELSE
        res := NextA25(vA25_sid1_2);
      END IF;
    END IF;
    CLOSE c2;     
    RETURN res;          
  END;
BEGIN
  
  OPEN c1;
    
  FETCH c1 INTO vSID, vA25_SID1, vZB;
  IF c1%FOUND THEN
    vZB := NextA25(vA25_SID1);
  END IF;
  CLOSE c1;
  IF vZB IS NULL THEN
    vZB := SUBSTR(pGKZ8, 1, 5);
  END IF;  
  RETURN vZB;
END;

/*******************************************************************************
  kompletten Eingangskorb ber  BTS_ID lschen
  
begin
  xgewerbe.deletebybtsid('F02A89CF126E4965AA9631B5E8DB6454');
end;  
*******************************************************************************/
PROCEDURE DeleteByBtsID( pBTS_ID IN tID, pAusgabe IN NUMBER := 0) AS
  
  CURSOR cUsc (pID IN tID) IS
  SELECT uc.d_bts_id2 
  FROM ein_d_usecase uc 
  WHERE uc.d_bts_id = pID;
    
  vUsc cUsc%ROWTYPE;    
  
  CURSOR cDubletten ( pID IN VARCHAR2) IS 
  SELECT uc2.d_bts_id, uc2.id ein_d_usecase_id
  FROM ein_d_usecase uc1
  JOIN ein_d_protokoll prt1 on prt1.d_bts_id = uc1.d_bts_id 
  AND prt1.status = 2
  join ein_d_usecase uc2 ON uc2.aus_d_usecase_id = uc1.aus_d_usecase_id
  AND uc2.usecase = 'DUBLETTE'
  JOIN ein_d_protokoll prt2 on prt2.d_bts_id = uc2.d_bts_id 
  AND prt2.status = 20
  where uc1.d_bts_id = pID
    AND uc1.usecase = 'DUBLETTE';  
  
  TYPE tbDubletten IS TABLE OF cDubletten%ROWTYPE;
  vDubletten tbDubletten;
  
  CURSOR cAdr (pID IN tID) IS
  SELECT id, d_kat_id, d_padr_id, d_verw_id 
  FROM ein_d_adresse 
    WHERE ID IN ( 
      -- ein_r_ABT_ADR
      SELECT r.d_adr_id
      FROM ein_d_abteilung abt
      JOIN ein_r_ABT_ADR r ON abt.id = r.d_abt_id
       AND abt.d_bts_id = pID
      UNION ALL  -- ein_r_PERS_ADR  
      SELECT R.D_ADR_ID
      FROM ein_d_funktion funk 
      JOIN ein_r_pers_adr r ON R.D_PERS_ID = FUNK.D_PERS_ID
       AND FUNK.D_BTS_ID = pID
      UNION ALL -- ein_r_FUNK_ADR
      SELECT R.D_ADR_ID
      FROM ein_d_funktion funk 
      JOIN ein_r_fkt_adr r ON R.D_fkt_ID = FUNK.ID
       AND FUNK.D_BTS_ID = pID
      UNION ALL  -- ein_r_BTS_ADR
      SELECT R.D_ADR_ID
      FROM ein_r_bts_adr r 
      WHERE r.D_BTS_ID = pID );
  
  TYPE tAdr IS TABLE OF cAdr%ROWTYPE ;  
  vAdr tAdr;  

  PROCEDURE Ausgabe(pText IN VARCHAR2, pNewline IN NUMBER := 1) AS
  BEGIN
    IF pAusgabe = 1 THEN 
      IF pNewline = 1 THEN
        DBMS_OUTPUT.PUT_LINE(pText);
      ELSE
        DBMS_OUTPUT.PUT(pText);
      END IF;
    END IF;
  END Ausgabe;

BEGIN
  /*****************************************************************************
  0. berprfung ob BTS_ID in EIN_D_USECASE.D_BTS_ID2 verwendet wird
  1. Bei Usecase DUBLETTE die vorhandenen Dubletten Lschen
  2. ein_d_ADRESSEN ber
     - ein_r_ABT_ADR - ein_d_ABTEILUNG
     - ein_r_PERS_ADR - ein_d_PERSON - ein_d_FUNKTION
     - ein_r_FKT_ADR - ein_d_FUNKTION
     - ein_r_BTS_ADR    
    zustzlich lschen
    - ein_d_VERWALTUNG
    - ein_d_KATASTER
    - ein_d_POSTADRESSE
     
  3. ein_d_REGISTRIERUNG ber
     - ein_r_BTS_REG
     - ein_r_FKT_REG - ein_d_FUNKTION
     - ein_r_PERS_REG - ein_d_PERSON - ein_d_FUNKTION
     - ein_r_ABT_REG
     
  4. ein_d_KOMMUNIKATION ber
     - ein_r_BTS_KOM
     - ein_r_FKT_KOM - ein_d_FUNKTION
     - ein_r_PERS_KOM - ein_d_PERSON - ein_d_FUNKTION
  5. ein_d_BEZIEHUNG ber
     - ein_r_BTS_BZH
  6. ein_d_PERSON ber
     - ein_d_FUNKTION
  7. ein_d_TIERANGABEN
  8. ein_d_FACHBEREICHE
  9. ein_d_BEHOERDE ber
     - ein_r_BTS_BEHOER  
  10. ein_d_BETRIEBSSTAETTE
  11. Vergleichdaten ber aus_d_usecase.d_bts_id2 lschen
  
  automatisch gelscht durch DELETE CASCADE Referenzen
  ein_d_BETRIEBSSTAETTE
  - ein_d_ABTEILUNG
  - ein_d_BETRIEBSART
  - ein_d_FUNKTION
  - ein_d_PROTOKOLL
  - ein_d_TAETIGKEIT
  - ein_d_USECASE
  - ein_r_BTS_ADR
  - ein_r_BTS_BEHOER
  - ein_r_BTS_BZH
  - ein_r_BTS_KOM
  - ein_r_BTS_REG
  *****************************************************************************/    
  
  --0. berprfung ob BTS_ID in EIN_D_USE_CASE.D_BTS_ID2 verwendet wird, 
  -- dann am Ende diese Daten lschen 
  OPEN cUsc (pBTS_ID);
  FETCH cUsc INTO vUsc;
  CLOSE cUsc; 

  --1. Bei Usecase DUBLETTE die vorhandenen Dubletten lschen 
  OPEN cDubletten (pBTS_ID);
  FETCH cDubletten BULK COLLECT INTO vDubletten;
  CLOSE cDubletten;
  
  IF vDubletten.COUNT > 0 THEN

    FORALL i IN vDubletten.FIRST .. vDubletten.LAST
    DELETE ein_d_usecase
    WHERE id = vDubletten(i).ein_d_usecase_id;   
    
    Ausgabe('Lschen Usecases DUBLETTE: ' || SQL%ROWCOUNT);    

    --Ausgabe('Begin Lschen Betriebssttten DUBLETTE'); 
    FOR i IN vDubletten.FIRST .. vDubletten.LAST LOOP
      Ausgabe('Lschen Dublette ' || i);
      DeleteByBtsId(vDubletten(i).d_bts_id, pAusgabe);
    END LOOP;
    
    Ausgabe('Ende Lschen Betriebssttten DUBLETTE'); 
    Ausgabe(' ');
  END IF;

  Ausgabe('Lschen Betriebssttte');
  
  --2. ein_d_ADRESSE
  /*FOR cAdr IN (
    SELECT id, d_kat_id, d_padr_id, d_verw_id 
    FROM ein_d_adresse 
      WHERE ID IN ( 
        -- ein_r_ABT_ADR
        SELECT r.d_adr_id
        FROM ein_d_abteilung abt
        JOIN ein_r_ABT_ADR r ON abt.id = r.d_abt_id
         AND abt.d_bts_id = vBTS_id
        UNION ALL  -- ein_r_PERS_ADR  
        SELECT R.D_ADR_ID
        FROM ein_d_funktion funk 
        JOIN ein_r_pers_adr r ON R.D_PERS_ID = FUNK.D_PERS_ID
         AND FUNK.D_BTS_ID = vBTS_ID
        UNION ALL -- ein_r_FUNK_ADR
        SELECT R.D_ADR_ID
        FROM ein_d_funktion funk 
        JOIN ein_r_fkt_adr r ON R.D_fkt_ID = FUNK.ID
         AND FUNK.D_BTS_ID = vBTS_ID
        UNION ALL  -- ein_r_BTS_ADR
        SELECT R.D_ADR_ID
        FROM ein_r_bts_adr r 
        WHERE r.D_BTS_ID = vBTS_ID )
  ) LOOP
  
    DELETE ein_d_verwaltung WHERE id = cAdr.d_verw_id;
    DELETE ein_d_kataster WHERE id = cAdr.d_kat_id;
    DELETE ein_d_postadresse WHERE id = cAdr.d_padr_id;
    DELETE ein_d_adresse WHERE id = cAdr.id;
    
  END LOOP; */
  
    
  OPEN cAdr (pBTS_ID); 
  FETCH cAdr BULK COLLECT INTO vAdr; 
  CLOSE cAdr;
  
  IF vAdr.COUNT > 0 THEN

    FORALL iAdr IN vAdr.FIRST .. vAdr.LAST    
      DELETE ein_d_adresse WHERE id = vAdr(iAdr).id;
    Ausgabe('ein_d_adresse: '||SQL%ROWCOUNT);
    
    FORALL iAdr IN vAdr.FIRST .. vAdr.LAST    
      DELETE ein_d_verwaltung WHERE id = vAdr(iAdr).d_verw_id;
    Ausgabe('ein_d_verwaltung: '||SQL%ROWCOUNT);
          
    FORALL iAdr IN vAdr.FIRST .. vAdr.LAST    
      DELETE ein_d_kataster WHERE id = vAdr(iAdr).d_kat_id;
    Ausgabe('ein_d_kataster: '||SQL%ROWCOUNT);
  
    FORALL iAdr IN vAdr.FIRST .. vAdr.LAST    
      DELETE ein_d_postadresse WHERE id = vAdr(iAdr).d_padr_id;
    Ausgabe('ein_d_postadresse: '||SQL%ROWCOUNT);
    
  END IF;

  --3. ein_d_REGISTRIERUNG ber
  --   ein_r_BTS_REG
  DELETE ein_d_registrierung 
  WHERE ID IN (
  SELECT R.D_REG_ID
  FROM ein_r_bts_reg r
  WHERE R.D_BTS_ID = pBTS_ID);
  Ausgabe('ein_d_registrierung ber ein_r_bts_reg: '||SQL%ROWCOUNT);  

  -- ein_r_FKT_REG - ein_d_FUNKTION
  DELETE ein_d_REGISTRIERUNG 
  WHERE ID IN (
  SELECT R.D_REG_ID 
  FROM ein_d_funktion funk 
  JOIN ein_r_fkt_reg r ON R.D_fkt_ID = FUNK.ID
   AND FUNK.D_BTS_ID = pBTS_ID);
  Ausgabe('ein_d_registrierung ber ein_r_fkt_reg: '||SQL%ROWCOUNT);  

  -- ein_r_PERS_REG - ein_d_PERSON - ein_d_FUNKTION
  DELETE ein_d_REGISTRIERUNG 
  WHERE ID IN (
  SELECT R.D_REG_ID 
  FROM ein_d_funktion funk 
  JOIN ein_r_pers_reg r ON R.D_pers_ID = FUNK.d_pers_ID
   AND FUNK.D_BTS_ID = pBTS_ID);     
  Ausgabe('ein_d_registrierung ber ein_r_pers_reg: '||SQL%ROWCOUNT);  

  --   ein_r_ABT_REG
  DELETE ein_d_REGISTRIERUNG 
  WHERE ID IN (
  SELECT R.D_REG_ID 
  FROM ein_d_abteilung abt 
  JOIN ein_r_abt_reg r ON R.D_abt_ID = abt.ID
   AND abt.D_BTS_ID = pBTS_ID);     
  Ausgabe('ein_d_registrierung ber ein_r_abt_reg: '||SQL%ROWCOUNT);  

  --4. ein_d_KOMMUNIKATION ber
  -- ein_r_BTS_KOM
  DELETE ein_d_kommunikation
  WHERE id IN (
  SELECT R.D_KOM_ID
  FROM ein_r_bts_kom r 
  WHERE R.D_BTS_ID = pBTS_ID);
  Ausgabe('ein_d_kommunikation ber ein_r_bts_kom: '||SQL%ROWCOUNT);  
  
  -- ein_r_FKT_KOM - ein_d_FUNKTION
  DELETE ein_d_kommunikation
  WHERE id IN (
  SELECT R.D_KOM_ID
  FROM ein_r_fkt_kom r
  JOIN ein_d_funktion funk ON funk.id = R.D_FKT_ID 
  WHERE funk.D_BTS_ID = pBTS_ID);
  Ausgabe('ein_d_kommunikation ber ein_r_fkt_kom: '||SQL%ROWCOUNT);  
  
  -- ein_r_PERS_KOM - ein_d_PERSON - ein_d_FUNKTION    
  DELETE ein_d_kommunikation
  WHERE id IN (
  SELECT R.D_KOM_ID
  FROM ein_r_pers_kom r
  JOIN ein_d_funktion funk ON funk.d_pers_id = R.D_pers_ID 
  WHERE funk.D_BTS_ID = pBTS_ID);
  Ausgabe('ein_d_kommunikation ber ein_r_pers_kom: '||SQL%ROWCOUNT);  

  --5. ein_d_BEZIEHUNG ber
  -- ein_r_BTS_BZH   
  DELETE ein_d_beziehung
  WHERE id IN (
  SELECT R.D_BZH_ID
  FROM ein_r_bts_bzh r 
  WHERE R.D_BTS_ID = pBTS_ID);   
  Ausgabe('ein_d_beziehung ber ein_r_bts_bzh: '||SQL%ROWCOUNT);  
  
  --6. ein_d_PERSON ber
  -- ein_d_FUNKTION
  DELETE ein_d_person
  WHERE id IN (
  SELECT funk.d_pers_ID -- 06.11.2015 bugfix funk.d_bts_id
  FROM ein_d_funktion funk 
  WHERE funk.D_BTS_ID = pBTS_ID); 
  Ausgabe('ein_d_person ber ein_d_funktion: '||SQL%ROWCOUNT);  
    
  --7. Tierangaben
  DELETE ein_d_tierangaben
  WHERE d_bts_id = pBTS_ID;
  Ausgabe('ein_d_tierangaben: '||SQL%ROWCOUNT);  

  --8. ein_d_FACHBEREICHE
  DELETE ein_d_fachbereiche
  WHERE d_bts_id = pBTS_ID;  -- bugfix 07.07.2016
  Ausgabe('ein_d_fachbereiche: '||SQL%ROWCOUNT);

  --9. ein_d_BEHOERDE 
  DELETE ein_d_behoerde
  WHERE id IN (
  SELECT r.D_BEHOERDE_ID
  FROM ein_r_bts_behoer r 
  WHERE r.D_BTS_ID = pBTS_ID); 
  Ausgabe('ein_d_behoerde ber ein_r_bts_behoer: '||SQL%ROWCOUNT); 
        
  --10. ein_d_BETRIEBSSTAETTE
  DELETE ein_d_betriebsstaette
  WHERE id = pBTS_ID;
  Ausgabe('ein_d_betriebsstaette: '||SQL%ROWCOUNT);

  --11. Vergleichdaten ber ein_d_usecase.d_bts_id2 lschen
  IF IS_ID(vUsc.d_bts_id2) THEN
    Ausgabe('Lschen Vergleichdaten ber ein_d_usecase.d_bts_id2');
    DeleteByBtsID(vUsc.d_bts_id2, pAusgabe);
  END IF;

END DeleteByBtsID;

/*******************************************************************************
  kompletten Eingangskorbs ber ein_d_protokoll.id lschen
  Param.:
  - pProtID: ID des Protokolls
*******************************************************************************/
PROCEDURE DeleteByProtID( pProtID IN tID) AS
BEGIN
  FOR c1 IN (  
    SELECT prot.d_bts_id
    FROM ein_d_protokoll prot
    WHERE prot.id = pProtID
  ) LOOP  
    DeleteByBtsID(c1.d_BTS_ID);
  END LOOP;
  
END DeleteByProtID;

/*******************************************************************************
  Usecase physisch lschen
  ist es der letzte Usecase, wird der kompletten Eingangskorbs gelscht
  Param.:
  - pUscID: ID des Usecase
*******************************************************************************/
PROCEDURE DeleteByUscID( pUscID IN tID) AS
BEGIN
  FOR c1 IN (  
    SELECT usc.id, usc.d_bts_id
    , ( SELECT COUNT(*) 
        FROM ein_d_usecase usc1 
        WHERE usc1.d_bts_id = usc.d_bts_id 
        AND usc1.usecase NOT LIKE 'DUBLETTE%' ) cntUsc
    FROM ein_d_usecase usc
    WHERE usc.id = pUscID
    AND usc.deleted = 0
  ) LOOP  
    IF c1.cntUsc < 2 THEN
      DeleteByBtsID(c1.d_BTS_ID);
    ELSE
      DELETE ein_d_usecase 
      WHERE id = pUscID;
    END IF;
  END LOOP;
  
END DeleteByUscID;

/*******************************************************************************
  Usecase physisch lschen ber S97
  ist es der letzte Usecase, wird der kompletten Eingangskorbs gelscht
  Param.:
  - pUscID: ID des Usecase
*******************************************************************************/
PROCEDURE DeleteUscByS97 AS
BEGIN

  FOR c1 IN (  
    SELECT usc.id, usc.d_bts_id
    , ( SELECT COUNT(*) FROM ein_d_usecase usc1 
        WHERE usc1.d_bts_id = usc.d_bts_id 
        AND usc1.usecase NOT LIKE 'DUBLETTE%'
        AND usc1.id NOT IN ( SELECT s97.id FROM vis_s97 s97) 
      ) delBts
    FROM ein_d_usecase usc
    WHERE usc.id IN ( SELECT s97.id FROM vis_s97 s97)
    AND usc.deleted = 0
  ) LOOP  

    IF c1.DelBts = 0 THEN
      DeleteByBtsID(c1.d_BTS_ID);
    ELSE
      DELETE ein_d_usecase 
      WHERE id = c1.id;
    END IF;
  END LOOP;
  
END DeleteUscByS97;

-- berprfung der Betreiber-ID des Betreibers der Betriebsstte mit pBTS_ID
-- Ist im Eingangskorb eine abweichende Betreiber-ID wird diese beim Betreiber aktualisert
PROCEDURE UpdateBetreiber_ID(pBTS_ID IN tID) AS

CURSOR c1 (pID IN tID) IS
  select reg.nummer reg_nr, reg.gueltig_bis reg_bis, reg.gueltig_von reg_von
  , d010102.rowid d010102_rowid, d0101.d0101_id3, d010102.nummer d010102_nr
  , d010102.gueltig_bis d010102_bis
  from ein_d_betriebsstaette bts
  join vis_d0101 d0101 on d0101.id = bts.ref_id
  and bts.ref_id <> '-1'
  join ein_d_funktion fkt on fkt.d_bts_id = bts.id
  and fkt.typ = Betreiber
  join ein_r_fkt_reg r2 on r2.d_fkt_id = fkt.id
  join ein_d_registrierung reg on reg.id = r2.d_reg_id
  and reg.art = BI
  --join vis_d0101 d0101_3 on d0101_3.id = d0101.d0101_id3
  left join vis_d010102 d010102 on d010102.d0101_id = d0101.d0101_id3 --d0101_3.id
  and d010102.deleted = 0  
  and d010102.a010145_sid = A010145_BETREIBER_ID
  --and d010102.nummer <> reg.nummer
  where bts.id = pID;

TYPE t1 IS TABLE OF c1%ROWTYPE;
v1 t1;
vID tID;
vSysdate CONSTANT DATE := SYSDATE;
vUserSID CONSTANT vis_d010102.upd_user%TYPE := blv_sys.get_user_sid;
BEGIN

  OPEN c1 (pBTS_ID);
  FETCH c1 BULK COLLECT INTO v1;
  CLOSE c1;
 
  IF v1.COUNT > 0 THEN
    IF v1(1).d010102_rowid IS NULL THEN -- BetreiberID nicht vorhanden

      -- alle BetreiberID lschen
      UPDATE vis_d010102
      SET del_date = vSysdate
        , del_user = vUserSid
        , deleted = -2  -- 13.04.2017
      WHERE deleted = 0
        AND nummer = v1(1).reg_nr
        AND a010145_sid = A010145_BETREIBER_ID;
   
      vID := SYS_GUID();    

      INSERT INTO vis_d010102 (
        ID, D0101_ID, A010145_SID, FB, BEZ,
        MANDANT, NUMMER, INS_USER, INS_DATE, UPD_USER, UPD_DATE, DELETED, 
        GUELTIG_VON, GUELTIG_BIS, a0302_05_sid, GUELTIG_VON_STAT --, GUELTIG_BIS_STAT
      )  
      SELECT 
        vID, v1(1).d0101_id3, A010145.sid, A010145.fb, A010145.bez,
        vMandant_SID, v1(1).reg_nr, vUser_sid, vSYSDATE, vUser_sid, vSYSDATE, 0,
        v1(1).reg_von, v1(1).reg_bis
        , A0302_05_ERTEILT A0302_05_sid
        , v1(1).reg_von
      FROM vis_a010145 a010145
      WHERE sid = A010145_BETREIBER_ID;
  
    ELSE -- BetreiberID vorhanden
      UPDATE vis_d010102
      SET del_date = vSysdate
        , del_user = vUserSid
        , deleted = -2  -- 13.04.2017
      WHERE deleted = 0
        AND nummer = v1(1).reg_nr
        AND a010145_sid = A010145_BETREIBER_ID
        AND rowid <> v1(1).d010102_rowid;
   
      -- 1. BetreiberID prfen und aktualisieren 
      IF v1(1).reg_nr <> v1(1).d010102_nr OR
      compare(v1(1).reg_bis, v1(1).d010102_bis) = 0 then
      
        UPDATE vis_d010102
        SET gueltig_bis = v1(1).reg_bis
          , nummer = v1(1).reg_nr      
          , upd_date = vSysdate
          , upd_user = vUserSid
        WHERE rowid = v1(1).d010102_rowid;
        
      END IF;
        
      -- alle weiteren BetreiberID zum Betreiber lschen zur Sicherheit          
      FORALL i IN v1.FIRST + 1 .. v1.LAST 
        UPDATE vis_d010102
        SET del_date = vSysdate
        , del_user = vUserSid
        , deleted = -2  -- 13.04.2017
        WHERE rowid = v1(i).d010102_rowid;
        
    END IF;        
  END IF;


END UpdateBetreiber_ID;


FUNCTION OutputDaten(pBTS_ID IN tID) RETURN tbListData PIPELINED AS
  vData tListData;
  vDaten tbListData := tbListData();
  PROCEDURE AddText ( p1 IN tListData) AS
  BEGIN
    vDaten.EXTEND;
    vDaten(vDaten.Last) := p1;
  END;
  procedure Zeile(p1 IN VARCHAR2, p2 IN VARCHAR2) AS
  BEGIN
    vData.bez := SUBSTR(p1, 1, 50);
    vData.wert := SUBSTR(p2, 1, 250);
    AddText(vData);
  END;
  procedure Zeile2(p1 IN VARCHAR2, p2 IN VARCHAR2) AS
  BEGIN
    IF p2 IS NOT NULL THEN
      vData.bez := SUBSTR(p1, 1, 50);
      vData.wert := SUBSTR(p2, 1, 250);
      AddText(vData);
    END IF;
  END;
  PROCEDURE adr(p1 IN tAdr) as
  begin
    Zeile2('PLZ', p1.padr.plz );
    Zeile2('Ort/Ortsteil', p1.padr.ort ||'/' ||p1.padr.ortsteil );
    IF p1.padr.postfach_jn = 1 THEN
      zeile2('Postfach', p1.padr.postfach );
    ELSE  
      zeile2('Strasse', p1.padr.strasse || ' '|| p1.padr.hausnr||p1.padr.hausnrzusatz );
    END IF;  
    zeile2('glo_a24_sid', p1.padr.glo_a24_sid );  
    zeile2('GKZ', p1.verw.gkz);
    zeile2('Rechtswert', p1.kat.rechtswert);
    zeile2('Hochwert', p1.kat.hochwert);
    zeile2('X-Wert', p1.kat.x_wert);
    zeile2('Y-Wert', p1.kat.y_wert);
    zeile2('s09_sid', p1.kat.s09_sid);
    zeile2('GIS-Quelle', p1.kat.gis_quelle);     
  end;
  procedure komm(p1 IN tKom) as
  begin
    --IF p1.telefon|| p1.fax|| p1.mobil|| p1.internet|| p1.email IS NOT NULL THEN
      zeile2( 'Telefon', p1.telefon );
      zeile2( 'Fax',  p1.fax );
      zeile2( 'Mobil',  p1.mobil );
      zeile2( 'Internet',  p1.internet );
      zeile2( 'EMail', p1.email );
    --END IF;
  end;
  procedure bta( p1 IN tbBTA) as
  begin
    if p1 IS NOT NULL AND p1.COUNT > 0 THEN
      for i in 1 .. p1.count loop
        Zeile2( i || '. Betriebsart', 
                 p1(i).code ||
                ' ,'||p1(i).art ||
                ' ,'||p1(i).bez ||
                ' ,'||p1(i).gueltig_von || '-' || p1(i).gueltig_bis);        
      end loop;  
    end if;
  end;
  procedure reg( p1 IN tbReg) as
  begin
    if p1 IS NOT NULL AND p1.COUNT > 0 THEN
      for i in 1 .. p1.count loop
        Zeile2( i || '. Nummer', p1(i).code ||
                ' ,'||p1(i).art ||
                ' ,'||p1(i).nummer ||
                ' ,'||p1(i).gueltig_von || '-' || p1(i).gueltig_bis);        
      end loop;  
    end if;
  end;
  procedure pers(p1 IN EIN_d_person%ROWTYPE) AS
  BEGIN
    Zeile2('Kurzbez1', p1.kurzbez1);
    Zeile2('Kurzbez2', p1.kurzbez2);
    Zeile2('Typ', p1.typ);
    Zeile2('Anrede', p1.anrede);
    Zeile2('Titel', p1.titel);
    Zeile2('Vorname', p1.vorname);
    Zeile2('Nachname', p1.nachname);
    Zeile2('Vorsatz Nachname', p1.vorsatz_nachname);
    Zeile2('Nachsatz Nachname', p1.nachsatz_nachname);
    Zeile2('Geburtsdatum', p1.geburtsdatum);
    Zeile2('Geburtsort', p1.geburtsort);
    Zeile2('Bezeichnung', p1.bezeichnung);
    Zeile2('Bezeichnung2', p1.bezeichnung2);
    Zeile2('Rechtsform', p1.rechtsform);
    --Zeile2('pers_id', p1.pers_id);
    --Zeile2('ref_id', p1.ref_id);
    --Zeile2('a0101_03_sid', p1.a0101_03_sid);
    --Zeile2('a0101_70_sid', p1.a0101_70_sid);
  END;
  PROCEDURE usc ( p1 IN ein_d_usecase%ROWTYPE) AS
  BEGIN
    Zeile2('Usecase', p1.usecase);
    Zeile2('Datenherkunft', p1.datenherkunft);
    Zeile2('externe Message', p1.extern_message);
    Zeile2('ZB',p1.zb);
    Zeile2('alter Wert', p1.alter_wert);
    Zeile2('neuer Wert', p1.neuer_wert);
    zeile2('Ins_Date', TO_CHAR(p1.ins_date, 'dd.mm.yyyy hh24:mi:ss') );  
    zeile2('Deleted', p1.deleted);  
  END;
  PROCEDURE Prot(p1 IN EIN_d_protokoll%ROWTYPE) AS
  BEGIN
    Zeile('Protokoll',NULL);
    Zeile2('Quelle', p1.quelle);
    Zeile2('Status', p1.status);
    Zeile2('Parameter', p1.parameter);
  END;
BEGIN

  FOR c1 IN (
    SELECT uc.* FROM ein_d_usecase uc WHERE uc.d_bts_id = pBTS_ID 
  ) LOOP
    --AddText( 'fill_bts:'|| FILL_BTS( bts1, pBTS_ID, 1, c1.usecase) );
    IF FILL_BTS( bts1, pBTS_ID, 1, c1.usecase) IS NULL THEN NULL; END IF;
    Usc(c1);
    Prot(bts1.prot);
    Zeile2('Betriebssttte', bts1.bts.zusatzbez);
    Zeile2('gltig von-bis', bts1.bts.gueltig_von ||'-'|| bts1.bts.gueltig_bis);
    Zeile2('ZB', bts1.bts.zb);
    Zeile('Standortadresse', null);
    adr(bts1.adr_btro);
    IF IS_ID(bts1.adr_btra.adr.id) THEN 
      Zeile('Postadresse', NULL);
      adr(bts1.adr_btra);
     END IF;
    -- bts Komm
    --Zeile('Kommunikation', NULL);
    komm( bts1.kom );
    --BA
    Zeile('Betriebsarten', NULL);
    bta(bts1.bta);
    -- bts Reg
    Zeile('Registrierungen', NULL);
    Reg( bts1.reg );

    -- Betreiber
    --  Postadresse
    IF bts1.btr_pers IS NOT NULL AND bts1.btr_pers.count > 0 THEN
      Zeile( 'Betreiber', NULL );
      FOR i IN bts1.btr_pers.FIRST .. bts1.btr_pers.LAST LOOP
        Zeile( 'Typ', bts1.btr_pers(i).betreiber.fkt.typ);
        pers(bts1.btr_pers(i).betreiber.pers);
        IF IS_ID(bts1.btr_pers(i).betreiber.adr.adr.id) THEN
          Zeile('Postadresse', NULL);
          adr( bts1.btr_pers(i).betreiber.adr );
        END IF;
        --Zeile('Kommunikation', NULL);
        komm( bts1.btr_pers(i).betreiber.kom );
        -- btr Reg
        Zeile('Registrierungen', NULL);
        Reg( bts1.btr_pers(i).betreiber.reg );
        -- Gesetzlicher Vertreter
        IF bts1.btr_pers(i).gv IS NOT NULL AND bts1.btr_pers(i).gv.COUNT > 0 THEN
          FOR iGV IN bts1.btr_pers(i).gv.FIRST .. bts1.btr_pers(i).gv.LAST LOOP
            Zeile(bts1.btr_pers(i).gv(iGV).fkt.typ, NULL);  
            pers( bts1.btr_pers(i).gv(iGv).pers );
            IF IS_ID(bts1.btr_pers(i).gv(iGv).adr.adr.id) THEN
              adr( bts1.btr_pers(i).gv(iGv).adr );
            END IF;
            komm( bts1.btr_pers(i).Gv(iGv).kom );
            Reg( bts1.btr_pers(i).Gv(iGv).reg );                   
          END LOOP;
        END IF;
        -- Hauptansprechpartner
        IF bts1.btr_pers(i).hv IS NOT NULL AND bts1.btr_pers(i).hv.COUNT > 0 THEN
          FOR iHV IN bts1.btr_pers(i).hv.FIRST .. bts1.btr_pers(i).hv.LAST LOOP
            Zeile(bts1.btr_pers(i).hv(iHv).fkt.typ, NULL); 
            pers( bts1.btr_pers(i).hv(iHv).pers );
            IF IS_ID(bts1.btr_pers(i).hv(iHv).adr.adr.id) THEN
              adr( bts1.btr_pers(i).hv(iHv).adr );
            END IF;
            komm( bts1.btr_pers(i).hv(iHv).kom );
            Reg( bts1.btr_pers(i).hv(iHv).reg );                   
          END LOOP;
        
        END IF;
      
      END LOOP;
    ELSE
      Zeile('Betreiber', 'kein vorhanden');
    END IF;

  END LOOP;
  
  FOR i IN vDaten.First .. vDaten.Last LOOP
    PIPE ROW ( vDaten(i) );
  END LOOP;
  
  RETURN;
END OutputDaten;

FUNCTION BTA_FB_FEHLER(pBTS_ID IN VARCHAR2, pBTA_ID IN VARCHAR2, pFB IN VARCHAR2) RETURN tbBTA PIPELINED AS
  vBTA tbBTA;
  vFB CONSTANT vis_d0101.fb%TYPE := '[' || pFB || ']';
  
  CURSOR cBTA IS 
  SELECT bta.*
  FROM ein_d_betriebsart bta 
  JOIN vis_a010108 a010108 ON a010108.code = bta.code
  AND a010108.deleted > -2
--  CROSS JOIN ( 
--  SELECT LISTAGG( a0101_06.FB ) WITHIN GROUP ( ORDER BY a0101_06.fb ) fb
--  FROM vis_s5004 s5004
--  JOIN vis_a0101 a0101_06 ON a0101_06.sid = s5004.a0101_06_sid
--  AND s5004.al >= 3 -- Bearbeitungrecht
--  AND s5004.s50_sid = pMandantSid
--  AND s5004.deleted = 0
--  ) s5004
  WHERE bta.art = 'BALVI'
  AND bta.d_bts_id = pBTS_ID
  AND bta.id LIKE pBTA_ID
--  AND NOT REGEXP_LIKE( a010108.fb, '['|| s5004.fb || ']', 'i'); 
  AND NOT REGEXP_LIKE( a010108.fb, vFB, 'i'); 
 
BEGIN

  OPEN cBTA;
  FETCH cBTA BULK COLLECT INTO vBTA;
  CLOSE cBTA;
  
  IF vBTA IS NOT NULL AND vBTA.COUNT > 0 THEN
    FOR i IN vBTA.FIRST .. vBTA.LAST LOOP
      PIPE ROW( vBTA(i) );
    END LOOP;
  END IF;
  
  RETURN;
END BTA_FB_FEHLER;

PROCEDURE UpdByGBI(pBTS_IDs IN tb_bez) AS
BEGIN

  -- Parameter zurcksetzen
  UPDATE ein_d_protokoll prt
  SET parameter = REPLACE( parameter, PARAM_XGEWERBE_GBI||'=1', PARAM_XGEWERBE_GBI||'=0')
    , d0101_id = '-1'
  WHERE prt.d_bts_id IN ( SELECT dx.bez FROM TABLE( pBTS_IDs ) dx );
  
  UPDATE ein_d_usecase
  SET d0101_id = '-1'
  WHERE d_bts_id IN ( SELECT dx.bez FROM TABLE( pBTS_IDs ) dx )
  AND usecase NOT IN (DUBL_BTR, DUBL_BTS)
  AND d0101_id <> '-1'
  AND deleted = 0;
      
  UPDATE ein_d_betriebsstaette
  SET ref_id = NULL
  WHERE id IN ( SELECT dx.bez FROM TABLE( pBTS_IDs ) dx )
  AND ref_id IS NOT NULL;
    
  -- D0101_ID von Meldungen mit gleicher Gewerbe_Betrieb_id bernehmen
  FOR c1 IN ( 
    SELECT dx.* FROM (   
      SELECT prt.rowid prt_rowid, prt0.d0101_id, prt.d_bts_id
      , ROW_NUMBER() OVER(  PARTITION BY prt.d_bts_id 
                            ORDER BY /*CASE WHEN prt0.d0101_id <> '-1' THEN 1 ELSE 2 END,*/ prt0.quelle_datum DESC, prt0.ins_date) lfdnr
      FROM ein_d_protokoll prt
      JOIN ein_d_protokoll prt0 ON prt0.gewerbe_betrieb_id = prt.gewerbe_betrieb_id
      AND prt0.id <> prt.id
      AND prt0.quelle_datum <= prt.quelle_datum
      AND prt0.deleted > -2
      JOIN vis_d0101 d0101 ON d0101.id = prt0.d0101_id AND d0101.deleted = 0
      WHERE prt.d_bts_id IN ( SELECT dx.bez FROM TABLE( pBTS_IDs ) dx )
      AND prt0.d0101_id <> '-1'
      --ORDER BY prt0.quelle_datum desc
    ) dx WHERE lfdnr = 1   
  ) LOOP
    
    UPDATE ein_d_protokoll
    SET d0101_id = c1.d0101_id
      , parameter = AddProtParam(parameter, PARAM_XGEWERBE_GBI, '1')
    WHERE rowid = c1.prt_rowid;
    
    UPDATE ein_d_usecase
    SET d0101_id = c1.d0101_id
    WHERE d_bts_id = c1.d_bts_id
    AND usecase NOT IN (DUBL_BTR, DUBL_BTS)
    AND deleted = 0;
      
    UPDATE ein_d_betriebsstaette
    SET ref_id = c1.d0101_id
    WHERE id = c1.d_bts_id;

  END LOOP;

END UpdByGBI;

PROCEDURE XGewerbeCheck( pBTS_IDs IN tb_bez, pErrMsg IN NUMBER) AS

  CURSOR cData IS 
  
  SELECT prt.d_bts_id --, d1.anzahl reg_anz, d1.text reg_text
  -- Parameter wird in DublettenBtr bereits gesetzt, nur noch Anzahl ermitteln
--  , CASE WHEN INSTR(prt.parameter, PARAM_XGEWERBE_DUBL||'=1') > 0 THEN  
--   ( 
--    SELECT COUNT(*) anzahl
--    FROM ein_d_usecase uc 
--    WHERE uc.d_bts_id = prt.d_bts_id 
--      AND uc.usecase IN( DUBL_BTR, DUBL_BTS) 
--    ) 
--    ELSE 0
--    END dubl_anz
  , TO_NUMBER(
      REPLACE(
      REGEXP_SUBSTR(prt.parameter, PARAM_XGEWERBE_DUBL_ANZ||'=([[:alnum:]]+\.?)', 1, 1)
      , PARAM_XGEWERBE_DUBL_ANZ||'=')
    ) dubl_anz
  , CASE WHEN INSTR(prt.parameter, PARAM_XGEWERBE_GBI ||'=1') > 0 THEN 1 ELSE 0 
    END GBI_Exists
    
--  , CASE WHEN prt.d0101_id <> '-1' THEN  
--   (
--    SELECT MAX( CASE WHEN prs.rechtsform = a0101_03.code THEN 0 ELSE 1 END ) F1
--    FROM ein_d_protokoll prt1
--    JOIN ein_d_funktion fkt ON fkt.d_bts_id = prt1.d_bts_id
--    AND fkt.typ = Betreiber
--    JOIN ein_d_person prs ON prs.id = fkt.d_pers_id
--    JOIN vis_d0101 d0101 ON d0101.id = prt1.d0101_id
--    JOIN vis_d0101 d3 ON d3.id = d0101.d0101_id3
--    JOIN vis_a0101 a0101_03 ON a0101_03.sid = d3.a0101_03_sid
--    WHERE prt1.d_bts_id = prt.d_bts_id 
--    --AND prt.d0101_ID <> '-1'   
--    ) 
--    ELSE 0 
--    END rechtsform_fehler
  , uc.id uc_id
  , uc.error_message 
  , prt.parameter
  , prt.d0101_id
  , CURSOR ( 
    SELECT COUNT(*) anzahl ,
      CASE WHEN COUNT(*) > 0 THEN
        CASE WHEN COUNT(*) = 1 THEN 
           '- Folgende Betriebssttte wurde anhand der Gewerberegisternummer ermittelt:'   
        WHEN COUNT(*) > 1 THEN
           '- Es konnte keine Betriebssttte eindeutig anhand der Gewerberegisternummer ermittelt werden:'
        END || CRLF ||  
          LISTAGG( '  - ' || d0101.code || ' / ' || d0101.bez || CASE WHEN d0101.name1 IS NOT NULL THEN ' / ' || d0101.name1 END, CRLF )
          WITHIN GROUP( ORDER BY d0101.code) 
      END text,
      MAX(d0101.id) d0101_id
    FROM ein_r_bts_reg r1 
    JOIN ein_d_registrierung reg ON r1.d_reg_id = reg.id
    AND reg.code = GEWERBE_CODE 
    --JOIN ein_r_bts_adr r2 ON r2.d_bts_id = r1.d_bts_id
    --AND r2.typ = StandortAdr --'Standortadresse'
    --JOIN ein_d_adresse adr ON adr.id = r2.d_adr_id
    --JOIN ein_d_verwaltung verw ON verw.id = adr.d_verw_id
    JOIN vis_d010102 D010102
    JOIN vis_d0101 d0101 ON d0101.id = d010102.d0101_id
    AND d0101.deleted = 0
    AND d010102.a010145_sid = A010145_GEWERBENR
      ON d010102.nummer = reg.nummer
      AND d010102.deleted = 0
    JOIN vis_d0101 d0101 ON d0101.id = d010102.d0101_id 
    --AND SUBSTR(d0101.gkz,1,8) = SUBSTR(verw.gkz,1,8)     
    WHERE r1.d_bts_id = prt.d_bts_id 
    AND SUBSTR(d0101.gkz,1,8) = SUBSTR(prt.gkz,1,8)     
    AND ROWNUM <= 10
    AND INSTR(prt.parameter, PARAM_XGEWERBE_GBI||'=1') = 0
    )  reg_text    

  FROM ein_d_protokoll prt
  JOIN ein_d_usecase uc ON uc.d_bts_id = prt.d_bts_id
  AND uc.usecase NOT IN (DUBL_BTS, DUBL_BTR)
  AND uc.deleted = 0
  WHERE prt.d_bts_id IN ( SELECT dx.bez FROM TABLE( pBTS_IDs ) dx );

--vD_BTS_ID VARCHAR2(32);
--vDubl_Anz NUMBER(10);
--vGbiExists NUMBER(1);
--vRechtsform_Fehler NUMBER(1);
vC1 SYS_REFCURSOR;
--vError_message ein_d_usecase.error_message%TYPE;

TYPE t1 IS RECORD ( anzahl NUMBER(10), text VARCHAR2(4000), d0101_id VARCHAR2(32) );
v1 t1;

TYPE t2 IS RECORD (
  D_BTS_ID ein_d_protokoll.d_bts_id%TYPE,
  Dubl_Anz NUMBER(10),
  GbiExists NUMBER(1),
  Rechtsform_Fehler NUMBER(1),
  uc_id ein_d_usecase.id%TYPE,
  d0101_id vis_d0101.id%TYPE,
  Error_message ein_d_usecase.error_message%TYPE,
  parameter ein_d_protokoll.parameter%TYPE );

v2 T2;

CURSOR cRechtsform (pD0101_ID IN tID, pBts_ID IN tID) IS
  SELECT CASE WHEN prs.rechtsform = a0101_03.code THEN 0 ELSE 1 END is_fehler
  FROM ein_d_funktion fkt 
  JOIN ein_d_person prs ON prs.id = fkt.d_pers_id
  JOIN vis_d0101 d0101 ON d0101.id = pD0101_id
  JOIN vis_d0101 d3 ON d3.id = d0101.d0101_id3
  JOIN vis_a0101 a0101_03 ON a0101_03.sid = d3.a0101_03_sid
  WHERE fkt.d_bts_id = pBts_id
  AND fkt.typ = Betreiber
  ORDER BY is_fehler desc;

--vRechtsform cRechtsform%ROWTYPE;

vErrMsg ein_d_usecase.error_message%TYPE;
vReturn_D0101_ID ein_d_usecase.d0101_id%TYPE;

BEGIN
 
  -- D0101_ID von Meldungen mit gleicher Gewerbe_Betrieb_id bernehmen
  IF pErrMsg IN ( 0,2) THEN
    UpdByGBI(pBTS_IDs);
  END IF;
  
  IF pErrMsg = 2 THEN 
    RETURN;
  END IF;
  
  OPEN cData;
  LOOP

    FETCH cData INTO v2.D_BTS_ID, v2.Dubl_Anz, v2.GbiExists --, v2.Rechtsform_Fehler
    , v2.uc_id, v2.error_message, v2.parameter, v2.d0101_id, vC1;
    EXIT WHEN cData%NotFound;
    
    FETCH vC1 INTO v1;
    CLOSE vC1;

    v2.Rechtsform_Fehler := 0;
    IF v2.d0101_id <> '-1' OR 
    (v2.GbiExists = 0 AND v1.anzahl = 1 AND v1.d0101_id <> '-1') 
    THEN  
      -- Rechtsformprfung
      OPEN cRechtsform(
        CASE WHEN IS_ID(v2.d0101_id) THEN v2.d0101_id ELSE v1.D0101_ID END,
        v2.d_bts_id);
      FETCH cRechtsform INTO v2.Rechtsform_Fehler;
      CLOSE cRechtsform;   
    END IF;
    
    v2.parameter :=
      AddProtParam( 
      AddProtParam(
      AddProtParam(
      AddProtParam(
      AddProtParam( v2.parameter,
        -- Dubletten 
        PARAM_XGEWERBE_DUBL, CASE WHEN v2.Dubl_anz > 0 THEN '1' ELSE '0' END) ,
        -- Gewerbenr. eindeutig
        PARAM_XGEWERBE_GEWNR, CASE WHEN v1.anzahl = 1 AND v2.GbiExists = 0 THEN '1' ELSE '0' END ),
        -- Gewerbenr. mehrfach 
        PARAM_XGEWERBE_GEWNR2, CASE WHEN v1.anzahl > 1 AND v2.GbiExists = 0 THEN '1' ELSE '0' END ), 
        --PARAM_XGEWERBE_FBFEHLER, '0'),
        -- GewerbeBetriebID gesetzt
        PARAM_XGEWERBE_GBI, CASE WHEN v2.GbiExists = 1 THEN '1' ELSE '0' END),
        -- Rechtsform stimmt nicht
        PARAM_XGEWERBE_RECHTSFORM, CASE WHEN v2.Rechtsform_Fehler = 1 THEN '1' ELSE '0' END );
    
    IF pErrMsg IN( 0, 1) AND INSTR(v2.error_message, XGEWERBE_TAG1) > 0 THEN    
      vErrMsg :=    
          LTRIM( RTRIM( 
            CASE     
            WHEN v2.GbiExists = 1 /*AND v2.d0101_id <> '-1'*/ THEN 
            'Die Betriebssttte wurde anhand der GewerbebetriebID ermittelt. Diese Meldung wird entsprechend zugeordnet.' || CRLF
            --'- Die Betriebssttte (GewerbeBetriebID) ist bereits vorhanden und wird verwendet.' || CRLF
            ELSE 
              CASE WHEN v1.Text IS NOT NULL THEN v1.text || CRLF END ||
              CASE WHEN v1.anzahl = 1 /*AND v2.GbiExists = 0*/ THEN 
                --'- Die vorhandene Betriebssttte mit der gleichen Gewerberegistriernummer wird verwendet.' || CRLF END
                '- Diese Meldung wird entsprechend zugeordnet.' || CRLF END
            END ||     
            CASE 
              WHEN v1.anzahl = 1 OR v2.GbiExists = 1 THEN NULL
              WHEN v2.Dubl_anz = 1 THEN '- Es ist 1 Dublette vorhanden.' || CRLF
              WHEN v2.Dubl_anz > 1 THEN '- Es sind ' || v2.Dubl_anz || ' Dubletten vorhanden.' || CRLF 
            END ||  
            CASE WHEN v2.Rechtsform_Fehler = 1 THEN '- Die gelieferte Rechtsform stimmt nicht mit der Rechtsform im Programm berein.' || CRLF END ||
            ''
          , CRLF), CRLF);    
      
      IF vErrMsg IS NULL THEN
        vErrMsg := ' ';
      END IF;
          
      v2.error_message := REGEXP_REPLACE(v2.error_message, 
        '('||XGEWERBE_TAG1||')' ||'[[:print:][:cntrl:]]{1,}'|| XGEWERBE_TAG2
        , '\1' || vErrMsg || XGEWERBE_TAG2 ); 
      
      UPDATE ein_d_usecase uc
      SET error_message = v2.error_message 
      WHERE uc.id = v2.uc_id;

    END IF;
    
--    IF pErrMsg > 0 THEN  
--      FORALL i IN vData.FIRST .. vData.LAST
--        UPDATE ein_d_usecase uc
--        SET error_message =
--            LTRIM( RTRIM( 
--              error_message || CRLF ||
--              CASE WHEN vData(i).reg_text IS NOT NULL /*AND vData(i).uc_abmeldung IS NULL*/ THEN vData(i).reg_text || CRLF END ||
--              CASE WHEN vData(i).dubl_anz = 1 THEN '- Es ist 1 Dublette vorhanden!' || CRLF END ||
--              CASE WHEN vData(i).dubl_anz > 1 THEN '- Es sind ' || vData(i).dubl_anz || ' Dubletten vorhanden.' || CRLF END ||
--              CASE WHEN uc.d0101_id <> '-1' THEN '- Die Betriebssttte ist bereits in iP vorhanden.' END 
--            , CRLF), CRLF)           
--        WHERE uc.d_bts_id = vData(i).d_bts_id
--          AND uc.usecase NOT IN (DUBL_BTR, DUBL_BTS)
--          AND uc.deleted = 0; 
--    END IF; 
    
--    FORALL i IN vData.FIRST .. vData.LAST
--      UPDATE ein_d_protokoll prt
--      SET parameter = AddProtParam( 
--                      AddProtParam(
--                      AddProtParam(parameter, PARAM_XGEWERBE_DUBL, CASE WHEN vData(i).dubl_anz > 0 THEN 1 ELSE 0 END) ,
--                                              PARAM_XGEWERBE_GEWNR, 0 /*, CASE WHEN vData(i).reg_text IS NOT NULL AND vData(i).uc_abmeldung IS NULL THEN 1 ELSE 0 END*/ ), 
--                                              PARAM_XGEWERBE_FBFEHLER, 0) 
--      WHERE prt.d_bts_id = vData(i).d_bts_id;

    IF v2.GbiExists = 0 AND v1.anzahl = 1 AND v1.d0101_id <> '-1' THEN 
      UPDATE ein_d_usecase uc
      SET d0101_id =  v1.d0101_id
      WHERE uc.id = v2.uc_id; --D_bts_id
        --AND uc.usecase NOT IN (DUBL_BTR, DUBL_BTS)
        --AND uc.deleted = 0
      --  AND uc.d0101_id = '-1';
      --RETURNING d0101_id INTO vReturn_D0101_ID; 
      
      IF SQL%ROWCOUNT > 0 THEN --AND vReturn_D0101_ID <> '-1' THEN
        UPDATE ein_d_protokoll
        SET d0101_id = v1.D0101_ID
        WHERE d_bts_id = v2.D_BTS_ID;

        UPDATE ein_d_betriebsstaette
        SET ref_id = v1.D0101_ID
        WHERE id = v2.D_BTS_ID;

      END IF;      
    END IF;   

    UPDATE ein_d_protokoll prt
    SET parameter = v2.parameter
    WHERE prt.d_bts_id = v2.D_bts_id;
      
  END LOOP;
  CLOSE cData;
 
END XGewerbeCheck;


PROCEDURE AbschlussXGewerbe( pBtrBez IN NUMBER := 1, pAdrNorm IN NUMBER := 1, pDubl IN NUMBER := 1, pBAStd NUMBER := 1)  AS

 vBTS_ID2 tb_bez := tb_bez();

CURSOR cPrt IS 
  SELECT prt.d_bts_id 
  FROM ein_d_protokoll prt
  WHERE PRT.QUELLE = QUELLE_XGEWERBE
  AND prt.status = 30 
  AND prt.deleted = 0;

TYPE tPrt IS TABLE OF cPrt%ROWTYPE;
vPrt tPrt;

BEGIN

  -- 62977090
  -- Meldungen lschen, die nur aus WZG-Schl. (Feld scope) ohne Fachbereich bestehen
  /* diese Daten werden nicht mehr im EK gespeichert, lschen nicht mehr notwendig
  vCnt := 0;  
  FOR c1 IN (
  
  SELECT prt.d_bts_id --, bta.* 
  FROM ein_d_protokoll prt
  --join ein_d_betriebsart bta on bta.d_bts_id = prt.d_bts_id
  WHERE PRT.QUELLE = QUELLE_XGEWERBE
  AND prt.status = 30 
  AND prt.deleted = 0
  AND 
    ( 
    SELECT COUNT(*) 
    FROM ein_d_betriebsart bta
    WHERE bta.d_bts_id = prt.d_bts_id) =
    (   
    SELECT COUNT(*) 
    FROM ein_d_betriebsart bta
    WHERE bta.d_bts_id = prt.d_bts_id
    AND bta.scope IS NOT NULL AND (bta.fachbereich = '%' OR bta.fachbereich IS NULL))
  ORDER BY  prt.d_bts_id
  
  ) LOOP  
  
    vCnt := vCnt + 1;
    DeleteByBtsId(c1.d_bts_id);
    IF MOD(vCnt, 100) = 0 AND vCommit = 1 THEN
      COMMIT;
    END IF;
  END LOOP;
  
  IF vCommit = 1 THEN
    COMMIT;
  END IF; */
  
  OPEN cPrt;
  FETCH cPrt BULK COLLECT INTO vPrt;
  CLOSE cPrt;
--DBMS_OUTPUT.PUT_LINE ( vPrt.count);
  
  vCnt := 0;
  
  IF vPrt.COUNT > 0 THEN 
    vBTS_ID2.extend( vPrt.COUNT ); 

    FOR i IN vPrt.FIRST .. vPrt.LAST LOOP
      vBTS_ID2(i) := t_bez( vPrt(i).d_bts_id );
    END LOOP;  
  
    AbschlussXGewerbeAuswahl(vBTS_ID2, pBtrBez, pAdrNorm, pDubl, pBAStd );
    
  END IF;  
  
END AbschlussXGewerbe;

PROCEDURE AbschlussXGewerbeAuswahl(pBTS_IDs IN tb_bez, pBtrBez IN NUMBER := 1, pAdrNorm IN NUMBER := 1, pDubl IN NUMBER := 1, pBAStd NUMBER := 1)  AS
--pBtrBez IN NUMBER := 1, pAdrNorm IN NUMBER := 1, pDubl IN NUMBER := 1, pBAStd NUMBER := 1
vSysdate CONSTANT DATE := SYSDATE; 

CURSOR cKorr IS
      SELECT prt1.rowid prt1_rowid, uc1.rowid uc1_rowid
      , REPLACE( TO_CHAR(prt.quelle_datum, 'DD.MM.YYYY HH24:MI:SS'), ' 00:00:00', '') quelle_datum
      FROM ein_d_protokoll prt
      JOIN ein_d_funktion fkt on fkt.d_bts_id = prt.d_bts_id
      AND fkt.typ = Betreiber
      JOIN ein_d_person prs ON prs.id = fkt.d_pers_id
      --AND NOT (prs.rechtsform = A0101_03_CODE_GbR OR prs.a0101_03_sid = A0101_03_SID_GbR)       
      JOIN ein_d_protokoll prt1 on prt1.source_id = prt.source_id
      AND prt1.quelle_datum <= prt.quelle_datum
      AND prt1.deleted = 0
      AND prt1.id <> prt.id
      JOIN ein_d_usecase uc1 on uc1.d_bts_id = prt1.d_bts_id
      AND uc1.deleted = 0
      AND uc1.usecase NOT IN (DUBL_BTR, DUBL_BTS)       
      WHERE prt.d_bts_id IN ( SELECT dx.bez FROM TABLE( pBTS_IDs ) dx )
      --AND prt.gewerbe_betrieb_id IS NOT NULL
      --AND prt.quelle_datum IS NOT NULL
      AND prt.korrektur_jn = 1;

TYPE tKorr IS TABLE OF cKorr%ROWTYPE;
vKorr tKorr;

vID_NULL CONSTANT VARCHAR2(36) := '00000000-0000-0000-0000-000000000000'; 
BEGIN  

  IF pBTS_IDs IS NOT NULL AND pBTS_IDs.COUNT > 0 THEN
    
    -- Error_message lschen
    IF pBtrBez = 1 AND pAdrNorm = 1 AND pDubl = 1 AND pBAStd = 1 THEN
      UPDATE ein_d_usecase
      SET error_message = XGEWERBE_TAG1 || ' ' || XGEWERBE_TAG2
      WHERE d_bts_id IN ( SELECT dx.bez FROM TABLE( pBTS_IDs ) dx )
      AND deleted = 0
      AND usecase NOT IN ( DUBL_BTR, DUBL_BTS); 

      UPDATE ein_d_protokoll
      SET gewerbe_betrieb_id = NULL
      WHERE gewerbe_betrieb_id = vID_Null
      AND d_bts_id IN ( SELECT dx.bez FROM TABLE( pBTS_IDs ) dx );
    END IF;
      
        
    -- bei Korrekturmeldung alle ltere Meldungen autom. besttigen
    OPEN cKorr;
    FETCH cKorr BULK COLLECT INTO vKorr;
    CLOSE cKorr;
    IF vKorr IS NOT NULL AND vKorr.COUNT > 0 THEN

      FORALL i IN vKorr.FIRST .. vKorr.LAST
      UPDATE ein_d_protokoll
      SET deleted = -1
      WHERE rowid = vKorr(i).prt1_rowid;
        
      FORALL i IN vKorr.FIRST .. vKorr.LAST
      UPDATE ein_d_usecase
      SET deleted = -1
      , del_date = vSYSDATE
      , error_message = 'Die Meldung wurde automatisch besttigt, da bereits eine Korrekturmeldung vom ' ||vKorr(i).quelle_datum|| ' vorliegt.' ||
                      CASE WHEN error_message IS NOT NULL THEN CRLF || error_message END
      WHERE rowid = vKorr(i).uc1_rowid;
          
    END IF;
               
    IF pBtrBez = 1 THEN
      BetreiberBezeichnungen(pBTS_IDs);
    END IF;
          
    IF pAdrNorm = 1 THEN     
      NormierungAdressen(pBTS_IDs);
    END IF;
         
    IF pBaStd = 1 THEN
      BA_Standardwerte_XGewerbe(pBTS_IDs);
    END IF;

    -- Betrieb mit GewerbeBetriebID ermitteln
    IF pAdrNorm = 1 OR pDubl = 1 THEN
      XGewerbeCheck( pBTS_IDs, 2 );
    END IF;

    IF pDubl = 1 THEN
    -- Betreiberdubletten ermitteln    
      DublettenBtr(pBTS_IDs);
    END IF;
  
    IF pBtrBez = 1 AND pAdrNorm = 1 AND pDubl = 1 AND pBAStd = 1 THEN
    
      /** Aufteilung nach Prfung und Meldungstexte
      erst alle Prfungen und dann Meldungstexte zusammenstellen.
      1. d0101_id ber GEWERBE_BETRIEB_ID - bereits oben erfolgt
      2. d0101_id ber Gewerbenummer -> menn mehrere dann Fehler
      3. Adressnormierung nicht wenn d0101_id bekannt ??? DD
      4. Dublettenprfung nicht wenn d0101_id vorh. - erledigt
      
      **/

      XGewerbeCheck( pBTS_IDs, 1 );  

      -- protokoll.status von 30 auf 0 setzten -> Anzeige in Gewerbemeldung erst jetzt
      UPDATE ein_d_protokoll
      SET status = 0
      WHERE d_bts_id IN ( SELECT dx.bez FROM TABLE( pBTS_IDs ) dx )
      AND status = 30; 
      
      vCnt := SQL%ROWCOUNT; 
      
    END IF;    
    
  ELSE
    vCnt := 0;
  END IF;

END AbschlussXGewerbeAuswahl;

FUNCTION AbschlussXGewerbeAnzahl RETURN NUMBER AS
BEGIN
  RETURN vCnt;
END;

PROCEDURE Fill_Komm( pTyp IN VARCHAR2, pID IN VARCHAR2, pKom OUT NOCOPY tKom) AS

CURSOR cFkt IS 
    SELECT telefon, fax, mobil, email, internet
    FROM (
      SELECT r.d_fkt_id, kom.komdata, kom.komtyp
      FROM EIN_d_kommunikation kom
      JOIN EIN_r_fkt_kom r ON R.D_KOM_ID = kom.id
      AND  r.d_fkt_id = pId 
    ) PIVOT( MIN(komdata)
      FOR KOMTYP IN ( 
        'TELEFON' AS telefon,
        'FAX' AS fax,
        'MOBIL' AS mobil,
        'EMAIL' as email,
        'INTERNET' AS internet ) );
--        
CURSOR cBTS IS 
    SELECT telefon, fax, mobil, email, internet
    FROM (
      SELECT r.d_bts_id, kom.komdata, kom.komtyp
      FROM EIN_d_kommunikation kom
      JOIN EIN_r_bts_kom r ON R.D_KOM_ID = kom.id
      AND  r.d_bts_id = pId
    ) PIVOT( MIN(komdata)
      FOR KOMTYP IN ( 
        'TELEFON' AS telefon,
        'FAX' AS fax,
        'MOBIL' AS mobil,
        'EMAIL' as email,
        'INTERNET' AS internet ) );

CURSOR cPrs IS 
    SELECT telefon, fax, mobil, email, internet
    FROM (
      SELECT r.d_pers_id, kom.komdata, kom.komtyp
      FROM EIN_d_kommunikation kom
      JOIN EIN_r_pers_kom r ON R.D_KOM_ID = kom.id
      AND  r.d_pers_id = pId
    ) PIVOT( MIN(komdata)
      FOR KOMTYP IN ( 
        'TELEFON' AS telefon,
        'FAX' AS fax,
        'MOBIL' AS mobil,
        'EMAIL' as email,
        'INTERNET' AS internet ) );

BEGIN

  CASE pTyp 
  WHEN 'FKT' THEN
  
    OPEN cFKT;
    FETCH cFKT INTO pKom.Telefon, pKom.fax, pKom.mobil, pKom.email, pKom.internet;
    CLOSE cFKT;
    
  WHEN 'BTS' THEN

    OPEN cBTS;
    FETCH cBTS INTO pKom.Telefon, pKom.fax, pKom.mobil, pKom.email, pKom.internet;
    CLOSE cBTS;

  WHEN 'PRS' THEN
    
    OPEN cPRS;
    FETCH cPRS INTO pKom.Telefon, pKom.fax, pKom.mobil, pKom.email, pKom.internet;
    CLOSE cPRS;
        
  ELSE RAISE_APPLICATION_ERROR(-20001, 'Package XGEWERBE.FILL_KOMM Param. Typ=' || pTyp || ' wird nicht untersttzt.');
  END CASE;        

END Fill_Komm;

/**
 Gibt alle Personen (Hauptverantwortliche, gesetzl. Vetreter, und vertretungsberechtigte Person)
 des 1. Betreibers aus dem Eingangskorb (pBTS_ID) und die Dubletten zum 
 Betrieb (pD0101_ID) zurck
**/  
FUNCTION GetD0102Dubl(pBTS_ID IN VARCHAR2, pD0101_ID IN VARCHAR2) RETURN tbD0102Dubl PIPELINED AS

-- Personaldubletten
CURSOR cD0102Dubl (pBTS_ID IN VARCHAR2, pD0101_ID IN VARCHAR2) IS 
  SELECT 
  prs.id prs_id
  , d010200.id d010200_id
  --, prs.nachname, prs.vorname, prs.geburtsdatum
  , CASE WHEN prs.id <> '-1' THEN
      SUBSTR(
      TRIM( BOTH FROM prs.anrede || ' ' ||  
                     GetD010200_BEZ( prs.NachName, prs.VorName, 
                                         prs.Vorsatz_nachname, prs.Nachsatz_nachname, 
                                         prs.Titel)) 
    || CASE WHEN prs.geburtsdatum IS NOT NULL 
       THEN ' (Geburtsdatum '||TO_CHAR(prs.geburtsdatum, 'dd.mm.yyyy') || ')' 
       END, 1, 500) 
    END prs_bez
  , CASE WHEN d0102.id <> '-1' THEN
      SUBSTR(
      TRIM( BOTH FROM d0102.anrede || ' ' ||  
                     GetD010200_BEZ( d0102.NName, d0102.VName, 
                                         d0102.Vorsatz_nname, d0102.nachsatz_nname, 
                                         d0102.Titel)) 
    || CASE WHEN d0102.geb_datum IS NOT NULL 
       THEN ' (Geburtsdatum '||TO_CHAR(d0102.geb_datum, 'dd.mm.yyyy') || ')' 
       END, 1, 500) 
    END d0102_bez 
  FROM ein_d_funktion fkt
  JOIN ein_d_person prs on prs.id = fkt.d_pers_id
  JOIN ein_d_protokoll prt on prt.d_bts_id = fkt.d_bts_id
  AND fkt.typ in (HV_Betreiber, GV_Betreiber, VERTRET_PERSON)
  AND fkt.d_bts_id = pBTS_ID
  
--  LEFT JOIN vis_d0101 d0101 
--    JOIN vis_d010200 d010200 
--    JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id
--    AND d010200.deleted = 0 
--    AND d0101.id = pD0101_ID
  LEFT JOIN vis_d0102 d0102  
    JOIN vis_d010200 d010200 on d0102.id = d010200.d0102_id
    AND d010200.deleted = 0 
    AND d010200.d0101_id = pD0101_ID
   
  ON prs.vorname || TAB = d0102.vname || TAB 
  AND prs.nachname = d0102.nname
  AND ( d0102.geb_datum IS NULL OR prs.geburtsdatum IS NULL OR d0102.geb_datum = prs.geburtsdatum) 
  AND d0102.deleted = 0;

vD0102Dubl tbD0102Dubl;

BEGIN
  OPEN cD0102Dubl(pBTS_ID => pBTS_ID, pD0101_ID => pD0101_ID);
  FETCH cD0102Dubl BULK COLLECT INTO vD0102Dubl LIMIT 999;
  CLOSE cD0102Dubl;
  
  IF vD0102Dubl.COUNT > 0 THEN
    FOR i IN vD0102Dubl.FIRST .. vD0102Dubl.LAST LOOP 
      PIPE ROW (vD0102Dubl(i));
    END LOOP;
  END IF;
  RETURN;

END GetD0102Dubl;

FUNCTION CONST_VERTRET_PERSON RETURN VARCHAR2 DETERMINISTIC AS
BEGIN
  RETURN VERTRET_PERSON;
END;
FUNCTION CONST_Betreiber RETURN VARCHAR2 DETERMINISTIC AS
BEGIN
  RETURN Betreiber;
END;
FUNCTION CONST_HV_Betreiber RETURN VARCHAR2 DETERMINISTIC AS
BEGIN
  RETURN HV_Betreiber;
END;
FUNCTION CONST_GV_Betreiber RETURN VARCHAR2 DETERMINISTIC AS
BEGIN
  RETURN GV_Betreiber;
END;
FUNCTION CONST_Dubl_Btr RETURN VARCHAR2 DETERMINISTIC AS
BEGIN
  RETURN DUBL_BTR;
END;
FUNCTION CONST_Dubl_Bts RETURN VARCHAR2 DETERMINISTIC AS
BEGIN
  RETURN DUBL_BTS;
END;
FUNCTION VERFAHREN_XGEWERBE RETURN VARCHAR2 DETERMINISTIC AS
BEGIN
  RETURN QUELLE_XGEWERBE;
END;

/**
  entfernt alle Tags in der Form <..>
**/  
FUNCTION RemoveTags(pValue IN VARCHAR2) RETURN VARCHAR2 AS
BEGIN

  RETURN REGEXP_REPLACE(pValue,'<.*?>');

END;

FUNCTION RemoveTags(pValue IN CLOB) RETURN CLOB AS
BEGIN

  RETURN TRIM( BOTH FROM REGEXP_REPLACE(pValue,'<.*?>'));

END;


FUNCTION Version RETURN VARCHAR2 AS
BEGIN
  --RETURN '1.24.008';
  RETURN '$Revision: 1146 $';
END;

BEGIN
  SELECT S00.GKZ2 INTO vGKZ2 FROM vis_s00 s00 WHERE s00.deleted = 0; 
END xgewerbe;
/

